/*
 *  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 *  WSO2 Inc. licenses this file to you under the Apache License,
 *  Version 2.0 (the "License"); you may not use this file except
 *  in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 *
 */

/*
endpoints.js deals with Endpoint Mediators
*/

var ENDPOINT_MANAGEMENT = "__EndpointAdmin";

/**  To keep the index of each  child endpoints of the current modifing endpoint */
var endpointindexs = new Array();
/**  when adding a new child--to keep the index of the parent */
var currentparentindex ;
/** Menus */
var epadd;
var childepadd;
var endpointstypes = ([ { text:"Address Endpoint", id:"address", value:"Address", onclick: { fn:onMenuItemClickToAddRoot } },{ text:"WSDL Endpoint", id:"wsdl", value:"WSDL",onclick: { fn:onMenuItemClickToAddRoot } },{ text:"Failover group", id:"failover", value:"FailOver" ,onclick: { fn:onMenuItemClickToAddRoot }},{ text:"Load-balance group", id:"loadbalance", value:"LoadBalance",onclick: { fn:onMenuItemClickToAddRoot } } ]);
var childendpointstypes = ([ { text:"Address Endpoint", id:"c_address", value:"Address",onclick: { fn:onMenuItemClickToChildAdd } },{ text:"WSDL Endpoint", id:"c_wsdl", value:"WSDL",onclick: { fn:onMenuItemClickToChildAdd } },{ text:"Failover group", id:"c_failover", value:"FailOver" ,onclick: { fn:onMenuItemClickToChildAdd }},{ text:"Load-balance group", id:"c_loadbalance", value:"LoadBalance",onclick: { fn:onMenuItemClickToChildAdd }},{ text:"Lookup Endpoint",onclick: { fn:onMenuItemClickToChildAdd } } ]);
var anonymousendpointstypes = ([ { text:"Address Endpoint", id:"a_address", value:"Address",onclick: { fn:onMenuItemClickToShowInNewPanel } },{ text:"WSDL Endpoint", id:"a_wsdl", value:"WSDL",onclick: { fn:onMenuItemClickToShowInNewPanel } },{ text:"Failover group", id:"a_failover", value:"FailOver" ,onclick: { fn:onMenuItemClickToShowInNewPanel }},{ text:"Load-balance group", id:"a_loadbalance", value:"LoadBalance",onclick: { fn:onMenuItemClickToShowInNewPanel } },{ text:"Lookup Endpoint",onclick: { fn:onMenuItemClickToShowInNewPanel } } ]);
var anonymousendpointstypes_send = ([ { text:"Address Endpoint", id:"s_address", value:"Address",onclick: { fn:onSendMediatorMenuItemClick } },{ text:"WSDL Endpoint", id:"s_wsdl", value:"WSDL",onclick: { fn:onSendMediatorMenuItemClick } },{ text:"Failover group", id:"s_failover", value:"FailOver" ,onclick: { fn:onSendMediatorMenuItemClick }},{ text:"Load-balance group", id:"s_loadbalance", value:"LoadBalance",onclick: { fn:onSendMediatorMenuItemClick } } ,{ text:"Lookup Endpoint",onclick: { fn:onSendMediatorMenuItemClick } } ]);
var epaddanonymouse;
var inlineProperties = new Array();
var epmode = 0;
// 0- add  ; 1 - edit
var state = 0;
// 0 temp state ; 1 - final state
var ep_str = null;

var iscurrentepanonymouse = false;
var isOnNewPanel = false;
var save_state = false;
var deletedChilds = new Array();

function enableendpointstatistics(endpointname) {

    var body_xml = '<ns1:enableStatistics xmlns:ns1="http://org.apache.synapse/xsd">' +
                   '<ns1:endpointName>' + endpointname + '</ns1:endpointName>' +
                   '</ns1:enableStatistics>';

    var callURL = serverURL + "/" + ENDPOINT_MANAGEMENT + "/" + "enableStatistics";
    send("enableStatistics", body_xml, "", callURL, "", false, commonEndpointCallback);
}

function disableendpointstatistics(endpointname) {

    var body_xml = '<ns1:disableStatistics xmlns:ns1="http://org.apache.synapse/xsd">' +
                   '<ns1:endpointName>' + endpointname + '</ns1:endpointName>' +
                   '</ns1:disableStatistics>';

    var callURL = serverURL + "/" + ENDPOINT_MANAGEMENT + "/" + "disableStatistics";
    send("disableStatistics", body_xml, "", callURL, "", false, commonEndpointCallback);
}

function addInLineProperties(key, propValue) {
    var isnewvalue = true ;
    for (var i = 0; i < inlineProperties.length; i++) {
        if (inlineProperties[i] != null && inlineProperties[i] != undefined &&
            inlineProperties[i].key == key) {
            inlineProperties[i].propValue = propValue;
            isnewvalue = false;
        }
    }
    if (isnewvalue) {
        var prop = new Object();
        prop.key = key;
        prop.propValue = propValue;
        inlineProperties[inlineProperties.length] = prop;
    }
}
function getInLineProperty(key) {
    for (var i = 0; i < inlineProperties.length; i++) {
        if (inlineProperties[i] != null && inlineProperties[i] != undefined &&
            inlineProperties[i].key == key) {
            return inlineProperties[i].propValue;
        }
    }
}
function removeInLineProperty(key) {
    for (var i = 0; i < inlineProperties.length; i++) {
        if (inlineProperties[i] != null && inlineProperties[i] != undefined &&
            inlineProperties[i].key == key) {
            inlineProperties[i] = null;
        }
    }
}
function clearInLineProperties() {
    inlineProperties = new Array();
}
function viewwsdl(key, anonymous) {
    if (anonymous != undefined && anonymous != null && anonymous == "true") {
        iscurrentepanonymouse = true;
    } else {
        iscurrentepanonymouse = false;
    }
    state = 0;
    viewlnlinewsdl(key, "addInLineWSDLDef");
}

function viewlnlinewsdl(key, savefun) {
    var inlinewsdl = getInLineProperty(key);
    showInLinePropertyEditor(key, savefun, "closeLinePropertyEditor", "In-lined WSDL Editor", "In-lined WSDL", "In-lined WSDL")
    var valueId = document.getElementById("inlineprop_value");
    if (valueId != null && valueId != undefined && inlinewsdl != null && inlinewsdl != undefined) {
        if (inlinewsdl != null && inlinewsdl != undefined) {
            if (browsername.indexOf(NETSCAPE_BROWSER_NAME) != -1) {
                if (inlinewsdl instanceof Object) {
                    inlinewsdlstr = xmlSerializerToString(inlinewsdl);
                } else {
                    inlinewsdlstr = inlinewsdl;
                }
            } else if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
                if (typeof inlinewsdl == typeof "string") {
                    inlinewsdlstr = inlinewsdl;
                } else {
                    inlinewsdlstr = xmlSerializerToString(inlinewsdl);
                }
            } else {
                esbwarning("Unsupported browser: " + browsername, TYPE_WARN);
                return;
            }
        }
        valueId.value = inlinewsdlstr;
    }
}
function closeLinePropertyEditor() {
    var divcontrol = document.getElementById("inlinepropertyPanel");
    divcontrol.innerHTML = "";
}
function addInLineWSDLDef(key) {
    state = 0;
    save_state = false;
    var valueId = document.getElementById("inlineprop_value");
    var inlinevalue = null;
    if (valueId != null && valueId != undefined) {
        inlinevalue = valueId.value;
    }
    if (inlinevalue == null || inlinevalue == "") {
        esbwarning("Invalid WSDL definition: Empty WSDL", TYPE_WARN);
        return;
    }
    if (window.ActiveXObject) {
        try {
            var doc = new ActiveXObject("Microsoft.XMLDOM");
            doc.async = "false";
            var hasParse = doc.loadXML(inlinevalue);
            if (!hasParse) {
                esbwarning("Invalid WSDL definition: XML parse error", TYPE_ERROR);
                return;
            }
        } catch (e) {
            esbwarning("Invalid WSDL definition: XML parse error", TYPE_ERROR);
            return;
        }
    } else {
        var parser = new DOMParser();
        var dom = parser.parseFromString(inlinevalue, "text/xml");
        if (dom.documentElement.nodeName == "parsererror") {
            esbwarning("Invalid WSDL definition: XML parse error", TYPE_ERROR);
            return;
        }
    }
    var wsdlObj = createesbelement(trim(inlinevalue)) ;
    var validWSDL = false ;
    if (wsdlObj.nodeName.indexOf("definitions") != -1) {
        validWSDL = true;
    } else if (wsdlObj.nodeName.indexOf("wsdl20:description") != -1) {
        validWSDL = true;
    }
    if (!validWSDL) {
        esbwarning("Invalid WSDL definition", TYPE_WARN);
        return;
    }
    var uri = document.getElementById(("endpoint_address" + key).toString());
    if (uri != null && uri.value != "") {
        addInLineProperties(key + "_uri", trim(uri.value));
    }
    addInLineProperties(key, trim(inlinevalue));
    closeLinePropertyEditor();
    if (key == "0") {
        var wsdlXml = null;
        if (iscurrentepanonymouse) {
            wsdlXml = getAnonymousWSDLEndPointString(key,"inlined")
        }
        else {
            wsdlXml = getXmlForWSDLEndpoint("inlined");
        }
        if (wsdlXml == undefined || wsdlXml == null) {
            wsdlXml = "<syn:endpoint xmlns:syn='http://ws.apache.org/ns/synapse'/>";
        }
        var epObj = createesbelement(wsdlXml);
        if (epObj == null || epObj == undefined) {
            return;
        }
        epObj.setAttribute("_wsdl", 0);
        var fn = "addSaveEndPoint";
        if (epmode == 1) {
            fn = "saveEndPoint";
        }
        if (iscurrentepanonymouse) {
            if (!isOnNewPanel) {
                createRootEndpointDivOnParentPanel("endpoints/wsdlendpoint_add.xsl", "WSDL", 0, epObj, fn, "true");
            } else {
                if (currentanonymousfun != null) {
                    fn = currentanonymousfun;
                }
                createRootEndpointDiv("endpoints/wsdlendpoint_add.xsl", "WSDL", 0, epObj, fn, "discardfun", "true");
            }
        } else {
            if (!isOnNewPanel) {
                createRootEndpointDivOnParentPanel("endpoints/wsdlendpoint_add.xsl", "WSDL", 0, epObj, fn, "false");
            } else {
                if (currentanonymousfun != null) {
                    fn = currentanonymousfun;
                }
                createRootEndpointDiv("endpoints/wsdlendpoint_add.xsl", "WSDL", 0, epObj, fn, "discardfun", "false");
            }
        }
    } else {
        var wsdlXml = getAnonymousWSDLEndPointString(key,"inlined");
        if (wsdlXml == undefined) {
            wsdlXml = "<syn:endpoint xmlns:syn='http://ws.apache.org/ns/synapse'/>";
        }
        var epObj = createesbelement(wsdlXml);
        if (epObj == null || epObj == undefined) {
            return;
        }
        epObj.setAttribute("_wsdl", 0);
        editChildEndpointDiv("endpoints/wsdlendpoint_add.xsl", "WSDL", key, epObj, "true");
    }
}
function addWSDLURI(key) {
    state = 0;
    save_state = false;
    if (key == 0) {
        var wsdlXml = null;
        if (iscurrentepanonymouse) {
            wsdlXml = getAnonymousWSDLEndPointString(key)
        }
        else {
            wsdlXml = getXmlForWSDLEndpoint();
        }
        if (wsdlXml == undefined || wsdlXml == null) {
            wsdlXml = "<syn:endpoint xmlns:syn='http://ws.apache.org/ns/synapse'/>";
        }
        var epObj = createesbelement(wsdlXml);
        if (epObj == null || epObj == undefined) {
            return;
        }
        epObj.setAttribute("_uri", 0);
        var fn = "addSaveEndPoint";
        if (epmode == 1) {
            fn = "saveEndPoint";
        }
        if (iscurrentepanonymouse) {
            if (!isOnNewPanel) {
                createRootEndpointDivOnParentPanel("endpoints/wsdlendpoint_add.xsl", "WSDL", 0, epObj, fn, "true");
            } else {
                if (currentanonymousfun != null) {
                    fn = currentanonymousfun;
                }
                createRootEndpointDiv("endpoints/wsdlendpoint_add.xsl", "WSDL", 0, epObj, fn, "discardfun", "true");
            }
        } else {
            if (!isOnNewPanel) {
                createRootEndpointDivOnParentPanel("endpoints/wsdlendpoint_add.xsl", "WSDL", 0, epObj, fn, "false");
            } else {
                if (currentanonymousfun != null) {
                    fn = currentanonymousfun;
                }
                createRootEndpointDiv("endpoints/wsdlendpoint_add.xsl", "WSDL", 0, epObj, fn, "discardfun", "false");
            }
        }
    } else {
        var wsdlXml = getAnonymousWSDLEndPointString(key);
        if (wsdlXml == undefined) {
            wsdlXml = "<syn:endpoint xmlns:syn='http://ws.apache.org/ns/synapse'/>";
        }
        var epObj = createesbelement(wsdlXml);
        if (epObj == null || epObj == undefined) {
            return;
        }
        epObj.setAttribute("_uri", 0);
        editChildEndpointDiv("endpoints/wsdlendpoint_add.xsl", "WSDL", key, epObj, "true");
    }
}
function showInLinePropertyEditor(key, onclickfn, discardfn, title, header, footer) {
    var divcontrol1 = document.getElementById("inlinepropertyPanel");
    divcontrol1.innerHTML = "";
    var panelcontrol = document.createElement("div");
    panelcontrol.setAttribute("id", "panelEndpoint");
    var inner_html = "<div class='hd'><div class='tl'></div><span>" + title + "</span><div class='tr'></div></div>"
        + "<div class='bd'><br/><div id='divAddInlineProperty' style='height:200px'>"
        + "<textarea style='margin-left: 50px;margin-right: 50px;' id='inlineprop_value' type='text' cols='94' rows='10'>&#32;</textarea></div>"
        + "<div>";
    if (onclickfn != null) {
        inner_html += "<table style='margin-left: 280px;'><tbody><tr>"
            + "<td><input type='button' class='panelbutton_default'"
            + "onclick=" + onclickfn + "('" + key + "')  value='Save'></td><td></td>"
            + "<td><input type='button' class='panelbutton_cancel'"
            + "onclick=" + discardfn + "() value='Cancel'/></td>"
            + "</tr></tbody></table>";
    }
    inner_html += "</div></div>"
        + "<div id='statusbar' class='ft'>" + footer + "</div>";
    panelcontrol.innerHTML = inner_html;
    document.getElementById("inlinepropertyPanel").appendChild(panelcontrol);
    document.getElementById("inlinepropertyPanel").style.display = "inline";
    var esbpanel2 = new YAHOO.widget.Panel("panelEndpoint", {width:"800px", fixedcenter:true, visible:false, constraintoviewport:true});
    esbpanel2.render();
    esbpanel2.show();
}

function setInLineWSDL(key, anonymous) {
    viewwsdl(key, anonymous);
}
function setWSDLURI(key, anonymous) {
    if (anonymous != undefined && anonymous != null && anonymous == "true") {
        iscurrentepanonymouse = true;
    } else {
        iscurrentepanonymouse = false;
    }
    addWSDLURI(key);
}
/**
 * Adding a new endpointindex(index + end point type)
 */
function addendpointindex(index, type) {
    var currentIndex = new Object();
    currentIndex.index = index;
    currentIndex.type = type;
    endpointindexs[endpointindexs.length] = currentIndex;
}
function removeendpointindex(index, pindex) {
    var limit = endpointindexs.length;
    for (var i = 0; i < limit; i++) {
        var current = endpointindexs[i] ;
        if (current != null && current != undefined && current.index.toString() == index.toString()) {
            endpointindexs[i] = null;
            var lim = deletedChilds.length;
            for (var j = 0; j < lim; j++) {
                var child = deletedChilds[j];
                if (child != null && child != undefined && child.id.toString() == pindex.toString()) {
                    var count = child.count;
                    if (count != undefined && count != null) {
                        child.count = parseInt(count) + 1;
                    } else {
                        child.count = 1;
                    }
                    return;
                }
            }
            var parent = new Object();
            parent.id = pindex;
            parent.count = 1;
            deletedChilds[deletedChilds.length] = parent;
        }
    }

}
function getDeletedChilds(pindex) {
    var limit = deletedChilds.length;
    for (var j = 0; j < limit; j++) {
        var child = deletedChilds[j];
        if (child != null && child != undefined && child.id.toString() == pindex.toString()) {
            var count = child.count;
            if (count != undefined && count != null) {
                return parseInt(count);
            }
        }
    }
    return 0;
}
/**
 * Event handler for the menu items---call this when adding child endpoints
 */
function onMenuItemClickToChildAdd(p_sType, p_aArgs, p_oValue) {
    save_state = false;
    var menuStr = p_oValue.toString();
    var divstr = "childEndPointsDIV" + currentparentindex;
    var childcount = parseInt(document.getElementById(divstr.toString()).childNodes.length);
    childcount += getDeletedChilds(currentparentindex);
    var index = currentparentindex + "." + childcount;
    var initendpoint = createesbelement("<syn:endpoint xmlns:syn='http://ws.apache.org/ns/synapse'/>");

    if (menuStr.indexOf("WSDL") > -1) {
        var childDiv = createChildEndpointDiv("endpoints/wsdlendpoint_add.xsl", "WSDL", index, initendpoint, "true");
        if (childDiv != null && childDiv != undefined) {
            document.getElementById(divstr.toString()).appendChild(childDiv);
        }
    }
    if (menuStr.indexOf("Look") > -1) {
        var childDiv = createChildEndpointDiv("endpoints/indirect_add.xsl", "InDirect", index, initendpoint, "true");
        if (childDiv != null && childDiv != undefined) {
            document.getElementById(divstr.toString()).appendChild(childDiv);
        }
    } else if (menuStr.indexOf("Address") > -1) {
        var childDiv = createChildEndpointDiv("endpoints/addressendpoint_add.xsl", "Address", index, initendpoint, "true");
        if (childDiv != null && childDiv != undefined) {
            document.getElementById(divstr.toString()).appendChild(childDiv);
        }
    } else if (menuStr.indexOf("Fail") > -1) {
        var childDiv = createChildEndpointDiv("endpoints/failoverendpoint_add.xsl", "FailOver", index, initendpoint, "true");
        if (childDiv != null && childDiv != undefined) {
            document.getElementById(divstr.toString()).appendChild(childDiv);
        }
    } else if (menuStr.indexOf("Load") > -1) {
        var childDiv = createChildEndpointDiv("endpoints/loadbalanceendpoint_add.xsl", "LoadBalance", index, initendpoint, "true");
        if (childDiv != null && childDiv != undefined) {
            document.getElementById(divstr.toString()).appendChild(childDiv);
        }
    }
}
/**
 * Event handler for the menu items---call this when adding root-parent endpoint
 */
function onMenuItemClickToAddRoot(p_sType, p_aArgs, p_oValue) {
    var menuStr = p_oValue.toString();
    clearInLineProperties();
    var initendpoint = createesbelement("<syn:endpoint xmlns:syn='http://ws.apache.org/ns/synapse'/>");
    if (menuStr.indexOf("WSDL") > -1) {
        createRootEndpointDivOnParentPanel("endpoints/wsdlendpoint_add.xsl", "WSDL", 0, initendpoint, "addSaveEndPoint", "false");
    } else if (menuStr.indexOf("Address") > -1) {
        createRootEndpointDivOnParentPanel("endpoints/addressendpoint_add.xsl", "Address", 0, initendpoint, "addSaveEndPoint", "false");
    } else if (menuStr.indexOf("Fail") > -1) {
        createRootEndpointDivOnParentPanel("endpoints/failoverendpoint_add.xsl", "FailOver", 0, initendpoint, "addSaveEndPoint", "false");
    } else if (menuStr.indexOf("Load") > -1) {
        createRootEndpointDivOnParentPanel("endpoints/loadbalanceendpoint_add.xsl", "LoadBalance", 0, initendpoint, "addSaveEndPoint", "false");
    }
}

function onMenuItemClickToShowInNewPanel(p_sType, p_aArgs, p_oValue) {
    var divcontrol = document.getElementById("divOverPanel");
    divcontrol.innerHTML = "";
    var menuStr = p_oValue.toString();
    clearInLineProperties();
    currentanonymousfun = "annonymouseendpointadd";
    var initendpoint = createesbelement("<syn:endpoint xmlns:syn='http://ws.apache.org/ns/synapse'/>");
    if (menuStr.indexOf("WSDL") > -1) {
        createRootEndpointDiv("endpoints/wsdlendpoint_add.xsl", "WSDL", 0, initendpoint, "annonymouseendpointadd", "discardfun", "true");
    } else if (menuStr.indexOf("Address") > -1) {
        createRootEndpointDiv("endpoints/addressendpoint_add.xsl", "Address", 0, initendpoint, "annonymouseendpointadd", "discardfun", "true");
    } else if (menuStr.indexOf("Fail") > -1) {
        createRootEndpointDiv("endpoints/failoverendpoint_add.xsl", "FailOver", 0, initendpoint, "annonymouseendpointadd", "discardfun", "true");
    } else if (menuStr.indexOf("Load") > -1) {
        createRootEndpointDiv("endpoints/loadbalanceendpoint_add.xsl", "LoadBalance", 0, initendpoint, "annonymouseendpointadd", "discardfun", "true");
    } else if (menuStr.indexOf("Look") > -1) {
        createRootEndpointDiv("endpoints/indirect_add.xsl", "InDirect", 0, initendpoint, "annonymouseendpointadd", "discardfun", "true");
    }
}
function onSendMediatorMenuItemClick(p_sType, p_aArgs, p_oValue) {
    var divcontrol = document.getElementById("divOverPanel");
    divcontrol.innerHTML = "";
    var menuStr = p_oValue.toString();
    clearInLineProperties();
    var initendpoint = createesbelement("<syn:endpoint xmlns:syn='http://ws.apache.org/ns/synapse'/>");
    if (menuStr.indexOf("WSDL") > -1) {
        createRootEndpointDiv("endpoints/wsdlendpoint_add.xsl", "WSDL", 0, initendpoint, "addSendMediatorEndponit", "discardfun", "true");
    } else if (menuStr.indexOf("Address") > -1) {
        createRootEndpointDiv("endpoints/addressendpoint_add.xsl", "Address", 0, initendpoint, "addSendMediatorEndponit", "discardfun", "true");
    } else if (menuStr.indexOf("Fail") > -1) {
        createRootEndpointDiv("endpoints/failoverendpoint_add.xsl", "FailOver", 0, initendpoint, "addSendMediatorEndponit", "discardfun", "true");
    } else if (menuStr.indexOf("Load") > -1) {
        createRootEndpointDiv("endpoints/loadbalanceendpoint_add.xsl", "LoadBalance", 0, initendpoint, "addSendMediatorEndponit", "discardfun", "true");
    } else if (menuStr.indexOf("Look") > -1) {
        createRootEndpointDiv("endpoints/indirect_add.xsl", "InDirect", 0, initendpoint, "addSendMediatorEndponit", "discardfun", "true");
    }
}
function createChildEndpointDiv(xsltfilename, type, index, xmlObj, isanonymous) {
    save_state = false;
    getAvailableEndpointForIndirectEndpoint();
    addendpointindex(index, type);
    var id = index + "_div";
    var transformeddiv = document.createElement("div");
    transformeddiv.setAttribute("id", id);
    xmlObj.setAttribute("index", index);
    xmlObj.setAttribute("anonymous", isanonymous);
    if (ep_str != null && ep_str != undefined) {
        xmlObj.setAttribute("a_ep", ep_str);
    }
    processXML(xmlObj, xsltfilename, transformeddiv);
    return transformeddiv;
}
function editChildEndpointDiv(xsltfilename, type, index, xmlObj, isanonymous) {
    getAvailableEndpointForIndirectEndpoint();
    addendpointindex(index, type);
    var id = index.toString() + "_div";
    var transformeddiv = document.getElementById(id);
    xmlObj.setAttribute("index", index.toString());
    xmlObj.setAttribute("anonymous", isanonymous);
    if (ep_str != null && ep_str != undefined) {
        xmlObj.setAttribute("a_ep", ep_str);
    }
    processXML(xmlObj, xsltfilename, transformeddiv);
}
function createRootEndpointDiv(xsltfilename, type, index, xmlObj, onclickfn, discardfn, isanonymous) {
    save_state = false;
    getAvailableEndpointForIndirectEndpoint();
    isOnNewPanel = true;
    var divcontrol1 = document.getElementById("divOverPanel");
    divcontrol1.innerHTML = "";
    var divcontrol = document.getElementById("endpointPanel");
    divcontrol.innerHTML = "";
    endpointindexs = new Array();
    deletedChilds = new Array();
    addendpointindex(index, type);
    var endponitStr = "";
    if (isanonymous == 'true') {
        endponitStr += " Anonymous ";
    } else {
        endponitStr += " Named ";
    }
    endponitStr += type;
    var panelcontrol = document.createElement("div");
    panelcontrol.setAttribute("id", "panelEp");
    var id = index.toString() + "_div";
    var transformeddiv = document.createElement("div");
    transformeddiv.setAttribute("id", id.toString());
    xmlObj.setAttribute("index", index.toString());
    xmlObj.setAttribute("anonymous", isanonymous);
    if (ep_str != null && ep_str != undefined) {
        xmlObj.setAttribute("a_ep", ep_str);
    }
    var str = transformXMLToString(xmlObj, xsltfilename, transformeddiv);
    panelcontrol.innerHTML = "<div class='hd'><div class='tl'></div><span>WSO2-ESB Endpoint Editor</span><div class='tr'></div></div>"
        + "<div class='bd'><br/><div id='divAddEndpoint' style='overflow:auto;height:400px'>" + str + "</div>"
        + "<div><table style='margin-left: 150px;'><tbody><tr>"
        + "<td><input type='button' class='panelbutton_default'"
        + "onclick=" + onclickfn + "('" + type + "')  value='Save'></td><td></td>"
        + "<td><input type='button' class='panelbutton_cancel'"
        + "onclick=" + discardfn + "() value='Cancel'/></td>"
        + "</tr></tbody></table></div></div>"
        + "<div id='statusbar' class='ft'>" + endponitStr + "Endpoint</div>";
    document.getElementById("endpointPanel").appendChild(panelcontrol);
    document.getElementById("endpointPanel").style.display = "inline";
    //    panelcontrol.style.zIndex = 3;
    showPanel();
}
function createRootEndpointDivOnParentPanel(xsltfilename, type, index, xmlObj, onclickfn, isanonymous) {
    save_state = false;
    getAvailableEndpointForIndirectEndpoint()
    currentanonymousfun = null;
    isOnNewPanel = false;
    endpointindexs = new Array();
    deletedChilds = new Array();
    addendpointindex(index, type);
    var endponitStr = "";
    if (isanonymous == 'true') {
        endponitStr += " Anonymous ";
    } else {
        endponitStr += " Named ";
    }
    endponitStr += type;
    var panelcontrol = document.getElementById("divEndpoints");
    var id = index + "_div";
    var transformeddiv = document.createElement("div");
    transformeddiv.setAttribute("id", id);
    xmlObj.setAttribute("index", index);
    xmlObj.setAttribute("anonymous", isanonymous);
    if (ep_str != null && ep_str != undefined) {
        xmlObj.setAttribute("a_ep", ep_str);
    }
    var str = transformXMLToString(xmlObj, xsltfilename, transformeddiv);
    panelcontrol.innerHTML = "<div class='breadcrumb'><a title='WSO2 ESB Home' onclick='javascript:showHome(); return false;' href='#'>Home</a>&#160;&gt;&#160;<a href='#' onclick='javascript: "
        + "showEndpoints(); return false;'>Manage Endpoints</a>&#160;&gt;&#160; "
        + type + " Endpoint " + "</div>"
        + "<div class='page-main-title title-endpoints'>New " + type + " Endpoint</div>"
        + "<div class='endpointcontentPaneClass'><div id='divAddEndpoint' height:900px>" + str + "</div>"
        + "<div><table class='data-table'><tbody><tr>"
        + "<td style='width:165px;'></td><td><input type='button' class='panelbutton_default button-space'"
        + "onclick=" + onclickfn + "('" + type + "')  value='Save'>"
        + "<input type='button' class='panelbutton_next button-space'"
        + "onclick=saveendpointtoregistry('" + type + "')  value='Registry Export'>"
        + "<input type='button' class='panelbutton_cancel button-space'"
        + "onclick=discard() value='Cancel'/></td>"
        + "</tr></tbody></table></div></div></div>";
}

function saveendpointtoregistry(type) {
    registrybrowserforsave("endpointtoregistry", "dicardregistrybrowser", type, "", "savetoregistryPanel");
}

var endpointcacheableduration;
var fullFilePathEndpoint;

function endpointtoregistry(type) {
    var endpointXML = "";
    if ("Address" == type) {
        endpointXML = getXmlForAddressEndpoint();
    } else if ("WSDL" == type) {
        endpointXML = getXmlForWSDLEndpoint();
    } else if ("FailOver" == type) {
        var nameId = "endpoint_name" + endpointindexs[0].index;
        var name = document.getElementById(nameId.toString());
        if (name != null && name.value != "") {
            if (!namevalidate(name.value)) {
                esbwarning(INVALID_NAME, TYPE_INFO);
            }
            var childepstr = dataToString(type);
            if (childepstr != undefined && childepstr != null) {
                endpointXML = '<syn:endpoint name="' + name.value + '" xmlns:syn="' + SYNAPSE_NS + '">' + childepstr +
                              '</syn:endpoint>';
            }

        }
    } else if ("LoadBalance" == type) {
        var nameId = "endpoint_name" + endpointindexs[0].index;
        var name = document.getElementById(nameId.toString());
        if (name != null && name.value != "") {
            if (!namevalidate(name.value)) {
                esbwarning(INVALID_NAME, TYPE_INFO);
            }
            var childepstr = dataToString(type);
            if (childepstr != undefined && childepstr != null) {
                endpointXML = '<syn:endpoint name="' + name.value + '" xmlns:syn="' + SYNAPSE_NS + '">' + childepstr + '</syn:endpoint>'
            }
        }
    } else {
        esbwarning("Unable to decide the endpoint type", TYPE_WARN);
    }

    var endpointnametosave = document.getElementById("regKeyField").value;

    endpointcacheableduration = document.getElementById("cacheDurField").value;
    if (endpointcacheableduration != "" && isNaN(endpointcacheableduration)) {
        esbwarning("Cachable duration (Seconds) should be a valid number", TYPE_WARN);
        return;
    }
    var parentFolder = "";

    if (filetree.getSelected() != null) {
        parentFolder = filetree.getSelected();
        if (parentFolder != "") {
            fullFilePathEndpoint = parentFolder + "/" + endpointnametosave;
        }
    }

    var body_xml = '<ns1:createFile xmlns:ns1="http://org.apache.synapse/xsd">' +
                   '<file>' +
                   '<parent>' + parentFolder + '</parent>' +
                   '<fileName>' + endpointnametosave + '</fileName>' +
                   '<content>' + endpointXML + "</content>" +
                   '</file>' +
                   '</ns1:createFile>';

    var callURL = serverURL + "/" + REGISTRY_MANAGEMENT + "/" + "createFile";

    send("createFile", body_xml, "", callURL, "", false, finalizeregistrysaveEndpoint);
}

function finalizeregistrysaveEndpoint() {
    if (!onError()) {
        return;
    }
    if (endpointcacheableduration != "") {
        var body_xml = '<ns1:updateRegistryEntry xmlns:ns1="http://org.apache.synapse/xsd">' +
                       '<regEntry>' +
                       '<key>' + fullFilePathEndpoint + '</key>' +
                       '<expiryTime>' + parseInt(endpointcacheableduration) + '</expiryTime>' +
                       '</regEntry>' +
                       '</ns1:updateRegistryEntry>';

        var callURL = serverURL + "/" + REGISTRY_MANAGEMENT + "/" + "updateRegistryEntry";

        send("updateRegistryEntry", body_xml, "", callURL, "", false, finalizeEntryUpdateEndpoint);
    } else {
        dicardregistrybrowser();
        showEndpoints();
    }
}

function finalizeEntryUpdateEndpoint() {
    if (!onError()) {
        return;
    }
    dicardregistrybrowser();
    showEndpoints();
}

function showPanel() {
    var esbpanel = new YAHOO.widget.Panel("panelEp", {width:"700px", fixedcenter:true, visible:false, constraintoviewport:true });
    esbpanel.render();
    esbpanel.show();
}
function discard() {
    document.getElementById("endpointPanel").innerHTML = "";
    endpointindexs = new Array();
    deletedChilds = new Array();
    currentparentindex = 0;
    showEndpoints();
}
function getTypeOfChildWithId(id) {
    for (var i = 0; i < endpointindexs.length; i++) {
        var eprecord = endpointindexs[i];
        if (eprecord != null) {
            if (eprecord.index.toString() == id.toString()) {
                return eprecord.type
            }
        }
    }
}
function toStringSessionType(id) {
    var format = document.getElementById("lbep_session_type" + id.toString());
    var format_index = null;
    var format_value = null;
    if (format != null)
    {
        format_index = format.selectedIndex;
        if (format_index != null) {
            format_value = format.options[format_index].value;

        }
    }
    if (format_value != null && format_value != undefined && format_value != "" && format_value != "Select A Value") {
        var xml = "<syn:session";
        xml += ' type="' + format_value + '"';
        xml += " />";
        return xml;
    }
}
function dataToString(type) {
    var str = null;
    if ("FailOver" == type) {
        str = "<syn:failover>";
    } else if ("LoadBalance") {
        var session = toStringSessionType(0);
        if (session != undefined && session != null) {
            str = session;
        }
        if (str == null || str == undefined) {
            str = "";
        }
        if (str != undefined && str != null) {
            str += "<syn:loadbalance>";
        }
    }
    var topdivstr = "childEndPointsDIV" + endpointindexs[0].index ;
    var topchilds = parseInt(document.getElementById(topdivstr.toString()).childNodes.length);
    topchilds += getDeletedChilds(endpointindexs[0].index);
    for (var i = 0; i < topchilds; i++) {
        var cid = "0." + i  ;
        var ctype = getTypeOfChildWithId(cid)  ;
        if (ctype != null && ctype != undefined) {
            if (ctype == "Address") {
                var cep = getAnonymousAddressEndPointString(cid);
                if (cep != null && cep != undefined) {
                    str += cep;
                } else {
                    return;
                }
            }
            if (ctype == "WSDL") {
                var cep = getAnonymousWSDLEndPointString(cid);
                if (cep != null && cep != undefined) {
                    str += cep;
                } else {
                    return;
                }
            }
            if (ctype == "InDirect") {
                var cep = getInDirectEndPointString(cid);
                if (cep != null && cep != undefined) {
                    str += cep;
                } else {
                    return;
                }
            } else if (ctype == "FailOver") {
                var cep = getAnonymousFailOverEndPointString(cid);
                if (cep != null && cep != undefined) {
                    str += cep;
                } else {
                    return;
                }
            } else if (ctype == "LoadBalance") {
                var cep = getAnonymousLoadBalanceEndPointString(cid);
                if (cep != null && cep != undefined) {
                    str += cep;
                } else {
                    return;
                }
            }

        }
    }
    if ("FailOver" == type) {
        str += "</syn:failover>";
    } else if ("LoadBalance") {
        str += "</syn:loadbalance>";
    }

    return str;
}

function getAnonymousFailOverEndPointString(id) {
    var str = '<syn:endpoint xmlns:syn="' + SYNAPSE_NS + '" >' +
              '<syn:failover>';
    var topdivstr = "childEndPointsDIV" + id ;
    var topDiv = document.getElementById(topdivstr.toString());
    if (topDiv != null && topDiv != undefined) {
        var topChildNodes = topDiv.childNodes;
        if (topChildNodes != null && topChildNodes != undefined) {
            var topchilds = parseInt(topChildNodes.length);
            topchilds += getDeletedChilds(id);
            for (var i = 0; i < topchilds; i++) {
                var cid = id + "." + i  ;
                var ctype = getTypeOfChildWithId(cid)  ;
                if (ctype != null && ctype != undefined) {
                    if (ctype == "Address") {
                        var cep = getAnonymousAddressEndPointString(cid);
                        if (cep != null && cep != undefined) {
                            str += cep;
                        } else {
                            return;
                        }
                    }
                    if (ctype == "WSDL") {
                        var cep = getAnonymousWSDLEndPointString(cid);
                        if (cep != null && cep != undefined) {
                            str += cep;
                        } else {
                            return;
                        }
                    }
                    if (ctype == "InDirect") {
                        var cep = getInDirectEndPointString(cid);
                        if (cep != null && cep != undefined) {
                            str += cep;
                        } else {
                            return;
                        }
                    } else if (ctype == "FailOver") {
                        var cep = getAnonymousFailOverEndPointString(cid);
                        if (cep != null && cep != undefined) {
                            str += cep;
                        } else {
                            return;
                        }
                    } else if (ctype == "LoadBalance") {
                        var cep = getAnonymousLoadBalanceEndPointString(cid);
                        if (cep != null && cep != undefined) {
                            str += cep;
                        } else {
                            return;
                        }
                    }
                }
            }
        }
    }
    str += '</syn:failover>' +
           '</syn:endpoint>';
    return str;

}

function getAnonymousLoadBalanceEndPointString(id) {
    var str = '<syn:endpoint xmlns:syn="' + SYNAPSE_NS + '" >' ;
    var session = toStringSessionType(id);
    if (session != undefined && session != null) {
        str += session;
    }
    str += '<syn:loadbalance>';
    var topdivstr = "childEndPointsDIV" + id ;
    var topDiv = document.getElementById(topdivstr.toString());
    if (topDiv != null && topDiv != undefined) {
        var topChildNodes = topDiv.childNodes;
        if (topChildNodes != null && topChildNodes != undefined) {
            var topchilds = parseInt(topChildNodes.length);
            topchilds += getDeletedChilds(id);
            for (var i = 0; i < topchilds; i++) {
                var cid = id + "." + i  ;
                var ctype = getTypeOfChildWithId(cid)  ;
                if (ctype != null && ctype != undefined) {
                    if (ctype == "Address") {
                        var cep = getAnonymousAddressEndPointString(cid);
                        if (cep != null && cep != undefined) {
                            str += cep;
                        } else {
                            return;
                        }
                    }
                    if (ctype == "WSDL") {
                        var cep = getAnonymousWSDLEndPointString(cid);
                        if (cep != null && cep != undefined) {
                            str += cep;
                        } else {
                            return;
                        }
                    }
                    if (ctype == "InDirect") {
                        var cep = getInDirectEndPointString(cid);
                        if (cep != null && cep != undefined) {
                            str += cep;
                        } else {
                            return;
                        }
                    } else if (ctype == "FailOver") {
                        var cep = getAnonymousFailOverEndPointString(cid);
                        if (cep != null && cep != undefined) {
                            str += cep;
                        } else {
                            return;
                        }
                    } else if (ctype == "LoadBalance") {
                        var cep = getAnonymousLoadBalanceEndPointString(cid);
                        if (cep != null && cep != undefined) {
                            str += cep;
                        } else {
                            return;
                        }
                    }
                }
            }
        }
    }
    str += '</syn:loadbalance>' +
           '</syn:endpoint>';
    return str;

}
function getAnonymousAddressEndPointString(id) {
    var uri = document.getElementById(("endpoint_address" + id).toString());
    if (uri != null && uri.value != "") {
        var body_xml = '<syn:endpoint xmlns:syn="' + SYNAPSE_NS + '" >' +
                       '<syn:address uri="' + convertToValidXMlString(trim(uri.value)) + '"';
        var format = document.getElementById("endpoint_format" + id.toString());
        var optimize = document.getElementById("endpoint_optimize" + id.toString());
        var format_index = null;
        var format_value = null;
        if (format != null)
        {
            format_index = format.selectedIndex;
            if (format_index != null) {
                format_value = format.options[format_index].value;

            }
        }
        if (format_value != null && format_value != undefined && format_value != "" && format_value != "Select A Value") {
            if (format_value == "SOAP11") {
                format_value = "soap11";
            } else if (format_value == "SOAP12") {
                format_value = "soap12"
            } else if (format_value == "POX") {
                format_value = "pox"
            } else if (format_value == "GET") {
                format_value = "get"
            }
            body_xml += ' format="' + format_value + '"';
        }
        var optimize_index = null;
        var optimize_value = null;

        if (optimize != null)
        {
            optimize_index = optimize.selectedIndex;
            if (optimize_index != null) {
                optimize_value = optimize.options[optimize_index].value;

            }
        }
        if (optimize_value != null && optimize_value != undefined && optimize_value != "" && optimize_value != "Select A Value") {
            if (optimize_value == "MTOM") {
                optimize_value = "mtom";
            } else if (optimize_value == "SwA") {
                optimize_value = "swa"
            }
            body_xml += ' optimize="' + optimize_value + '"';
        }
        body_xml += " >";
        var suspend_duration = document.getElementById("endpoint_suspend_duration" + id.toString());
        if (suspend_duration != null && suspend_duration != undefined) {
            var tdvalue = suspend_duration.value ;
            if (tdvalue != null && tdvalue != undefined && tdvalue != "") {
                body_xml += "<syn:suspendDurationOnFailure> " + trim(tdvalue) + "</syn:suspendDurationOnFailure>";
            }
        }
        var timeout_duration = document.getElementById("endpoint_duration" + id.toString());
        var timeoutaction = document.getElementById("endpoint_timeout_action" + id.toString());
        if ((timeout_duration != null && timeout_duration != undefined) ||
            (timeoutaction != null && timeoutaction != undefined)) {
            body_xml += "<syn:timeout> ";
            if (timeout_duration != undefined && timeout_duration != null) {
                var tdvalue = timeout_duration.value;
                if (tdvalue != null && tdvalue != undefined && tdvalue != "") {
                    body_xml += "<syn:duration> " + tdvalue + "</syn:duration> ";
                }
            }
            if (timeoutaction != null && timeoutaction != undefined) {
                var action_index = timeoutaction.selectedIndex;
                if (action_index != null) {
                    var action_value = timeoutaction.options[action_index].value;
                    if (action_value != null && action_value != undefined && action_value != "Select A Value") {
                        body_xml += "<syn:action> " + action_value + "</syn:action> ";
                    }
                }
            }
            body_xml += "</syn:timeout>";
        }
        var wsAddressing = document.getElementById("wsAddressingEngaged" + id.toString());
        var separateListener = document.getElementById("separateListener" + id.toString());
        if (wsAddressing != null && wsAddressing.checked) {
            if (separateListener != null && separateListener.checked) {
                body_xml += "<syn:enableAddressing separateListener='true'/>";
            } else {
                body_xml += "<syn:enableAddressing/>"
            }
        }
        var wsRm = document.getElementById("wsRMEngaged" + id.toString());
        if (wsRm != null && wsRm.checked) {
            body_xml += "<syn:enableRM ";
            var policy_key = document.getElementById("rm_policy" + id.toString());
            var currentpolicy = getInLineProperty("rm_policy" + id.toString());
            if (currentpolicy != null && currentpolicy != undefined) {
                body_xml += ' policy="' + currentpolicy + '"';
            } else {
                if (policy_key != null && policy_key != undefined && policy_key.value != "") {
                    body_xml += ' policy="' + policy_key.value + '"';
                }
            }
            body_xml += "/>";
        }
        var wsSec = document.getElementById("wsSecEngaged" + id.toString());
        if (wsSec != null && wsSec.checked) {
            body_xml += "<syn:enableSec";
            var policy_key = document.getElementById("sec_policy" + id.toString());
            var currentpolicy = getInLineProperty("sec_policy" + id.toString());
            if (currentpolicy != null && currentpolicy != undefined) {
                body_xml += ' policy="' + currentpolicy + '"';
            } else {
                if (policy_key != null && policy_key != undefined && policy_key.value != "") {
                    body_xml += ' policy="' + policy_key.value + '"';
                }
            }
            body_xml += "/>";
        }
        body_xml += '</syn:address>' +
                    '</syn:endpoint>';
        return trim(body_xml);

    } else {
        if (save_state = true) {
            esbwarning("Invalid anonymous Address Endpoint: Address must be specified", TYPE_INFO);
            return;
        }
    }

}
function discardfun() {
    var divcontrol = document.getElementById("divOverPanel");
    if (divcontrol != undefined && divcontrol != null) {
        divcontrol.innerHTML = "";
    }
    var divcontrol1 = document.getElementById("endpointPanel");
    if (divcontrol1 != undefined && divcontrol1 != null) {
        divcontrol1.innerHTML = "";
    }
}

function getInDirectEndPointString(id) {
    var ref = document.getElementById("endpoint_key" + id.toString());
    var ref_value = null;
    if (ref != null && ref != undefined) {
        ref_value = ref.value;
    }
    var currentepkey = getInLineProperty("endpoint_key" + id.toString());
    if (currentepkey != null && currentepkey != undefined) {
        var body_xml = '<syn:endpoint xmlns:syn="' + SYNAPSE_NS + '" key="' + currentepkey + '" />';
        return body_xml;

    } else {
        if (ref_value != null && ref_value != undefined && ref_value != " ") {
            var body_xml = '<syn:endpoint xmlns:syn="' + SYNAPSE_NS + '" key="' + ref_value + '" />';
            return body_xml;
        } else {
            esbwarning("Invalid Endpoint lookup", TYPE_ERROR);
            return;
        }
    }
}
function getAnonymousWSDLEndPointString(id,type) {
    var uri = document.getElementById(("endpoint_address" + id).toString());
    var inlinewsdlstr = null;
    var body_xml = '<syn:endpoint xmlns:syn="' + SYNAPSE_NS + '" >' +
                   "<syn:wsdl ";
    var isvalid = false;
    var reasonType = document.getElementsByName("group" + id.toString());
    var reasonValueType;
    if (reasonType[0].checked) {
        reasonValueType = 0;
    } else {
        reasonValueType = 1;
    }

    if (uri != null && type != "inlined") {

        if (uri.value == "") {
            esbwarning("WSDL url must be specified ", TYPE_INFO);
            return;
        }

        body_xml += 'uri="' + uri.value + '"';
        addInLineProperties(id + "_uri", uri.value);
        isvalid = true;
    } else {
        if (state == 0 && reasonValueType != 0) {
            var wsdluri = getInLineProperty(id + "_uri");
            if (wsdluri != null && wsdluri != undefined) {
                body_xml += 'uri="' + wsdluri + '"';
                isvalid = true;
            }
        } else {
            var inlinewsdl = getInLineProperty(id);
            if (inlinewsdl != null && inlinewsdl != undefined) {
                if (browsername.indexOf(NETSCAPE_BROWSER_NAME) != -1) {
                    if (inlinewsdl instanceof Object) {
                        inlinewsdlstr = xmlSerializerToString(inlinewsdl);
                    } else {
                        inlinewsdlstr = inlinewsdl;
                    }
                } else if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
                    if (typeof inlinewsdl == typeof "string") {
                        inlinewsdlstr = inlinewsdl;
                    } else {
                        inlinewsdlstr = xmlSerializerToString(inlinewsdl);
                    }
                } else {
                    esbwarning("Unsupported browser : " + browsername, TYPE_WARN);
                    return;
                }
            }
        }
    }
    if (inlinewsdlstr != null) {
        isvalid = true;
    }
    if (!isvalid) {
        if (save_state) {
            esbwarning("Invalid anonymous WSDL Endpoint: In-lined WSDL or WSDL URI must be specified", TYPE_INFO);
            return;
        }
    }
    var format = document.getElementById("endpoint_service" + id.toString());
    var optimize = document.getElementById("endpoint_port" + id.toString());
    if (format != null && format != undefined && format.value != "") {
        body_xml += ' service="' + format.value + '"';
    } else {
        if (save_state) {
            esbwarning("Invalid anonymous WSDL Endpoint: Service must be specified", TYPE_INFO);
            return;
        }
    }
    if (optimize != null && optimize != undefined && optimize.value != "") {
        body_xml += ' port="' + optimize.value + '"';
    } else {
        if (save_state) {
            esbwarning("Invalid anonymous WSDL Endpoint: Port must be specified", TYPE_INFO);
            return;
        }
    }
    body_xml += " >";
    if (inlinewsdlstr != null) {
        body_xml += inlinewsdlstr;
    }
    var timeout_duration = document.getElementById("endpoint_duration" + id.toString());
    var timeoutaction = document.getElementById("endpoint_timeout_action" + id.toString());
    if ((timeout_duration != null && timeout_duration != undefined) ||
        (timeoutaction != null && timeoutaction != undefined)) {
        body_xml += "<syn:timeout> ";
        if (timeout_duration != undefined && timeout_duration != null) {
            var tdvalue = timeout_duration.value ;
            if (tdvalue != null && tdvalue != undefined && tdvalue != "") {
                body_xml += "<syn:duration> " + tdvalue + "</syn:duration> ";
            }
        }
        if (timeoutaction != null && timeoutaction != undefined) {
            var action_index = timeoutaction.selectedIndex;
            if (action_index != null) {
                var action_value = timeoutaction.options[action_index].value;
                if (action_value != null && action_value != undefined && action_value != "Select A Value") {
                    body_xml += "<syn:action> " + action_value + "</syn:action> ";
                }
            }
        }
        body_xml += "</syn:timeout>";
    }
    var suspend_duration = document.getElementById("endpoint_suspend_duration" + id.toString());
    if (suspend_duration != null && suspend_duration != undefined) {
        var tdvalue = suspend_duration.value ;
        if (tdvalue != null && tdvalue != undefined && tdvalue != "") {
            body_xml += "<syn:suspendDurationOnFailure> " + trim(tdvalue) + "</syn:suspendDurationOnFailure>";
        }
    }
    var wsAddressing = document.getElementById("wsAddressingEngaged" + id.toString());
    var separateListener = document.getElementById("separateListener" + id.toString());
        if (wsAddressing != null && wsAddressing.checked) {
            if (separateListener != null && separateListener.checked) {
                body_xml += "<syn:enableAddressing separateListener='true'/>";
            } else {
                body_xml += "<syn:enableAddressing/>"
            }
        }
    var wsRm = document.getElementById("wsRMEngaged" + id.toString());
    if (wsRm != null && wsRm.checked) {
        body_xml += "<syn:enableRM ";
        var policy_key = document.getElementById("rm_policy" + id.toString());
        var currentpolicy = getInLineProperty("rm_policy" + id.toString());
        if (currentpolicy != null && currentpolicy != undefined) {
            body_xml += ' policy="' + currentpolicy + '"';
        } else {
            if (policy_key != null && policy_key != undefined && policy_key.value != "") {
                body_xml += ' policy="' + policy_key.value + '"';
            }
        }
        body_xml += "/>";
    }
    var wsSec = document.getElementById("wsSecEngaged" + id.toString());
    if (wsSec != null && wsSec.checked) {
        body_xml += "<syn:enableSec";
        var policy_key = document.getElementById("sec_policy" + id.toString());
        var currentpolicy = getInLineProperty("sec_policy" + id.toString());
        if (currentpolicy != null && currentpolicy != undefined) {
            body_xml += ' policy="' + currentpolicy + '"';
        } else {
            if (policy_key != null && policy_key != undefined && policy_key.value != "") {
                body_xml += ' policy="' + policy_key.value + '"';
            }
        }
        body_xml += "/>";
    }
    body_xml += '</syn:wsdl>' +
                '</syn:endpoint>';
    return trim(body_xml);
}
function addSaveEndPoint(type) {
    state = 1;
    save_state = true;
    if ("Address" == type) {
        var addrXML = getXmlForAddressEndpoint();
        if (addrXML == undefined) {
            return;
        }
        var body_xml = '<ns1:addEndpoint xmlns:ns1="http://org.apache.synapse/xsd" xmlns:syn="' + SYNAPSE_NS + '">' ;
        body_xml += addrXML;
        body_xml += '</ns1:addEndpoint>';
        var callURL = serverURL + "/" + ENDPOINT_MANAGEMENT + "/" + "addEndpoint";
        send("addEndpoint", body_xml, "", callURL, "", false, addEndpointSaveCallback);

    }
    if ("WSDL" == type) {
        var wsdlXml = getXmlForWSDLEndpoint();
        if (wsdlXml == undefined) {
            return;
        }
        var body_xml = '<ns1:addEndpoint xmlns:ns1="http://org.apache.synapse/xsd" xmlns:syn="' + SYNAPSE_NS + '">' ;
        body_xml += wsdlXml;
        body_xml += '</ns1:addEndpoint>';
        var callURL = serverURL + "/" + ENDPOINT_MANAGEMENT + "/" + "addEndpoint";
        send("addEndpoint", body_xml, "", callURL, "", false, addEndpointSaveCallback);


    } else if ("FailOver" == type) {
        var nameId = "endpoint_name" + endpointindexs[0].index;
        var name = document.getElementById(nameId.toString());
        if (name != null && name.value != "") {
            if (!namevalidate(name.value)) {
                esbwarning(INVALID_NAME, TYPE_INFO);
                return;
            }
            var childepstr = dataToString(type);
            if (childepstr != undefined && childepstr != null) {
                var body_xml = '<ns1:addEndpoint xmlns:ns1="http://org.apache.synapse/xsd" xmlns:syn="' + SYNAPSE_NS + '">' +
                               '<syn:endpoint name="' + trim(name.value) + ' ">' + childepstr +
                               '</syn:endpoint>' +
                               '</ns1:addEndpoint>';
                var callURL = serverURL + "/" + ENDPOINT_MANAGEMENT + "/" + "addEndpoint";
                send("addEndpoint", body_xml, "", callURL, "", false, addEndpointSaveCallback);
            }
        } else {
            esbwarning("Invalid Failover Endpoint: Name must be specified", TYPE_INFO);
        }

    } else if ("LoadBalance" == type) {
        var nameId = "endpoint_name" + endpointindexs[0].index;
        var name = document.getElementById(nameId.toString());
        if (name != null && name.value != "") {
            if (!namevalidate(name.value)) {
                esbwarning(INVALID_NAME, TYPE_INFO);
                return;
            }
            var childepstr = dataToString(type);
            if (childepstr != undefined && childepstr != null) {
                var body_xml = '<ns1:addEndpoint xmlns:ns1="http://org.apache.synapse/xsd" xmlns:syn="' + SYNAPSE_NS + '">' +
                               '<syn:endpoint name="' + trim(name.value) + ' ">' + childepstr +
                               '</syn:endpoint>' +
                               '</ns1:addEndpoint>';
                var callURL = serverURL + "/" + ENDPOINT_MANAGEMENT + "/" + "addEndpoint";
                send("addEndpoint", body_xml, "", callURL, "", false, addEndpointSaveCallback);
            }
        } else {
            esbwarning("Invalid Load-balance Endpoint: Name must be specified", TYPE_INFO);
        }
    }
}

function getXmlForAddressEndpoint() {
    var name = document.getElementById("endpoint_name0");
    var uri = document.getElementById("endpoint_address0");
    if (name != null && name.value != "") {
        var value = trim(name.value);
        if (!namevalidate(value)) {
            esbwarning(INVALID_NAME, TYPE_INFO);
            return;
        }
        if (uri != null && uri.value != "") {
            var body_xml = '<syn:endpoint xmlns:syn="' + SYNAPSE_NS + '" name="' + value + '">' +
                           '<syn:address uri="' + convertToValidXMlString(trim(uri.value)) + '"';
            var format = document.getElementById("endpoint_format0");
            var format_index = null;
            var format_value = null;
            if (format != null)
            {
                format_index = format.selectedIndex;
                if (format_index != null) {
                    format_value = format.options[format_index].value;
                }
            }
            if (format_value != null && format_value != undefined && format_value != "" && format_value != "Select A Value") {
                if (format_value == "SOAP11") {
                    format_value = "soap11";
                } else if (format_value == "SOAP12") {
                    format_value = "soap12"
                } else if (format_value == "POX") {
                    format_value = "pox"
                } else if (format_value == "GET") {
                    format_value = "get"
                }
                body_xml += ' format="' + format_value + '"';
            }
            var optimize = document.getElementById("endpoint_optimize0");
            var optimize_index = null;
            var optimize_value = null;

            if (optimize != null)
            {
                optimize_index = optimize.selectedIndex;
                if (optimize_index != null) {
                    optimize_value = optimize.options[optimize_index].value;
                }
            }
            if (optimize_value != null && optimize_value != undefined && optimize_value != "" && optimize_value != "Select A Value") {
                if (optimize_value == "MTOM") {
                    optimize_value = "mtom";
                } else if (optimize_value == "SwA") {
                    optimize_value = "swa"
                }
                body_xml += ' optimize="' + optimize_value + '"';
            }
            body_xml += " >";
            var suspend_duration = document.getElementById("endpoint_suspend_duration0");
            if (suspend_duration != null && suspend_duration != undefined) {
                var tdvalue = suspend_duration.value ;
                if (tdvalue != null && tdvalue != undefined && tdvalue != "") {
                    body_xml += "<syn:suspendDurationOnFailure> " + trim(tdvalue) + "</syn:suspendDurationOnFailure>";
                }
            }
            var wsAddressing = document.getElementById("wsAddressingEngaged0");
            var separateListener = document.getElementById("separateListener0");
        if (wsAddressing != null && wsAddressing.checked) {
            if (separateListener != null && separateListener.checked) {
                body_xml += "<syn:enableAddressing separateListener='true'/>";
            } else {
                body_xml += "<syn:enableAddressing/>"
            }
        }
            var timeout_duration = document.getElementById("endpoint_duration0");
            var timeoutaction = document.getElementById("endpoint_timeout_action0");
            if ((timeout_duration != null && timeout_duration != undefined) ||
                (timeoutaction != null && timeoutaction != undefined)) {
                body_xml += "<syn:timeout> ";
                if (timeout_duration != undefined && timeout_duration != null) {
                    var tdvalue = timeout_duration.value;
                    if (tdvalue != null && tdvalue != undefined && tdvalue != "") {
                        body_xml += "<syn:duration> " + tdvalue + "</syn:duration> ";
                    }
                }
                if (timeoutaction != null && timeoutaction != undefined) {
                    var action_index = timeoutaction.selectedIndex;
                    if (action_index != null) {
                        var action_value = timeoutaction.options[action_index].value;
                        if (action_value != null && action_value != undefined && action_value != "Select A Value") {
                            body_xml += "<syn:action> " + action_value + "</syn:action> ";
                        }
                    }
                }
                body_xml += "</syn:timeout>";
            }

            var wsRm = document.getElementById("wsRMEngaged0");
            if (wsRm != null && wsRm.checked) {
                body_xml += "<syn:enableRM ";
                var currentpolicy = getInLineProperty("rm_policy0");
                if (currentpolicy != null && currentpolicy != undefined) {
                    body_xml += ' policy="' + currentpolicy + '"';
                } else {
                    var policy_key = document.getElementById("rm_policy0");
                    if (policy_key != null && policy_key != undefined && policy_key.value != "") {
                        body_xml += ' policy="' + policy_key.value + '"';
                    }
                }
                body_xml += "/>";
            }
            var wsSec = document.getElementById("wsSecEngaged0");
            if (wsSec != null && wsSec.checked) {
                body_xml += "<syn:enableSec";
                var currentpolicy = getInLineProperty("sec_policy0");
                if (currentpolicy != null && currentpolicy != undefined) {
                    body_xml += ' policy="' + currentpolicy + '"';
                } else {
                    var policy_key = document.getElementById("sec_policy0");
                    if (policy_key != null && policy_key != undefined && policy_key.value != "") {
                        body_xml += ' policy="' + policy_key.value + '"';
                    }
                }
                body_xml += "/>";
            }
            body_xml += '</syn:address>' +
                        '</syn:endpoint>';
            return trim(body_xml);
        } else {
            if (save_state = true) {
                esbwarning("Invalid Address Endpoint: URI must be specified", TYPE_INFO);
                return;
            }
        }

    } else {
        if (save_state = true) {
            esbwarning("Invalid Address Endpoint: Name must be specified", TYPE_INFO);
            return;
        }
    }

}
function getXmlForWSDLEndpoint(type) {
    var name = document.getElementById("endpoint_name0");
    var uri = document.getElementById("endpoint_address0");
    if (name != null && name.value != "") {
        if (!namevalidate(name.value)) {
            esbwarning(INVALID_NAME, TYPE_INFO);
            return;
        }
        var inlinewsdlstr = null;
        var body_xml = '<syn:endpoint xmlns:syn="' + SYNAPSE_NS + '" name="' + trim(name.value) + '">' +
                       "<syn:wsdl ";
        var isvalid = false;
        var reasonType = document.getElementsByName("group0");
        var reasonValueType;
        if (reasonType[0].checked) {
            reasonValueType = 0;
        } else {
            reasonValueType = 1;
        }
        if (uri != null && type != "inlined") {
            if (uri.value == "") {
                esbwarning("WSDL url must be specified ", TYPE_INFO);
                return;
            }
            body_xml += 'uri="' + uri.value + '"';
            isvalid = true;
            addInLineProperties("0_uri", uri.value);
        } else {
            if (state == 0 && reasonValueType != 0) {
                var wsdluri = getInLineProperty("0_uri");
                if (wsdluri != null && wsdluri != undefined) {
                    body_xml += 'uri="' + wsdluri + '"';
                    isvalid = true;
                }
            } else {

                var inlinewsdl = getInLineProperty(0);
                if (inlinewsdl != null && inlinewsdl != undefined) {
                    if (browsername.indexOf(NETSCAPE_BROWSER_NAME) != -1) {
                        if (inlinewsdl instanceof Object) {
                            inlinewsdlstr = xmlSerializerToString(inlinewsdl);
                        } else {
                            inlinewsdlstr = inlinewsdl;
                        }
                    } else if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
                        if (typeof inlinewsdl == typeof "string") {
                            inlinewsdlstr = inlinewsdl;
                        } else {
                            inlinewsdlstr = xmlSerializerToString(inlinewsdl);
                        }
                    } else {
                        esbwarning("Unsupported browser: " + browsername, TYPE_WARN);
                        return;
                    }
                }
            }
        }
        if (inlinewsdlstr != null) {
            isvalid = true;
        }
        if (!isvalid) {
            if (save_state) {
                esbwarning("Invalid WSDL EndPoint: In-lined WSDL or WSDL URI must be specified", TYPE_INFO);
                return;
            }
        }
        var format = document.getElementById("endpoint_service0");
        var optimize = document.getElementById("endpoint_port0");

        if (format != null && format != undefined && format.value != "") {
            body_xml += ' service="' + format.value + '"';
        } else {
            if (save_state) {
                esbwarning("Invalid WSDL Endpoint: Service must be specified", TYPE_INFO);
                return;
            }
        }
        if (optimize != null && optimize != undefined && optimize.value != "") {
            body_xml += ' port="' + optimize.value + '"';
        } else {
            if (save_state) {
                esbwarning("Invalid WSDL Endpoint: Port must be specified", TYPE_INFO);
                return;
            }
        }
        body_xml += " >";
        if (inlinewsdlstr != null) {
            body_xml += inlinewsdlstr;
        }
        var timeout_duration = document.getElementById("endpoint_duration0");
        var timeoutaction = document.getElementById("endpoint_timeout_action0");
        if ((timeout_duration != null && timeout_duration != undefined) ||
            (timeoutaction != null && timeoutaction != undefined)) {
            body_xml += "<syn:timeout> ";
            if (timeout_duration != undefined && timeout_duration != null) {
                var tdvalue = timeout_duration.value ;
                if (tdvalue != null && tdvalue != undefined && tdvalue != "") {
                    body_xml += "<syn:duration> " + tdvalue + "</syn:duration> ";
                }
            }
            if (timeoutaction != null && timeoutaction != undefined) {
                var action_index = timeoutaction.selectedIndex;
                if (action_index != null) {
                    var action_value = timeoutaction.options[action_index].value;
                    if (action_value != null && action_value != undefined && action_value != "Select A Value") {
                        body_xml += "<syn:action> " + action_value + "</syn:action> ";
                    }
                }
            }
            body_xml += "</syn:timeout>";
        }
        var suspend_duration = document.getElementById("endpoint_suspend_duration0");
        if (suspend_duration != null && suspend_duration != undefined) {
            var tdvalue = suspend_duration.value ;
            if (tdvalue != null && tdvalue != undefined && tdvalue != "") {
                body_xml += "<syn:suspendDurationOnFailure> " + trim(tdvalue) + "</syn:suspendDurationOnFailure>";
            }
        }
        var wsAddressing = document.getElementById("wsAddressingEngaged0");
        var separateListener = document.getElementById("separateListener0");
        if (wsAddressing != null && wsAddressing.checked) {
            if (separateListener != null && separateListener.checked) {
                body_xml += "<syn:enableAddressing separateListener='true'/>";
            } else {
                body_xml += "<syn:enableAddressing/>"
            }
        }
        var wsRm = document.getElementById("wsRMEngaged0");
        if (wsRm != null && wsRm.checked) {
            body_xml += "<syn:enableRM ";
            var policy_key = document.getElementById("rm_policy0");
            var currentpolicy = getInLineProperty("rm_policy0");
            if (currentpolicy != null && currentpolicy != undefined) {
                body_xml += ' policy="' + currentpolicy + '"';
            } else {
                if (policy_key != null && policy_key != undefined && policy_key.value != "") {
                    body_xml += ' policy="' + policy_key.value + '"';
                }
            }
            body_xml += "/>";
        }
        var wsSec = document.getElementById("wsSecEngaged0");
        if (wsSec != null && wsSec.checked) {
            body_xml += "<syn:enableSec";
            var policy_key = document.getElementById("sec_policy0");
            var currentpolicy = getInLineProperty("sec_policy0");
            if (currentpolicy != null && currentpolicy != undefined) {
                body_xml += ' policy="' + currentpolicy + '"';
            } else {
                if (policy_key != null && policy_key != undefined && policy_key.value != "") {
                    body_xml += ' policy="' + policy_key.value + '"';
                }
            }
            body_xml += "/>";
        }
        body_xml += '</syn:wsdl>' +
                    '</syn:endpoint>';
        return trim(body_xml);
    }
    else
    {
        if (save_state) {
            esbwarning("Invalid WSDL Endpoint: Name must be specified", TYPE_INFO);
            return;
        }
    }

}
function saveEndPoint(type) {
    state = 1;
    save_state = true;
    if ("Address" == type) {
        var addrXML = getXmlForAddressEndpoint();
        if (addrXML == undefined) {
            return;
        }
        var body_xml = '<ns1:saveEndpoint xmlns:ns1="http://org.apache.synapse/xsd" xmlns:syn="' + SYNAPSE_NS + '">' ;
        body_xml += addrXML;
        body_xml += '</ns1:saveEndpoint>';

        var callURL = serverURL + "/" + ENDPOINT_MANAGEMENT + "/" + "saveEndpoint";
        send("saveEndpoint", body_xml, "", callURL, "", false, addEndpointSaveCallback);

    }
    if ("WSDL" == type) {
        var wsdlXml = getXmlForWSDLEndpoint();
        if (wsdlXml == undefined) {
            return;
        }
        var body_xml = '<ns1:saveEndpoint xmlns:ns1="http://org.apache.synapse/xsd" xmlns:syn="' + SYNAPSE_NS + '">' ;
        body_xml += wsdlXml;
        body_xml += '</ns1:saveEndpoint>';
        var callURL = serverURL + "/" + ENDPOINT_MANAGEMENT + "/" + "saveEndpoint";
        send("saveEndpoint", body_xml, "", callURL, "", false, addEndpointSaveCallback);
        // ruwan
    } else if ("FailOver" == type) {
        var nameId = "endpoint_name" + endpointindexs[0].index;
        var name = document.getElementById(nameId.toString());
        if (name != null && name.value != "") {
            var childepstr = dataToString(type);
            if (childepstr != undefined && childepstr != null) {
                var value = trim(name.value);
                if (!namevalidate(value)) {
                    esbwarning(INVALID_NAME, TYPE_INFO);
                    return;
                }
                var body_xml = '<ns1:saveEndpoint xmlns:ns1="http://org.apache.synapse/xsd" xmlns:syn="' + SYNAPSE_NS + '">' +
                               '<syn:endpoint name="' + value + ' ">' + childepstr +
                               '</syn:endpoint>' +
                               '</ns1:saveEndpoint>';
                var callURL = serverURL + "/" + ENDPOINT_MANAGEMENT + "/" + "saveEndpoint";
                send("saveEndpoint", body_xml, "", callURL, "", false, addEndpointSaveCallback);
            }
        } else {
            esbwarning("Invalid Failover Endpoint: Name must be specified", TYPE_INFO);
        }
    } else if ("LoadBalance" == type) {
        var nameId = "endpoint_name" + endpointindexs[0].index;
        var name = document.getElementById(nameId.toString());
        if (name != null && name.value != "") {
            var childepstr = dataToString(type);
            if (childepstr != undefined && childepstr != null) {
                var value = trim(name.value);
                if (!namevalidate(value)) {
                    esbwarning(INVALID_NAME, TYPE_INFO);
                    return;
                }
                var body_xml = '<ns1:saveEndpoint xmlns:ns1="http://org.apache.synapse/xsd" xmlns:syn="' + SYNAPSE_NS + '">' +
                               '<syn:endpoint name="' + value + ' ">' + childepstr +
                               '</syn:endpoint>' +
                               '</ns1:saveEndpoint>';
                var callURL = serverURL + "/" + ENDPOINT_MANAGEMENT + "/" + "saveEndpoint";
                send("saveEndpoint", body_xml, "", callURL, "", false, addEndpointSaveCallback);
            }

        } else {
            esbwarning("Invalid Load-balance Endpoint: Name must be specified", TYPE_INFO);
        }
    }
}

function getXmlForAnonymousEndpoint(type) {
    state = 1;
    if ("Address" == type) {
        var addrXML = getAnonymousAddressEndPointString(0);
        if (addrXML == undefined || addrXML == null) {
            return;
        }
        return addrXML;
    }
    if ("WSDL" == type) {
        var wsdlXml = getAnonymousWSDLEndPointString(0);
        if (wsdlXml == undefined || wsdlXml == null) {
            return;
        }
        return wsdlXml;
    } else if ("FailOver" == type) {
        return getAnonymousFailOverEndPointString(0);

    } else if ("LoadBalance" == type) {
        return getAnonymousLoadBalanceEndPointString(0);
    } else if ("InDirect" == type) {
        return getInDirectEndPointString(0);
    }
}
function showEndpoints() {
    var body_xml = '<ns1:endpointDataRequest xmlns:ns1="http://org.apache.synapse/xsd">' +
                   '</ns1:endpointDataRequest>';

    var callURL = serverURL + "/" + ENDPOINT_MANAGEMENT + "/" + "endpointData";
    send("endpointData", body_xml, "", callURL, "", false, showEndpointsCallback);

}

function deleteEndpoint(endpointName) {
    var body_xml = '<ns1:deleteEndpoint xmlns:ns1="http://org.apache.synapse/xsd">' +
                   '<ns1:endpointName>' + endpointName + '</ns1:endpointName>' +
                   '</ns1:deleteEndpoint>';

    var callURL = serverURL + "/" + ENDPOINT_MANAGEMENT + "/" + "deleteEndpoint";
    send("deleteEndpoint", body_xml, "", callURL, "", false, commonEndpointCallback);

}

function commonEndpointCallback() {
    if (!onError()) {
        return;
    }
    showEndpoints();
}

function showEndpointsCallback() {
    if (!onError()) {
        return;
    }
    callbackhelper("endpoints.xsl", document.getElementById("divEndpoints"));
}

function anonymousaddendpoint(args, param, value) {
    epmode = 0;
    if (epaddanonymouse == null) {
        epaddanonymouse = new YAHOO.widget.Menu("addanonymouseendpointmenu", {});
    }
    epaddanonymouse.clearContent();
    var menuItems = epaddanonymouse.addItems(anonymousendpointstypes);
    epaddanonymouse.render(document.getElementById("divOverMenu"));
    document.getElementById("divOverMenu").style.display = "inline";
    document.getElementById("divOverMenu").style.left = value.event.clientX;
    document.getElementById("divOverMenu").style.top = document.body.scrollTop + value.event.clientY;
    epaddanonymouse.show();
}

function addEndpoint(event) {
    epmode = 0;
    var objDiv = document.getElementById("divAddEndpoint");
    if (epadd == null) {
        epadd = new YAHOO.widget.Menu("addendpointmenu", {});
    }
    epadd.clearContent();
    var menuItems = epadd.addItems(endpointstypes);
    epadd.render(document.getElementById("divOverMenu"));
    document.getElementById("divOverMenu").style.display = "inline";
    document.getElementById("divOverMenu").style.left = event.clientX;
    document.getElementById("divOverMenu").style.top = document.body.scrollTop + event.clientY;
    epadd.show();
}
var currentanonymousfun = null;
function addSendMediatorEndpointmenu(event, position) {
    currentanonymousfun = "addSendMediatorEndponit";
    sendmediator_c_pos = position;
    epmode = 0;
    var objDiv = document.getElementById("divAddEndpoint");
    if (epadd == null) {
        epadd = new YAHOO.widget.Menu("addsendmediatorendpointmenu", {});
    }
    epadd.clearContent();
    var menuItems = epadd.addItems(anonymousendpointstypes_send);
    epadd.render(document.getElementById("divOverMenu"));
    document.getElementById("divOverMenu").style.display = "inline";
    document.getElementById("divOverMenu").style.left = event.clientX;
    document.getElementById("divOverMenu").style.top = document.body.scrollTop + event.clientY;
    epadd.show();
}
function addChildEndpoint(event, parentindex) {
    currentparentindex = parentindex;
    var objDiv = document.getElementById("divAddEndpoint");
    if (childepadd == null) {
        childepadd = new YAHOO.widget.Menu("addendpointchildmenu", {});
    }
    childepadd.clearContent();
    var menuItems = childepadd.addItems(childendpointstypes);
    childepadd.render(document.getElementById("divOverMenu"));
    document.getElementById("divOverMenu").style.display = "inline";
    document.getElementById("divOverMenu").style.left = event.clientX;
    document.getElementById("divOverMenu").style.top = document.body.scrollTop + event.clientY;
    childepadd.show();
}


function showPolicyChange() {
    showPolicyChanges(1);
}
function addEndpointSaveCallback() {
    if (!onError()) {
        return;
    }
    showEndpoints();
}

function editEndpoint(endpointName) {
    var body_xml = '<ns1:getEndpoint xmlns:ns1="http://org.apache.synapse/xsd">' +
                   '<ns1:endpointName>' + endpointName + '</ns1:endpointName>' +
                   '</ns1:getEndpoint>';
    var callURL = serverURL + "/" + ENDPOINT_MANAGEMENT + "/" + "getEndpoint";
    send("getEndpoint", body_xml, "", callURL, "", false, editEndpointCallback);
}

function editEndpointCallback() {
    if (!onError()) {
        return;
    }
    epmode = 1;
    var data = getBody(xhReq.responseXML);
    var eps = getNodeFromPath("return", data);
    var childs = eps.getElementsByTagName("endpoints").length;
    clearInLineProperties();
    if (childs == 0) {
        var typeEle = eps.getElementsByTagName("type");
        var type = null;
        if (browsername.indexOf(NETSCAPE_BROWSER_NAME) != -1) {
            type = typeEle[0].textContent;
        }
        else if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
            type = typeEle[0].text;
        }

        if (type == 0) {
            createRootEndpointDivOnParentPanel("endpoints/addressendpoint_edit.xsl", "Address", 0, eps, "saveEndPoint", "false");
        }
        if (type == 1) {
            var wsdlelement = null;
            var limit = eps.childNodes.length;
            for (var n = 0; n < limit; n++) {
                if (eps.childNodes[n].nodeName == "wsdl:definitions" || eps.childNodes[n].nodeName == "wsdl20:description") {
                    wsdlelement = eps.childNodes[n];
                }
            }
            if (wsdlelement != null && wsdlelement != undefined) {
                addInLineProperties(0, wsdlelement);
            }
            createRootEndpointDivOnParentPanel("endpoints/wsdlendpoint_edit.xsl", "WSDL", 0, eps, "saveEndPoint", "false");
        } else if (type == 2) {
            createRootEndpointDivOnParentPanel("endpoints/failoverendpoint_edit.xsl", "FailOver", 0, eps, "saveEndPoint", "false");
        } else if (type == 3) {
            createRootEndpointDivOnParentPanel("endpoints/loadbalanceendpoint_edit.xsl", "LoadBalance", 0, eps, "saveEndPoint", "false");
        }
    } else {
        var cnodes = eps.childNodes.length ;
        var type = null;
        var childDivs = new Array();
        for (var i = 0; i < cnodes; i++) {
            if (eps.childNodes[i].nodeName == "type") {
                if (browsername.indexOf(NETSCAPE_BROWSER_NAME) != -1) {
                    type = eps.childNodes[i].textContent;
                }
                else if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
                    type = eps.childNodes[i].text;
                }
            }
            if (eps.childNodes[i].nodeName == "endpoints") {
                childDivs[childDivs.length] = eps.childNodes[i];
            }
        }
        if (type == 2) {
            createRootEndpointDivOnParentPanel("endpoints/failoverendpoint_edit.xsl", "FailOver", 0, eps, "saveEndPoint", "false");
            addChildEndPointDiv(0, childDivs);
        }
        if (type == 3) {
            createRootEndpointDivOnParentPanel("endpoints/loadbalanceendpoint_edit.xsl", "LoadBalance", 0, eps, "saveEndPoint", "false");
            addChildEndPointDiv(0, childDivs);
        }
    }
}
function removeEndpoint(position) {
    deleteSendMediatorEndponit(position);
}
function convertToEndpoint(position) {
    var ep = getCurrentendpointObejct(position);
    if (ep == undefined || ep == null) {
        return;
    }
    clearnodepositions(ep);
    var body_xml = '<ns1:convertToEndpointData xmlns:ns1="http://org.apache.synapse/xsd">' +
                   xmlSerializerToString(ep) +
                   '</ns1:convertToEndpointData>';
    var callURL = serverURL + "/" + ENDPOINT_MANAGEMENT + "/" + "convertToEndpointData";
    send("convertToEndpointData", body_xml, "", callURL, "", false, convertToEndpointCallback);
}

function showepOnEditMode(ep) {
    var body_xml = '<ns1:convertToEndpointData xmlns:ns1="http://org.apache.synapse/xsd">' +
                   xmlSerializerToString(ep) +
                   '</ns1:convertToEndpointData>';
    var callURL = serverURL + "/" + ENDPOINT_MANAGEMENT + "/" + "convertToEndpointData";
    send("convertToEndpointData", body_xml, "", callURL, "", false, convertToEndpointprxoyCallback);
}

function showepOnEditModeForRegistry(ep) {
    var body_xml = '<ns1:convertToEndpointData xmlns:ns1="http://org.apache.synapse/xsd">' +
                   xmlSerializerToString(ep) +
                   '</ns1:convertToEndpointData>';
    var callURL = serverURL + "/" + ENDPOINT_MANAGEMENT + "/" + "convertToEndpointData";
    send("convertToEndpointData", body_xml, "", callURL, "", false, convertToEndpointCallbackForRegistry);
}

function convertToEndpointprxoyCallback() {
    if (!onError()) {
        return;
    }
    epmode = 1;
    currentanonymousfun = "saveproxyEndponit";
    var data = getBody(xhReq.responseXML);
    var eps = getNodeFromPath("return", data);
    var childs = eps.getElementsByTagName("endpoints").length;
    clearInLineProperties();
    if (childs == 0) {
        var typeEle = eps.getElementsByTagName("type");
        var type = null;
        if (browsername.indexOf(NETSCAPE_BROWSER_NAME) != -1) {
            type = typeEle[0].textContent;
        }
        else if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
            type = typeEle[0].text;
        }
        if (type == 0) {
            createRootEndpointDiv("endpoints/addressendpoint_edit.xsl", "Address", 0, eps, "saveproxyEndponit", "discardsendepsave", "true");
        }
        if (type == 4) {
            createRootEndpointDiv("endpoints/indirect_edit.xsl", "InDirect", 0, eps, "saveproxyEndponit", "discardsendepsave", "true");
        }
        if (type == 1) {
            var wsdlelement = null;
            var limit = eps.childNodes.length;
            for (var n = 0; n < limit; n++) {
                if (eps.childNodes[n].nodeName == "wsdl:definitions" || eps.childNodes[n].nodeName == "wsdl20:description") {
                    wsdlelement = eps.childNodes[n];
                }
            }
            if (wsdlelement != null && wsdlelement != undefined) {
                addInLineProperties(0, wsdlelement);
            }
            createRootEndpointDiv("endpoints/wsdlendpoint_edit.xsl", "WSDL", 0, eps, "saveproxyEndponit", "discardsendepsave", "true");
        } else if (type == 2) {
            createRootEndpointDiv("endpoints/failoverendpoint_edit.xsl", "FailOver", 0, eps, "saveproxyEndponit", "discardsendepsave", "true");
        } else if (type == 3) {
            createRootEndpointDiv("endpoints/loadbalanceendpoint_edit.xsl", "LoadBalance", 0, eps, "saveproxyEndponit", "discardsendepsave", "true");
        }
    } else {
        var cnodes = eps.childNodes.length ;
        var type = null;
        var childDivs = new Array();
        for (var i = 0; i < cnodes; i++) {
            if (eps.childNodes[i].nodeName == "type") {
                if (browsername.indexOf(NETSCAPE_BROWSER_NAME) != -1) {
                    type = eps.childNodes[i].textContent;
                }
                else if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
                    type = eps.childNodes[i].text;
                }
            }
            if (eps.childNodes[i].nodeName == "endpoints") {
                childDivs[childDivs.length] = eps.childNodes[i];
            }
        }
        if (type == 2) {
            createRootEndpointDiv("endpoints/failoverendpoint_edit.xsl", "FailOver", 0, eps, "saveproxyEndponit", "discardsendepsave", "true");
            addChildEndPointDiv(0, childDivs);
        }
        if (type == 3) {
            createRootEndpointDiv("endpoints/loadbalanceendpoint_edit.xsl", "LoadBalance", 0, eps, "saveproxyEndponit", "discardsendepsave", "true");
            addChildEndPointDiv(0, childDivs);
        }
    }
}

function convertToEndpointCallback() {
    if (!onError()) {
        return;
    }
    epmode = 1;
    currentanonymousfun = "saveSendMediatorEndponit";
    var data = getBody(xhReq.responseXML);
    var eps = getNodeFromPath("return", data);
    var childs = eps.getElementsByTagName("endpoints").length;
    clearInLineProperties();
    if (childs == 0) {
        var typeEle = eps.getElementsByTagName("type");
        var type = null;
        if (browsername.indexOf(NETSCAPE_BROWSER_NAME) != -1) {
            type = typeEle[0].textContent;
        }
        else if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
            type = typeEle[0].text;
        }
        if (type == 0) {
            createRootEndpointDiv("endpoints/addressendpoint_edit.xsl", "Address", 0, eps, "saveSendMediatorEndponit", "discardsendepsave", "true");
        }
        if (type == 4) {
            createRootEndpointDiv("endpoints/indirect_edit.xsl", "InDirect", 0, eps, "saveSendMediatorEndponit", "discardsendepsave", "true");
        }
        if (type == 1) {
            var wsdlelement = null;
            var limit = eps.childNodes.length;
            for (var n = 0; n < limit; n++) {
                if (eps.childNodes[n].nodeName == "wsdl:definitions" || eps.childNodes[n].nodeName == "wsdl20:description") {
                    wsdlelement = eps.childNodes[n];
                }
            }
            if (wsdlelement != null && wsdlelement != undefined) {
                addInLineProperties(0, wsdlelement);
            }
            createRootEndpointDiv("endpoints/wsdlendpoint_edit.xsl", "WSDL", 0, eps, "saveSendMediatorEndponit", "discardsendepsave", "true");
        } else if (type == 2) {
            createRootEndpointDiv("endpoints/failoverendpoint_edit.xsl", "FailOver", 0, eps, "saveSendMediatorEndponit", "discardsendepsave", "true");
        } else if (type == 3) {
            createRootEndpointDiv("endpoints/loadbalanceendpoint_edit.xsl", "LoadBalance", 0, eps, "saveSendMediatorEndponit", "discardsendepsave", "true");
        }
    } else {
        var cnodes = eps.childNodes.length ;
        var type = null;
        var childDivs = new Array();
        for (var i = 0; i < cnodes; i++) {
            if (eps.childNodes[i].nodeName == "type") {
                if (browsername.indexOf(NETSCAPE_BROWSER_NAME) != -1) {
                    type = eps.childNodes[i].textContent;
                }
                else if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
                    type = eps.childNodes[i].text;
                }
            }
            if (eps.childNodes[i].nodeName == "endpoints") {
                childDivs[childDivs.length] = eps.childNodes[i];
            }
        }
        if (type == 2) {
            createRootEndpointDiv("endpoints/failoverendpoint_edit.xsl", "FailOver", 0, eps, "saveSendMediatorEndponit", "discardsendepsave", "true");
            addChildEndPointDiv(0, childDivs);
        }
        if (type == 3) {
            createRootEndpointDiv("endpoints/loadbalanceendpoint_edit.xsl", "LoadBalance", 0, eps, "saveSendMediatorEndponit", "discardsendepsave", "true");
            addChildEndPointDiv(0, childDivs);
        }
    }
}

function convertToEndpointCallbackForRegistry() {
    if (!onError()) {
        return;
    }
    epmode = 1;
    currentanonymousfun = "saveEndpointForRegistry";
    var data = getBody(xhReq.responseXML);
    var eps = getNodeFromPath("return", data);
    var childs = eps.getElementsByTagName("endpoints").length;
    clearInLineProperties();
    if (childs == 0) {
        var typeEle = eps.getElementsByTagName("type");
        var type = null;
        if (browsername.indexOf(NETSCAPE_BROWSER_NAME) != -1) {
            type = typeEle[0].textContent;
        }
        else if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
            type = typeEle[0].text;
        }
        if (type == 0) {
            createRootEndpointDiv("endpoints/addressendpoint_edit.xsl", "Address", 0, eps, "saveEndpointForRegistry", "discardsendepsave", "true");
        }
        if (type == 4) {
            createRootEndpointDiv("endpoints/indirect_edit.xsl", "InDirect", 0, eps, "saveEndpointForRegistry", "discardsendepsave", "true");
        }
        if (type == 1) {
            var wsdlelement = null;
            var limit = eps.childNodes.length;
            for (var n = 0; n < limit; n++) {
                if (eps.childNodes[n].nodeName == "wsdl:definitions" || eps.childNodes[n].nodeName == "wsdl20:description") {
                    wsdlelement = eps.childNodes[n];
                }
            }
            if (wsdlelement != null && wsdlelement != undefined) {
                addInLineProperties(0, wsdlelement);
            }
            createRootEndpointDiv("endpoints/wsdlendpoint_edit.xsl", "WSDL", 0, eps, "saveEndpointForRegistry", "discardsendepsave", "true");
        } else if (type == 2) {
            createRootEndpointDiv("endpoints/failoverendpoint_edit.xsl", "FailOver", 0, eps, "saveEndpointForRegistry", "discardsendepsave", "true");
        } else if (type == 3) {
            createRootEndpointDiv("endpoints/loadbalanceendpoint_edit.xsl", "LoadBalance", 0, eps, "saveEndpointForRegistry", "discardsendepsave", "true");
        }
    } else {
        var cnodes = eps.childNodes.length ;
        var type = null;
        var childDivs = new Array();
        for (var i = 0; i < cnodes; i++) {
            if (eps.childNodes[i].nodeName == "type") {
                if (browsername.indexOf(NETSCAPE_BROWSER_NAME) != -1) {
                    type = eps.childNodes[i].textContent;
                }
                else if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
                    type = eps.childNodes[i].text;
                }
            }
            if (eps.childNodes[i].nodeName == "endpoints") {
                childDivs[childDivs.length] = eps.childNodes[i];
            }
        }
        if (type == 2) {
            createRootEndpointDiv("endpoints/failoverendpoint_edit.xsl", "FailOver", 0, eps, "saveEndpointForRegistry", "discardsendepsave", "true");
            addChildEndPointDiv(0, childDivs);
        }
        if (type == 3) {
            createRootEndpointDiv("endpoints/loadbalanceendpoint_edit.xsl", "LoadBalance", 0, eps, "saveEndpointForRegistry", "discardsendepsave", "true");
            addChildEndPointDiv(0, childDivs);
        }
    }
}

function saveEndpointForRegistry(type) {
    var currentepobj = getXmlForAnonymousEndpoint(type);
    var currentpath = regTree.getSelected();
    if (currentpath == null || currentpath == undefined) {
        esbwarning("null entity", TYPE_ERROR);
        return;
    }
    if (currentpath == "") {
        esbwarning("Please select an item first", TYPE_ERROR);
        return;
    }
    editFilePath = currentpath;

    var body_xml = '<ns1:updateRegistryEntryValue xmlns:ns1="http://org.apache.synapse/xsd">' +
                   '<regEntry>' +
                   '<key>' + currentpath + '</key>' +
                   '<value>' + currentepobj + '</value>' +
                   '</regEntry>' +
                   '</ns1:updateRegistryEntryValue>';

    var callURL = serverURL + "/" + REGISTRY_MANAGEMENT + "/" + "updateRegistryEntryValue";

    send("updateRegistryEntryValue", body_xml, "", callURL, "", false, editRegistryEndpointFileCallback);

}

function editRegistryEndpointFileCallback() {
    if (!onError()) {
        return;
    }
    discardsendepsave();
    resetRegistryDisplay();
    regTree.fillAndExpand(editFilePath);
}


function addChildEndPointDiv(pindex, childeps) {
    if (childeps != null && childeps != undefined) {
        var cnodes = childeps.length;
        for (var i = 0; i < cnodes; i++) {
            var cep = childeps[i];
            if (cep != null && cep != undefined) {
                var nextceps = cep.childNodes.length ;
                var type = null;
                var childDivs = new Array();
                for (var j = 0; j < nextceps; j++) {
                    if (cep.childNodes[j].nodeName == "type") {
                        if (browsername.indexOf(NETSCAPE_BROWSER_NAME) != -1) {
                            type = cep.childNodes[j].textContent;
                        }
                        else if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
                            type = cep.childNodes[j].text;
                        }
                    }
                    if (cep.childNodes[j].nodeName == "endpoints") {
                        childDivs[childDivs.length] = cep.childNodes[j];
                    }
                }
                var k = parseInt(i);
                var index = pindex + "." + k;
                var divstr = "childEndPointsDIV" + pindex;
                if (type == 2) {
                    var childDiv = createChildEndpointDiv("endpoints/failoverendpoint_edit.xsl", "FailOver", index, cep, "true");
                    if (childDiv != null && childDiv != undefined) {
                        document.getElementById(divstr.toString()).appendChild(childDiv);
                    }
                    addChildEndPointDiv(index, childDivs);
                }
                if (type == 3) {
                    var childDiv = createChildEndpointDiv("endpoints/loadbalanceendpoint_edit.xsl", "LoadBalance", index, cep, "true");
                    if (childDiv != null && childDiv != undefined) {
                        document.getElementById(divstr.toString()).appendChild(childDiv);
                    }
                    addChildEndPointDiv(index, childDivs);
                }
                if (type == 0) {
                    var childDiv = createChildEndpointDiv("endpoints/addressendpoint_edit.xsl", "Address", index, cep, "true");
                    if (childDiv != null && childDiv != undefined) {
                        document.getElementById(divstr.toString()).appendChild(childDiv);
                    }
                }
                if (type == 1) {
                    var wsdlelement = null;
                    var limit = cep.childNodes.length;
                    for (var n = 0; n < limit; n++) {
                        if (cep.childNodes[n].nodeName == "wsdl:definitions" || cep.childNodes[n].nodeName == "wsdl20:description") {
                            wsdlelement = cep.childNodes[n];
                        }
                    }
                    if (wsdlelement != null && wsdlelement != undefined) {
                        addInLineProperties(index, wsdlelement);
                    }
                    var childDiv = createChildEndpointDiv("endpoints/wsdlendpoint_edit.xsl", "WSDL", index, cep, "true");
                    if (childDiv != null && childDiv != undefined) {
                        document.getElementById(divstr.toString()).appendChild(childDiv);
                    }
                }
                if (type == 4) {
                    var childDiv = createChildEndpointDiv("endpoints/indirect_edit.xsl", "InDirect", index, cep, "true");
                    if (childDiv != null && childDiv != undefined) {
                        document.getElementById(divstr.toString()).appendChild(childDiv);
                    }
                }
            }
        }
    }
}
function editEndpointSaveCallback() {
    if (!onError()) {
        return;
    }
    showEndpoints();
}

function getAvailableEndpointForIndirectEndpoint() {
    var body_xml = '<ns1:getAvailabelEndpoints xmlns:ns1="http://org.apache.synapse/xsd">' +
                   '</ns1:getAvailabelEndpoints>';
    var callURL = serverURL + "/" + PROXY_ADMIN + "/" ;
    send("getAvailabelEndpoints", body_xml, "", callURL, "", false, getAvailableEndpointForIndirectEndpointcallback);
}
;

function getAvailableEndpointForIndirectEndpointcallback() {
    if (!onError()) {
        return;
    }
    var ep = xhReq.responseXML.getElementsByTagName("return");
    var epstring = "";
    for (i = 0; i < ep.length; i++) {
        if (ep[i].firstChild.text != undefined) {
            epstring += ep[i].firstChild.text + " ";
        } else {
            epstring += ep[i].firstChild.textContent + " ";
        }
    }
    ep_str = epstring;
}

function policyfromregistry(index, type, eptype, anonymous) {
    iscurrentepanonymouse = anonymous != undefined && anonymous != null && anonymous == "true";
    var panelId = ("mypanel" + index).toString();
    if (type == "RM") {
        if (eptype == "Address") {
            registrybrowser("savermpolicykey", "dicardregistrybrowser", index, 1, panelId);
        }
        if (eptype == "WSDL") {
            registrybrowser("savermpolicykey", "dicardregistrybrowser", index, 1, panelId);
        }
    } else if (type == "SEC") {
        if (eptype == "Address") {
            registrybrowser("savesecpolicykey", "dicardregistrybrowser", index, 1, panelId);
        }
        if (eptype == "WSDL") {
            registrybrowser("savesecpolicykey", "dicardregistrybrowser", index, 1, panelId);
        }
    }
}
function endpointfromregistry(index, anonymous) {
    iscurrentepanonymouse = anonymous != undefined && anonymous != null && anonymous == "true";
    var panelId = ("mypanel" + index).toString();
    registrybrowser("saveindirectepkey", "dicardregistrybrowser", index, 1, panelId);
}
function dicardregistrybrowser() {
    document.getElementById("registryPanel").innerHTML = "";
}

function savermpolicykey(index) {
    var regKey = getRegistryKey()
    var divcontrol = document.getElementById("registryPanel");
    divcontrol.innerHTML = "";
    if (regKey != null && regKey != undefined) {
        var id = "rm_policy" + index;
        var policyref = document.getElementById(id.toString());
        if (policyref != undefined && policyref != null) {
            policyref.value = regKey;
        }
    }
}
function saveindirectepkey(index) {
    var regKey = getRegistryKey()
    var divcontrol = document.getElementById("registryPanel");
    divcontrol.innerHTML = "";
    if (regKey != null && regKey != undefined) {
        var id = "endpoint_key" + index;
        var policyref = document.getElementById(id.toString());
        if (policyref != undefined && policyref != null) {
            policyref.value = regKey;
        }
    }
}
function savesecpolicykey(index) {
    var regKey = getRegistryKey()
    var divcontrol = document.getElementById("registryPanel");
    divcontrol.innerHTML = "";
    if (regKey != null && regKey != undefined) {
        var id = "sec_policy" + index;
        var policyref = document.getElementById(id.toString());
        if (policyref != undefined && policyref != null) {
            policyref.value = regKey;
        }
    }
}
function onwsrmchange(index) {
    onchangeqos(index, ("wsRMEngaged" + index).toString());
}
function onwssecchange(index) {
    onchangeqos(index, ("wsSecEngaged" + index).toString());
}
function onchangeqos(index, qosid) {
    var qos = document.getElementById(qosid);
    var id = "wsAddressingEngaged" + index;
    var addrdoc = document.getElementById(id.toString());
    if (qos.checked) {
        addrdoc.checked = true;
    }
}

function changeoptions(id, bool, bool2) {
    var addrdoc = document.getElementById(id.toString());
    addrdoc.checked = bool;
    addrdoc.disabled = bool2;
}
function checkboxedit(id, bool) {
    var addrdoc = document.getElementById(id.toString());
    addrdoc.disabled = bool;
}
function onformatchange(index) {
    var indexstr = index.toString();
    var format = document.getElementById(("endpoint_format" + indexstr).toString());
    var format_indexstr = null;
    var format_value = null;
    if (format != null)
    {
        format_indexstr = format.selectedIndex;
        if (format_indexstr != null) {
            format_value = format.options[format_indexstr].value;
        }
    }
    if (format_value != null && format_value != undefined && format_value != "" && format_value != "Select A Value") {

        if (format_value == "POX") {
            changeoptions("wsAddressingEngaged" + indexstr, false, true);
            changeoptions("wsRMEngaged" + indexstr, false, true);
            changeoptions("wsSecEngaged" + indexstr, false, true);

        } else if (format_value == "SOAP11" || format_value == "SOAP12") {
            checkboxedit("wsAddressingEngaged" + indexstr, false);
            checkboxedit("wsRMEngaged" + indexstr, false);
            checkboxedit("wsSecEngaged" + indexstr, false);
        }
    }
}
function deleteChildEndpoint(index) {
    if (index != "0") {
        var parentid = index.substring(0, index.lastIndexOf("."));
        var parentdiv = document.getElementById("childEndPointsDIV" + parentid);
        if (parentdiv != undefined && parentdiv != null) {
            var divstr = index + "_div";
            var childDiv = document.getElementById(divstr.toString());
            if (childDiv != null && childDiv != undefined) {
                removeendpointindex(index, parentid);
                parentdiv.removeChild(childDiv);
            }
        }
    }
}

function onActionChange(index) {
    var actionElement = document.getElementById(("endpoint_timeout_action" + index).toString());
    var selectedIndex = actionElement.selectedIndex;
    var durationText = document.getElementById(("endpoint_duration" + index).toString());
    if (actionElement[selectedIndex].value != "Select A Value") {
        var duration = durationText.value;
        if (duration != null && duration != undefined) {
            var intvalue = parseInt(duration);
            if (intvalue == undefined || intvalue == null || intvalue <= 0) {
                durationText.value = "30";
                durationText.disabled = false;
            }
        } else {
            durationText.value = "30";
            durationText.disabled = false;
        }
    } else {
        durationText.value = "0";
        durationText.disabled = true;
    }
}