/*
 *  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 *  WSO2 Inc. licenses this file to you under the Apache License,
 *  Version 2.0 (the "License"); you may not use this file except
 *  in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 *
 */

/**
 * This js file is for the aggregate mediator specific UI operations
 */

initedit["aggregate"] = function initaggregateedit(mediator) {

    var oncompElem = mediator.getElementsByTagName("onComplete");
    if (oncompElem == undefined || oncompElem.length == 0) {
        oncompElem = mediator.getElementsByTagName("syn:onComplete");
        if (oncompElem == undefined || oncompElem.length == 0) {
            mediator.appendChild(createesbelement("<syn:onComplete " + syn_ns_declaration + "/>"));
        }
    }

    setnodepositions(internalmodel.sequence);
}

var syn_ns_declaration = "xmlns:syn='http://ws.apache.org/ns/synapse'";

collectdata["aggregate"] = function collectaggregatedata(mediator, validate) {

    //alert(new XMLSerializer().serializeToString(mediator))

    var correlate_expr = document.getElementById("correlate_expr");
    var complete_time = document.getElementById("complete_time");
    var complete_max = document.getElementById("complete_max");
    var complete_min = document.getElementById("complete_min");
    var aggregate_expr = document.getElementById("aggregate_expr");
    var on_complete = document.getElementById("on_complete");

    if (correlate_expr != null && correlate_expr != undefined && correlate_expr.value != undefined) {
        if (correlate_expr.value == "") {
            var correlateOnElem = mediator.getElementsByTagName("correlateOn");
            if (correlateOnElem.length != 0) {
                correlateOnElem[0].removeAttribute("expression");
            } else {
                correlateOnElem = mediator.getElementsByTagName("syn:correlateOn");
                if (correlateOnElem.length != 0) {
                    correlateOnElem[0].removeAttribute("expression");
                }
            }
        } else {
            correlateOnElem = mediator.getElementsByTagName("correlateOn");
            if (correlateOnElem.length != 0) {
                correlateOnElem[0].setAttribute("expression", correlate_expr.value);
            } else {
                correlateOnElem = mediator.getElementsByTagName("syn:correlateOn");
                if (correlateOnElem.length != 0) {
                    correlateOnElem[0].setAttribute("expression", correlate_expr.value);
                } else {
                    mediator.appendChild(createesbelement("<syn:correlateOn expression='" + correlate_expr.value + "' " + syn_ns_declaration + "/>"));
                }
            }
        }
    }

    if (complete_time != null && complete_time != undefined && complete_time.value != undefined) {
        var completeConditionElem = mediator.getElementsByTagName("completeCondition");
        if (complete_time.value == "") {
            if (completeConditionElem.length != 0) {
                completeConditionElem[0].removeAttribute("timeout");
            } else {
                completeConditionElem = mediator.getElementsByTagName("syn:completeCondition");
                if (completeConditionElem.length != 0) {
                    completeConditionElem[0].removeAttribute("timeout");
                }
            }
        } else {
            if (completeConditionElem.length != 0) {
                completeConditionElem[0].setAttribute("timeout", complete_time.value);
            } else {
                completeConditionElem = mediator.getElementsByTagName("syn:completeCondition");
                if (completeConditionElem.length != 0) {
                    completeConditionElem[0].setAttribute("timeout", complete_time.value);
                } else {
                    mediator.appendChild(createesbelement("<syn:completeCondition timeout='" + complete_time.value + "' " + syn_ns_declaration + "/>"));
                }
            }
        }
        }

    if (complete_max != null && complete_max != undefined && complete_max.value != undefined) {
        var completeConditionElem2 = mediator.getElementsByTagName("completeCondition");
        if (completeConditionElem2.length != 0) {
            if (complete_max.value == "") {
                setmessagecount(completeConditionElem2[0], "max", 0);
            } else {
                setmessagecount(completeConditionElem2[0], "max", complete_max.value);
            }
        } else {
            completeConditionElem2 = mediator.getElementsByTagName("syn:completeCondition");
            if (completeConditionElem2.length != 0) {
                if (complete_max.value == "") {
                    setmessagecount(completeConditionElem2[0], "max", 0);
                } else {
                    setmessagecount(completeConditionElem2[0], "max", complete_max.value);
                }
            } else {
                if (complete_max.value == "") {
                    mediator.appendChild(createesbelement("<syn:completeCondition " + syn_ns_declaration + " max='0'/>"));
                } else {
                    mediator.appendChild(createesbelement("<syn:completeCondition " + syn_ns_declaration + " max='" + complete_max.value + "'/>"));
                }
            }
        }
    }

    if (complete_min != null && complete_min != undefined && complete_min.value != undefined) {
        var completeConditionElem3 = mediator.getElementsByTagName("completeCondition");
        if (completeConditionElem3.length != 0) {
            if (complete_min.value == "") {
                setmessagecount(completeConditionElem3[0], "min", 0);
            } else {
                setmessagecount(completeConditionElem3[0], "min", complete_min.value);
            }
        } else {
            completeConditionElem3 = mediator.getElementsByTagName("syn:completeCondition");
            if (completeConditionElem3.length != 0) {
                if (complete_min.value == "") {
                    setmessagecount(completeConditionElem3[0], "min", 0);
                } else {
                    setmessagecount(completeConditionElem3[0], "min", complete_min.value);
                }
            } else {
                if (complete_min.value == "") {
                    mediator.appendChild(createesbelement("<syn:completeCondition " + syn_ns_declaration + " min='0'/>"));
                } else {
                    mediator.appendChild(createesbelement("<syn:completeCondition " + syn_ns_declaration + " min='" + complete_min.value + "'/>"));
                }
            }
        }
    }

    if (aggregate_expr != null && aggregate_expr != undefined && aggregate_expr.value != undefined) {
        var onCompleteElem = mediator.getElementsByTagName("onComplete");
        if (aggregate_expr.value == "") {
            if (onCompleteElem.length != 0) {
                onCompleteElem[0].removeAttribute("expression");
            } else {
                onCompleteElem = mediator.getElementsByTagName("syn:onComplete");
                if (onCompleteElem.length != 0) {
                    onCompleteElem[0].removeAttribute("expression");
                }
            }
        } else {
            if (onCompleteElem.length != 0) {
                onCompleteElem[0].setAttribute("expression", aggregate_expr.value);
            } else {
                onCompleteElem = mediator.getElementsByTagName("syn:onComplete");
                if (onCompleteElem.length != 0) {
                    onCompleteElem[0].setAttribute("expression", aggregate_expr.value);
                } else {
                    mediator.appendChild(createesbelement("<syn:onComplete expression='" + aggregate_expr.value + "' " + syn_ns_declaration + "/>"));
                }
            }
        }
    }

    if (on_complete != null && on_complete != undefined && on_complete.value != undefined) {
        var onCompleteElem2 = mediator.getElementsByTagName("onComplete");
        if (on_complete.value == "") {
            if (onCompleteElem2.length != 0) {
                onCompleteElem2[0].removeAttribute("sequence");
                removeunwantedchilds(onCompleteElem2[0]);
            } else {
                onCompleteElem2 = mediator.getElementsByTagName("syn:onComplete");
                if (onCompleteElem2.length != 0) {
                    onCompleteElem2[0].removeAttribute("sequencec");
                    removeunwantedchilds(onCompleteElem2[0]);
                }
            }
        } else {
            if (onCompleteElem2.length != 0) {
                onCompleteElem2[0].setAttribute("sequence", on_complete.value);
                removeunwantedchilds(onCompleteElem2[0]);
            } else {
                onCompleteElem2 = mediator.getElementsByTagName("syn:onComplete");
                if (onCompleteElem2.length != 0) {
                    onCompleteElem2[0].setAttribute("sequencec", on_complete.value);
                    removeunwantedchilds(onCompleteElem2[0]);
                } else {
                    mediator.appendChild(createesbelement("<syn:onComplete sequence='" + on_complete.value + "' " + syn_ns_declaration + "/>"));
                }
            }
        }
    }
    
    return true;
};

function setmessagecount(elem, attr, attr_value) {

    var msgcountElem = elem.getElementsByTagName("messageCount");
    if(msgcountElem.length != 0) {
        if (attr_value == "") {
            msgcountElem[0].removeAttribute(attr);
        } else {
            msgcountElem[0].setAttribute(attr, attr_value);
        }
    } else {
        msgcountElem = elem.getElementsByTagName("syn:messageCount");
        if(msgcountElem.length != 0) {
            if (attr_value == "") {
                msgcountElem[0].removeAttribute(attr);
            } else {
                msgcountElem[0].setAttribute(attr, attr_value);
            }
        } else {
            elem.appendChild(createesbelement("<syn:messageCount " + attr + "='" + attr_value + "' " + syn_ns_declaration + "/>"))
        }
    }
}

function removeunwantedchilds(elem) {
    var childs = elem.childNodes;
    if (childs == undefined) {
        childs = elem.children();
    }

    if (childs != undefined && childs.length != 0) {
        while (childs.length > 0) {
            elem.removeChild(childs[childs.length - 1]);
        }
    }
}

mediatorelementstring["aggregate"] = function aggregatestring() {
    return "<syn:aggregate xmlns:syn='http://ws.apache.org/ns/synapse'><syn:correlateOn/><syn:completeCondition/><syn:onComplete/></syn:aggregate>";
};

function oncompletefromregistry() {
    var position = geteditingmediatorposition();
    var mediator = getnestedmediator(internalmodel.sequence, position);
    collectdata["aggregate"](mediator, false);
    registrybrowser("setoncompletefromregistry", "dicardregistrybrowser", "", 1, "registryPanel");
}

function setoncompletefromregistry() {

    var position = geteditingmediatorposition();
    var mediator = getnestedmediator(internalmodel.sequence, position);

    if (mediator.getElementsByTagName("onComplete")[0] != undefined) {
        mediator.getElementsByTagName("onComplete")[0].setAttribute("sequence", getRegistryKey());
    } else if (mediator.getElementsByTagName("syn:onComplete")[0] != undefined) {
        mediator.getElementsByTagName("syn:onComplete")[0].setAttribute("sequence", getRegistryKey());
    } else {
        mediator.appendChild(createesbelement("<syn:onComplete sequence='" + getRegistryKey() + "' xmlns:syn='http://ws.apache.org/ns/synapse'/>"));
    }

    dicardregistrybrowser(1);

    editmediator(position);
}

function oncompletetoref() {
    var position = geteditingmediatorposition();
    var mediator = getnestedmediator(internalmodel.sequence, position);
    collectdata["aggregate"](mediator, false);
    if (mediator.getElementsByTagName("onComplete")[0] != undefined) {
        mediator.getElementsByTagName("onComplete")[0].setAttribute("sequence", "");
    } else if (mediator.getElementsByTagName("syn:onComplete")[0] != undefined) {
        mediator.getElementsByTagName("syn:onComplete")[0].setAttribute("sequence", "");
    } else {
        mediator.appendChild(createesbelement("<syn:onComplete sequence='' xmlns:syn='http://ws.apache.org/ns/synapse'/>"));
    }
    editmediator(position);
}

function oncompletetoinline() {
    var position = geteditingmediatorposition();
    var mediator = getnestedmediator(internalmodel.sequence, position);
    collectdata["aggregate"](mediator, false);
    if (mediator.getElementsByTagName("onComplete")[0] != undefined) {
        mediator.getElementsByTagName("onComplete")[0].removeAttribute("sequence");
    } else if (mediator.getElementsByTagName("syn:onComplete")[0] != undefined) {
        mediator.getElementsByTagName("syn:onComplete")[0].removeAttribute("sequence");
    }
    editmediator(position);
}