/*
 *  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 *  WSO2 Inc. licenses this file to you under the Apache License,
 *  Version 2.0 (the "License"); you may not use this file except
 *  in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 *
 */

/**
 * This js file is for the log mediator specific UI operations
 */


collectdata["callout"] = function collectlogdata(mediator, validate) {
    return collectdatatemporallyforcallout(mediator, validate);
};
function collectdatatemporallyforcallout(mediator, validate) {
    var serviceURL = document.getElementById("callout_serviceURL");
    var action = document.getElementById("callout_action");
    var sourcexpath = document.getElementById("source_xpath");
    var sourcekey = document.getElementById("source_key");
    var targetxpath = document.getElementById("target_xpath");
    var targetkey = document.getElementById("target_key");

    if (serviceURL != null && serviceURL.value != "") {
        mediator.setAttribute("serviceURL", serviceURL.value);

    } else if (!validate) {
        esbwarning("The serviceURL must be specified", TYPE_INFO);
        return false;
    }

    if (action != undefined && action != null && action.value != "") {
        mediator.setAttribute("action", action.value);
    }
    var chlimit = mediator.childNodes.length;
    var sourceindex = null;
    var targetindex = null;
    for (var i = 0; i < chlimit; i++) {
        var child = mediator.childNodes[i] ;
        if (child != null && child != undefined) {
            var name = child.nodeName;
            if (name == "syn:source" || name == "source") {
                sourceindex = i;
            }
            if (name == "syn:target" || name == "target") {
                targetindex = i;
            }
        }
    }
    if (mediator.childNodes[sourceindex] == undefined || mediator.childNodes[sourceindex] == null) {
        mediator.appendChild(createesbelement("<syn:source xmlns:syn='http://ws.apache.org/ns/synapse'/>"));
    }
    if (mediator.childNodes[targetindex] == undefined || mediator.childNodes[targetindex] == null) {
        mediator.appendChild(createesbelement("<syn:target xmlns:syn='http://ws.apache.org/ns/synapse'/>"));
    }
    chlimit = mediator.childNodes.length;
    for (var i = 0; i < chlimit; i++) {
        var child = mediator.childNodes[i] ;
        if (child != null && child != undefined) {
            var name = child.nodeName;
            if (name == "syn:source" || name == "source") {
                sourceindex = i;
            }
            if (name == "syn:target" || name == "target") {
                targetindex = i;
            }
        }
    }
    var source = mediator.childNodes[sourceindex];
    if (source == null && !validate) {
        esbwarning("The source must be specified", TYPE_INFO);
        return false;
    }
    var target = mediator.childNodes[targetindex];
    if (target == null && !validate) {
        esbwarning("The target must be specified", TYPE_INFO);
        return false;
    }
    if (sourcexpath != null && sourcexpath.value != "") {
        if (source != null) {
            source.setAttribute("xpath", sourcexpath.value);
            source.removeAttribute("key");
        }
    } else if (sourcekey != null && sourcekey.value != "") {
        if (source != null) {
            source.setAttribute("key", sourcekey.value);
            source.removeAttribute("xpath");
        }
    } else if (!validate) {
        esbwarning("A key or XPath must be specified for the source", TYPE_INFO);
        return false;
    }
    if (targetxpath != null && targetxpath.value != "") {
        if (target != null) {
            target.setAttribute("xpath", targetxpath.value);
            target.removeAttribute("key");
        }
    } else if (targetkey != null && targetkey.value != "") {
        if (target != null) {
            target.setAttribute("key", targetkey.value);
            target.removeAttribute("xpath");
        }
    } else if (!validate) {
        esbwarning("A key or XPath must be specified for the target", TYPE_INFO);
        return false;
    }

    return true;
}
function sourcexpath(index) {
    var mediator = getnestedmediator(internalmodel.sequence, index);
    collectdatatemporallyforcallout(mediator, true);
    var chlimit = mediator.childNodes.length;
    var chindex = null;
    for (var i = 0; i < chlimit; i++) {
        var child = mediator.childNodes[i] ;
        if (child != null && child != undefined) {
            var name = child.nodeName;
            if (name == "syn:source" || name == "source") {
                chindex = i;
            }
        }
    }
    if (chindex != null) {
        var key = mediator.childNodes[chindex].getAttribute("key") ;
        if (key != null && key != undefined) {
            mediator.childNodes[chindex].removeAttribute("key");
        }
    }
    mediator.setAttribute("source_xpath", 0);
    mediator.removeAttribute("source_key");
    var epdiv = document.getElementById("callout_edit_div");
    if (epdiv != null && mediator != null) {
        processXML(mediator, "mediators/callout_edit.xsl", epdiv);
    }
}
function sourcekey(index) {
    var mediator = getnestedmediator(internalmodel.sequence, index);
    collectdatatemporallyforcallout(mediator, true);
    var chlimit = mediator.childNodes.length;
    var chindex = null;
    for (var i = 0; i < chlimit; i++) {
        var child = mediator.childNodes[i] ;
        if (child != null && child != undefined) {
            var name = child.nodeName;
            if (name == "syn:source" || name == "source") {
                chindex = i;
            }
        }
    }
    if (chindex != null) {
        var key = mediator.childNodes[chindex].getAttribute("xpath") ;
        if (key != null && key != undefined) {
            mediator.childNodes[chindex].removeAttribute("xpath");
        }
    }
    mediator.setAttribute("source_key", 0);
    mediator.removeAttribute("source_xpath");
    var epdiv = document.getElementById("callout_edit_div");
    if (epdiv != null && mediator != null) {
        processXML(mediator, "mediators/callout_edit.xsl", epdiv);
    }
}
function targetxpath(index) {
    var mediator = getnestedmediator(internalmodel.sequence, index);
    collectdatatemporallyforcallout(mediator, true);
    var chlimit = mediator.childNodes.length;
    var chindex = null;
    for (var i = 0; i < chlimit; i++) {
        var child = mediator.childNodes[i] ;
        if (child != null && child != undefined) {
            var name = child.nodeName;
            if (name == "syn:target" || name == "target") {
                chindex = i;
            }
        }
    }
    if (chindex != null) {
        var key = mediator.childNodes[chindex].getAttribute("key") ;
        if (key != null && key != undefined) {
            mediator.childNodes[chindex].removeAttribute("key");
        }
    }
    mediator.setAttribute("target_xpath", 0);
    mediator.removeAttribute("target_key");
    var epdiv = document.getElementById("callout_edit_div");
    if (epdiv != null && mediator != null) {
        processXML(mediator, "mediators/callout_edit.xsl", epdiv);
    }
}
function targetkey(index) {
    var mediator = getnestedmediator(internalmodel.sequence, index);
    collectdatatemporallyforcallout(mediator, true);
    var chlimit = mediator.childNodes.length;
    var chindex = null;
    for (var i = 0; i < chlimit; i++) {
        var child = mediator.childNodes[i] ;
        if (child != null && child != undefined) {
            var name = child.nodeName;
            if (name == "syn:target" || name == "target") {
                chindex = i;
            }
        }
    }
    if (chindex != null) {
        var key = mediator.childNodes[chindex].getAttribute("xpath") ;
        if (key != null && key != undefined) {
            mediator.childNodes[chindex].removeAttribute("xpath");
        }
    }
    mediator.setAttribute("target_key", 0);
    mediator.removeAttribute("target_xpath");
    var epdiv = document.getElementById("callout_edit_div");
    if (epdiv != null && mediator != null) {
        processXML(mediator, "mediators/callout_edit.xsl", epdiv);
    }
}

function showNameSpaceEditorForTarget(pindex, attribute, inputID) {
    var mediator = getnestedmediator(internalmodel.sequence, pindex);
    var temp = collectdatatemporallyforcallout(mediator, true);
    setnodepositions(mediator, pindex);
    var chlimit = mediator.childNodes.length;
    var position = null;
    for (var i = 0; i < chlimit; i++) {
        var child = mediator.childNodes[i] ;
        if (child != null && child != undefined) {
            var name = child.nodeName;
            if (name == "syn:target" || name == "target") {
                position = child.getAttribute("esb_med_pos");
            }
        }
    }
    if (position == null) {
        return;
    }
    showNameSpaceEditor(position, attribute, inputID);
}
function showNameSpaceEditorForSource(pindex, attribute, inputID) {
    var mediator = getnestedmediator(internalmodel.sequence, pindex);
    var temp = collectdatatemporallyforcallout(mediator, true);
    setnodepositions(mediator, pindex);
    var chlimit = mediator.childNodes.length;
    var position = null;
    for (var i = 0; i < chlimit; i++) {
        var child = mediator.childNodes[i] ;
        if (child != null && child != undefined) {
            var name = child.nodeName;
            if (name == "syn:source" || name == "source") {
                position = child.getAttribute("esb_med_pos");
            }
        }
    }
    if (position == null) {
        return;
    }
    showNameSpaceEditor(position, attribute, inputID)
}

function calloutsourcekeyfromregistry(position) {
    var panelId = ("mypanel" + position).toString();
    registrybrowser("savecalloutsourcekeyfromregistry", "dicardregistrybrowser", position, 1, panelId);
}

function savecalloutsourcekeyfromregistry(position) {
    var regKey = getRegistryKey();
    var divcontrol = document.getElementById("registryPanel");
    divcontrol.innerHTML = "";
    if (regKey != null && regKey != undefined) {
        var xquerykeyinput = document.getElementById("source_key");
        if (xquerykeyinput != null && xquerykeyinput != undefined) {
            xquerykeyinput.value = regKey;
        }
    }
}


mediatorelementstring["callout"] = function logstring() {
    return "<syn:callout xmlns:syn='http://ws.apache.org/ns/synapse' source_xpath='0' target_xpath='0'><syn:source/><syn:target/></syn:callout>";
};

