/*
 *  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 *  WSO2 Inc. licenses this file to you under the Apache License,
 *  Version 2.0 (the "License"); you may not use this file except
 *  in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 *
 */

/**
 * This js file is for the log mediator specific UI operations
 */

var allstatement = new Array();
var statementindexes = new Array();
var parameterindexes = new Array();
var resultindexes = new Array();
var propertyindexes = -1;
var newParmsForExisstatement = new Array();
var newResultsForExisstatement = new Array();
var namespaces = new Array();
var needthforprop = true;
var state = 1
var existpropertynames = new Array();

function addpropertyname(name) {
    existpropertynames[existpropertynames.length] = name;
}

function containspropertyname(name) {
    for (var i = 0; i < existpropertynames.length; i++) {
        if (existpropertynames[i] != null && existpropertynames[i].toString() == name.toString()) {
            return true;
        }
    }
    return false;
}
function addnamespace(position, namespase) {
    var found = false;
    if (namespaces.length > 0) {
        for (var i = 0; i < namespaces.length; i++) {
            if (namespaces[i].key == position) {
                namespaces[i].value = namespase;
                found = true;
            }
        }
    }
    if (!found) {
        var obj = new Object();
        obj.key = position;
        obj.value = namespase;
        namespaces[namespaces.length] = obj;
    }
}

function getnamespase(position) {
    if (namespaces.length > 0) {
        for (var i = 0; i < namespaces.length; i++) {
            if (namespaces[i].key == position) {
                return namespaces[i].value;
            }
        }
    }
}
function addParameterIndex(statementindex, noofparameter) {
    var found = false;
    if (parameterindexes.length > 0) {
        for (var i = 0; i < parameterindexes.length; i++) {
            if (parameterindexes[i].si == statementindex) {
                if (parameterindexes[i].pi != null) {
                    parameterindexes[i].pi[parameterindexes[i].pi.length] = parameterindexes[i].pi.length + 1;
                    found = true;
                }
            }
        }
    }
    if (!found) {
        var parm = new Object();
        parm.si = parseInt(statementindex);
        var parames = new Array();
        var len = parseInt(noofparameter);
        if (len == 0) {
            len += 1;
        }
        for (var i = 0; i < len; i++) {
            parames[parames.length] = i + 1;
        }
        parm.pi = parames;
        parameterindexes[parameterindexes.length] = parm;
    }
}
function deleteparameterindex(statementindex, parameterindex) {
    if (parameterindexes.length > 0) {
        for (var i = 0; i < parameterindexes.length; i++) {
            if (parameterindexes[i].si == statementindex) {
                if (parameterindexes[i].pi != null) {
                    for (var j = 0; j < parameterindexes[i].pi.length; j++) {
                        if (parameterindexes[i].pi[j] != null && parseInt(parameterindexes[i].pi[j]) == (parseInt(parameterindex) + 1)) {
                            parameterindexes[i].pi[j] = null;
                            return;
                        }
                    }
                }
            }
        }
    }
}

function getdeleteparametercount(statementindex, parameterindex) {
    var count = 0;
    if (parameterindexes.length > 0) {
        for (var i = 0; i < parameterindexes.length; i++) {
            if (parameterindexes[i].si == statementindex) {
                if (parameterindexes[i].pi != null) {
                    for (var j = 0; j < parameterindexes[i].pi.length; j++) {

                        if (parameterindexes[i].pi[j] != null && parseInt(parameterindexes[i].pi[j]) == parseInt(parameterindex)) {
                            return count;
                        }
                        if (parameterindexes[i].pi[j] == null) {
                            count += 1;
                        }
                    }
                }
            }
        }
    }
}
function getnoofparameter(statementindex) {
    if (parameterindexes.length > 0) {
        for (var i = 0; i < parameterindexes.length; i++) {
            if (parameterindexes[i].si == statementindex) {
                return parseInt(parameterindexes[i].pi.length);
            }
        }
    }
}
function addresultIndex(statementindex, noofresult) {
    var found = false;
    if (resultindexes.length > 0) {
        for (var i = 0; i < resultindexes.length; i++) {
            if (resultindexes[i].si == statementindex) {
                if (resultindexes[i].pi != null) {
                    resultindexes[i].pi = parseInt(resultindexes[i].pi) + 1;
                    found = true;
                }
            }
        }
    }
    if (!found) {
        var parm = new Object();
        parm.si = parseInt(statementindex);
        parm.pi = parseInt(noofresult) + 1;
        resultindexes[resultindexes.length] = parm;
    }
}

function getnoofresult(statementindex) {
    if (resultindexes.length > 0) {
        for (var i = 0; i < resultindexes.length; i++) {
            if (resultindexes[i].si == statementindex) {
                return parseInt(resultindexes[i].pi);
            }
        }
    }
}
function addpropertyIndex(noofproperty) {
    if (propertyindexes == -1) {
        propertyindexes = parseInt(noofproperty) + 1;
    } else {
        propertyindexes += parseInt(noofproperty) + 1;
    }
}

function getnoofproperty() {
    if (propertyindexes != -1) {
        return propertyindexes;
    }
}
function addstatementIndex(index) {

    if (parseInt(index) == 0) {
        statementindexes[statementindexes.length] = statementindexes.length;

    } else {
        if (statementindexes.length == 0) {
            for (var i = 0; i <= parseInt(index); i++) {
                statementindexes[statementindexes.length] = i;
            }
        } else {
            statementindexes[statementindexes.length] = statementindexes.length;
        }
    }
}

function deletestatementIndex(index) {
    if (statementindexes.length > 0) {
        for (var i = 0; i < statementindexes.length; i++) {
            if (statementindexes[i] != null && parseInt(statementindexes[i]) == index) {
                statementindexes[i] = null;
                return;
            }
        }
    }
}
function getdeletedpreviousstatements(index) {
    var count = 0;
    if (statementindexes.length > 0) {
        for (var i = 0; i < statementindexes.length; i++) {
            if (statementindexes[i] != null && parseInt(statementindexes[i]) == index) {
                return count;
            }
            if (statementindexes[i] == null) {
                count += 1;
            }
        }
    }
}
initedit["dblookup"] = function initdblookupedit(mediator) {
    initdbmediator(mediator);
    //        showStuffInNewWindow(new XMLSerializer().serializeToString(mediator));
};

collectdata["dblookup"] = function collectlogdata(mediator) {
    state = 0;
    var retrunvalue = collectdatatemporaly(mediator);
    if (retrunvalue) {
        resetstatesofdbmediator();
    }
    state = 1;
    return retrunvalue;

};

function resetstatesofdbmediator() {
    statementindexes = new Array();
    allstatement = new Array();
    newParmsForExisstatement = new Array();
    newResultsForExisstatement = new Array();
    parameterindexes = new Array();
    propertyindexes = -1;
    resultindexes = new Array();
    namespaces = new Array();
    needthforprop = true;
    existpropertynames = new Array();
}
function initdbmediator(mediator) {
    resetstatesofdbmediator();
    mediator.setAttribute("statement_index", 0);
    var driver = mediator.getElementsByTagName("driver");
    if (driver == undefined || driver == null || driver.length == 0) {
        driver = mediator.getElementsByTagName("syn:driver");
    }
    if (driver != null && driver != undefined && driver.length == 1) {
        if (mediator.getAttribute("pool") == null || mediator.getAttribute("pool") == undefined) {
            mediator.setAttribute("pool", "0");
        }
    } else {
        var dsName = mediator.getElementsByTagName("dsName");
        if (dsName == undefined || dsName == null || dsName.length == 0) {
            dsName = mediator.getElementsByTagName("syn:dsName");
        }
        if (dsName != null && dsName != undefined && dsName.length == 1) {
            if (mediator.getAttribute("datasource") == null || mediator.getAttribute("datasource") == undefined) {
                mediator.setAttribute("datasource", "0");
            }
        } else {
            if (mediator.getAttribute("pool") == null || mediator.getAttribute("pool") == undefined) {
                mediator.setAttribute("pool", "0");
            }
        }
    }
    var existingquries = mediator.getElementsByTagName("statement");
    if (existingquries == undefined || existingquries == null || existingquries.length == 0) {
        existingquries = mediator.getElementsByTagName("syn:statement");
    }
    if (existingquries != null && existingquries.length > 0) {
        for (var i = 0; i < existingquries.length; i++) {
            if (existingquries[i].getAttribute("statement_index") == null) {
                existingquries[i].setAttribute("statement_index", i);
            }
            var existingParms = existingquries[i].getElementsByTagName("parameter");
            if (existingParms == null || existingParms == null || existingParms.length == 0) {
                existingParms = existingquries[i].getElementsByTagName("syn:parameter");
            }
            for (var j = 0; j < existingParms.length; j++) {
                if (existingParms[j].getAttribute("parameter_index") == null) {
                    existingParms[j].setAttribute("parameter_index", j);
                }
                existingParms[j].setAttribute("statement_index", i);
            }
            var existingresult = existingquries[i].getElementsByTagName("result");
            if (existingresult == null || existingresult == null || existingresult.length == 0) {
                existingresult = existingquries[i].getElementsByTagName("syn:result");
            }
            for (var j = 0; j < existingresult.length; j++) {
                if (existingresult[j].getAttribute("result_index") == null) {
                    existingresult[j].setAttribute("result_index", j);
                }
                existingresult[j].setAttribute("statement_index", i);
            }
            addParameterIndex(i, existingParms.length);
            addresultIndex(i, existingParms.length);
            statementindexes[statementindexes.length] = i;
        }
    }
    var existingproperties = mediator.getElementsByTagName("property");
    if (existingproperties == undefined || existingproperties == null || existingproperties.length == 0) {
        existingproperties = mediator.getElementsByTagName("syn:property");
    }
    for (var i = 0; i < existingproperties.length; i++) {
        if (existingproperties[i].getAttribute("property_index") == null) {
            existingproperties[i].setAttribute("property_index", i);
        }
    }
    propertyindexes = existingproperties.length;
}
function collectdatatemporaly(mediator) {
    //     alert((new XMLSerializer().serializeToString(mediator)));
    var ps = mediator.getAttribute("esb_med_pos");

    var poolstr = '<syn:pool xmlns:syn="' + SYNAPSE_NS + '">';
    var dirverElem = document.getElementById("driver_id");
    if (dirverElem != null && dirverElem != undefined && dirverElem.value != undefined && dirverElem.value != "") {
        poolstr += "<syn:driver>" + trim(dirverElem.value) + "</syn:driver>";
    } else if (document.getElementById("ic_class_id") != undefined) {
        var icclassElem = document.getElementById("ic_class_id");
        if (icclassElem != null && icclassElem != undefined && icclassElem.value != undefined && icclassElem.value != "") {
            poolstr += "<syn:icClass>" + trim(icclassElem.value) + "</syn:icClass>";
        } else {
            if (state == 0) {
                esbwarning("Couldn't find the initial context class ", TYPE_INFO);
                return false;
            }
        }
        var dsNameElem = document.getElementById("ds_name_id");
        if (dsNameElem != null && dsNameElem != undefined && dsNameElem.value != undefined && dsNameElem.value != "") {
            poolstr += "<syn:dsName>" + trim(dsNameElem.value) + "</syn:dsName>";
        } else {
            if (state == 0) {
                esbwarning("Couldn't find the DataSource name ", TYPE_INFO);
                return false;
            }
        }
    } else {
        if (state == 0) {
            esbwarning("Couldn't find the driver ", TYPE_INFO);
            return false;
        }
    }
    var urlElem = document.getElementById("url_id");
    if (urlElem != null && urlElem != undefined && urlElem.value != undefined && urlElem.value != "") {
        poolstr += "<syn:url>" + trim(urlElem.value) + "</syn:url>";
    } else {
        if (state == 0) {
            esbwarning("Couldn't find the connection url  ", TYPE_INFO);
            return false;
        }
    }
    var userElem = document.getElementById("user_id");
    if (userElem != null && userElem != undefined && userElem.value != undefined && userElem.value != "") {
        poolstr += "<syn:user>" + trim(userElem.value) + "</syn:user>";
    } else {
        if (state == 0) {
            esbwarning("Couldn't find the usename ", TYPE_INFO);
            return false;
        }
    }
    var passwordElem = document.getElementById("password_id");
    if (passwordElem != null && passwordElem != undefined && passwordElem.value != undefined && passwordElem.value != "") {
        poolstr += "<syn:password>" + trim(passwordElem.value) + "</syn:password>";
    } else {
        if (state == 0) {
            esbwarning("Couldn't find the password ", TYPE_INFO);
            return false;
        }
    }
    poolstr += '</syn:pool>';

    var prevconn = mediator.getElementsByTagName("connection");
    if (prevconn == null || prevconn == undefined || prevconn.length == 0) {
        prevconn = mediator.getElementsByTagName("syn:connection");
    }

    var poolobj = createesbelement(poolstr);
    if (prevconn != null && prevconn.length > 0) {
        mediator.removeChild(prevconn[0]);
    }
    var propertystable = document.getElementById("properties");
    if (propertystable != undefined && propertystable != null) {
        var trs = propertystable.getElementsByTagName("tr");
        if (trs != undefined && trs != null) {
            var canaddprop = getpropertyforpool(trs, poolobj);
            if (!canaddprop) {
                return false;
            }
        }
    }
    var connectionObj = createesbelement('<syn:connection xmlns:syn="' + SYNAPSE_NS + '"/>');
    connectionObj.appendChild(poolobj);
    mediator.appendChild(connectionObj);
    var existingquries = mediator.getElementsByTagName("statement");
    if (existingquries == undefined || existingquries == null || existingquries.length <= 0) {
        existingquries = mediator.getElementsByTagName("syn:statement");
    }
    if (browsername.indexOf(NETSCAPE_BROWSER_NAME) != -1) {
        while (existingquries.length > 0) {
            var parameters = existingquries[existingquries.length - 1].getElementsByTagName("parameter");
            if (parameters == undefined || parameters == null || parameters.length <= 0) {
                parameters = existingquries[existingquries.length - 1].getElementsByTagName("syn:parameter");
            }
            if (parameters.length > 0) {
                for (var p = 0; p < parameters.length; p++) {
                    var attrs = parameters[p].attributes;
                    var nsarr = new Array();
                    for (var k = 0; k < attrs.length; k++) {
                        if (attrs[k].name.indexOf("xmlns:") == 0) {
                            nsarr[nsarr.length] = attrs[k];
                        }
                    }
                    var pos = parameters[p].getAttribute("esb_med_pos");
                    if (pos != null && nsarr.length > 0) {
                        addnamespacedbr(pos, nsarr);
                    }
                }
            }
            mediator.removeChild(existingquries[existingquries.length - 1]);
        }
    } else if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
        for (var j = 0; j < existingquries.length; j++) {
            var parameters = existingquries[j].getElementsByTagName("parameter");
            if (parameters == undefined || parameters == null || parameters.length <= 0) {
                parameters = existingquries[j].getElementsByTagName("syn:parameter");
            }
            if (parameters.length > 0) {
                for (var p = 0; p < parameters.length; p++) {
                    var attrs = parameters[p].attributes;
                    var nsarr = new Array();
                    for (var k = 0; k < attrs.length; k++) {
                        if (attrs[k].name.indexOf("xmlns:") == 0) {
                            nsarr[nsarr.length] = attrs[k];
                        }
                    }
                    var pos = parameters[p].getAttribute("esb_med_pos");
                    if (pos != null && nsarr.length > 0) {
                        addnamespacedbr(pos, nsarr);
                    }
                }
            }
            mediator.removeChild(existingquries[j]);
        }
    }
    var queriesdiv = document.getElementById("queries");
    if (queriesdiv != undefined && queriesdiv != null && queriesdiv.childNodes != null && queriesdiv.childNodes.length > 0) {
        var statementLength = statementindexes.length;
        if (statementLength != undefined && statementLength != null && statementLength > 0) {
            var ql = parseInt(statementLength) ;
            for (var i = 0; i < ql; i++) {
                if (statementindexes[i] != null) {
                    var statementstr = '<syn:statement xmlns:syn="' + SYNAPSE_NS + '" ';
                    statementstr += "><syn:sql><![CDATA[";
                    var sqlElem = document.getElementById("sql_id" + i);
                    if (sqlElem != undefined && sqlElem != null && sqlElem.value != undefined && sqlElem.value != "" && trim(sqlElem.value) != "") {
                        statementstr += trim(sqlElem.value);
                    } else {
                        if (state == 0) {
                            esbwarning("Couldn't find the SQL query  ", TYPE_INFO);
                            return false;
                        }
                    }
                    statementstr += ']]></syn:sql></syn:statement>';
                    var statement = createesbelement(statementstr);
                    statement.setAttribute("statement_index", i);
                    var parameterstable = document.getElementById("parameters" + i);
                    if (parameterstable != undefined && parameterstable != null) {
                        var trs = parameterstable.getElementsByTagName("tr");
                        if (trs != undefined && trs != null) {
                            var canaddparm = getparameterobject(trs, statement, ps, i);
                            if (!canaddparm) {
                                return false;
                            }
                        }
                    }
                    var resultstable = document.getElementById("results" + i);
                    if (resultstable != undefined && resultstable != null) {
                        var trs = resultstable.getElementsByTagName("tr");
                        if (trs != undefined && trs != null) {
                            var canaddresult = getresultobject(trs, statement);
                            if (!canaddresult) {
                                return false;
                            }
                        }
                    }
                    mediator.appendChild(statement);
                }
            }
        }
    }
    return true;
}

function getparameterobject(trs, statement, pindex, si) {

    var propertytrs = new Array();
    for (var i = 0; i < trs.length; i++) {
        if (trs[i].getAttribute("name") == "syn-parameter") {
            propertytrs[propertytrs.length] = trs[i];
        }
    }

    for (var j = 0; j < propertytrs.length; j++) {
        var id = propertytrs[j].getAttribute("id");
        var pi = id.substring(0, id.indexOf("parameter_id"));
        var deletedpi = getdeleteparametercount(parseInt(si), parseInt(pi) + 1);
        var deletedsi = getdeletedpreviousstatements(si);

        var position = pindex.toString() + "." + (parseInt(si) + 1).toString() + "." + (parseInt(pi) + 1).toString();
        if (deletedsi != null && deletedsi != undefined && deletedsi != 0) {
            position = pindex.toString() + "." + (parseInt(si) + 1 - deletedsi).toString() + "." + (parseInt(pi) + 1).toString();

            if (deletedpi != null && deletedpi != undefined && deletedpi != 0) {
                position = pindex.toString() + "." + (parseInt(si) + 1 - deletedsi).toString() + "." + (parseInt(pi) + 1 - deletedpi).toString();
            }
        } else {
            if (deletedpi != null && deletedpi != undefined && deletedpi != 0) {
                position = pindex.toString() + "." + (parseInt(si) + 1).toString() + "." + (parseInt(pi) + 1 - deletedpi).toString();

            }
        }
        var namespce = getnamespase(position);
        if (window.ActiveXObject) {
            if (state == 0) {
                if (propertytrs[j].children[0].children[0].value != "" && propertytrs[j].children[2].children[0].value != "") {

                    var propertystr = "<syn:parameter xmlns:syn='http://ws.apache.org/ns/synapse' type='"
                        + propertytrs[j].children[0].children[0].value + "' ";

                    var propertytype = propertytrs[j].children[1].children[0].options[
                        propertytrs[j].children[1].children[0].selectedIndex].value;
                    if (propertytype == "value") {
                        propertystr += "value='" + convertAllXmlSpecialChars(propertytrs[j].children[2].children[0].value) + "' ";
                    } else if (propertytype == "expression") {
                        propertystr += "expression='" + convertAllXmlSpecialChars(propertytrs[j].children[2].children[0].value) + "' ";
                    }
                    if (namespce != undefined && namespce != null) {
                        for (var g = 0; g < namespce.length; g++) {
                            if (namespce[g].name != "xmlns:syn") {
                                propertystr += namespce[g].name + "='" + namespce[g].value + "' ";
                            }
                        }
                    }
                    statement.appendChild(createesbelement(propertystr + "/>"));
                } else {
                    if (propertytrs[j].children[0].children[0].value == ""
                        || propertytrs[j].children[0].children[0].value == "Select A Value") {
                        esbwarning("Some parameters may haven't defined the parameter type. Each parameter must define a type.", TYPE_INFO);
                        return false;
                    } else if (propertytrs[j].children[2].children[0].value == "") {
                        esbwarning("Some parameters may haven't defined the value/expression . Each parameter must define a value/expression.", TYPE_INFO);
                        return false;
                    }
                }
            } else {
                var propertystr = "<syn:parameter xmlns:syn='http://ws.apache.org/ns/synapse' type='"
                    + propertytrs[j].children[0].children[0].value + "' ";

                var propertytype = propertytrs[j].children[1].children[0].options[
                    propertytrs[j].children[1].children[0].selectedIndex].value;
                if (propertytype == "value") {
                    propertystr += "value='" + propertytrs[j].children[2].children[0].value + "' ";
                } else if (propertytype == "expression") {
                    propertystr += "expression='" + propertytrs[j].children[2].children[0].value + "' ";
                }
                if (namespce != undefined && namespce != null) {
                    for (var g = 0; g < namespce.length; g++) {
                        if (namespce[g].name != "xmlns:syn") {
                            propertystr += namespce[g].name + "='" + namespce[g].value + "' ";
                        }
                    }
                }
                statement.appendChild(createesbelement(propertystr + "/>"));
            }
        } else {

            if (state == 0) {
                if (propertytrs[j].childNodes[0].childNodes[0].value != ""
                    && propertytrs[j].childNodes[2].childNodes[0].value != "") {
                    var property;
                    if (document.createElementNS != "undefined") {
                        property = document.createElementNS(SYNAPSE_NS, "syn:parameter");
                    }
                    property.setAttribute("type", propertytrs[j].childNodes[0].childNodes[0].value);
                    var propertytype = propertytrs[j].childNodes[1].childNodes[0].options[
                        propertytrs[j].childNodes[1].childNodes[0].selectedIndex].value;
                    if (propertytype == "value") {
                        property.setAttribute("value", propertytrs[j].childNodes[2].childNodes[0].value);
                    } else if (propertytype == "expression") {
                        property.setAttribute("expression", propertytrs[j].childNodes[2].childNodes[0].value);
                    }
                    if (namespce != undefined && namespce != null) {
                        for (var g = 0; g < namespce.length; g++) {
                            if (namespce[g].name != "xmlns:syn") {
                                property.setAttribute(namespce[g].name, namespce[g].value);
                            }
                        }
                    }

                    statement.appendChild(property);
                } else {
                    if (propertytrs[j].childNodes[0].childNodes[0].value == ""
                        || propertytrs[j].childNodes[0].childNodes[0].value == "Select A Value") {
                        esbwarning("Some parameters may haven't defined the parameter type. Each parameter must define a type.", TYPE_INFO);
                        return false;
                    } else if (propertytrs[j].childNodes[2].childNodes[0].value == "") {
                        esbwarning("Some parameters may haven't defined the value/expression . Each parameter must define a value/expression.", TYPE_INFO);
                        return false;
                    }
                }
            } else {
                var property;
                if (document.createElementNS != "undefined") {
                    property = document.createElementNS(SYNAPSE_NS, "syn:parameter");
                }
                property.setAttribute("type", propertytrs[j].childNodes[0].childNodes[0].value);
                var propertytype = propertytrs[j].childNodes[1].childNodes[0].options[
                    propertytrs[j].childNodes[1].childNodes[0].selectedIndex].value;
                if (propertytype == "value") {
                    property.setAttribute("value", propertytrs[j].childNodes[2].childNodes[0].value);
                } else if (propertytype == "expression") {
                    property.setAttribute("expression", propertytrs[j].childNodes[2].childNodes[0].value);
                }
                if (namespce != undefined && namespce != null) {
                    for (var g = 0; g < namespce.length; g++) {
                        if (namespce[g].name != "xmlns:syn") {
                            property.setAttribute(namespce[g].name, namespce[g].value);
                        }
                    }
                }
                statement.appendChild(property);
            }
        }
    }
    return true;
}

function getresultobject(trs, statement) {
    var propertytrs = new Array();
    for (var i = 0; i < trs.length; i++) {
        if (trs[i].getAttribute("name") == "syn-result") {
            propertytrs[propertytrs.length] = trs[i];
        }
    }
    for (var j = 0; j < propertytrs.length; j++) {
        if (window.ActiveXObject) {
            if (propertytrs[j].children[0].children[0].value != "" && propertytrs[j].children[1].children[0].value != "") {
                var name = trim(propertytrs[j].children[0].children[0].value);
                if (!namevalidate(name)) {
                    esbwarning(INVALID_NAME, TYPE_INFO);
                    return false;
                }
                var propertystr = "<syn:result xmlns:syn='http://ws.apache.org/ns/synapse' name='"
                    + name + "' ";
                propertystr += "column='" + propertytrs[j].children[1].children[0].value + "' ";
                statement.appendChild(createesbelement(propertystr + "/>"));
            } else {
                if (propertytrs[j].children[0].children[0].value == "") {
                    esbwarning("Some results may haven't defined the name. Each result must define a name.", TYPE_INFO);
                    return false;

                } else if (propertytrs[j].children[1].children[0].value == "") {
                    esbwarning("Some results may haven't defined the column(Number/Name). Each result must define a column(Number/Name).", TYPE_INFO);
                    return false;
                }
            }
        } else {
            if (propertytrs[j].childNodes[0].childNodes[0].value != "" && propertytrs[j].childNodes[1].childNodes[0].value != "") {
                var property;
                if (document.createElementNS != "undefined") {
                    property = document.createElementNS(SYNAPSE_NS, "syn:result");
                }
                property.setAttribute("name", propertytrs[j].childNodes[0].childNodes[0].value);
                property.setAttribute("column", propertytrs[j].childNodes[1].childNodes[0].value);
                statement.appendChild(property);
            } else {
                if (propertytrs[j].childNodes[0].childNodes[0].value == "") {
                    esbwarning("Some results may haven't defined the name. Each result must define a name.", TYPE_INFO);
                    return false;

                } else if (propertytrs[j].childNodes[1].childNodes[0].value == "") {
                    esbwarning("Some results may haven't defined the column(Number/Name). Each result must define a column(Number/Name).", TYPE_INFO);
                    return false;
                }
            }
        }
    }
    return true;
}

function showpool(position) {
    var epdiv = document.getElementById("connection_edit");
    if (epdiv != null && epdiv != undefined && epdiv.childNodes.length == 1) {
        var transformeddiv = document.createElement("div");
        var xmlObj = createesbelement("<syn:connection xmlns:syn='http://ws.apache.org/ns/synapse'/>");
        collectconnectioninfo(xmlObj);
        xmlObj.setAttribute("pool", 0);
        processXML(xmlObj, "mediators/connection.xsl", transformeddiv);
        if (transformeddiv.childNodes.length == 1) {
            epdiv.removeChild(epdiv.childNodes[0]);
            epdiv.appendChild(transformeddiv.childNodes[0]);
        }

    }
}

function collectconnectioninfo(xmlObj) {
    var dirverElem = document.getElementById("driver_id");
    if (dirverElem != null && dirverElem != undefined && dirverElem.value != undefined && dirverElem.value != "") {
        xmlObj.setAttribute("driver", trim(dirverElem.value));
    } else if (document.getElementById("ic_class_id") != undefined) {
        var icclassElem = document.getElementById("ic_class_id");
        if (icclassElem != null && icclassElem != undefined && icclassElem.value != undefined && icclassElem.value != "") {
            xmlObj.setAttribute("icClass", trim(icclassElem.value));
        }
        var dsNameElem = document.getElementById("ds_name_id");
        if (dsNameElem != null && dsNameElem != undefined && dsNameElem.value != undefined && dsNameElem.value != "") {
            xmlObj.setAttribute("dsName", trim(dsNameElem.value));
        }
    }
    var urlElem = document.getElementById("url_id");
    if (urlElem != null && urlElem != undefined && urlElem.value != undefined && urlElem.value != "") {
        xmlObj.setAttribute("url", trim(urlElem.value));
    }
    var userElem = document.getElementById("user_id");
    if (userElem != null && userElem != undefined && userElem.value != undefined && userElem.value != "") {
        xmlObj.setAttribute("user", trim(userElem.value));
    }
    var passwordElem = document.getElementById("password_id");
    if (passwordElem != null && passwordElem != undefined && passwordElem.value != undefined && passwordElem.value != "") {
        xmlObj.setAttribute("password", trim(passwordElem.value));
    }
}
function showdatasource(position) {
    var epdiv = document.getElementById("connection_edit");
    if (epdiv != null && epdiv != undefined && epdiv.childNodes.length == 1) {
        var transformeddiv = document.createElement("div");
        var xmlObj = createesbelement("<syn:connection xmlns:syn='http://ws.apache.org/ns/synapse'/>");
        collectconnectioninfo(xmlObj);
        xmlObj.setAttribute("ds", 0);
        processXML(xmlObj, "mediators/connection.xsl", transformeddiv);
        if (transformeddiv.childNodes.length == 1) {
            epdiv.removeChild(epdiv.childNodes[0]);
            epdiv.appendChild(transformeddiv.childNodes[0]);
        }

    }
}

function addstatement(position, statementindex) {
    addstatementIndex(statementindex);
    var qi = statementindexes.length - 1 ;
    var statement_parm = new Object();
    statement_parm.qi = qi;
    statement_parm.isinitparm = "false";
    statement_parm.isinitresult = "false";
    allstatement[allstatement.length] = statement_parm;
    var transformeddiv = document.createElement("div");
    var xmlObj = createesbelement("<syn:statement xmlns:syn='http://ws.apache.org/ns/synapse'/>");
    xmlObj.setAttribute("esb_med_pos", position.toString());
    xmlObj.setAttribute("pindex", position.toString());
    xmlObj.setAttribute("statement_index", qi);
    processXML(xmlObj, "mediators/statement.xsl", transformeddiv);
    var epdiv = document.getElementById("queries");

    if (browsername.indexOf(NETSCAPE_BROWSER_NAME) != -1) {
        if (transformeddiv.childNodes.length == 1) {
            epdiv.appendChild(transformeddiv.childNodes[0]);
        }
        if (transformeddiv.childNodes.length == 2) {
            epdiv.appendChild(transformeddiv.childNodes[0]);
            epdiv.appendChild(transformeddiv.childNodes[0]);
        }
    } else if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
        if (transformeddiv.childNodes[0].childNodes.length == 1) {
            epdiv.appendChild(transformeddiv.childNodes[0].childNodes[0]);
        }
        if (transformeddiv.childNodes[0].childNodes.length == 2) {
            epdiv.appendChild(transformeddiv.childNodes[0].childNodes[0]);
            epdiv.appendChild(transformeddiv.childNodes[0].childNodes[0]);
        }
    }
}

function addparameter(position, pindex, statementindex, parameterindex) {
    addParameterIndex(statementindex, parameterindex);
    var addth = false;
    var mediator = getnestedmediator(internalmodel.sequence, position);
    if (mediator != null) {
        var existingquries = mediator.getElementsByTagName("parameter");
        if (existingquries == undefined || existingquries == null || existingquries.length == 0) {
            existingquries = mediator.getElementsByTagName("syn:parameter");
        }
        if ((existingquries == undefined || existingquries == null || existingquries.length == 0) && parseInt(parameterindex) == 0) {
            var tempbol = true;
            for (var j = 0; j < newParmsForExisstatement.length; j++) {
                if (newParmsForExisstatement[j].ps == statementindex) {
                    tempbol = false;
                }
            }
            if (tempbol) {
                var obj = new Object();
                obj.ps = statementindex;
                newParmsForExisstatement[newParmsForExisstatement.length] = obj;
            }
            addth = tempbol;
        }
    }
    for (var i = 0; i < allstatement.length; i++) {
        if (allstatement[i].qi == statementindex) {
            if (allstatement[i].isinitparm == "false") {
                allstatement[i].isinitparm = "true"
                addth = true;
            } else {
                addth = false;
            }
        }
    }
    var transformeddiv = document.createElement("div");
    var xmlObj = createesbelement("<syn:parameter xmlns:syn='http://ws.apache.org/ns/synapse'/>");

    var noofparm = getnoofparameter(statementindex);
    var paramindex = noofparm - 1;
    if (paramindex != undefined && paramindex != null) {
        xmlObj.setAttribute("parameter_index", paramindex.toString());
    }
    if (addth) {
        if (parseInt(parameterindex) == 0) {
            xmlObj.setAttribute("thneed", "true");
        }
    } else {
        if (parseInt(parameterindex) != 0) {
            var tbody = document.getElementById("parameters" + statementindex.toString());
            if (tbody != null && tbody != undefined) {
                if (tbody.childNodes.length == 0) {
                    xmlObj.setAttribute("thneed", "true");
                }
            }
        }
        else {
            xmlObj.setAttribute("thneed", "false");
        }
    }

    var ps = pindex.toString() + "." + (parseInt(statementindex) + 1).toString() + "." + (paramindex + 1).toString();
    xmlObj.setAttribute("esb_med_pos", ps);
    xmlObj.setAttribute("pindex", pindex.toString());
    xmlObj.setAttribute("statement_index", statementindex);

    processXML(xmlObj, "mediators/parameter.xsl", transformeddiv);
    var epdiv = document.getElementById("parameters" + statementindex.toString());
    if (browsername.indexOf(NETSCAPE_BROWSER_NAME) != -1) {
        if (transformeddiv.childNodes[0].childNodes[0].childNodes.length == 1) {
            epdiv.appendChild(transformeddiv.childNodes[0].childNodes[0].childNodes[0]);
        }
        if (transformeddiv.childNodes[0].childNodes[0].childNodes.length == 2) {
            epdiv.appendChild(transformeddiv.childNodes[0].childNodes[0].childNodes[0]);
            epdiv.appendChild(transformeddiv.childNodes[0].childNodes[0].childNodes[0]);
        }
    } else if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
        if (transformeddiv.childNodes[0].childNodes[0].childNodes[0].childNodes.length == 1) {
            epdiv.appendChild(transformeddiv.childNodes[0].childNodes[0].childNodes[0].childNodes[0]);
        }
        if (transformeddiv.childNodes[0].childNodes[0].childNodes[0].childNodes.length == 2) {
            epdiv.appendChild(transformeddiv.childNodes[0].childNodes[0].childNodes[0].childNodes[0]);
            epdiv.appendChild(transformeddiv.childNodes[0].childNodes[0].childNodes[0].childNodes[0]);
        }
    }
}
function addresult(position, statementindex, parameterindex) {
    addresultIndex(statementindex, parameterindex);
    var addth = false;
    var mediator = getnestedmediator(internalmodel.sequence, position);
    if (mediator != null) {
        var existingquries = mediator.getElementsByTagName("result");
        if (existingquries == undefined || existingquries == null || existingquries.length == 0) {
            existingquries = mediator.getElementsByTagName("syn:result");
        }
        if ((existingquries == undefined || existingquries == null || existingquries.length == 0) && parseInt(parameterindex) == 0) {
            var tempbol = true;
            for (var j = 0; j < newResultsForExisstatement.length; j++) {
                if (newResultsForExisstatement[j].ps == statementindex) {
                    tempbol = false;
                }
            }
            if (tempbol) {
                var obj = new Object();
                obj.ps = statementindex;
                newResultsForExisstatement[newResultsForExisstatement.length] = obj;
            }
            addth = tempbol;
        }
    }
    for (var i = 0; i < allstatement.length; i++) {
        if (allstatement[i].qi == statementindex) {
            if (allstatement[i].isinitresult == "false") {
                allstatement[i].isinitresult = "true"
                addth = true;
            } else {
                addth = false;
            }
        }
    }
    var transformeddiv = document.createElement("div");
    var xmlObj = createesbelement("<syn:result xmlns:syn='http://ws.apache.org/ns/synapse'/>");
    xmlObj.setAttribute("esb_med_pos", position);
    xmlObj.setAttribute("statement_index", statementindex);
    var noofresult = getnoofresult(statementindex);
    if (noofresult != null && noofresult != undefined) {
        xmlObj.setAttribute("result_index", noofresult);
    }
    if (addth) {
        if (parseInt(parameterindex) == 0) {
            xmlObj.setAttribute("thneed", "true");
        }
    } else {
        if (parseInt(parameterindex) != 0) {
            var tbody = document.getElementById("results" + statementindex.toString());
            if (tbody != null && tbody != undefined) {
                if (tbody.childNodes.length == 0) {
                    xmlObj.setAttribute("thneed", "true");
                }
            }
        }
        else {
            xmlObj.setAttribute("thneed", "false");
        }
    }
    processXML(xmlObj, "mediators/result.xsl", transformeddiv);
    var epdiv = document.getElementById("results" + statementindex.toString());
    if (browsername.indexOf(NETSCAPE_BROWSER_NAME) != -1) {
        if (transformeddiv.childNodes[0].childNodes[0].childNodes.length == 1) {
            epdiv.appendChild(transformeddiv.childNodes[0].childNodes[0].childNodes[0]);
        }
        if (transformeddiv.childNodes[0].childNodes[0].childNodes.length == 2) {
            epdiv.appendChild(transformeddiv.childNodes[0].childNodes[0].childNodes[0]);
            epdiv.appendChild(transformeddiv.childNodes[0].childNodes[0].childNodes[0]);
        }
    } else if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
        if (transformeddiv.childNodes[0].childNodes[0].childNodes[0].childNodes.length == 1) {
            epdiv.appendChild(transformeddiv.childNodes[0].childNodes[0].childNodes[0].childNodes[0]);
        }
        if (transformeddiv.childNodes[0].childNodes[0].childNodes[0].childNodes.length == 2) {
            epdiv.appendChild(transformeddiv.childNodes[0].childNodes[0].childNodes[0].childNodes[0]);
            epdiv.appendChild(transformeddiv.childNodes[0].childNodes[0].childNodes[0].childNodes[0]);
        }
    }
}
function addpoolproperty(med_pos, propcount) {
    addpropertyIndex(propcount);
    var addth = false;
    //    if (parseInt(propcount) == 0) {
    if (needthforprop) {
        addth = true;
        needthforprop = false;
    }
    //    }
    var propertys = document.getElementById("properties");
    if (propertys != undefined && propertys != null) {
        var ths = propertys.getElementsByTagName("th");
        if (ths != null && ths != undefined && ths.length > 0) {
            addth = false;
        }
    }
    var transformeddiv = document.createElement("div");
    var xmlObj = createesbelement("<syn:property xmlns:syn='http://ws.apache.org/ns/synapse'/>");
    var noofprop = getnoofproperty();
    if (noofprop != null && noofprop != undefined) {
        xmlObj.setAttribute("property_index", noofprop);
    }
    if (addth) {
        xmlObj.setAttribute("thneed", "true");
    } else {
        xmlObj.setAttribute("thneed", "false");
    }

    processXML(xmlObj, "mediators/property.xsl", transformeddiv);
    var epdiv = document.getElementById("properties");

    if (browsername.indexOf(NETSCAPE_BROWSER_NAME) != -1) {
        if (transformeddiv.childNodes[0].childNodes[0].childNodes.length == 1) {
            epdiv.appendChild(transformeddiv.childNodes[0].childNodes[0].childNodes[0]);
        }
        if (transformeddiv.childNodes[0].childNodes[0].childNodes.length == 2) {
            epdiv.appendChild(transformeddiv.childNodes[0].childNodes[0].childNodes[0]);
            epdiv.appendChild(transformeddiv.childNodes[0].childNodes[0].childNodes[0]);
        }
    } else if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
        if (transformeddiv.childNodes[0].childNodes[0].childNodes[0].childNodes.length == 1) {
            epdiv.appendChild(transformeddiv.childNodes[0].childNodes[0].childNodes[0].childNodes[0]);
        }
        if (transformeddiv.childNodes[0].childNodes[0].childNodes[0].childNodes.length == 2) {
            epdiv.appendChild(transformeddiv.childNodes[0].childNodes[0].childNodes[0].childNodes[0]);
            epdiv.appendChild(transformeddiv.childNodes[0].childNodes[0].childNodes[0].childNodes[0]);
        }
    }
}
function getpropertyforpool(trs, mediator) {
    var propertytrs = new Array();
    for (var i = 0; i < trs.length; i++) {
        if (trs[i].getAttribute("name") == "syn-property") {
            propertytrs[propertytrs.length] = trs[i];
        }
    }
    for (var j = 0; j < propertytrs.length; j++) {
        if (window.ActiveXObject) {
            if (propertytrs[j].children[0].children[0].value != "" && propertytrs[j].children[0].children[0].value != "Select A Value" && propertytrs[j].children[1].children[0].value != "") {
                var name = trim(propertytrs[j].children[0].children[0].value);
                if (!namevalidate(name)) {
                    esbwarning(INVALID_NAME, TYPE_INFO);
                    return false;
                }
                var propertystr = "<syn:property xmlns:syn='http://ws.apache.org/ns/synapse' name='"
                    + name + "' ";

                propertystr += "value='" + convertAllXmlSpecialChars(propertytrs[j].children[1].children[0].value) + "' ";
                mediator.appendChild(createesbelement(propertystr + "/>"));
            } else {
                if (propertytrs[j].children[0].children[0].value == ""
                    || propertytrs[j].children[0].children[0].value == "Select A Value") {
                    esbwarning("Some properties may haven't defined the name. Each property must define a name.", TYPE_INFO);
                    return false;

                } else if (propertytrs[j].children[1].children[0].value == "") {
                    esbwarning("Some properties may haven't defined the value. Each property must define a value.", TYPE_INFO);
                    return false;
                }
            }
        } else {
            if (propertytrs[j].childNodes[0].childNodes[0].value != "" && propertytrs[j].childNodes[0].childNodes[0].value != "Select A Value" && propertytrs[j].childNodes[1].childNodes[0].value != "") {
                var property;
                if (document.createElementNS != "undefined") {
                    property = document.createElementNS(SYNAPSE_NS, "syn:property");
                }
                property.setAttribute("name", propertytrs[j].childNodes[0].childNodes[0].value);
                property.setAttribute("value", propertytrs[j].childNodes[1].childNodes[0].value);
                mediator.appendChild(property);
            } else {
                if (propertytrs[j].childNodes[0].childNodes[0].value == ""
                    || propertytrs[j].childNodes[0].childNodes[0].value == "Select A Value") {
                    esbwarning("Some properties may haven't defined the name. Each property must define a name.", TYPE_INFO);
                    return false;

                } else if (propertytrs[j].childNodes[1].childNodes[0].value == "") {
                    esbwarning("Some properties may haven't defined the value. Each property must define a value.", TYPE_INFO);
                    return false;
                }
            }
        }
    }
    return true;
}
function deletemediatorparameter(statementindex, parameterindex) {
    var parameter = document.getElementById(parameterindex.toString() + "parameter_id" + statementindex.toString());
    var id = parameterindex.toString() + "parameter_id" + statementindex.toString();
    var parameters = document.getElementById("parameters" + statementindex.toString());
    if (parameters != undefined && parameter != undefined) {
        deleteparameterindex(statementindex, parameterindex);
        var isremovedth = false;
        var tbody = parameters.getElementsByTagName("tbody");
        if (tbody != null && tbody != undefined && tbody.length > 0) {
            var nooftrs = tbody[0].childNodes.length;
            for (var i = 0; i < nooftrs; i++) {
                if (tbody[0].childNodes[i].getAttribute("id") == id) {
                    tbody[0].removeChild(parameter);
                    if (nooftrs == 2 && parameters.childNodes.length == 1) {
                        tbody[0].removeChild(tbody[0].childNodes[0]);
                        for (var j = 0; j < allstatement.length; j++) {
                            if (allstatement[j].qi == statementindex) {
                                allstatement[j].isinitparm = "false";
                            }
                        }
                        isremovedth = true;
                    }
                    return;
                }
            }
        }

        var nooftrs = parameters.childNodes.length;
        for (var i = 0; i < nooftrs; i++) {
            if (parameters.childNodes[i] != null && parameters.childNodes[i].getAttribute("id") == id) {
                parameters.removeChild(parameter);
            }
        }
        if (!isremovedth) {
            if (parameters.getElementsByTagName("tbody") != undefined && parameters.getElementsByTagName("tbody").length > 0) {
                if (parameters.childNodes.length == 2) {
                    parameters.removeChild(parameters.childNodes[1]);
                    for (var j = 0; j < allstatement.length; j++) {
                        if (allstatement[j].qi == statementindex) {
                            allstatement[j].isinitparm = "false";
                        }
                    }
                }

            } else {
                if (parameters.childNodes.length == 1) {
                    parameters.removeChild(parameters.childNodes[0]);
                    for (var j = 0; j < allstatement.length; j++) {
                        if (allstatement[j].qi == statementindex) {
                            allstatement[j].isinitparm = "false";
                        }
                    }
                }

            }
        }
    }
}
function deletemediatorresult(statementindex, resultindex) {
    var result = document.getElementById(resultindex.toString() + "result_id" + statementindex.toString());
    var id = resultindex.toString() + "result_id" + statementindex.toString();
    var results = document.getElementById("results" + statementindex.toString());
    if (results != undefined && result != undefined) {
        var isremovedth = false;
        var tbody = results.getElementsByTagName("tbody");
        if (tbody != null && tbody != undefined && tbody.length > 0) {
            var nooftrs = tbody[0].childNodes.length;
            for (var i = 0; i < nooftrs; i++) {
                if (tbody[0].childNodes[i].getAttribute("id") == id) {
                    tbody[0].removeChild(result);
                    if (nooftrs == 2 && results.childNodes.length == 1) {
                        tbody[0].removeChild(tbody[0].childNodes[0]);
                        for (var j = 0; j < allstatement.length; j++) {
                            if (allstatement[j].qi == statementindex) {
                                allstatement[j].isinitresult = "false";
                            }
                        }
                        isremovedth = true;
                    }
                    return;
                }
            }
        }

        var nooftrs = results.childNodes.length;
        for (var i = 0; i < nooftrs; i++) {
            if (results.childNodes[i] != null && results.childNodes[i].getAttribute("id") == id) {
                results.removeChild(result);
            }
        }
        if (!isremovedth) {
            if (results.getElementsByTagName("tbody") != undefined && results.getElementsByTagName("tbody").length > 0) {
                if (results.childNodes.length == 2) {
                    results.removeChild(results.childNodes[1]);
                    for (var j = 0; j < allstatement.length; j++) {
                        if (allstatement[j].qi == statementindex) {
                            allstatement[j].isinitresult = "false";
                        }
                    }
                }

            } else {
                if (results.childNodes.length == 1) {
                    results.removeChild(results.childNodes[0]);
                    for (var j = 0; j < allstatement.length; j++) {
                        if (allstatement[j].qi == statementindex) {
                            allstatement[j].isinitresult = "false";
                        }
                    }
                }

            }
        }
    }
}
function deletepoolproperty(propertyindex) {
    var property = document.getElementById("property" + propertyindex.toString());
    var id = "property" + propertyindex.toString();
    var propertys = document.getElementById("properties");
    if (propertys != undefined && property != undefined && propertys != null && property != null) {
        var isremovedth = false;
        var tbody = propertys.getElementsByTagName("tbody");
        if (tbody != null && tbody != undefined && tbody.length > 0) {
            var nooftrs = tbody[0].childNodes.length;
            for (var i = 0; i < nooftrs; i++) {
                if (tbody[0].childNodes[i].getAttribute("id") == id) {
                    tbody[0].removeChild(property);
                    if (nooftrs == 2 && propertys.childNodes.length == 1) {
                        tbody[0].removeChild(tbody[0].childNodes[0]);
                        isremovedth = true;
                        needthforprop = true;
                    }
                    return;
                }
            }
        }

        var nooftrs = propertys.childNodes.length;

        for (var i = 0; i < nooftrs; i++) {
            if (propertys.childNodes[i] != null && propertys.childNodes[i].getAttribute("id") == id) {
                propertys.removeChild(property);
            }
        }

        if (!isremovedth) {
            if (propertys.getElementsByTagName("tbody") != undefined && propertys.getElementsByTagName("tbody").length > 0) {
                if (propertys.childNodes.length == 2) {
                    propertys.removeChild(propertys.childNodes[1]);
                    needthforprop = true;
                }

            } else {
                if (propertys.childNodes.length == 1) {
                    propertys.removeChild(propertys.childNodes[0]);
                    needthforprop = true;
                }
            }
        }
    }
}

function deletestatement(statementindex, position) {
    deletestatementIndex(statementindex);
    var epdiv = document.getElementById("queries");
    var id = "statement" + statementindex.toString();
    var childDivs = epdiv.childNodes;
    if (childDivs != null) {
        for (var i = 0; i < childDivs.length; i++) {
            if (childDivs[i].getAttribute("id") == id) {
                epdiv.removeChild(childDivs[i]);
                return;
            }
        }
    }
}

function onpropertynamechange(propertyindex) {
    var property = document.getElementById("property" + propertyindex.toString());
    var id = "property" + propertyindex.toString();
    var propertys = document.getElementById("properties");
    if (propertys != undefined && property != undefined && propertys != null && property != null) {
        var tbody = propertys.getElementsByTagName("tbody");
        var found = false;
        if (tbody != null && tbody != undefined && tbody.length > 0) {
            for (var i = 0; i < tbody[0].childNodes.length; i++) {
                if (tbody[0].childNodes[i].getAttribute("id") == id) {
                    found = true;
                    var name = tbody[0].childNodes[i].childNodes[0].childNodes[0].value;
                    if (containspropertyname(name)) {
                        tbody[0].childNodes[i].childNodes[0].childNodes[0].options.selectedIndex = 0;
                        esbwarning("The property with a name ' " + name + " ' has already been" +
                                   "defined. Adding the same property twice isn't allowed.", TYPE_INFO);
                        return;
                    }
                    addpropertyname(name);
                    var oldchild = tbody[0].childNodes[i].childNodes[1];
                    if (name == "autocommit" || name == "poolstatements" || name == "testonborrow" || name == "testonreturn"
                        || name == "testwhileidle") {
                        oldchild.removeChild(oldchild.childNodes[0]);
                        var select = createboolselectelement();
                        oldchild.appendChild(select);
                    } else if (name == "initialsize" || name == "maxactive" || name == "maxidle" || name == "maxopenstatements"
                        || name == "minidle") {
                        oldchild.innerHTML = "<input type='text' class='esb-edit small_textbox'"
                            + "onclick=" + "onclickpropertyname('" + propertyindex + "')  value='( int )' >"
                    } else if (name == "validationquery") {
                        oldchild.innerHTML = "<input type='text' class='esb-edit small_textbox'"
                            + "onclick=" + "onclickpropertyname('" + propertyindex + "')  value='( String )' >"
                    } else if (name == "maxwait") {
                        oldchild.innerHTML = "<input type='text' class='esb-edit small_textbox'"
                            + "onclick=" + "onclickpropertyname('" + propertyindex + "')  value='( long )' >"
                    } else if (name == "isolation") {
                        oldchild.removeChild(oldchild.childNodes[0]);
                        var select = createisolationcombobox();
                        oldchild.appendChild(select);
                    } else if (name == "Select A Value") {
                        oldchild.removeChild(oldchild.childNodes[0]);
                        var select = createinputtextbox(null);
                        oldchild.appendChild(select);
                    }
                }
            }
        }
        if (!found) {
            for (var i = 0; i < propertys.childNodes.length; i++) {
                if (propertys.childNodes[i].getAttribute("id") == id) {
                    var name = propertys.childNodes[i].childNodes[0].childNodes[0].value;
                    if (containspropertyname(name)) {
                        propertys.childNodes[i].childNodes[0].childNodes[0].options.selectedIndex = 0;
                        esbwarning("The property with a name ' " + name + " ' has already been "
                            + "defined. Adding the same property twice isn't allowed.", TYPE_INFO);
                        return;
                    }
                    addpropertyname(name);
                    var oldchild = propertys.childNodes[i].childNodes[1];
                    if (name == "autocommit" || name == "poolstatements" || name == "testonborrow" || name == "testonreturn"
                        || name == "testwhileidle") {
                        oldchild.removeChild(oldchild.childNodes[0]);
                        var select = createboolselectelement();
                        oldchild.appendChild(select);
                    } else if (name == "initialsize" || name == "maxactive" || name == "maxidle" || name == "maxopenstatements"
                        || name == "minidle") {
                        oldchild.innerHTML = "<input type='text' class='esb-edit small_textbox'"
                            + "onclick=" + "onclickpropertyname('" + propertyindex + "')  value='( int )' >"
                    } else if (name == "validationquery") {
                        oldchild.innerHTML = "<input type='text' class='esb-edit small_textbox'"
                            + "onclick=" + "onclickpropertyname('" + propertyindex + "')  value='( String )' >"
                    } else if (name == "maxwait") {
                        oldchild.innerHTML = "<input type='text' class='esb-edit small_textbox'"
                            + "onclick=" + "onclickpropertyname('" + propertyindex + "')  value='( long )' >"
                    } else if (name == "isolation") {
                        oldchild.removeChild(oldchild.childNodes[0]);
                        var select = createisolationcombobox();
                        oldchild.appendChild(select);
                    } else if (name == "Select A Value") {
                        oldchild.removeChild(oldchild.childNodes[0]);
                        var select = createinputtextbox(null);
                        oldchild.appendChild(select);
                    }
                }
            }
        }

    }
}

function createboolselectelement() {
    // Create the element:
    var combo_box = document.createElement('select');
    combo_box.className = "esb-edit small_textbox";

    // Set some properties:
    combo_box.name = 'property_value';

    // Add some choices:
    var choice = document.createElement('option');
    choice.value = 'true';
    choice.appendChild(document.createTextNode('true'));
    combo_box.appendChild(choice);

    choice = document.createElement('option');
    choice.value = 'false';
    choice.appendChild(document.createTextNode('false'));
    combo_box.appendChild(choice);

    return combo_box;
}

function createinputtextboxwithid(id) {
    var input = document.createElement('input');
    input.className = 'esb-edit small_textbox';
    input.setAttribute('type', 'text');
    if (id != null && id != undefined) {
        input.setAttribute("id", id);
    }
    return input;
}
function createinputtextbox(value) {

    var input = document.createElement('input');
    input.className = 'esb-edit small_textbox';
    input.setAttribute('type', 'text');
    if (value != null && value != undefined) {
        input.setAttribute('value', value);
    } else {
        input.className = "esb-edit_disabled";
        input.disabled = true;
    }

    return input;
}

function createisolationcombobox() {
    // Create the element:
    var combo_box = document.createElement('select');
    combo_box.className = "esb-edit small_textbox";

    // Set some properties:
    combo_box.name = 'property_value';

    // Add some choices:
    var choice = document.createElement('option');
    choice.value = 'Connection.TRANSACTION_NONE';
    choice.appendChild(document.createTextNode('Connection.TRANSACTION_NONE'));
    combo_box.appendChild(choice);

    choice = document.createElement('option');
    choice.value = 'Connection.TRANSACTION_READ_COMMITTED';
    choice.appendChild(document.createTextNode('Connection.TRANSACTION_READ_COMMITTED'));
    combo_box.appendChild(choice);

    choice = document.createElement('option');
    choice.value = 'Connection.TRANSACTION_READ_UNCOMMITTED';
    choice.appendChild(document.createTextNode('Connection.TRANSACTION_READ_UNCOMMITTED'));
    combo_box.appendChild(choice);

    choice = document.createElement('option');
    choice.value = 'Connection.TRANSACTION_REPEATABLE_READ';
    choice.appendChild(document.createTextNode('Connection.TRANSACTION_REPEATABLE_READ'));
    combo_box.appendChild(choice);

    choice = document.createElement('option');
    choice.value = 'Connection.TRANSACTION_SERIALIZABLE';
    choice.appendChild(document.createTextNode('Connection.TRANSACTION_SERIALIZABLE'));
    combo_box.appendChild(choice);

    return combo_box;
}

function showNamespaceButtonForPrameters(position, pindex, typeID, cellID) {
    var typeElement = document.getElementById(typeID + position);
    var type = typeElement[typeElement.selectedIndex].value;
    var Buttoncell = document.getElementById(cellID + position);

    var si = position.substring((pindex.toString() + ".").length, position.length) ;
    var correctedps = null;
    if (si != null && si != undefined) {
        var si2 = si.substring(0, si.indexOf("."));
        var pi = si.substring(si.indexOf(".") + 1, si.length);
        if (pi != null && pi != undefined && si2 != null && si2 != undefined) {
            var deletedsi = getdeletedpreviousstatements(parseInt(si2) - 1);
            var deletedpi = getdeleteparametercount((parseInt(si2) - 1), parseInt(pi));
            if (deletedsi != undefined && deletedsi != null && deletedsi != 0) {
                if (deletedpi != null && deletedpi != undefined && deletedpi != 0) {
                    var csi = si2 - deletedsi ;
                    if (csi != undefined && csi != null) {
                        correctedps = pindex.toString() + "." + (csi).toString() + "." + (parseInt(pi) - parseInt(deletedpi)).toString();
                    }
                } else {
                    var csi = si2 - deletedsi ;
                    if (csi != undefined && csi != null) {
                        correctedps = pindex.toString() + "." + (csi).toString() + "." + (parseInt(pi)).toString();
                    }
                }
            } else {
                if (deletedpi != null && deletedpi != undefined && deletedpi != 0) {
                    if (si2 != undefined && si2 != null) {
                        correctedps = pindex.toString() + "." + (si2).toString() + "." + (parseInt(pi) - parseInt(deletedpi)).toString();
                    }
                } else {
                    if (si2 != undefined && si2 != null) {
                        correctedps = pindex.toString() + "." + (si2).toString() + "." + (parseInt(pi)).toString();
                    }
                }
            }
        }
    }
    if (correctedps != null && correctedps != undefined) {
        position = correctedps;
    }
    if (type == "expression") {
        Buttoncell.innerHTML = "<a title='Namespace Editor' onclick=showNameSpaceEditorForParameter('" + position + "','" + pindex + "','','') class='ns_editor'>&nbsp;&nbsp;&nbsp;&nbsp;</a>";
    } else {
        Buttoncell.innerHTML = "";
    }
}

function showNameSpaceEditorForParameter(position, pindex, attribute, inputID) {
    var mediator = getnestedmediator(internalmodel.sequence, pindex);
    var temp = collectdatatemporaly(mediator);
    setnodepositions(mediator, pindex);
    showNameSpaceEditor(position, attribute, inputID);
}