/*
 *  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 *  WSO2 Inc. licenses this file to you under the Apache License,
 *  Version 2.0 (the "License"); you may not use this file except
 *  in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 *
 */

/**
 * This js file is for the log mediator specific UI operations
 */


collectdata["filter"] = function collectlogdata(mediator) {
    var xpath = document.getElementById("filter_xpath");
    var _source = document.getElementById("filter_src");
    var regex = document.getElementById("filter_regex");

    if (xpath != undefined && _source == undefined && regex == undefined) {
        if (xpath != null && xpath.value != "") {
            mediator.setAttribute("xpath", xpath.value);
            mediator.removeAttribute("source");
            mediator.removeAttribute("regex");
        } else {
            esbwarning("The source XPath must be specified for the filter mediator", TYPE_INFO);
            return false;
        }
    } else {
        if ((_source != null && _source.value != "")) {
            mediator.setAttribute("source", trim(_source.value));

        } else {
            esbwarning("The source XPath must be specified for the filter mediator", TYPE_INFO);
            return false;
        }
        if (regex != null && regex.value != "") {
            mediator.setAttribute("regex", trim(regex.value));
        } else {
            esbwarning("The regular expression must be specified for the filter mediator", TYPE_INFO);
            return false;
        }
        mediator.removeAttribute("xpath");
    }

    return true;
};

function setsourceregex(position) {

    var epdiv = document.getElementById("filter_edit_div");
    var mediator = getnestedmediator(internalmodel.sequence, position);

    if (epdiv != null && mediator != null) {
        mediator.setAttribute("set_src", "1");
        mediator.setAttribute("set_xpath", "0");
        processXML(mediator, "mediators/filter_edit.xsl", epdiv);
    }

}

function setxpath(position) {

    var epdiv = document.getElementById("filter_edit_div");
    var mediator = getnestedmediator(internalmodel.sequence, position);

    if (epdiv != null && mediator != null) {
        mediator.setAttribute("set_xpath", "1");
        mediator.setAttribute("set_src", "0");
        processXML(mediator, "mediators/filter_edit.xsl", epdiv);
    }

}

mediatorelementstring["filter"] = function logstring() {
    return "<syn:filter xmlns:syn='http://ws.apache.org/ns/synapse'><syn:then/><syn:else/></syn:filter>";
};
