/*
 *  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 *  WSO2 Inc. licenses this file to you under the Apache License,
 *  Version 2.0 (the "License"); you may not use this file except
 *  in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 *
 */

/**
 * This js file is for the log mediator specific UI operations
 */


collectdata["header"] = function collectlogdata(mediator, validate) {
    var name = document.getElementById("header_name");
    var typeElements = document.getElementsByName("type");
    var _value = document.getElementById("header_valueorexpr_value");
    var actionElements = document.getElementsByName("action");

    if (name != null && name.value != "") {
        if (!namevalidate(name.value)) {
            esbwarning(INVALID_NAME, TYPE_INFO);
            return false;
        }
        mediator.setAttribute("name", name.value);
        if ((_value == undefined || _value == null || _value.value == "") && actionElements[0].checked && !validate) {
            esbwarning("A value or expression must be specified to select the SOAP header", TYPE_INFO);
            return false;
        }

        if (name.value.indexOf(":") != -1) {
            var prefix = name.value.substring(0, name.value.indexOf(":"));
            if (!isDeclared(mediator, prefix) && !validate) {
                esbwarning("Undeclared namesapce: " + prefix, TYPE_WARN);
                return false;
            }
        }

        if (actionElements[0].checked) {
            mediator.setAttribute("action", "set");
            if (typeElements.length != 0 && typeElements[0].checked) {
                mediator.setAttribute("value", _value.value);
                mediator.removeAttribute("expression");
            } else if (_value != undefined && _value != null) {
                mediator.setAttribute("expression", _value.value);
                mediator.removeAttribute("value");
            }
        } else {
            mediator.setAttribute("action", "remove");
        }
    }
    else if (!validate) {
        esbwarning("The header name must be specified", TYPE_INFO);
        return false;
    }

    return true;
};

function setExpr(position) {

    var medposition = geteditingmediatorposition();

    var mediator = getnestedmediator(internalmodel.sequence, medposition);

    collectdata["header"](mediator, true);
    mediator.removeAttribute("value");
    mediator.setAttribute("expression", "");

    editmediator(position);

    showNamespaceButton(position, '', '', 'namespaceButtonCell', 'true');
}

function setValue(position) {

    var medposition = geteditingmediatorposition();

    var mediator = getnestedmediator(internalmodel.sequence, medposition);

    collectdata["header"](mediator, true);
    mediator.removeAttribute("expression");
    mediator.setAttribute("value", "");

    editmediator(position);
}

function setRemoveState(action) {

    var position = geteditingmediatorposition();

    var mediator = getnestedmediator(internalmodel.sequence, position);

    collectdata["header"](mediator, true);
    mediator.setAttribute("action", action);

    editmediator(position);
}