/*
 *  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 *  WSO2 Inc. licenses this file to you under the Apache License,
 *  Version 2.0 (the "License"); you may not use this file except
 *  in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 *
 */

/**
 * This js file is for the makefault mediator specific UI operations
 */

var mediatorPosition;
var currentsoapversion = "soap11"

initedit["makefault"] = function initmakefaultedit(mediator) {
    var version = mediator.getAttribute("version");
    if (version != null && version != undefined) {
        currentsoapversion = version;
    }
};

collectdata["makefault"] = function collectlogdata(mediator) {

    var selectedVersion;
    if (document.getElementById("soap11").getAttribute("checked")) {
        selectedVersion = "soap11";
    } else {
        selectedVersion = "soap12";
    }

    var reasonContent = document.getElementById("reasonContent").value;

    var prefix = "";
    if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
        prefix = "syn:";
    }

    var codeElement = document.getElementById("codeValue");
    var selectedIndex = codeElement.selectedIndex;
    var codeValue = codeElement[selectedIndex].value;

    //code and reason have to be filled by the user code can not be blank (selection control)
    if (reasonContent != "") {

        if (mediator.getElementsByTagName(prefix + "node").length != 0) {
            mediator.removeChild(mediator.getElementsByTagName(prefix + "node")[0]);
        }

        if (mediator.getElementsByTagName(prefix + "role").length != 0) {
            mediator.removeChild(mediator.getElementsByTagName(prefix + "role")[0]);
        }

        if (mediator.getElementsByTagName(prefix + "detail").length != 0) {
            mediator.removeChild(mediator.getElementsByTagName(prefix + "detail")[0]);
        }

        var codeelem = mediator.getElementsByTagName(prefix + "code")[0];
        mediator.removeChild(codeelem);

        if (selectedVersion == "soap11") {
            mediator.appendChild(createesbelement("<syn:code value='sf11:" + codeValue
                + "' xmlns:sf11='http://schemas.xmlsoap.org/soap/envelope/' "
                + "xmlns:syn='http://ws.apache.org/ns/synapse'/>"));
            mediator.setAttribute("version", "soap11");
        }

        if (selectedVersion == "soap12") {
            mediator.appendChild(createesbelement("<syn:code value='sf12:" + codeValue
                + "' xmlns:sf12='http://www.w3.org/2003/05/soap-envelope' "
                + "xmlns:syn='http://ws.apache.org/ns/synapse'/>"));
            mediator.setAttribute("version", "soap12");
        }

        var reasonTypeValue = document.getElementById("reasonTypeValue");
        var reasonelem = mediator.getElementsByTagName(prefix + "reason")[0];

        if (reasonTypeValue.checked) {
            if (reasonelem.getAttribute("expression") != null) {
                reasonelem.removeAttribute("expression");
            }
            reasonelem.setAttribute("value", trim(reasonContent));
        } else {
            if (reasonelem.getAttribute("value") != null) {
                reasonelem.removeAttribute("value");
            }
            reasonelem.setAttribute("expression", trim(reasonContent));
        }

        if (selectedVersion == "soap12") {

            if (document.getElementById("node").value != "") {
                mediator.appendChild(createesbelement(
                    "<syn:node xmlns:syn='http://ws.apache.org/ns/synapse'>"
                        + trim(document.getElementById("node").value) + "</syn:node>"));
            }
        }

        if (document.getElementById("role").value != "") {
            mediator.appendChild(createesbelement(
                "<syn:role xmlns:syn='http://ws.apache.org/ns/synapse'>"
                    + trim(document.getElementById("role").value) + "</syn:role>"));
        }

        if (document.getElementById("detail") != null && document.getElementById("detail").value != "") {
            mediator.appendChild(createesbelement(
                "<syn:detail xmlns:syn='http://ws.apache.org/ns/synapse'>"
                    + trim(document.getElementById("detail").value) + "</syn:detail>"));
        }

    } else {
        esbwarning("Code and Reason must be specified", TYPE_INFO);
        return false;
    }
    currentsoapversion = "soap11"
    return true;
};

mediatorelementstring["makefault"] = function makefaultstring() {
    return "<syn:makefault xmlns:syn='http://ws.apache.org/ns/synapse'>" +
           "<syn:code/><syn:reason/></syn:makefault>";
};

function changeVersion(version, position) {

    if (currentsoapversion != version) {

        currentsoapversion = version;

        var epdiv = document.getElementById("makefault_edit_div");
        var mediator = getnestedmediator(internalmodel.sequence, position);

        clearAllAttributesOfMakeFaultMediator(mediator);

        if (epdiv != null && mediator != null) {
            mediator.setAttribute("version", version);
            processXML(mediator, "mediators/makefault_edit.xsl", epdiv);
        }

    } else {
        if (version == "soap11") {
            if (document.getElementById("soap12").checked) {
                document.getElementById("soap11").checked = true;
                document.getElementById("soap12").checked = false;

                var epdiv = document.getElementById("makefault_edit_div");
                var mediator = getnestedmediator(internalmodel.sequence, position);


                if (epdiv != null && mediator != null) {
                    mediator.setAttribute("version", "soap11");
                    processXML(mediator, "mediators/makefault_edit.xsl", epdiv);
                }
            }
        } else {
            if (document.getElementById("soap11").checked) {
                document.getElementById("soap11").checked = false;
                document.getElementById("soap12").checked = true;

                var epdiv = document.getElementById("makefault_edit_div");
                var mediator = getnestedmediator(internalmodel.sequence, position);

                if (epdiv != null && mediator != null) {
                    mediator.setAttribute("version", "soap12")
                    processXML(mediator, "mediators/makefault_edit.xsl", epdiv);
                }
            }

        }
    }

    function clearAllAttributesOfMakeFaultMediator(mediator) {
        var limit = mediator.childNodes.length;
        for (var i = 0; i < limit; i++) {
            var child = mediator.childNodes[i] ;
            if (child != null && child != undefined) {
                var name = child.nodeName;
                if (name == "syn:code" || name == "code") {
                    child.removeAttribute("expression");
                    child.removeAttribute("value");
                } else if (name == "syn:reason" || name == "reason") {
                    child.removeAttribute("expression");
                    child.removeAttribute("value");
                } else if (name == "syn:node" || name == "node") {
                    while (child.childNodes != null && child.childNodes.length > 0) {
                        child.removeChild(child.childNodes[child.childNodes.length - 1]);
                    }
                } else if (name == "syn:role" || name == "role") {
                    while (child.childNodes != null && child.childNodes.length > 0) {
                        child.removeChild(child.childNodes[child.childNodes.length - 1]);
                    }
                } else if (name == "syn:detail" || name == "detail") {
                    while (child.childNodes != null && child.childNodes.length > 0) {
                        child.removeChild(child.childNodes[child.childNodes.length - 1]);
                    }
                }
            }
        }
    }
}




