/*
 *  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 *  WSO2 Inc. licenses this file to you under the Apache License,
 *  Version 2.0 (the "License"); you may not use this file except
 *  in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 *
 */

/**
 * This js file is for the log mediator specific UI operations
 */

collectdata["pojoCommand"] = function collectcommanddata(mediator, validate) {

    var name = document.getElementById("command_pojo_name");
    if (name != null && name.value != null && name.value != "") {
        mediator.setAttribute("name", name.value);
    } else if (!validate) {
        esbwarning("The class name must be specified for the class mediator", TYPE_INFO);
        return false;
    }

    var namespaces = new Array();

    var prefix = "";
    if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
        prefix = "syn:";
    }

    var existingprops = mediator.getElementsByTagName(prefix + "property");
    while (existingprops.length > 0) {
        var attrs = existingprops[0].attributes;
        var ns_string = "";
        for (var s = 0; s < attrs.length; s++) {
            if (attrs[s].name.indexOf("xmlns:") == 0) {
                ns_string = ns_string + " " + attrs[s].name.substring(6, attrs[s].name.length) + "###" + attrs[s].value;
            }
        }
        if (ns_string != "") {
            namespaces[existingprops[0].getAttribute("name")] = ns_string;
        }
        mediator.removeChild(existingprops[0]);
    }

    var propertyNamess = document.getElementsByName("property_name");
    //    alert(propertyNamess.length)
    for (var i = 0; i < propertyNamess.length; i++) {
        var propName_shown = propertyNamess[i].getAttribute("value");
        var propName_real = propName_shown.charAt(0).toLowerCase() + propName_shown.substring(1, propName_shown.length);
        var propReadValue_real = document.getElementById("command_med_prop_read" + propName_real);
        var propReadType_real = document.getElementsByName("prop_type_read_" + propName_real)[0].value; // todo: check 0
        var propUpdateValue_real = document.getElementById("command_med_prop_update" + propName_real);
        var propUpdateType_real = document.getElementsByName("prop_type_update_" + propName_real)[0].value;
        var read_value, update_value;
        if (propReadValue_real != null) {
            read_value = propReadValue_real.value;
        } else {
            read_value = "";
        }

        if (propUpdateValue_real != null) {
            update_value = propUpdateValue_real.value;
        } else {
            update_value = "";
        }
        //        alert(propValue_real.value)
        if (propReadType_real != "none" || propUpdateType_real != "none") {
            //            var propchild = getsynproperty();
            //            alert(propValue_real)
            var propchild = createesbelement("<syn:property xmlns:syn='http://ws.apache.org/ns/synapse'/>");
            propchild.setAttribute("name", propName_real);
            var propchild2 = null;
            if (propReadType_real == "value" && propUpdateType_real == "message") {
                // ReadValueUpdateMessage
                propchild.setAttribute("value", read_value);
                propchild.setAttribute("expression", update_value);
            } else if (propReadType_real == "value" && propUpdateType_real == "context") {
                // ReadValueUpdateContext
                propchild.setAttribute("value", read_value);
                propchild.setAttribute("context-name", update_value);
            } else if (propReadType_real == "value" && propUpdateType_real == "none") {
                // ReadValue
                propchild.setAttribute("value", read_value);
            } else if (propReadType_real == "message" && propUpdateType_real == "message") {
                propchild.setAttribute("expression", read_value);
                if (read_value == update_value) {
                    // ReadAndUpdateMessage
                    propchild.setAttribute("action", "ReadAndUpdateMessage")
                } else {
                    // ReadMessage + UpdateMessage
                    propchild.setAttribute("action", "ReadMessage");
                    propchild2 = createesbelement("<syn:property xmlns:syn='http://ws.apache.org/ns/synapse'/>");
                    propchild2.setAttribute("name", propName_real);
                    propchild2.setAttribute("expression", update_value);
                    propchild2.setAttribute("action", "UpdateMessage");                    
                }
            } else if (propReadType_real == "message" && propUpdateType_real == "context") {
                // ReadMessageAndUpdateContext
                propchild.setAttribute("expression", read_value);
                propchild.setAttribute("context-name", update_value);
                propchild.setAttribute("action", "ReadMessage");
            } else if (propReadType_real == "message" && propUpdateType_real == "none") {
                // ReadMessage
                propchild.setAttribute("expression", read_value);
                propchild.setAttribute("action", "ReadMessage");
            } else if (propReadType_real == "context" && propUpdateType_real == "message") {
                // ReadContextAndUpdateMessage
                propchild.setAttribute("context-name", read_value);
                propchild.setAttribute("expression", update_value);
                propchild.setAttribute("action", "ReadContext");
            } else if (propReadType_real == "context" && propUpdateType_real == "context") {
                propchild.setAttribute("context-name", read_value);
                if (read_value == update_value) {
                    // ReadAndUpdateContext
                    propchild.setAttribute("action", "ReadAndUpdateContext")
                } else {
                    // ReadContext + UpdateContext
                    propchild.setAttribute("action", "ReadContext");
                    propchild2 = createesbelement("<syn:property xmlns:syn='http://ws.apache.org/ns/synapse'/>");
                    propchild2.setAttribute("name", propName_real);
                    propchild2.setAttribute("context-name", update_value);
                    propchild2.setAttribute("action", "UpdateContext");
                }
            } else if (propReadType_real == "context" && propUpdateType_real == "none") {
                // ReadContext
                propchild.setAttribute("context-name", read_value);
                propchild.setAttribute("action", "ReadContext");
            } else if (propReadType_real == "none" && propUpdateType_real == "message") {
                // UpdateMessage
                propchild.setAttribute("expression", update_value);
                propchild.setAttribute("action", "UpdateMessage")
            } else if (propReadType_real == "none" && propUpdateType_real == "context") {
                propchild.setAttribute("context-name", update_value);
                propchild.setAttribute("action", "UpdateContext")
            }
            var attaching_ns = namespaces[propName_real];
            if (attaching_ns != undefined) {
                var splitted_ns = attaching_ns.split(" ");
                for (var j = 0; j < splitted_ns.length; j++) {
                    var nsparts = splitted_ns[j].split("###");
                    if (nsparts.length == 2) {
                        propchild.setAttribute("xmlns:" + nsparts[0], nsparts[1]);
                        if (propchild2 != null) {
                            propchild2.setAttribute("xmlns:" + nsparts[0], nsparts[1]);                            
                        }
                    }
                }
            }
            mediator.appendChild(propchild);
            if (propchild2 != null) {
                mediator.appendChild(propchild2);
            }
        }
    }
    //    alert((new XMLSerializer()).serializeToString(mediator))
    //collectproppertydata(mediator);
    return true;
};

mediatorelementstring["pojoCommand"] = function commandstring() {
    return "<syn:pojoCommand xmlns:syn='http://ws.apache.org/ns/synapse'/>";
};

var propsbeforereload = new Array();

function loadcommandpojo() {

    propsbeforereload = new Array();
    var propertyNames = document.getElementsByName("property_name");
    //    getnestedmediator(internalmodel.sequence, geteditingmediatorposition()).setAttribute("name", document.getElementById("command_pojo_name").value);
    //    for (var i=0; i<propertyNames.length; i++) {
    //        var propName_shown = propertyNames[i].getAttribute("value");
    //        var propName_real = propName_shown.charAt(0).toLowerCase() + propName_shown.substring(1, propName_shown.length);
    //        var propValue_real = document.getElementById("command_med_prop" + propName_real);
    //        var propType_real = document.getElementsByName("prop_type_" + propName_real)[0].value;
    //        propsbeforereload[propName_real] = propType_real + "###" + propValue_real.value;
    //    }

    collectdata["pojoCommand"](getnestedmediator(internalmodel.sequence, geteditingmediatorposition()));

    var body_xml = '<ns1:loadCommand xmlns:ns1="http://org.apache.synapse/xsd">' +
                   '<ns1:className>' + document.getElementById("command_pojo_name").value + '</ns1:className>' +
                   '</ns1:loadCommand>';
    var callURL = serverURL + "/" + MEDIATOR_ADMIN + "/" ;
    send("loadCommand", body_xml, "", callURL, "", false, loadcommandpojocallback);
}

function loadcommandpojocallback() {
    if (!onError()) {
        return;
    }
    var prefix = "";
    if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
        prefix = "syn:";
    }
    var properties = xhReq.responseXML.getElementsByTagName(prefix + "property");


    var position = geteditingmediatorposition();
    var mediator = getnestedmediator(internalmodel.sequence, position);
    var existingprops = mediator.getElementsByTagName(prefix + "property");


    while (properties.length > 0) {
        var propName = properties[0].getAttribute("name");
        var exists = false;
        for (var g = 0; g < existingprops.length; g++) {
            if (existingprops[g].getAttribute("name") == propName) {
                //                alert("setting true")
                exists = true;
                //                break;
            }
        }
        //        if (propsbeforereload[propName] != undefined && propsbeforereload[propName].indexOf("value###") == 0) {
        //            properties[0].setAttribute("value", propsbeforereload[propName].substring(8));
        //        } else if (propsbeforereload[propName] != undefined && propsbeforereload[propName].indexOf("expression###") == 0) {
        //            properties[0].setAttribute("expression", propsbeforereload[propName].substring(13));
        //            properties[0].removeAttribute("value");
        //        }
        //        alert(propName + " " + exists)
        if (!exists) {
            //            alert("impossible")
            mediator.appendChild(properties[0]);
        } else {
            properties[0].parentNode.removeChild(properties[0]);
        }
    }

    setnodepositions(mediator, position);

    processXML(mediator, "mediators/pojoCommand_edit.xsl", document.getElementById("command_edit_div"))
}

function reloadChanges() {
    var position = geteditingmediatorposition();
    var mediator = getnestedmediator(internalmodel.sequence, position);
    collectdata["pojoCommand"](mediator);
    editmediator(position);
}

function removecommandmedprop(propname) {

    // editing mediator position in the internal model
    var position = geteditingmediatorposition();

    // mediator retrieved and extracting the properties
    var mediator = getnestedmediator(internalmodel.sequence, position);

    collectdata["pojoCommand"](mediator, true);

    var prefix = "";
    if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
        prefix = "syn:";
    }
    var existingprops = mediator.getElementsByTagName(prefix + "property");
    for (var k = 0; k < existingprops.length; k++) {
        if (existingprops[k].getAttribute("name") == propname) {
            mediator.removeChild(existingprops[k]);
            break;
        }
    }

    setnodepositions(mediator, position);

    processXML(mediator, "mediators/pojoCommand_edit.xsl", document.getElementById("command_edit_div"))
}