/*
 *  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 *  WSO2 Inc. licenses this file to you under the Apache License,
 *  Version 2.0 (the "License"); you may not use this file except
 *  in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 *
 */

/**
 * This js file is for the router mediator specific UI operations
 */

initedit["router"] = function initrouteredit(mediator) {

    var targets = mediator.getElementsByTagName("syn:target");
    if (targets.length == 0) {
        targets = mediator.getElementsByTagName("target");
    }

    for (var i=0; i<targets.length; i++) {
        var target_position = targets[i].getAttribute("esb_med_pos");
        targets[i].setAttribute("tg_pos", parseInt(target_position.substring(target_position.lastIndexOf(".") + 1, target_position.length)) + 1);
    }

    var routes = mediator.getElementsByTagName("syn:route");
    if (routes.length == 0) {
        routes = mediator.getElementsByTagName("route");
    }

    for (var j=0; j<routes.length; j++) {
        var route_position = routes[j].getAttribute("esb_med_pos");
        routes[j].setAttribute("rt_pos", parseInt(route_position.substring(route_position.lastIndexOf(".") + 1, route_position.length)) + 1);
    }
}

collectdata["router"] = function collectrouterdata(mediator, validate) {

    var cont_par = document.getElementById("continueAfter").value;
    mediator.setAttribute("continueAfter", cont_par);

    var routes = mediator.getElementsByTagName("syn:route");
    if (routes.length == 0) {
        routes = mediator.getElementsByTagName("route");
    }

    for (var j=0; j<routes.length; j++) {
        var route_position = routes[j].getAttribute("rt_pos");
        var expression = document.getElementById("route_expr" + route_position);
        if (expression != undefined && expression != null && expression.value != undefined) {
            routes[j].setAttribute("expression", expression.value);
        }
        var match = document.getElementById("route_match" + route_position);
        if (match != undefined && match != null && match.value != undefined) {
            routes[j].setAttribute("match", match.value);
        }
        var routebreak = document.getElementById("route_break" + route_position);
        if (routebreak != undefined && routebreak != null && routebreak.value != undefined) {
            routes[j].setAttribute("breakRouter", routebreak.value);
        }

        collectmedtargetdata(routes[j]);
    }

    return true;
};

mediatorelementstring["router"] = function routerstring() {
    return "<syn:router xmlns:syn='http://ws.apache.org/ns/synapse'/>";
};

function addroute() {
    var position = geteditingmediatorposition();
    var mediator = getnestedmediator(internalmodel.sequence, position);

    collectdata[mediator.nodeName.substring(mediator.nodeName.indexOf(":") + 1, mediator.nodeName.length)](mediator, true);

    mediator.appendChild(createesbelement("<syn:route xmlns:syn='http://ws.apache.org/ns/synapse'><syn:target editing='true'/></syn:route>"));

    setnodepositions(mediator, position);

    editmediator(position);
}