/*
 *  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 *  WSO2 Inc. licenses this file to you under the Apache License,
 *  Version 2.0 (the "License"); you may not use this file except
 *  in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 *
 */

/**
 * This js file is for the switch mediator specific UI operations
 */

collectdata["switch"] = function collectswitchdata(mediator, validate) {

    var sourcevalue = document.getElementById("source_val");

    if (sourcevalue != undefined && sourcevalue != null && sourcevalue != "undefined" && sourcevalue.value != "") {
        mediator.setAttribute("source", sourcevalue.value);
    } else if(!validate) {
        esbwarning("Source XPath must be specified", TYPE_INFO);
        return false;
    }

    return true;
};

collectdata["case"] = function collectswitchdata(mediator, validate) {

    var regexvalue = document.getElementById("regex_val");

    if (regexvalue != undefined && regexvalue != null && regexvalue != "undefined" && regexvalue.value != "") {
        mediator.setAttribute("regex", regexvalue.value);
    } else if(!validate) {
        esbwarning("The regular expression must be specified for each case", TYPE_INFO);
        return false;
    }

    return true;
};

mediatorelementstring["switch"] = function logstring() {
    return "<syn:switch xmlns:syn='http://ws.apache.org/ns/synapse'/>";
};

function addcase(position) {
    
    var switchmed = getnestedmediator(internalmodel.sequence, position);

    var editingpos = geteditingmediatorposition();

    if(editingpos != -1) {
        var editingelem = getnestedmediator(internalmodel.sequence, editingpos);
        collectdata[editingelem.nodeName.substring(editingelem.nodeName.indexOf(":") + 1, editingelem.nodeName.length)] (editingelem, true);
    }
    
    var addingposition = position.toString()  + "." + switchmed.childNodes.length;
    
    switchmed.appendChild(createesbelement("<syn:case regex='' xmlns:syn='http://ws.apache.org/ns/synapse'/>"));
    reloadsequencedisplay();

    editmediator(addingposition);
}

function adddefault(position) {

    var switchmed = getnestedmediator(internalmodel.sequence, position);

    var editingpos = geteditingmediatorposition();
    
    if(editingpos != -1) {
        var editingelem = getnestedmediator(internalmodel.sequence, editingpos);
        collectdata[editingelem.nodeName.substring(editingelem.nodeName.indexOf(":") + 1, editingelem.nodeName.length)] (editingelem, true);
    }
    
    switchmed.appendChild(createesbelement("<syn:default xmlns:syn='http://ws.apache.org/ns/synapse'/>"));
    reloadsequencedisplay();
}