/*
 *  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 *  WSO2 Inc. licenses this file to you under the Apache License,
 *  Version 2.0 (the "License"); you may not use this file except
 *  in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 *
 */

/**
 * This js file is for mediator target specific UI operations
 */
function collectmedtargetdata(mediator) {

    var targets = mediator.getElementsByTagName("syn:target");
    if (targets.length == 0) {
        targets = mediator.getElementsByTagName("target");
    }

    for (var j=0; j<targets.length; j++) {
        var target_position = targets[j].getAttribute("tg_pos");
        var toURI = document.getElementById("toURI" + target_position);
        if (toURI != undefined && toURI != null && toURI.value != undefined) {
            targets[j].setAttribute("to", toURI.value);
        }
        var soapAction = document.getElementById("soapAction" + target_position);
        if (soapAction != undefined && soapAction != null && soapAction.value != undefined) {
            targets[j].setAttribute("soapAction", soapAction.value);
        }
        targets[j].setAttribute("editing", "false");
    }
}

function addtarget() {

    var position = geteditingmediatorposition();
    var mediator = getnestedmediator(internalmodel.sequence, position);

    collectdata[mediator.nodeName.substring(mediator.nodeName.indexOf(":") + 1, mediator.nodeName.length)](mediator, true);

    mediator.appendChild(createesbelement("<syn:target xmlns:syn='http://ws.apache.org/ns/synapse' editing='true'/>"));

    setnodepositions(mediator, position);

    editmediator(position);
}

var target_position;
var target_ref_type;

function settargetref(position, type) {
    var med_edit = getnestedmediator(internalmodel.sequence, geteditingmediatorposition());
    collectdata[med_edit.localName](med_edit, false);
    target_position = position;
    target_ref_type = type;
    registrybrowser("settargetreffromregistry", "dicardregistrybrowser", "", 1, "registryPanel");
}

function settargetreffromregistry() {

    var target_med = getnestedmediator(internalmodel.sequence, target_position);
    var target_childs = target_med.childNodes;
    if (target_childs.length == 0) {
        target_childs = target_med.children;
    }

    if (target_childs != undefined) {
        for (var i=0; i<target_childs.length; i++) {
            if (target_childs[i].localName.indexOf(target_ref_type) != -1) {
                target_med.removeChild(target_childs[i]);
            }
        }
    }

    if (target_ref_type == "endpoint") {
        target_med.removeAttribute("ep_anon");
    }

    var ref_key = getRegistryKey();
    dicardregistrybrowser(1);
    target_med.setAttribute(target_ref_type, ref_key);

    editmediator(geteditingmediatorposition());
}

function settargetseqinline(position) {

    var med_pos = geteditingmediatorposition();

    getnestedmediator(internalmodel.sequence, position).removeAttribute("sequence");
    getnestedmediator(internalmodel.sequence, position).appendChild(createesbelement("<syn:sequence name='' anonymous='true' xmlns:syn='http://ws.apache.org/ns/synapse'/>"));
    setnodepositions(internalmodel.sequence);

    vieweditedmediator();

    editmediator(med_pos);
}

function settargetepinline(position) {

    var med_pos = geteditingmediatorposition();

    getnestedmediator(internalmodel.sequence, position).removeAttribute("endpoint");
    getnestedmediator(internalmodel.sequence, position).setAttribute("ep_anon", "true");
    setnodepositions(internalmodel.sequence);

    vieweditedmediator();

    editmediator(med_pos);
}

function deleteTargetEndponit(position) {
    var taregt_c_pos = position;
    if (taregt_c_pos != null && taregt_c_pos != undefined) {
        var mediator = getnestedmediator(internalmodel.sequence, taregt_c_pos);
        if (mediator.childNodes.length > 0) {
            removepreviousendpoint(mediator);
        }
        var epdiv = document.getElementById("ep" + taregt_c_pos);
        if (epdiv != null && mediator != null) {
            processXML(mediator, "mediators/target_edit.xsl", epdiv.parentNode);
        }
    }
}