/*
 *  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 *  WSO2 Inc. licenses this file to you under the Apache License,
 *  Version 2.0 (the "License"); you may not use this file except
 *  in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 *
 */

/**
 * This js file is for the log mediator specific UI operations
 */

var priviouspolicy = null;
var throttle_save_state = 0;

initedit["throttle"] = function initthrottleedit(mediator) {
    throttle_save_state = 0
    priviouspolicy = null;
};

collectdata["throttle"] = function collectlogdata(mediator) {
    throttle_save_state = 1
    var canupdate = upadatemediator(mediator);
    throttle_save_state = 0;
    return canupdate;
};

function upadatemediator(mediator) {
    if (mediator != undefined && mediator != null) {
        var cp = mediator.getAttribute("esb_med_pos");
        var chlimit = mediator.childNodes.length;
        var chindex = null;
        for (var i = 0; i < chlimit; i++) {
            var child = mediator.childNodes[i] ;
            if (child != null && child != undefined && child.nodeName == "syn:policy") {
                chindex = i;
            }
        }
        if (mediator.childNodes[chindex] == undefined || mediator.childNodes[chindex] == null) {
            mediator.appendChild(createesbelement("<syn:policy xmlns:syn='http://ws.apache.org/ns/synapse'/>"));
        }
        chlimit = mediator.childNodes.length;
        for (var i = 0; i < chlimit; i++) {
            var child = mediator.childNodes[i] ;
            if (child != null && child != undefined && child.nodeName == "syn:policy") {
                chindex = i;
            }
        }

        mediator.removeAttribute("id");
        var thottleID = document.getElementById(("throttle_id" + cp).toString());
        if (thottleID != null && thottleID != undefined && thottleID.value != "") {
            var id = trim(thottleID.value);
            if (!namevalidate(id)) {
                esbwarning("The value for the ID contains invalid characters." +
                           " Only, alphanumeric , underscore or dash characters are allowed. ", TYPE_INFO);
                return false;
            }
            mediator.setAttribute("id", id);
        } else {
            if (throttle_save_state == 1) {
                esbwarning("Throttle Id must be specified", TYPE_INFO);
                return false;
            }
        }

        var policykey = document.getElementById(("policy_ref" + cp).toString());
        if (chindex != null && chindex != undefined) {
            if (policykey != null && policykey != undefined) {
                var in_line = mediator.childNodes[chindex].childNodes[0];
                if (in_line != null && in_line != undefined) {
                    mediator.childNodes[chindex].removeChild(in_line);
                }
                if (policykey.value != null && policykey.value != undefined && policykey.value != "Select A Value") {
                    mediator.childNodes[chindex].setAttribute("key", policykey.value);
                }
            } else {
                var policyvalue = null;
                if (priviouspolicy != null && priviouspolicy != undefined) {
                    policyvalue = mediator.childNodes[chindex].childNodes[0];
                    if (policyvalue != null && policyvalue != undefined) {
                        clearnodepositions(policyvalue);
                        mediator.childNodes[chindex].removeChild(policyvalue);
                    }
                    var previousInlinePolicy = createesbelement(priviouspolicy);
                    if (previousInlinePolicy != null) {
                        clearnodepositions(previousInlinePolicy);
                        mediator.childNodes[chindex].appendChild(previousInlinePolicy);
                        mediator.childNodes[chindex].removeAttribute("key")
                    }
                }
            }
        }
        var onaccept_ref = document.getElementById(("onaccept_ref" + cp).toString());
        if (onaccept_ref != undefined && onaccept_ref != null && onaccept_ref.value != null) {
            mediator.setAttribute("onAccept", onaccept_ref.value);
        }
        var onreject_ref = document.getElementById(("onreject_ref" + cp).toString());
        if (onreject_ref != undefined && onreject_ref != null && onreject_ref.value != null) {
            mediator.setAttribute("onReject", onreject_ref.value);
        }
    }
    return true;
}
mediatorelementstring["throttle"] = function logstring() {
    return "<syn:throttle xmlns:syn='http://ws.apache.org/ns/synapse' inline='0'><syn:onAccept/><syn:onReject/><syn:policy/></syn:throttle>";
};

function editinlinethrottlepolicy(index) {
    showInLinePropertyEditor(index, "saveinlinepolicy", "closeLinePropertyEditor", "In-lined Policy Viewer", "In-lined Policy ", "In-lined Policy")
    setinlinepolicy(index);
}
function viewinlinethrottlepolicy(index) {
    showInLinePropertyEditor(index, null, "closeLinePropertyEditor", "In-lined Policy Viewer", "In-lined Policy ", "In-lined Policy")
    setinlinepolicy(index);
    var valueId = document.getElementById("inlineprop_value");
    if (valueId != null && valueId != undefined) {
        valueId.disabled = true;
    }
}
function saveinlinepolicy(index) {
    var valueId = document.getElementById("inlineprop_value");
    var inlinevalue = null;
    if (valueId != null && valueId != undefined) {
        inlinevalue = valueId.value;
    }
    if (inlinevalue == null || inlinevalue == "") {
        esbwarning("Invalid Value", TYPE_WARN);
        return;
    }
    if (window.ActiveXObject) {
        try {
            var doc = new ActiveXObject("Microsoft.XMLDOM");
            doc.async = "false";
            var hasParse = doc.loadXML(inlinevalue);
            if (!hasParse) {
                esbwarning("Invalid WS-Policy definition: XML parse error", TYPE_ERROR);
                return;
            }
        } catch (e) {
            esbwarning("Invalid WS-Policy definition: XML parse error", TYPE_ERROR);
            return;
        }
    } else {
        var parser = new DOMParser();
        var dom = parser.parseFromString(inlinevalue, "text/xml");
        if (dom.documentElement.nodeName == "parsererror") {
            esbwarning("Invalid WS-Policy definition: XML parse error", TYPE_ERROR);
            return;
        }
    }
    priviouspolicy = trim(inlinevalue);
    closeLinePropertyEditor();
}
function throttlepolicykeyfromregistry(index) {
    var panelId = ("mypanel" + index).toString();
    registrybrowser("savepolicykeyfromregistry", "dicardregistrybrowser", index, 1, panelId);
}
function onacceptkeyfromregistry(index) {
    var panelId = ("mypanel" + index).toString();
    registrybrowser("saveonacceptfromregistry", "dicardregistrybrowser", index, 1, panelId);
}
function onrejectkeyfromregistry(index) {
    var panelId = ("mypanel" + index).toString();
    registrybrowser("saveonrejectfromregistry", "dicardregistrybrowser", index, 1, panelId);
}
function savepolicykeyfromregistry(index) {
    var regKey = getRegistryKey()
    var divcontrol = document.getElementById("registryPanel");
    divcontrol.innerHTML = "";
    if (regKey != null && regKey != undefined) {
        var id = "policy_ref" + index;
        var policyref = document.getElementById(id.toString());
        if (policyref != undefined && policyref != null) {
            policyref.value = regKey;
        }
    }
}
function saveonacceptfromregistry(index) {
    var regKey = getRegistryKey()
    var divcontrol = document.getElementById("registryPanel");
    divcontrol.innerHTML = "";
    if (regKey != null && regKey != undefined) {
        var id = "onaccept_ref" + index;
        var policyref = document.getElementById(id.toString());
        if (policyref != undefined && policyref != null) {
            policyref.value = regKey;
        }
    }
}
function saveonrejectfromregistry(index) {
    var regKey = getRegistryKey()
    var divcontrol = document.getElementById("registryPanel");
    divcontrol.innerHTML = "";
    if (regKey != null && regKey != undefined) {
        var id = "onreject_ref" + index;
        var policyref = document.getElementById(id.toString());
        if (policyref != undefined && policyref != null) {
            policyref.value = regKey;
        }
    }
}
function setinlinepolicy(index) {
    var mediator = getnestedmediator(internalmodel.sequence, index);
    var policyvalue = null;
    if (mediator != undefined && mediator != null) {
        var chlimit = mediator.childNodes.length;
        var chindex = null;
        for (var i = 0; i < chlimit; i++) {
            var child = mediator.childNodes[i] ;
            if (child != null && child != undefined && child.nodeName == "syn:policy") {
                chindex = i;
            }
        }
        if (chindex != null && chindex != undefined) {
            if (priviouspolicy == null || priviouspolicy == undefined) {
                policyvalue = mediator.childNodes[chindex].childNodes[0];
            } else {
                policyvalue = priviouspolicy;
            }
        }
    }
    var newpolicy = null;
    if (policyvalue != null && policyvalue != undefined) {
        if (browsername.indexOf(NETSCAPE_BROWSER_NAME) != -1) {
            if (policyvalue instanceof Object) {
                clearnodepositions(policyvalue);
                newpolicy = policyvalue
            } else {
                newpolicy = createesbelement(policyvalue);
                clearnodepositions(newpolicy);
            }
        } else if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
            if (typeof policyvalue == typeof "string") {
                newpolicy = createesbelement(policyvalue);
                clearnodepositions(newpolicy);
            } else {
                clearnodepositions(policyvalue);
                newpolicy = policyvalue
            }
        }
    }
    var valueId = document.getElementById("inlineprop_value");
    if (valueId != null && valueId != undefined) {
        var policyvaluestr = "";
        if (newpolicy != null && newpolicy != undefined) {
            if (browsername.indexOf(NETSCAPE_BROWSER_NAME) != -1) {
                if (newpolicy instanceof Object) {
                    policyvaluestr = xmlSerializerToString(newpolicy);
                } else {
                    policyvaluestr = newpolicy;
                }
            } else if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
                if (typeof newpolicy == typeof "string") {
                    policyvaluestr = newpolicy;
                } else {
                    policyvaluestr = xmlSerializerToString(newpolicy);
                }
            }
        }
        valueId.value = policyvaluestr;
    }
}
function showinlinepolicylayout(index) {
    var mediator = getnestedmediator(internalmodel.sequence, index);
    upadatemediator(mediator);
    var chlimit = mediator.childNodes.length;
    var chindex = null;
    for (var i = 0; i < chlimit; i++) {
        var child = mediator.childNodes[i] ;
        if (child != null && child != undefined && child.nodeName == "syn:policy") {
            chindex = i;
        }
    }
    if (chindex != null) {
        var key = mediator.childNodes[chindex].getAttribute("key") ;
        if (key != null && key != undefined) {
            mediator.childNodes[chindex].removeAttribute("key");
        }
    }
    mediator.setAttribute("inline", 0);
    var epdiv = document.getElementById("throttle_edit");
    if (epdiv != null && mediator != null) {
        processXML(mediator, "mediators/throttle_edit.xsl", epdiv);
    }
}
function showrefpolicylayout(index) {
    var mediator = getnestedmediator(internalmodel.sequence, index);
    upadatemediator(mediator);
    var chlimit = mediator.childNodes.length;
    var chindex = null;
    for (var i = 0; i < chlimit; i++) {
        var child = mediator.childNodes[i] ;
        if (child != null && child != undefined && child.nodeName == "syn:policy") {
            chindex = i;
        }
    }
    if (chindex != null) {
        if (mediator.childNodes[chindex].childNodes.length >= 1) {
            mediator.childNodes[chindex].removeChild(mediator.childNodes[chindex].childNodes[0]);
        }
        mediator.childNodes[chindex].setAttribute("key", "")
    }
    mediator.setAttribute("inline", 1);
    var epdiv = document.getElementById("throttle_edit");
    if (epdiv != null && mediator != null) {
        processXML(mediator, "mediators/throttle_edit.xsl", epdiv);
    }
}
function showrefonacceptlayout(index) {
    var pvsvalue = document.getElementById("policylayoutdiv");
    var mediator = getnestedmediator(internalmodel.sequence, index);
    upadatemediator(mediator);
    var chlimit = mediator.childNodes.length;
    var chindex = null;
    for (var i = 0; i < chlimit; i++) {
        var child = mediator.childNodes[i] ;
        if (child != null && child != undefined && child.nodeName == "syn:onAccept") {
            chindex = i;
        }
    }
    if (chindex != null) {
        mediator.removeChild(mediator.childNodes[chindex]);
    }
    var key = mediator.getAttribute("onAccept") ;
    if (key == null || key == undefined) {
        mediator.setAttribute("onAccept", "");
    }
    var epdiv = document.getElementById("throttle_edit");
    if (epdiv != null && mediator != null) {
        processXML(mediator, "mediators/throttle_edit.xsl", epdiv);
    }
}
function showrefonrejectlayout(index) {
    var pvsvalue = document.getElementById("policylayoutdiv");
    var mediator = getnestedmediator(internalmodel.sequence, index);
    upadatemediator(mediator);
    var chlimit = mediator.childNodes.length;
    var chindex = null;
    for (var i = 0; i < chlimit; i++) {
        var child = mediator.childNodes[i] ;
        if (child != null && child != undefined && child.nodeName == "syn:onReject") {
            chindex = i;
        }
    }
    if (chindex != null) {
        mediator.removeChild(mediator.childNodes[chindex]);
    }
    var key = mediator.getAttribute("onReject") ;
    if (key == null || key == undefined) {
        mediator.setAttribute("onReject", "");
    }
    var epdiv = document.getElementById("throttle_edit");
    if (epdiv != null && mediator != null) {
        processXML(mediator, "mediators/throttle_edit.xsl", epdiv);
    }
}

function showinlineonacceplayout(index) {
    var pvsvalue = document.getElementById("policylayoutdiv");
    var mediator = getnestedmediator(internalmodel.sequence, index);
    upadatemediator(mediator);
    var chlimit = mediator.childNodes.length;
    var chindex = null;
    for (var i = 0; i < chlimit; i++) {
        var child = mediator.childNodes[i] ;
        if (child != null && child != undefined && child.nodeName == "syn:onAccept") {
            chindex = i;
        }
    }
    if (chindex != null) {
        mediator.removeChild(mediator.childNodes[chindex]);
    }
    var key = mediator.getAttribute("onAccept") ;
    if (key != null && key != undefined) {
        mediator.removeAttribute("onAccept")
    }
    mediator.appendChild(createesbelement("<syn:onAccept esb_med_pos='" + index.toString() + "." + (mediator.childNodes.length) + "' xmlns:syn='http://ws.apache.org/ns/synapse'/>"));
    var epdiv = document.getElementById("throttle_edit");
    if (epdiv != null && mediator != null) {
        processXML(mediator, "mediators/throttle_edit.xsl", epdiv);
        //        var newvalue = document.getElementById("policylayoutdiv");
        //        if (newvalue == undefined && pvsvalue != undefined && pvsvalue != null) {
        //            document.getElementById("policy_div").appendChild(pvsvalue);
        //        }
    }
}
function showinlineonrejectlayout(index) {
    var pvsvalue = document.getElementById("policylayoutdiv");
    var mediator = getnestedmediator(internalmodel.sequence, index);
    upadatemediator(mediator);
    var chlimit = mediator.childNodes.length;
    var chindex = null;
    for (var i = 0; i < chlimit; i++) {
        var child = mediator.childNodes[i] ;
        if (child != null && child != undefined && child.nodeName == "syn:onReject") {
            chindex = i;
        }
    }
    if (chindex != null) {
        mediator.removeChild(mediator.childNodes[chindex]);
    }
    var key = mediator.getAttribute("onReject") ;
    if (key != null && key != undefined) {
        mediator.removeAttribute("onReject")
    }
    mediator.appendChild(createesbelement("<syn:onReject esb_med_pos='" + index.toString() + "." + (mediator.childNodes.length) + "' xmlns:syn='http://ws.apache.org/ns/synapse'/>"));
    var epdiv = document.getElementById("throttle_edit");
    if (epdiv != null && mediator != null) {
        processXML(mediator, "mediators/throttle_edit.xsl", epdiv);
        //        var newvalue = document.getElementById("policylayoutdiv");
        //        if (newvalue == undefined && pvsvalue != undefined && pvsvalue != null) {
        //            document.getElementById("policy_div").appendChild(pvsvalue);
        //        }
    }
}