/*
 *  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 *  WSO2 Inc. licenses this file to you under the Apache License,
 *  Version 2.0 (the "License"); you may not use this file except
 *  in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 *
 */

/**
 * This js file is for the log mediator specific UI operations
 */

var validate_save_mode = false;

initedit["validate"] = function initvalidateedit(mediator) {

    var oncompElem = mediator.getElementsByTagName("on-fail");
    if (oncompElem == undefined || oncompElem.length == 0) {
        oncompElem = mediator.getElementsByTagName("syn:on-fail");
        if (oncompElem == undefined || oncompElem.length == 0) {
            mediator.appendChild(createesbelement("<syn:on-fail " + syn_ns_declaration + "/>"));
        }
    }

    setnodepositions(internalmodel.sequence);
}

var syn_ns_declaration = "xmlns:syn='http://ws.apache.org/ns/synapse'";

collectdata["validate"] = function collectvalidatedata(mediator, validate) {
    validate_save_mode = true;
    return updatesendmediator(mediator, validate);
};

function updatesendmediator(mediator, validate) {
    var schemakeys = document.getElementsByName("schema_key");
    var k = schemakeys.length;
    if (!validate && k == 0) {
        if (validate_save_mode) {
            esbwarning("Schema registry keys to be used for validation must be specified", TYPE_INFO);
            return false;
        }
    }
    var prefix = "";
    if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
        prefix = "syn:";
    }
    var existingschemakeys = mediator.getElementsByTagName(prefix + "schema");
    if (browsername.indexOf(IE_BROWSER_NAME) == -1) {
        while (existingschemakeys.length > 0) {
            mediator.removeChild(existingschemakeys[existingschemakeys.length - 1]);
        }
    } else {
        for(var i=0; i<existingschemakeys.length; i++) {
            mediator.removeChild(existingschemakeys[i]);
        }
    }
    var validkeyfound = false;
    for (var x = 0; x < k; x++) {
        if (schemakeys[x].value != undefined && schemakeys[x].value != null && schemakeys[x].value != "") {
            validkeyfound = true;
            var schemakey = createesbelement("<syn:schema key='" + schemakeys[x].value + "' xmlns:syn='http://ws.apache.org/ns/synapse'/>");
//            schemakey.setAttribute("key", schemakeys[x].value);
            mediator.appendChild(schemakey);
        }
    }
    if (!validate && !validkeyfound) {
        if (validate_save_mode) {
            esbwarning("One or more schema registry keys must be specified for validation", TYPE_INFO);
            return false;
        }
    }
    var source = document.getElementById("validate_source");
    if (source != null && source.value != null && source.value != "") {
        mediator.setAttribute("source", source.value);
    } else {
        mediator.removeAttribute("source");
    }
   collectfeaturedata(mediator);
  return true;
}

mediatorelementstring["validate"] = function validatestring() {
    return "<syn:validate xmlns:syn='http://ws.apache.org/ns/synapse'><syn:on-fail/><syn:schema key=''/></syn:validate>";
};

function addschemakey(position) {
    validate_save_mode = false
    var epdiv = document.getElementById("validate_edit_div");
    var mediator = getnestedmediator(internalmodel.sequence, position);
    updatesendmediator(mediator, false);

    if (epdiv != null && mediator != null) {
        var newschemas = document.getElementsByName("schema_key") ;
        var existingschemas = mediator.getElementsByTagName("schema");
        var i = newschemas.length;
        var j = existingschemas.length;

        var schema = createesbelement("<syn:schema key='' xmlns:syn='http://ws.apache.org/ns/synapse'/>");
        mediator.appendChild(schema);
        processXML(mediator, "mediators/validate_edit.xsl", epdiv);
    }
}
function getsynschema() {
    var doc = new ActiveXObject("Microsoft.XMLDOM");
    doc.async = "false";
    doc.loadXML("<syn:schema xmlns:syn='http://ws.apache.org/ns/synapse'/>");
    return doc.getElementsByTagName("syn:schema")[0];
}
var currentIndex = null;
function schemakeyfromregistry(index, position) {
    currentIndex = index;
    var panelId = ("mypanel" + index).toString();
    registrybrowser("saveschemakeyfromregistry", "dicardregistrybrowser", position, 1, panelId);
}

function saveschemakeyfromregistry(position) {
    var regKey = getRegistryKey();
    var keyid = ("schema_key" + currentIndex).toString();
    var divcontrol = document.getElementById("registryPanel");
    divcontrol.innerHTML = "";
    var schemaref = document.getElementById(keyid.toString());
    if (schemaref != undefined && schemaref != null) {
        schemaref.value = regKey;
    }
}
