/*
 *  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 *  WSO2 Inc. licenses this file to you under the Apache License,
 *  Version 2.0 (the "License"); you may not use this file except
 *  in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 *
 */

/**
 * This js file is for the log mediator specific UI operations
 */
var variablesindexs = new Array();
var allvariables = new Array();
var needthforprop = true;
var namespacesxquery = new Array();

function addnamespacexquery(position, namespase) {
    var found = false;
    if (namespacesxquery.length > 0) {
        for (var i = 0; i < namespacesxquery.length; i++) {
            if (namespacesxquery[i].key == position) {
                namespacesxquery[i].value = namespase;
                found = true;
            }
        }
    }
    if (!found) {
        var obj = new Object();
        obj.key = position;
        obj.value = namespase;
        namespacesxquery[namespacesxquery.length] = obj;
    }
}

function getnamespasexquery(position) {
    if (namespacesxquery.length > 0) {
        for (var i = 0; i < namespacesxquery.length; i++) {
            if (namespacesxquery[i].key == position) {
                return namespacesxquery[i].value;
            }
        }
    }
}

initedit["xquery"] = function initxqueryedit(mediator) {

    resetdataofxquery();
    mediator.setAttribute("variable_index", 0);
    var existingvariables = mediator.getElementsByTagName("variable");
    if (existingvariables == undefined || existingvariables == null || existingvariables.length == 0) {
        existingvariables = mediator.getElementsByTagName("syn:variable");
    }
    if (existingvariables != null && existingvariables.length > 0) {
        for (var i = 0; i < existingvariables.length; i++) {
            if (existingvariables[i].getAttribute("variable_index") == null) {
                existingvariables[i].setAttribute("variable_index", i);
            }
            variablesindexs[variablesindexs.length] = i;
        }
    }
};

collectdata["xquery"] = function collectlogdata(mediator, validate) {

    var iscollectsuccess = collectdatatemporallyofxquery(mediator, validate);
    if (iscollectsuccess) {
        resetdataofxquery();
    }
    return iscollectsuccess;

};

function collectdatatemporallyofxquery(mediator, validate) {
    var ps = mediator.getAttribute("esb_med_pos");
    var key = document.getElementById("xquery_key");
    if (key != null && key.value != null && key.value != "") {
        mediator.setAttribute("key", key.value);
        var source = document.getElementById("xquery_target");
        if (source != null && source.value != null && source.value != "") {
            mediator.setAttribute("target", source.value);
        } else {
            mediator.removeAttribute("target");
        }
    } else if (!validate) {
        esbwarning("XQuery registry key to be used for the transformation must be specified", TYPE_INFO);
        return false;
    }

    var existingvariables = mediator.getElementsByTagName("variable");
    if (existingvariables == undefined || existingvariables == null || existingvariables.length <= 0) {
        existingvariables = mediator.getElementsByTagName("syn:variable");
    }
    if (existingvariables != undefined && existingvariables != null && existingvariables.length > 0) {
        for (var p = 0; p < existingvariables.length; p++) {
            var attrs = existingvariables[p].attributes;
            var nsarr = new Array();
            for (var k = 0; k < attrs.length; k++) {
                if (attrs[k].name.indexOf("xmlns:") == 0) {
                    nsarr[nsarr.length] = attrs[k];
                }
            }
            var pos = existingvariables[p].getAttribute("esb_med_pos");
            if (pos != null && nsarr.length > 0) {
                addnamespacexquery(pos, nsarr);
            }
        }
        if (browsername.indexOf(NETSCAPE_BROWSER_NAME) != -1) {
            while (existingvariables.length > 0) {
                mediator.removeChild(existingvariables[existingvariables.length - 1]);
            }
        }
        else if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
            for (var j = 0; j < existingvariables.length; j++) {
                mediator.removeChild(existingvariables[j]);
            }
        }
    }
    var variablesdiv = document.getElementById("variables");
    if (variablesdiv != undefined && variablesdiv != null && variablesdiv.childNodes != null && variablesdiv.childNodes.length > 0) {
        var trs = variablesdiv.getElementsByTagName("tr");
        if (trs != undefined && trs != null) {
            var canaddvar = addvariableobjects(trs, mediator, ps, validate);
            if (!canaddvar) {
                return false;
            }
        }
    }
    return true;
}

function resetdataofxquery() {

    variablesindexs = new Array();
    allvariables = new Array();
    namespacesxquery = new Array();
    needthforprop = true;
}

mediatorelementstring["xquery"] = function logstring() {
    return "<syn:xquery xmlns:syn='http://ws.apache.org/ns/synapse'></syn:xquery>";
};

function addvariableobjects(trs, mediator, pindex, validate) {

    var propertytrs = new Array();
    for (var i = 0; i < trs.length; i++) {
        if (trs[i].getAttribute("name") == "syn-variable") {
            propertytrs[propertytrs.length] = trs[i];
        }
    }

    for (var j = 0; j < propertytrs.length; j++) {
        var id = propertytrs[j].getAttribute("id");
        var pi = id.substring(0, id.indexOf("variable_id"));
        var delvar = getdeletedpreviousvariables(pi);

        var position = pindex.toString() + "." + (parseInt(pi)).toString();
        if (delvar != undefined && delvar != null && delvar != 0) {
            position = pindex.toString() + "." + (parseInt(pi) - delvar).toString();
        }
        var namespce = getnamespasexquery(position);
        if (window.ActiveXObject) {
            if (!validate) {
                var name = propertytrs[j].children[1].children[0].value;
                if (propertytrs[j].children[0].children[0].value != ""
                    && propertytrs[j].children[0].children[0].value != "Select A Value"
                    && name != "") {
                    name = trim(name);
                    if (!namevalidate(name)) {
                        esbwarning(INVALID_NAME, TYPE_INFO);
                        return false;
                    }

                    var propertystr = "<syn:variable xmlns:syn='http://ws.apache.org/ns/synapse' type='"
                        + propertytrs[j].children[0].children[0].value + "' name='"
                        + name + "' ";

                    var propertytype = propertytrs[j].children[2].children[0].options[
                        propertytrs[j].children[2].children[0].selectedIndex].value;
                    if (propertytype == "value") {
                        var value = propertytrs[j].children[3].children[0].value;
                        if (value != null && value != undefined && trim(value) != "") {
                            propertystr += "value='" + convertAllXmlSpecialChars(trim(value)) + "' ";
                        } else {
                            esbwarning("Varibale value must be defined for the variable type :" + propertytrs[j].children[0].children[0].value, TYPE_INFO);
                            return false;
                        }
                    } else if (propertytype == "expression") {
                        propertystr += "expression='" + convertAllXmlSpecialChars(trim(propertytrs[j].children[3].children[0].value)) + "' ";
                    }
                    if (namespce != undefined && namespce != null) {
                        for (var g = 0; g < namespce.length; g++) {
                            if (namespce[g].name != "xmlns:syn") {
                                propertystr += namespce[g].name + "='" + namespce[g].value + "' ";
                            }
                        }
                    }
                    var variablekeyinput = document.getElementById("registry_key" + pi.toString());
                    if (variablekeyinput != null && variablekeyinput != undefined && variablekeyinput.value != "") {
                        propertystr += "key='" + variablekeyinput.value + "' ";
                    }
                    mediator.appendChild(createesbelement(propertystr + "/>"));
                } else {
                    if (propertytrs[j].children[0].children[0].value == ""
                        || propertytrs[j].children[0].children[0].value == "Select A Value") {
                        esbwarning("Some variables may haven't defined the variable type. Each variable must define a type.", TYPE_INFO);
                        return false;

                    } else if (propertytrs[j].children[1].children[0].value == "") {
                        esbwarning("Some variables may haven't defined the name. Each variable must define a name.", TYPE_INFO);
                        return false;
                    }
                }
            } else {
                var propertystr = "<syn:variable xmlns:syn='http://ws.apache.org/ns/synapse' type='"
                    + propertytrs[j].children[0].children[0].value + "' name='"
                    + propertytrs[j].children[1].children[0].value + "' ";

                var propertytype = propertytrs[j].children[2].children[0].options[
                    propertytrs[j].children[2].children[0].selectedIndex].value;
                if (propertytype == "value") {
                    propertystr += "value='" + propertytrs[j].children[3].children[0].value + "' ";
                } else if (propertytype == "expression") {
                    propertystr += "expression='" + propertytrs[j].children[3].children[0].value + "' ";
                }
                if (namespce != undefined && namespce != null) {
                    for (var g = 0; g < namespce.length; g++) {
                        if (namespce[g].name != "xmlns:syn") {
                            propertystr += namespce[g].name + "='" + namespce[g].value + "' ";
                        }
                    }
                }
                var variablekeyinput = document.getElementById("registry_key" + pi.toString());
                if (variablekeyinput != null && variablekeyinput != undefined && variablekeyinput.value != "") {
                    propertystr += "key='" + variablekeyinput.value + "' ";
                }
                mediator.appendChild(createesbelement(propertystr + "/>"));

            }

        } else {
            if (!validate) {
                var name = propertytrs[j].childNodes[1].childNodes[0].value;
                if (propertytrs[j].childNodes[0].childNodes[0].value != ""
                    && propertytrs[j].childNodes[0].childNodes[0].value != "Select A Value"
                    && name != "") {
                    name = trim(name);
                    if (!namevalidate(name)) {
                        esbwarning(INVALID_NAME, TYPE_INFO);
                        return false;
                    }
                    var property;
                    if (document.createElementNS != "undefined") {
                        property = document.createElementNS(SYNAPSE_NS, "syn:variable");
                    }
                    property.setAttribute("type", propertytrs[j].childNodes[0].childNodes[0].value);
                    property.setAttribute("name", name);
                    var propertytype = propertytrs[j].childNodes[2].childNodes[0].options[
                        propertytrs[j].childNodes[2].childNodes[0].selectedIndex].value;
                    if (propertytype == "value") {
                        var value = propertytrs[j].childNodes[3].childNodes[0].value;
                        if (value != null && value != undefined && trim(value) != "") {
                            property.setAttribute("value", trim(value));
                        } else {
                            esbwarning("Varibale value must be defined for the variable type :" + propertytrs[j].childNodes[0].childNodes[0].value, TYPE_INFO);
                            return false;
                        }
                    } else if (propertytype == "expression") {
                        property.setAttribute("expression", propertytrs[j].childNodes[3].childNodes[0].value);
                    }
                    if (namespce != undefined && namespce != null) {
                        for (var g = 0; g < namespce.length; g++) {
                            if (namespce[g].name != "xmlns:syn") {
                                property.setAttribute(namespce[g].name, namespce[g].value);
                            }
                        }
                    }
                    var variablekeyinput = document.getElementById("registry_key" + pi.toString());
                    if (variablekeyinput != null && variablekeyinput != undefined && variablekeyinput.value != "") {
                        property.setAttribute("key", variablekeyinput.value);
                    }
                    mediator.appendChild(property);
                } else {
                    if (propertytrs[j].childNodes[0].childNodes[0].value == ""
                        || propertytrs[j].childNodes[0].childNodes[0].value == "Select A Value") {
                        esbwarning("Some variables may haven't defined the variable type. Each variable must define a type.", TYPE_INFO);
                        return false;

                    } else if (propertytrs[j].childNodes[1].childNodes[0].value == "") {
                        esbwarning("Some variables may haven't defined the name. Each variable must define a name.", TYPE_INFO);
                        return false;
                    }
                }
            } else {

                var property;
                if (document.createElementNS != "undefined") {
                    property = document.createElementNS(SYNAPSE_NS, "syn:variable");
                }
                property.setAttribute("type", propertytrs[j].childNodes[0].childNodes[0].value);
                property.setAttribute("name", propertytrs[j].childNodes[1].childNodes[0].value);
                var propertytype = propertytrs[j].childNodes[2].childNodes[0].options[
                    propertytrs[j].childNodes[2].childNodes[0].selectedIndex].value;
                if (propertytype == "value") {
                    property.setAttribute("value", propertytrs[j].childNodes[3].childNodes[0].value);
                } else if (propertytype == "expression") {
                    property.setAttribute("expression", propertytrs[j].childNodes[3].childNodes[0].value);
                }
                if (namespce != undefined && namespce != null) {
                    for (var g = 0; g < namespce.length; g++) {
                        if (namespce[g].name != "xmlns:syn") {
                            property.setAttribute(namespce[g].name, namespce[g].value);
                        }
                    }
                }
                var variablekeyinput = document.getElementById("registry_key" + pi.toString());
                if (variablekeyinput != null && variablekeyinput != undefined && variablekeyinput.value != "") {
                    property.setAttribute("key", variablekeyinput.value);
                }
                mediator.appendChild(property);
            }
        }
    }
    return true;
}

function addvariableIndex(index) {

    if (parseInt(index) == 0) {
        variablesindexs[variablesindexs.length] = variablesindexs.length;

    } else {
        if (variablesindexs.length == 0) {
            for (var i = 0; i <= parseInt(index); i++) {
                variablesindexs[variablesindexs.length] = i;
            }
        } else {
            variablesindexs[variablesindexs.length] = variablesindexs.length;
        }
    }
}

function deletevariableIndex(index) {
    if (variablesindexs.length > 0) {
        for (var i = 0; i < variablesindexs.length; i++) {
            if (variablesindexs[i] != null && parseInt(variablesindexs[i]) == index) {
                variablesindexs[i] = null;
                return;
            }
        }
    }
}
function getdeletedpreviousvariables(index) {
    var count = 0;
    if (variablesindexs.length > 0) {
        for (var i = 0; i < variablesindexs.length; i++) {
            if (variablesindexs[i] != null && parseInt(variablesindexs[i]) == index) {
                return count;
            }
            if (variablesindexs[i] == null) {
                count += 1;
            }
        }
    }
}

function addvariable(position, propcount) {
    addvariableIndex(propcount);
    var qi = variablesindexs.length - 1 ;
    var addth = false;
    if (needthforprop) {
        addth = true;
        needthforprop = false;
    }
    var propertys = document.getElementById("variables");
    if (propertys != undefined && propertys != null) {
        var ths = propertys.getElementsByTagName("th");
        if (ths != null && ths != undefined && ths.length > 1) {
            addth = false;
        }
    }
    var transformeddiv = document.createElement("div");
    var xmlObj = createesbelement("<syn:variable xmlns:syn='http://ws.apache.org/ns/synapse'/>");
    if (qi != null && qi != undefined) {
        xmlObj.setAttribute("variable_index", qi);
    }
    if (addth) {
        xmlObj.setAttribute("thneed", "true");
    } else {
        xmlObj.setAttribute("thneed", "false");
    }
    var ps = position.toString() + "." + (parseInt(qi)).toString() ;

    xmlObj.setAttribute("esb_med_pos", ps.toString());
    xmlObj.setAttribute("pindex", position.toString());
    processXML(xmlObj, "mediators/variable.xsl", transformeddiv);
    var epdiv = document.getElementById("variables");

    if (browsername.indexOf(NETSCAPE_BROWSER_NAME) != -1) {
        if (transformeddiv.childNodes[0].childNodes[0].childNodes.length == 1) {
            epdiv.appendChild(transformeddiv.childNodes[0].childNodes[0].childNodes[0]);
        }
        if (transformeddiv.childNodes[0].childNodes[0].childNodes.length == 2) {
            epdiv.appendChild(transformeddiv.childNodes[0].childNodes[0].childNodes[0]);
            epdiv.appendChild(transformeddiv.childNodes[0].childNodes[0].childNodes[0]);
        }
    } else if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
        if (transformeddiv.childNodes[0].childNodes[0].childNodes[0].childNodes.length == 1) {
            epdiv.appendChild(transformeddiv.childNodes[0].childNodes[0].childNodes[0].childNodes[0]);
        }
        if (transformeddiv.childNodes[0].childNodes[0].childNodes[0].childNodes.length == 2) {
            epdiv.appendChild(transformeddiv.childNodes[0].childNodes[0].childNodes[0].childNodes[0]);
            epdiv.appendChild(transformeddiv.childNodes[0].childNodes[0].childNodes[0].childNodes[0]);
        }
    }

}

function deletemediatorvariable(vi, pos) {
    var epdiv = document.getElementById("variables");
    var id = vi.toString() + "variable_id";
    var childDivs = epdiv.childNodes;
    var variable = document.getElementById(id);
    if (childDivs != null && variable != null) {
        deletevariableIndex(vi);
        var isremovedth = false;
        var tbody = epdiv.getElementsByTagName("tbody");
        if (tbody != null && tbody != undefined && tbody.length > 0) {
            var nooftrs = tbody[0].childNodes.length;
            for (var i = 0; i < nooftrs; i++) {
                if (tbody[0].childNodes[i] != null && tbody[0].childNodes[i].getAttribute("id") == id) {
                    tbody[0].removeChild(variable);
                    if (nooftrs == 2 && epdiv.childNodes.length == 1) {
                        tbody[0].removeChild(tbody[0].childNodes[0]);
                        isremovedth = true;
                        needthforprop = true;
                    }
                    return;
                }
            }
        }

        var nooftrs = epdiv.childNodes.length;
        for (var i = 0; i < nooftrs; i++) {
            if (epdiv.childNodes[i] != null && epdiv.childNodes[i].getAttribute("id") == id) {
                epdiv.removeChild(variable);
            }
        }

        if (!isremovedth) {
            if (epdiv.getElementsByTagName("tbody") != undefined && epdiv.getElementsByTagName("tbody").length > 0) {
                if (epdiv.childNodes.length == 2) {
                    epdiv.removeChild(epdiv.childNodes[1]);
                    needthforprop = true;
                }

            } else {
                if (epdiv.childNodes.length == 1) {
                    epdiv.removeChild(epdiv.childNodes[0]);
                    needthforprop = true;
                }
            }
        }
    }
}
function xquerykeyfromregistry(position) {
    var panelId = ("mypanel" + position).toString();
    registrybrowser("savexquerykeyfromregistry", "dicardregistrybrowser", position, 1, panelId);
}
function savexquerykeyfromregistry(position) {
    var regKey = getRegistryKey();
    var divcontrol = document.getElementById("registryPanel");
    divcontrol.innerHTML = "";
    if (regKey != null && regKey != undefined) {
        var xquerykeyinput = document.getElementById("xquery_key");
        if (xquerykeyinput != null && xquerykeyinput != undefined) {
            xquerykeyinput.value = regKey;
        }
    }
}
function savevariablefromregistry(position) {
    var regKey = getRegistryKey();
    var divcontrol = document.getElementById("registryPanel");
    divcontrol.innerHTML = "";
    if (regKey != null && regKey != undefined) {
        var variablekeyinput = document.getElementById("registry_key" + position.toString());
        if (variablekeyinput != null && variablekeyinput != undefined) {
            variablekeyinput.value = regKey;
        }
    }
}

function variablekeyfromregistry(index, ps) {
    var panelId = ("mypanel" + ps).toString();
    registrybrowser("savevariablefromregistry", "dicardregistrybrowser", index, 1, panelId);
}

function showNamespaceButtonForVariable(position, pindex, vindex, typeID, cellID) {
    var typeElement = document.getElementById(typeID + position);
    var type = typeElement[typeElement.selectedIndex].value;
    var Buttoncell = document.getElementById(cellID + position);
    var registrykeycel = document.getElementById("registry_key_cell" + vindex);
    var si = position.substring((pindex.toString() + ".").length, position.length) ;
    var correctedps = null;
    if (si != null && si != undefined) {
        var deletedsi = getdeletedpreviousvariables(parseInt(si));
        if (deletedsi != undefined && deletedsi != null && deletedsi != 0) {
            var csi = si - deletedsi ;
            if (csi != undefined && csi != null) {
                correctedps = pindex.toString() + "." + (csi).toString();
            }
        } else {
            correctedps = pindex.toString() + "." + (si).toString();
        }

    }
    if (correctedps != null && correctedps != undefined) {
        position = correctedps;
    }
    if (type == "expression") {
        registrykeycel.innerHTML = "<img src='extensions/core/images/registry_picker.gif' title='Registry Browser' onclick=variablekeyfromregistry('" + vindex + "','" + position + "') />"
        Buttoncell.innerHTML = "<a title='Namespace Editor' onclick=showNameSpaceEditorForVariable('" + position + "','" + pindex + "','','') class='ns_editor'>&nbsp;&nbsp;&nbsp;&nbsp;</a>";
    } else {
        Buttoncell.innerHTML = "";
        registrykeycel.innerHTML = "";
    }

}
function showNameSpaceEditorForVariable(position, pindex, attribute, inputID) {
    var mediator = getnestedmediator(internalmodel.sequence, pindex);
    var temp = collectdatatemporallyofxquery(mediator, true);
    setnodepositions(mediator, pindex);
    showNameSpaceEditor(position, attribute, inputID);
}

function onvariabletypechange(esb_med_pos, pindex, variableindex) {
    var variable = document.getElementById(variableindex.toString() + "variable_id");
    var id = variableindex.toString() + "variable_id";
    var variables = document.getElementById("variables");
    if (variables != undefined && variable != undefined && variables != null && variable != null) {
        var tbody = variables.getElementsByTagName("tbody");
        var found = false;
        if (tbody != null && tbody != undefined && tbody.length > 0) {
            for (var i = 0; i < tbody[0].childNodes.length; i++) {
                if (tbody[0].childNodes[i].getAttribute("id") == id) {
                    found = true;
                    var name = tbody[0].childNodes[i].childNodes[0].childNodes[0].value;
                    var oldchild = tbody[0].childNodes[i].childNodes[2];
                    var id1 = ('parameterType' + esb_med_pos).toString();
                    if (name == "FLOAT" || name == "INT" || name == "INTEGER" || name == "SHORT" || name == "INTEGER" || name == "BYTE" || name == "BOOLEAN"
                        || name == "DOUBLE" || name == "STRING") {
                        var op_index = null;
                        var op_value = null;
                        var opStr = "</option><option value='value'>Value</option><option value='expression'>expression</option>";
                        if (oldchild.childNodes[0] != null)
                        {
                            op_index = oldchild.childNodes[0].selectedIndex;
                            if (op_index != null) {
                                op_value = oldchild.childNodes[0].options[op_index].value;
                                if (op_value == "expression") {
                                    opStr = "<option value='expression'>expression</option></option><option value='value'>Value</option>"
                                }
                            }
                        }
                        oldchild.innerHTML = "<select id='" + id1 + "' class='esb-edit small_textbox' style='width: 80px ! important'"
                            + "onchange=" + "showNamespaceButtonForVariable('" + esb_med_pos + "','" + pindex + "','" + variableindex + "','parameterType','namespaceCell') >" +
                                             opStr + "</select>";
                    } else if (name == "DOCUMENT" || name == "ELEMENT" || name == "DOCUMENT_ELEMENT") {
                        var op_index = null;
                        var op_value = null;
                        var opStr = "<option value='Select A Value'  selected='true'>Leave As-Is</option><option value='expression'>expression</option>";
                        if (oldchild.childNodes[0] != null)
                        {
                            op_index = oldchild.childNodes[0].selectedIndex;
                            if (op_index != null) {
                                op_value = oldchild.childNodes[0].options[op_index].value;
                                if (op_value == "expression") {
                                    opStr = "<option value='expression'>expression</option><option value='Select A Value'>Leave As-Is</option>"
                                }
                            }
                        }
                        oldchild.innerHTML = "<select id='" + id1 + "' class='esb-edit small_textbox' style='width: 80px ! important'"
                            + "onchange=" + "showNamespaceButtonForVariable('" + esb_med_pos + "','" + pindex + "','" + variableindex + "','parameterType','namespaceCell') >" +
                                             opStr + "</select>";
                    } else if (name == "Select A Value") {
                        oldchild.innerHTML = "<select id='" + id1 + "' class='esb-edit small_textbox' style='width: 80px ! important'"
                            + "onchange=" + "showNamespaceButtonForVariable('" + esb_med_pos + "','" + pindex + "','" + variableindex + "','parameterType','namespaceCell') >" +
                                             "<option value='Select A Value'  selected='true'>Leave As-Is</option><option value='value'>Value</option><option value='expression'>expression</option></select>";
                    }
                }
            }
        }
        if (!found) {
            for (var i = 0; i < variables.childNodes.length; i++) {
                if (variables.childNodes[i].getAttribute("id") == id) {
                    var name = variables.childNodes[i].childNodes[0].childNodes[0].value;
                    var oldchild = variables.childNodes[i].childNodes[2];
                    var id1 = ('parameterType' + esb_med_pos).toString();
                    if (name == "FLOAT" || name == "INT" || name == "INTEGER" || name == "SHORT" || name == "INTEGER" || name == "BYTE" || name == "BOOLEAN"
                        || name == "DOUBLE" || name == "STRING") {
                        var op_index = null;
                        var op_value = null;
                        var opStr = "</option><option value='value'>Value</option><option value='expression'>expression</option>";
                        if (oldchild.childNodes[0] != null)
                        {
                            op_index = oldchild.childNodes[0].selectedIndex;
                            if (op_index != null) {
                                op_value = oldchild.childNodes[0].options[op_index].value;
                                if (op_value == "expression") {
                                    opStr = "<option value='expression'>expression</option></option><option value='value'>Value</option>"
                                }
                            }
                        }
                        oldchild.innerHTML = "<select id='" + id1 + "' class='esb-edit small_textbox' style='width: 80px ! important'"
                            + "onchange=" + "showNamespaceButtonForVariable('" + esb_med_pos + "','" + pindex + "','" + variableindex + "','parameterType','namespaceCell') >" +
                                             opStr + "</select>";
                    } else if (name == "DOCUMENT" || name == "ELEMENT" || name == "DOCUMENT_ELEMENT") {
                        var op_index = null;
                        var op_value = null;
                        var opStr = "<option value='Select A Value'  selected='true'>Leave As-Is</option><option value='expression'>expression</option>";
                        if (oldchild.childNodes[0] != null)
                        {
                            op_index = oldchild.childNodes[0].selectedIndex;
                            if (op_index != null) {
                                op_value = oldchild.childNodes[0].options[op_index].value;
                                if (op_value == "expression") {
                                    opStr = "<option value='expression'>expression</option><option value='Select A Value'>Leave As-Is</option>"
                                }
                            }
                        }
                        oldchild.innerHTML = "<select id='" + id1 + "' class='esb-edit small_textbox' style='width: 80px ! important'"
                            + "onchange=" + "showNamespaceButtonForVariable('" + esb_med_pos + "','" + pindex + "','" + variableindex + "','parameterType','namespaceCell') >" +
                                             opStr + "</select>";

                    } else if (name == "Select A Value") {
                        oldchild.innerHTML = "<select id='" + id1 + "' class='esb-edit small_textbox' style='width: 80px ! important'"
                            + "onchange=" + "showNamespaceButtonForVariable('" + esb_med_pos + "','" + pindex + "','" + variableindex + "','parameterType','namespaceCell') >" +
                                             "<option value='Select A Value'  selected='true'>Leave As-Is</option><option value='value'>Value</option><option value='expression'>expression</option></select>";
                    }
                }
            }
        }

    }
}

function createvalueexpcombobox() {
    // Create the element:
    var combo_box = document.createElement('select');
    combo_box.className = "esb-edit small_textbox";
    combo_box.style.width = "80px ! important"

    // Set some properties:
    combo_box.name = 'variable_value';

    // Add some choices:
    var choice = document.createElement('option');
    choice.value = 'value';
    choice.appendChild(document.createTextNode('value'));
    combo_box.appendChild(choice);

    choice = document.createElement('option');
    choice.value = 'expression';
    choice.appendChild(document.createTextNode('expression'));
    combo_box.appendChild(choice);

    return combo_box;

}
function createexpcombobox() {
    // Create the element:
    var combo_box = document.createElement('select');
    combo_box.className = "esb-edit small_textbox";
    combo_box.style.width = "80px ! important"

    // Set some properties:
    combo_box.name = 'variable_value';

    // Add some choices:
    var choice = document.createElement('option');
    choice.value = 'Select A Value';
    choice.appendChild(document.createTextNode('Leave As-Is'));
    combo_box.appendChild(choice);


    choice = document.createElement('option');
    choice.value = 'expression';
    choice.appendChild(document.createTextNode('expression'));
    combo_box.appendChild(choice);

    return combo_box;
}

function createexpvalueandnonecombobox() {
    // Create the element:
    var combo_box = document.createElement('select');
    combo_box.className = "esb-edit small_textbox";
    combo_box.style.width = "80px ! important"

    // Set some properties:
    combo_box.name = 'variable_value';

    // Add some choices:
    var choice = document.createElement('option');
    choice.value = 'Select A Value';
    choice.appendChild(document.createTextNode('Leave As-Is'));
    combo_box.appendChild(choice);

    choice = document.createElement('option');
    choice.value = 'value';
    choice.appendChild(document.createTextNode('value'));
    combo_box.appendChild(choice);

    choice = document.createElement('option');
    choice.value = 'expression';
    choice.appendChild(document.createTextNode('expression'));
    combo_box.appendChild(choice);

    return combo_box;
}