/*
 *  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 *
 *  WSO2 Inc. licenses this file to you under the Apache License,
 *  Version 2.0 (the "License"); you may not use this file except
 *  in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 *
 */

/*
endpoints.js deals with Endpoint Mediators
*/

var TASK_MANAGEMENT = "__TaskAdmin";

function showtasks() {
   
    var body_xml = '<ns1:taskDataRequest xmlns:ns1="http://org.apache.synapse/xsd">' +
                   '</ns1:taskDataRequest>';

    var callURL = serverURL + "/" + TASK_MANAGEMENT + "/" + "taskbData";
    send("taskData", body_xml, "", callURL, "", false, showtaskscallback);
}

function showtaskscallback() {
    if (!onError()) {
        return;
    }
    callbackhelper("tasks.xsl", document.getElementById("divTasks"));
}

function edittask(name) {
    var bodyxml = '<ns1:getTask xmlns:ns1="http://org.apache.synapse/xsd">' +
                  '<ns1:taskName>' + name + '</ns1:taskName>' +
                  '</ns1:getTask>';

    var callurl = serverURL + "/" + TASK_MANAGEMENT + "/" + "getTask";
    send("getTask", bodyxml, "", callurl, "", false, edittaskcallback);
}

function removetaskprop(propname) {
    var element = document.getElementById(propname);
    var tdElement = element.parentNode;
    var trElement = tdElement.parentNode;
    trElement.parentNode.removeChild(trElement);
}

function updatetaskprop(id) {
    var element = document.getElementById(id);
    var classValue = element.getAttribute("class");
    if(classValue == "esb-edit") {
      element.setAttribute("class", "esb-edit small_textarea");
    } else {
      element.setAttribute("class", "esb-edit");
    }
}

var mode="add";

function edittaskcallback() {

    if (!onError()) {
        return;
    }
    internalmodel.task = getNodeFromPath("return", xhReq.responseXML).firstChild;
    setnodepositions(internalmodel.task, 0);

    var objdiv = document.getElementById("divTask");
    objdiv.innerHTML = "";

    objdiv.innerHTML = "<h2 id='moduleHeader'><a href='#' onclick='javascript: "
            + "showtasks(); return false;'>Manage Tasks</a>&#160;&gt;&#160; Edit Task " + internalmodel.task.getAttribute("name") + "</h2><br/><br/>";

    var taskshowdiv = document.createElement("div");
    processXML(internalmodel.task, "tasks/task_edit.xsl", taskshowdiv);
    objdiv.appendChild(taskshowdiv);
    
    var savepanel = document.createElement("div");
    savepanel.innerHTML += "<div id='savediv'><table class='data-table' style='width:400px;'><tbody><tr>"
            + "<td style='width:150px;'></td><td align='left'><input type='button' class='panelbutton_default button-space' "
            + "onclick='javascript: tasksave(); return false;' value='Schedule'>"
            + "<input type='button' class='panelbutton_cancel' "
            + "onclick='javascript: showtasks(); return false;' value='Cancel'/></td>"
            + "</tr></tbody></table></div>";
    objdiv.appendChild(savepanel);
    mode="edit";
    showOnlyOneMain(objdiv);
}

function deletetask(taskname) {
    var body_xml = '<ns1:deleteTask xmlns:ns1="http://org.apache.synapse/xsd">' +
                   '<ns1:taskName>' + taskname + '</ns1:taskName>' +
                   '</ns1:deleteTask>';

    var callURL = serverURL + "/" + TASK_MANAGEMENT + "/" + "deleteTask";
    send("deleteTask", body_xml, "", callURL, "", false, commontaskcallback);    
}

function commontaskcallback() {
    if (!onError()) {
        return;
    }
    showtasks();
}

function disabletaskstatistics(name) {
    alert("// todo : disable task statistics " + name)        
}

function disabletasktracing(name) {
    alert("// todo : disable task tracing " + name)
}

function enabletaskstatistics(name) {
    alert("// todo : enable task statistics " + name)
}

function enabletasktracing(name) {
    alert("// todo : enable task tracing " + name)
}

function addtask() {
    mode="add";
    internalmodel.task = createesbelement("<syn:task name='' class='' xmlns:syn='http://ws.apache.org/ns/synapse'><syn:trigger count=''/></syn:task>");
    setnodepositions(internalmodel.task, 0);

    var objdiv = document.getElementById("divTask");
    objdiv.innerHTML = "";

    objdiv.innerHTML = "<div class='breadcrumb'><a title='WSO2 ESB Home' onclick='javascript:showHome(); return false;' href='#'>Home</a>&#160;&gt;&#160;<a href='#' onclick='javascript: "
            + "showtasks(); return false;'>Manage Tasks</a>&#160;&gt;&#160; Schedule New Task</div>";

    var taskshowdiv = document.createElement("div");
    processXML(internalmodel.task, "tasks/task_edit.xsl", taskshowdiv);
    objdiv.appendChild(taskshowdiv);

    var savepanel = document.createElement("div");
    savepanel.innerHTML += "<div id='savediv'><table class='data-table' style='width:400px;'><tbody><tr>"
            + "<td style='width:150px;'></td><td align='left'><input type='button' class='panelbutton_default button-space' "
            + "onclick='javascript: tasksave(); return false;' value='Schedule'>"
            + "<input type='button' class='panelbutton_cancel' "
            + "onclick='javascript: showtasks(); return false;' value='Cancel'/></td>"
            + "</tr></tbody></table></div>";
    objdiv.appendChild(savepanel);

    showOnlyOneMain(objdiv);
}

function tasksave() {
    collecttaskdata(true);

    var taskstring = internalmodel.task.xml;
    if (taskstring == undefined) {
        taskstring = new XMLSerializer().serializeToString(internalmodel.task);
    }
//    alert(taskstring)
    var body_xml = '<ns1:' + mode + 'Task xmlns:ns1="http://org.apache.synapse/xsd">' +
                   '<ns1:taskElement>' + taskstring + '</ns1:taskElement>' +
                   '</ns1:' + mode + 'Task>';

    var callURL = serverURL + "/" + TASK_MANAGEMENT + "/" + mode + "Task";
    send(mode + "Task", body_xml, "", callURL, "", false, commontaskcallback);
}

function collecttaskdata(validate) {
    var taskname = document.getElementById("task_name");
    var taskclass = document.getElementById("task_class");
    var tasktrigger = document.getElementsByName("task_trigger");
    var triggercount = document.getElementById("trigger_count");
    var triggerinterval = document.getElementById("trigger_interval");
    var triggercron = document.getElementById("trigger_cron");
    var triggertype = "simple";
    var pinnedServers = document.getElementById("pinnedServers");

    for (var i=0; i<tasktrigger.length; i++) {
        if (tasktrigger[i].checked) {
            triggertype = tasktrigger[i].value;
            var triggernode = internalmodel.task.getElementsByTagName("trigger");
            if (triggernode.length == 0) {
                triggernode = internalmodel.task.getElementsByTagName("syn:trigger");
            }

            if (triggernode.length > 0) {
                if (triggertype == "simple") {
                    if (triggercount != undefined && triggercount.value != undefined && triggercount.value != "") {
                        triggernode[0].setAttribute("count", triggercount.value);
                    } else {
                        triggernode[0].removeAttribute("count");
                    }
                    if (triggerinterval != undefined && triggerinterval.value != undefined && triggerinterval.value != "") {
                        triggernode[0].setAttribute("interval", triggerinterval.value);
                    } 
                    triggernode[0].removeAttribute("cron");
                } else if (triggertype == "cron") {
                    if (triggercron != undefined && triggercron.value != undefined && triggercron.value != "") {
                        triggernode[0].setAttribute("cron", triggercron.value);
                    }
                    triggernode[0].removeAttribute("count");
                    triggernode[0].removeAttribute("interval");
                }
            }
        }
    }

    if (taskname != undefined && taskname.value != undefined && taskname.value != "") {
        internalmodel.task.setAttribute("name", taskname.value);
    }

    if (taskclass != undefined && taskclass.value != undefined && taskclass.value != "") {
        internalmodel.task.setAttribute("class", taskclass.value);
    }

    internalmodel.task.setAttribute("pinnedServers", pinnedServers.value);

    var namespaces = new Array();

    var prefix = "";
    if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
        prefix = "syn:";
    }

    var existingprops = internalmodel.task.getElementsByTagName(prefix + "property");
    var u = existingprops.length;
    while (u > 0) {
        if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
            var attrs2 = existingprops[existingprops.length - u].attributes;
            var ns_string2 = "";
            for (var s2 = 0; s2 < attrs2.length; s2++) {
                if (attrs2[s2].name.indexOf("xmlns:") == 0) {
                    ns_string2 = ns_string2 + " " + attrs2[s2].name.substring(6, attrs2[s2].name.length) + "###" + attrs2[s2].value;
                }
            }
            if (ns_string2 != "") {
                namespaces[existingprops[existingprops.length - u].getAttribute("name")] = ns_string2;
            }
            internalmodel.task.removeChild(existingprops[existingprops.length - u]);
        } else {
            var attrs = existingprops[0].attributes;
            var ns_string = "";
            for (var s = 0; s < attrs.length; s++) {
                if (attrs[s].name.indexOf("xmlns:") == 0) {
                    ns_string = ns_string + " " + attrs[s].name.substring(6, attrs[s].name.length) + "###" + attrs[s].value;
                }
            }
            if (ns_string != "") {
                namespaces[existingprops[0].getAttribute("name")] = ns_string;
            }
            internalmodel.task.removeChild(existingprops[0]);
        }
        u--;
    }

    var propertyNamess = document.getElementsByName("property_name");
    for (var i = 0; i < propertyNamess.length; i++) {
        var propName_shown = propertyNamess[i].getAttribute("value");
        var propName_real = propName_shown.charAt(0).toLowerCase() + propName_shown.substring(1, propName_shown.length);
        var propValue_real = document.getElementById("task_prop" + propName_real);
        var propType_real = document.getElementsByName("prop_type_" + propName_real)[0].value;
        if (validate || (propValue_real != null && propValue_real.value != "")) {
            //            var propchild = getsynproperty();
            var propchild = createesbelement("<syn:property xmlns:syn='http://ws.apache.org/ns/synapse'/>");
            propchild.setAttribute("name", propName_real);
            if (propType_real == "value") {
                propchild.setAttribute("value", propValue_real.value);
            } else if (propType_real == "xml") {
//                propchild.setAttribute("expression", propValue_real.value);
                propchild.removeAttribute("value");
                var xmlFragment = propValue_real.value;
                xmlFragment = xmlFragment.replace("/&lt;/", "<");
                xmlFragment = xmlFragment.replace("/&gt;/", ">");
                xmlFragment = trim(xmlFragment);
                propchild.appendChild(createesbelement(xmlFragment));
            }
            var attaching_ns = namespaces[propName_real];
            if (attaching_ns != undefined) {
                var splitted_ns = attaching_ns.split(" ");
                for (var j = 0; j < splitted_ns.length; j++) {
                    var nsparts = splitted_ns[j].split("###");
                    if (nsparts.length == 2) {
                        if (propchild.getAttribute("xmlns:" + nsparts[0]) == null) {
                            propchild.setAttribute("xmlns:" + nsparts[0], nsparts[1]);
                        }
                    }
                }
            }
            internalmodel.task.appendChild(propchild);
        }
    }
}

function loadtaskclass() {

    collecttaskdata(false);

    var body_xml = '<ns1:loadCommand xmlns:ns1="http://org.apache.synapse/xsd">' +
                   '<ns1:className>' + document.getElementById("task_class").value + '</ns1:className>' +
                   '</ns1:loadCommand>';
    var callURL = serverURL + "/" + MEDIATOR_ADMIN + "/" ;
    send("loadCommand", body_xml, "", callURL, "", false, loadtaskclasscallback);
}

function loadtaskclasscallback() {
    if (!onError()) {
        return;
    }
    var prefix = "";
    if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
        prefix = "syn:";
    }
    var properties = xhReq.responseXML.getElementsByTagName(prefix + "property");

    var existingprops = internalmodel.task.getElementsByTagName(prefix + "property");

    var f = properties.length;
    while (f > 0) {
        var propName;
        if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
            propName = properties[properties.length - f].getAttribute("name");            
        } else {
            propName = properties[0].getAttribute("name");
        }
        var exists = false;
        for (var g = 0; g < existingprops.length; g++) {
            if (existingprops[g].getAttribute("name") == propName) {
                exists = true;
            }
        }
        if (!exists) {
            if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
                internalmodel.task.appendChild(properties[properties.length - f].parentNode.removeChild(properties[properties.length - f]));
            } else {
                internalmodel.task.appendChild(properties[0]);
            }
            f--;
        } else {
            if (browsername.indexOf(IE_BROWSER_NAME) != -1) {
                properties[properties.length - f].parentNode.removeChild(properties[properties.length - f]);
            } else {
                properties[0].parentNode.removeChild(properties[0]);
            }
            f--;
        }
    }
    setnodepositions(internalmodel.task, 0);

    processXML(internalmodel.task, "tasks/task_edit.xsl", document.getElementById("task_edit_div"))
}

function settrigger(triggertype) {
    var trigger = internalmodel.task.getElementsByTagName("trigger");
    if(trigger.length == 0) {
        trigger = internalmodel.task.getElementsByTagName("syn:trigger");
    }

    if (trigger.length > 0) {
        if (triggertype == "simple") {
            trigger[0].removeAttribute("cron")
        } else if (triggertype == "cron") {
            trigger[0].setAttribute("cron", "")
        }
    }

    setnodepositions(internalmodel.task, 0);

    processXML(internalmodel.task, "tasks/task_edit.xsl", document.getElementById("task_edit_div"))
}

function showNamespaceButtonForTaskProperties(position, typeID, cellID){

    var typeElement = document.getElementById(typeID + position);
    var type = typeElement[typeElement.selectedIndex].value;
    var Buttoncell = document.getElementById(cellID + position);

    if(type == "expression"){
       Buttoncell.innerHTML = "<a title='Namespace Editor' onclick=showTaskNameSpaceEditor('"+position+"','','') class='ns_editor'>&nbsp;&nbsp;&nbsp;&nbsp;</a>";
    }else{
       Buttoncell.innerHTML ="";
    }
}

var taskPosition;
var taskAttribute;
var changeinputID;

function showTaskNameSpaceEditor(position, attribute, inputID) {
//    alert(position + " " + position.indexOf(".") + " " + position.length)
    if (position.indexOf(".") != -1) {
        taskPosition = position.substring(position.indexOf(".") + 1, position.length);
    } else {
        taskPosition = position;
    }
//    alert("pos " + taskPosition)
    taskAttribute = attribute;
    changeinputID = inputID;
//    alert(position + " " + attribute + " " + inputID)
    var divcontrol = document.getElementById("divNamespaceEditor");
    divcontrol.innerHTML = "";

    var finalHTML = getDataHTML(getnestedtask(internalmodel.task, taskPosition));

    //If no attribute is passed here apply button is not displayed
    var applyHTML = "";

    if(taskAttribute != ""){
       applyHTML = "<td><input type='button' class='panelbutton_default' value='Apply' onclick='javascript:applyNamespace()'></td>";
    }

    var panelcontrol = document.createElement("div");
    panelcontrol.setAttribute("id", "myPanel");
    panelcontrol.innerHTML = "<div class='hd'><div class='tl'></div><span>WSO2-ESB Namespace Editor</span>"
            + "<div class='tr'></div></div>"
            + "<div class='bd'><div id='namespaceEditor' style='max-height:400px; overflow-x:hidden; overflow-y:auto;'>"
            + "<div id='common_table_content'><span>Existing Namespace Declarations</span>"
	        + "<table border='0' cellpadding='0' cellspacing='0'>"
	 		+ "<tr><th>Select</th><th>Prefix</th><th>URL</th></tr>"
            + finalHTML
			+ "<tr></table></div>"
            + "<table style='margin-left:40px;'><tr>" + applyHTML + "<td><input type='button' class='panelbutton_default' value='New' "
            + "onclick='javascript:showAddTaskNamespace()'></td>"
            + "<td><input type='button' class='panelbutton_default' value='Edit' onclick='javascript:showEditTaskNamespace()'></td>"
            + "<td><input type='button' class='panelbutton_cancel' value='Delete' onclick='javascript:deleteTaskNamespace()'></td>"
            + "<td><input type='button' class='panelbutton_cancel' value='Close' onclick='javascript:closeEditNamespace()'></td></tr></table></div></div>"
            + "<div id='statusbar' class='ft'>Namespace Editor</div>";

    divcontrol.appendChild(panelcontrol);
    panelcontrol.style.zIndex = 3;
    var esbpanel = new YAHOO.widget.Panel("myPanel", { width:"600px", fixedcenter:true, visible:false,
        constraintoviewport:true });
    divcontrol.style.display = "inline";
    esbpanel.render();
    esbpanel.show();
    existingns = " ";

}

function showAddTaskNamespace() {
//    alert("pos " + taskPosition)
    var divcontrol = document.getElementById("divAddNamespace");
    divcontrol.innerHTML = "";
    var panelcontrol = document.createElement("div");
    panelcontrol.setAttribute("id", "myPanel2");
    panelcontrol.innerHTML = "<div class='hd'><div class='tl'></div><span>Add Namespace</span><div class='tr'></div></div>"
            + "<div class='bd'><div id='addPanel' style='height:90px; overflow-x:hidden; overflow-y:hidden; margin-top:10px;'>"
            + "<table><tr><td>Prefix</td><td><input id='prefix' type='text' class='esb-edit' style='width: 80px;'/></td></tr>"
            + "<tr><td>URI</td><td><input id='uri' type='text' class='esb-edit'/></td></tr>"
            + "<tr><td colspan='2'></td></tr><tr><td></td>"
            + "<td><input type='button' class='panelbutton_default' value='Add' onclick='javascript:addTaskNamespace()'/>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
            + "<input type='button' class='panelbutton_cancel' value='Cancel' onclick='javascript:hideAddTaskNamespace()'/></td></tr></table>"
            + "</div></div><div id='statusbar' class='ft'>Add Namespace</div>";
    divcontrol.appendChild(panelcontrol);
    panelcontrol.style.zIndex = 3;
    var esbpanel = new YAHOO.widget.Panel("myPanel2", { width:"400px", fixedcenter:true, visible:false,
        constraintoviewport:true });
    divcontrol.style.display = "inline";
    esbpanel.render();
    esbpanel.show();

}

function hideAddTaskNamespace() {
    document.getElementById("divAddNamespace").innerHTML = "";
}

function addTaskNamespace() {
//    alert(taskPosition)
    var mediator = getnestedtask(internalmodel.task, taskPosition);
//    alert(new XMLSerializer().serializeToString(internalmodel.task));
//    alert(mediator.nodeName);
    var prefix = document.getElementById("prefix");
    var uri = document.getElementById("uri");

    if(prefix.value != "" && uri.value != ""){
        mediator.setAttribute("xmlns:" + prefix.value, uri.value);
        hideAddTaskNamespace();
        showTaskNameSpaceEditor(taskPosition, taskAttribute, changeinputID);
    }else{
        esbwarning("Empty values are not allowed for the URI or namespace prefix", TYPE_WARN);
    }
}

function applyTaskNamespace() {
    var declarations = document.getElementsByName("select");
    var currentPrefix = "";
    for (var i = 0; i < declarations.length; i++) {
        if (declarations[i].checked) {
            currentPrefix = declarations[i].id;
        }
    }
    if(currentPrefix != ""){
        var mediator = getnestedtask(internalmodel.task, taskPosition);
        var currnetAttValue = document.getElementById(changeinputID).value;
        mediator.removeAttribute(taskAttribute);
        var newAttValue = currentPrefix + ':' + currnetAttValue.substring(currnetAttValue.indexOf(':') + 1);
        mediator.setAttribute(taskAttribute, newAttValue);
        document.getElementById(changeinputID).value = newAttValue;
        var divcontrol = document.getElementById("divNamespaceEditor");
        divcontrol.innerHTML = "";
    }else{
        esbwarning("No namespace selected", TYPE_INFO);
    }
}

function showEditTaskNamespace() {

    //Get selected Namespace
    var currentPrefix = "";
    var declarations = document.getElementsByName("select");
    for (var i = 0; i < declarations.length; i++) {
        if (declarations[i].checked) {
            currentPrefix = declarations[i].id;
        }
    }

    //Check is Editable
    var mediator = getnestedtask(internalmodel.task, taskPosition);
    var attributes = mediator.attributes;
    var isEditable = false;
    var removeAttribute = "xmlns:" + currentPrefix;
    for (var i = 0; i < attributes.length; i++) {
        if (removeAttribute == attributes[i].name) {
            isEditable = true;
        }
    }

    //If editable show Edit panel
    if (isEditable) {
        var currPrefix = document.getElementById("p" + currentPrefix).innerHTML;
        var currURI = document.getElementById("n" + currentPrefix).innerHTML;
        var divcontrol = document.getElementById("divAddNamespace");
        divcontrol.innerHTML = "";
        var panelcontrol = document.createElement("div");
        panelcontrol.setAttribute("id", "myPanel2");
        panelcontrol.innerHTML = "<div class='hd'><div class='tl'></div><span>Edit Namespace</span><div class='tr'></div></div>"
                + "<div class='bd'><div id='addPanel' style='height:90px; overflow-x:hidden; overflow-y:hidden; margin-top:10px;'>"
                + "<table><tr><td>Prefix</td><td><input id='prefix' type='text' value= '" + currPrefix + "' class='esb-edit' style='width:80px;' /></td></tr>"
                + "<tr><td>URI</td><td width='100'><input id='uri' type='text' value= '" + currURI + "' class='esb-edit' /></td></tr>"
                + "<tr><td colspan='2'></td></tr>"
                + "<tr><td></td><td><input type='button' class='panelbutton_default' value='Save' onclick=editTaskNamespace('"+currURI+"','"+currPrefix+"') />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
                + "<input type='button' class='panelbutton_cancel' value='Cancel' onclick='javascript:hideAddTaskNamespace()'/></td></tr></table>"
                + "</div></div><div id='statusbar' class='ft'>Namespace Editor</div>";
        divcontrol.appendChild(panelcontrol);
        panelcontrol.style.zIndex = 3;
        var esbpanel = new YAHOO.widget.Panel("myPanel2", { width:"400px", fixedcenter:true, visible:false,
            constraintoviewport:true });
        divcontrol.style.display = "inline";
        esbpanel.render();
        esbpanel.show();
    } else {
        esbwarning("Cannot edit namespaces declarations of parent elements", TYPE_WARN);
    }

}

function editTaskNamespace(uri, prefix) {
    //collect Edited Values
    var newPrefix = document.getElementById("prefix").value;
    var newURI = document.getElementById("uri").value;
    var removeAttribute = "xmlns:" + prefix;

    //Remove Attributes
    var mediator = getnestedtask(internalmodel.task, taskPosition);
    mediator.removeAttribute(removeAttribute);
    var newAttribute = "xmlns:" + trim(newPrefix);

    mediator.setAttribute(newAttribute ,trim(newURI));

    hideAddTaskNamespace();
    showTaskNameSpaceEditor(taskPosition, taskAttribute, changeinputID);
}

function deleteTaskNamespace() {
    var mediator = getnestedtask(internalmodel.task, taskPosition);

    //Get selected Namespace Declaration
    var declarations = document.getElementsByName("select");
    var currentPrefix = "";
    for (var i = 0; i < declarations.length; i++) {
        if (declarations[i].checked) {
            currentPrefix = declarations[i].id;
        }
    }

    //Check if the namespace is deleteable
    var isDeleteable = false;
    var removeAttribute = "xmlns:" + currentPrefix;
    var attributes = mediator.attributes;
    for (var i = 0; i < attributes.length; i++) {
        if (removeAttribute == attributes[i].name) {
            isDeleteable = true;
        }
    }

    //delete the namespace
    if (isDeleteable) {
        var currPrefix = document.getElementById("p" + currentPrefix).innerHTML;
        mediator.removeAttribute("xmlns:" + currPrefix);
        showTaskNameSpaceEditor(taskPosition, taskAttribute, changeinputID);
    } else {
        esbwarning("Cannot edit namespace declarations of parent elements", TYPE_WARN);
    }
}

function getnestedtask(mediatornode, position) {
//    alert(new XMLSerializer().serializeToString(mediatornode) + " " + position);
    position = position.toString();
    if (position.indexOf(".") == -1) {
        if(mediatornode != undefined && mediatornode.childNodes.length != 0)
            return mediatornode.childNodes[position];
    } else {
        return getnestedtask(mediatornode.childNodes[position.substring(0, ("" + position)
                .indexOf("."))], position.substring(position.indexOf(".") + 1, position.length));
    }
}