<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:syn="http://ws.apache.org/ns/synapse">

    <xsl:template name="options_from_string">

        <xsl:param name="option_string"/>
        <xsl:param name="selected_value"/>

        <xsl:choose>

            <xsl:when test="substring-before($option_string, ' ') != ''">
                <xsl:choose>
                    <xsl:when test="substring-before($option_string, ' ') = $selected_value">
                        <option selected="true">
                            <xsl:attribute name="value">
                                <xsl:value-of select="substring-before($option_string, ' ')"/>
                            </xsl:attribute>
                            <xsl:value-of select="substring-before($option_string, ' ')"/>
                        </option>
                    </xsl:when>
                    <xsl:otherwise>
                        <option>
                            <xsl:attribute name="value">
                                <xsl:value-of select="substring-before($option_string, ' ')"/>
                            </xsl:attribute>
                            <xsl:value-of select="substring-before($option_string, ' ')"/>
                        </option>
                    </xsl:otherwise>
                </xsl:choose>
                <xsl:call-template name="options_from_string">
                    <xsl:with-param name="option_string" select="substring-after($option_string, ' ')"/>
                    <xsl:with-param name="selected_value" select="$selected_value"/>
                </xsl:call-template>
            </xsl:when>

            <xsl:otherwise>
                <xsl:if test="$option_string != ''">
                    <xsl:choose>
                        <xsl:when test="$option_string = $selected_value">
                            <option selected="true">
                                <xsl:attribute name="value">
                                    <xsl:value-of select="$option_string"/>
                                </xsl:attribute>
                                <xsl:value-of select="$option_string"/>
                            </option>
                        </xsl:when>
                        <xsl:otherwise>
                            <option>
                                <xsl:attribute name="value">
                                    <xsl:value-of select="$option_string"/>
                                </xsl:attribute>
                                <xsl:value-of select="$option_string"/>
                            </option>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:if>
            </xsl:otherwise>

        </xsl:choose>

    </xsl:template>

</xsl:stylesheet>