<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:template match="syn:endpoint" xmlns:syn="http://ws.apache.org/ns/synapse">
         <xsl:element name="div">
           <xsl:attribute name="id"><xsl:value-of select="concat('esb_endpoint_div',@index)"/></xsl:attribute>
           <xsl:attribute name="style">width:500px;</xsl:attribute>
            <div class="content-header">
                <img src="extensions/core/images/failover_endpoint.gif" align="top"/>
                <xsl:text> Failover Endpoint </xsl:text>
            
	           <xsl:if test="@index != '0' ">
	            <xsl:element name="img">
	                <xsl:attribute name="style">margin-left:15px</xsl:attribute>
	                <xsl:attribute name="src">
	                    extensions/core/images/delete.gif</xsl:attribute>
	                <xsl:attribute name="title">Delete Endpoint</xsl:attribute>
	                <xsl:attribute name="onClick">
	                    javascript:deleteChildEndpoint('<xsl:value-of select="@index"/>');return false;
	                </xsl:attribute>
	            </xsl:element>
	            </xsl:if>
	        </div>
            
            <div id="endpoint_edit" style="margin-left:10px;">
                
                <table border="0" class="data-table" style="width:450px;">
                    <tbody>
                        <xsl:if test="@anonymous = 'false' ">
                        <tr>
                            <td style="width:150px;">
                                   Name<font style='color: red;font-size: 8pt;'>&#160;*</font>
                                </td>
                                <td>

                                    <xsl:element name="input">
                                        <xsl:attribute name="id"><xsl:value-of select="concat('endpoint_name',@index)" /></xsl:attribute>
                                        <xsl:attribute name="type">text</xsl:attribute>
                                         <xsl:attribute name="size">40</xsl:attribute>
                                        <xsl:attribute name="class">esb-edit</xsl:attribute>

                                       <xsl:attribute name="value">
                                            <xsl:text></xsl:text>
                                        </xsl:attribute>
                                          </xsl:element>

                                </td>
                        </tr>
                        </xsl:if>
                    </tbody>
                </table>
                <fieldset class="field-group">



                <xsl:element name="div">
                    <xsl:attribute name="id"><xsl:value-of select="concat('childEndPointsDIV',@index)"/>
                    </xsl:attribute>
                    <xsl:attribute name="class"></xsl:attribute>
                </xsl:element>
                	<legend>
                    <img src='extensions/core/images/add_mediator.gif' align="top">
                        <xsl:attribute name="onclick">javascript:addChildEndpoint(event,'<xsl:value-of select="@index"/>');</xsl:attribute>
                    </img>
                	<label class='styled-link' style="line-height:25px;">Add Endpoint</label>
                	</legend>
				</fieldset>
            	</div>
            
        </xsl:element>
    </xsl:template>
</xsl:stylesheet>