<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:template match="syn:endpoint" xmlns:syn="http://ws.apache.org/ns/synapse"  xmlns:wsdl20="http://www.w3.org/2004/03/wsdl" xmlns:wsdl="http://schemas.xmlsoap.org/wsdl/">
        <xsl:element name="div">
            <xsl:attribute name="id">
                <xsl:value-of select="concat('esb_endpoint_div',@index)"/>
            </xsl:attribute>
            <xsl:attribute name="style">width:500px;</xsl:attribute>
            <div class="content-header">
                <img src="extensions/core/images/wsdl_endpoint.gif" align="top"/>
                <xsl:text> WSDL Endpoint </xsl:text>
            
	            <xsl:if test="@index != '0' ">
	                <xsl:element name="img">
	                    <xsl:attribute name="style">margin-left:15px</xsl:attribute>
	                    <xsl:attribute name="src">
	                        extensions/core/images/delete.gif
	                    </xsl:attribute>
	                    <xsl:attribute name="title">Delete Endpoint</xsl:attribute>
	                    <xsl:attribute name="onClick">
	                        javascript:deleteChildEndpoint('<xsl:value-of select="@index"/>');return false;
	                    </xsl:attribute>
	                </xsl:element>
	            </xsl:if>
            </div>
            <div id="endpoint_edit" class="end-point-div">
                
                <table border="0" class="data-table" style="width:450px;">
                    <tbody>
                        <xsl:if test="@anonymous = 'false' ">
                            <tr>
                                <td style="width:150px;">
                                    Name
                                    <font style='color: red;font-size: 8pt;'>&#160;*</font>
                                </td>
                                <td>
                                    <xsl:element name="input">
                                        <xsl:attribute name="id">
                                            <xsl:value-of select="concat('endpoint_name',@index)"/>
                                        </xsl:attribute>
                                        <xsl:attribute name="type">text</xsl:attribute>
                                        <xsl:attribute name="size">40</xsl:attribute>
                                        <xsl:attribute name="class">esb-edit</xsl:attribute>
                                        <xsl:attribute name="value">
                                            <xsl:if test="@name"><xsl:value-of select="@name"/></xsl:if>
                                            <xsl:if test="not(@name)"><xsl:text></xsl:text></xsl:if>
                                        </xsl:attribute>
                                    </xsl:element>
                                </td>
                            </tr>
                        </xsl:if>
                        <xsl:if test="@_wsdl = 0 or syn:wsdl/wsdl20:description or syn:wsdl/wsdl:definitions">
                            <tr>
                                <td>Specify as:</td>
                                <td>
                                    <xsl:element name="input">
                                        <xsl:attribute name="type">radio</xsl:attribute>
                                        <xsl:attribute name="name">
                                            <xsl:value-of select="concat('group',@index)"/>
                                        </xsl:attribute>
                                        <xsl:attribute name="value">InLineWSDL</xsl:attribute>
                                        <xsl:attribute name="checked">checked</xsl:attribute>
                                    </xsl:element>
                                    In-lined WSDL
                                    <xsl:element name="input">
                                        <xsl:attribute name="type">radio</xsl:attribute>
                                        <xsl:attribute name="style">margin-left:15px</xsl:attribute>
                                        <xsl:attribute name="name">
                                            <xsl:value-of select="concat('group',@index)"/>
                                        </xsl:attribute>
                                        <xsl:attribute name="value">wsdl_uri
                                            <font style='color: red;font-size: 8pt;'>&#160;*</font>
                                        </xsl:attribute>
                                        <xsl:attribute name="onClick">
                                            javascript:setWSDLURI('<xsl:value-of select="@index"/>','<xsl:value-of select="@anonymous"/>');return false;
                                        </xsl:attribute>
                                    </xsl:element>
                                    URI
                                </td>
                            </tr>
                            <tr>
                                <td>In-lined WSDL
                                    <font style='color: red;font-size: 8pt;'>&#160;*</font>
                                </td>
                                <td>
                                    <xsl:element name="img">
                                        <xsl:attribute name="src">
                                            extensions/core/images/_edit.gif
                                        </xsl:attribute>
                                        <xsl:attribute name="title">Edit In-lined WSDL</xsl:attribute>
                                        <xsl:attribute name="onClick">
                                            javascript:viewwsdl('<xsl:value-of select="@index"/>','<xsl:value-of select="@anonymous"/>');return false;
                                        </xsl:attribute>
                                    </xsl:element>
                                </td>
                            </tr>
                        </xsl:if>
                        <xsl:if test="not(@_wsdl) and not(syn:wsdl/wsdl20:description) and not(syn:wsdl/wsdl:definitions)">
                            <tr>
                                <td>Specify as:</td>
                                <td>
                                    <xsl:element name="input">
                                        <xsl:attribute name="type">radio</xsl:attribute>
                                        <xsl:attribute name="name">
                                            <xsl:value-of select="concat('group',@index)"/>
                                        </xsl:attribute>
                                        <xsl:attribute name="value">Inline WSDL
                                            <font style='color: red;font-size: 8pt;'>&#160;*</font>
                                        </xsl:attribute>
                                        <xsl:attribute name="onClick">
                                            javascript:setInLineWSDL('<xsl:value-of select="@index"/>','<xsl:value-of select="@anonymous"/>');return false;
                                        </xsl:attribute>
                                    </xsl:element>
                                    In-lined WSDL
                                    <xsl:element name="input">
                                        <xsl:attribute name="type">radio</xsl:attribute>
                                        <xsl:attribute name="style">margin-left:15px</xsl:attribute>
                                        <xsl:attribute name="name">
                                            <xsl:value-of select="concat('group',@index)"/>
                                        </xsl:attribute>
                                        <xsl:attribute name="value">WSDL-Uri
                                            <font style='color: red;font-size: 8pt;'>&#160;*</font>
                                        </xsl:attribute>
                                        <xsl:attribute name="checked">checked</xsl:attribute>
                                    </xsl:element>
                                    URI
                                </td>
                            </tr>
                            <tr>
                                <td>
                                    WSDL URI
                                    <font style='color: red;font-size: 8pt;'>&#160;*</font>
                                </td>
                                <td>
                                    <xsl:element name="input">
                                        <xsl:attribute name="id">
                                            <xsl:value-of select="concat('endpoint_address',@index)"/>
                                        </xsl:attribute>
                                        <xsl:attribute name="type">text</xsl:attribute>
                                        <xsl:attribute name="size">40</xsl:attribute>
                                        <xsl:attribute name="class">esb-edit</xsl:attribute>
                                        <xsl:attribute name="value">
                                            <xsl:if test="syn:wsdl">
                                                <xsl:value-of select="syn:wsdl/@uri"></xsl:value-of>
                                            </xsl:if>
                                            <xsl:if test="not(syn:wsdl)">
                                                <xsl:text></xsl:text>
                                            </xsl:if>

                                        </xsl:attribute>
                                    </xsl:element>
                                </td>
                            </tr>
                        </xsl:if>
                        <tr>
                            <td>
                                Service
                                <font style='color: red;font-size: 8pt;'>&#160;*</font>
                            </td>
                            <td>
                                <xsl:element name="input">
                                    <xsl:attribute name="id">
                                        <xsl:value-of select="concat('endpoint_service',@index)"/>
                                    </xsl:attribute>
                                    <xsl:attribute name="type">text</xsl:attribute>
                                    <xsl:attribute name="size">40</xsl:attribute>
                                    <xsl:attribute name="class">esb-edit</xsl:attribute>
                                    <xsl:attribute name="value">
                                        <xsl:if test="syn:wsdl">
                                            <xsl:value-of select="syn:wsdl/@service"></xsl:value-of>
                                        </xsl:if>
                                        <xsl:if test="not(syn:wsdl)">
                                            <xsl:text></xsl:text>
                                        </xsl:if>

                                    </xsl:attribute>
                                </xsl:element>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                Port
                                <font style='color: red;font-size: 8pt;'>&#160;*</font>
                            </td>
                            <td>
                                <xsl:element name="input">
                                    <xsl:attribute name="id">
                                        <xsl:value-of select="concat('endpoint_port',@index)"/>
                                    </xsl:attribute>
                                    <xsl:attribute name="type">text</xsl:attribute>
                                    <xsl:attribute name="size">40</xsl:attribute>
                                    <xsl:attribute name="class">esb-edit</xsl:attribute>
                                    <xsl:attribute name="value">
                                        <xsl:if test="syn:wsdl">
                                            <xsl:value-of select="syn:wsdl/@port"></xsl:value-of>
                                        </xsl:if>
                                        <xsl:if test="not(syn:wsdl)">
                                            <xsl:text></xsl:text>
                                        </xsl:if>
                                    </xsl:attribute>
                                </xsl:element>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                <xsl:text>Suspend </xsl:text>
                            </td>
                              </tr>
                        <tr>
                             <td class="indent-small form-sub-field">
                                    <xsl:text>Duration (Secs)</xsl:text>
                                </td>
                            <td>
                                <xsl:element name="input">
                                    <xsl:attribute name="id">
                                        <xsl:value-of select="concat('endpoint_suspend_duration',@index)"/>
                                    </xsl:attribute>
                                    <xsl:attribute name="type">text</xsl:attribute>
                                    <xsl:attribute name="class">esb-edit</xsl:attribute>
                                    <xsl:attribute name="value">
                                        <xsl:if test="syn:wsdl/syn:suspendDurationOnFailure">
                                            <xsl:variable name="duration"><xsl:value-of
                                                    select="syn:wsdl/syn:suspendDurationOnFailure"/></xsl:variable>
                                            <xsl:value-of select="$duration"/>
                                        </xsl:if>
                                    </xsl:attribute>
                                </xsl:element>
                            </td>
                        </tr>

                        <tr>
                            <td>
                                <xsl:text>Timeout</xsl:text>
                            </td>
                        </tr>
                        <tr>
                            <td class="indent-small form-sub-field">
                                <xsl:text>Action</xsl:text>
                            </td>
                            <td>
                                <xsl:element name="select">
                                    <xsl:attribute name="onchange">
                                        javascript:onActionChange('<xsl:value-of select="@index"/>');
                                    </xsl:attribute>
                                    <xsl:attribute name="id">
                                        <xsl:value-of select="concat('endpoint_timeout_action',@index)"/>
                                    </xsl:attribute>
                                    <xsl:attribute name="class">esb-edit</xsl:attribute>
                                    <xsl:if test="syn:wsdl/syn:timeout/syn:action/child::text() ='discard'">
                                        <option value="discard">Discard message</option>
                                        <option value="fault">Execute fault sequence</option>
                                        <option value="Select A Value">Never timeout</option>
                                    </xsl:if>
                                    <xsl:if test="syn:wsdl/syn:timeout/syn:action/child::text() ='fault'">

                                        <option value="fault">Execute fault sequence</option>
                                        <option value="Select A Value">Never timeout</option>
                                        <option value="discard">Discard message</option>
                                    </xsl:if>
                                    <xsl:if test="not(syn:wsdl/syn:timeout/syn:action/child::text() ='discard') and not(syn:wsdl/syn:timeout/syn:action/child::text() ='fault')">
                                        <option value="Select A Value">Never timeout</option>
                                        <option value="discard">Discard message</option>
                                        <option value="fault">Execute fault sequence</option>
                                    </xsl:if>
                                </xsl:element>
                            </td>
                        </tr>
                        <tr>
                            <td class="indent-small form-sub-field">
                                <xsl:text>Duration (Secs)</xsl:text>
                            </td>
                            <td>
                                <xsl:element name="input">
                                    <xsl:attribute name="id">
                                        <xsl:value-of select="concat('endpoint_duration',@index)"/>
                                    </xsl:attribute>
                                    <xsl:attribute name="type">text</xsl:attribute>
                                    <xsl:attribute name="class">esb-edit</xsl:attribute>
                                    <xsl:attribute name="value">
                                        <xsl:if test="syn:wsdl/syn:timeout">
                                            <xsl:value-of select="syn:wsdl/syn:timeout/syn:duration"></xsl:value-of>
                                        </xsl:if>
                                        <xsl:if test="not(syn:wsdl/syn:timeout)">
                                            <xsl:text>0</xsl:text>
                                        </xsl:if>
                                    </xsl:attribute>
                                    <xsl:attribute name="disabled">
                                        true
                                    </xsl:attribute>
                                </xsl:element>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                <xsl:text>WS-Addressing</xsl:text>
                            </td>
                            <td>
                                <xsl:element name="input">
                                    <xsl:attribute name="type">checkbox</xsl:attribute>
                                    <xsl:attribute name="id">
                                        <xsl:value-of select="concat('wsAddressingEngaged',@index)"/>
                                    </xsl:attribute>
                                    <xsl:if test="syn:wsdl/syn:enableAddressing">
                                        <xsl:attribute name="checked">checked</xsl:attribute>
                                    </xsl:if>
                                </xsl:element>
                            </td>
                        </tr>
                        <tr>
                            <td class="indent-small form-sub-field">
                                <xsl:text>Policy key</xsl:text>
                            </td>
                            <td>
                                <xsl:element name="input">
                                    <xsl:attribute name="type">checkbox</xsl:attribute>
                                    <xsl:attribute name="id">
                                        <xsl:value-of select="concat('separateListener',@index)"/>
                                    </xsl:attribute>
                                    <xsl:if test="syn:wsdl/syn:enableAddressing/@separateListener">
                                        <xsl:attribute name="checked">checked</xsl:attribute>
                                    </xsl:if>
                                </xsl:element>
                            </td>
                        </tr>
                        <tr>
                            <td>
                                <xsl:text>WS-Security</xsl:text>
                            </td>
                            <td>
                                <xsl:element name="input">
                                    <xsl:attribute name="type">checkbox</xsl:attribute>
                                    <xsl:attribute name="id">
                                        <xsl:value-of select="concat('wsSecEngaged',@index)"/>
                                    </xsl:attribute>
                                    <xsl:if test="syn:wsdl/syn:enableSec">
                                        <xsl:attribute name="checked">checked</xsl:attribute>
                                    </xsl:if>
                                    <xsl:attribute name="onClick">
                                        javascript:onwssecchange('<xsl:value-of select="@index"/>');
                                    </xsl:attribute>
                                </xsl:element>
                            </td>
                        </tr>
                        <tr>
                            <td class="indent-small form-sub-field">
                                <xsl:text>Policy key</xsl:text>
                            </td>
                            <td>
                                <xsl:element name="input">
                                    <xsl:attribute name="id">
                                        <xsl:value-of select="concat('sec_policy',@index)"/>
                                    </xsl:attribute>
                                    <xsl:attribute name="type">text</xsl:attribute>
                                    <xsl:attribute name="size">40</xsl:attribute>
                                    <xsl:attribute name="class">esb-edit_disabled</xsl:attribute>
                                    <xsl:attribute name="value">
                                        <xsl:value-of select="syn:wsdl/syn:enableSec/@policy"/>
                                    </xsl:attribute>
                                    <xsl:attribute name="DISABLED"/>
                                </xsl:element>
                            </td>
                            <td>
                                <xsl:element name="img">
                                    <xsl:attribute name="src">
                                        extensions/core/images/registry_picker.gif
                                    </xsl:attribute>
                                    <xsl:attribute name="title">Registry Browser</xsl:attribute>
                                    <xsl:attribute name="onClick">
                                        javascript:policyfromregistry('<xsl:value-of select="@index"/>','SEC','WSDL','<xsl:value-of select="@anonymous"/>');return false;
                                    </xsl:attribute>
                                </xsl:element>
                            </td>
                        </tr>

                        <tr>
                            <td>
                                <xsl:text>WS-RM</xsl:text>
                            </td>
                            <td>
                                <xsl:element name="input">
                                    <xsl:attribute name="type">checkbox</xsl:attribute>
                                    <xsl:attribute name="id">
                                        <xsl:value-of select="concat('wsRMEngaged',@index)"/>
                                    </xsl:attribute>
                                    <xsl:if test="syn:wsdl/syn:enableRM">
                                        <xsl:attribute name="checked">checked</xsl:attribute>
                                    </xsl:if>
                                    <xsl:attribute name="onClick">
                                        javascript:onwsrmchange('<xsl:value-of select="@index"/>');
                                    </xsl:attribute>
                                </xsl:element>
                            </td>
                        </tr>
                        <tr>
                            <td class="indent-small form-sub-field">
                                <xsl:text>Policy key</xsl:text>
                            </td>
                            <td>
                                <xsl:element name="input">
                                    <xsl:attribute name="id">
                                        <xsl:value-of select="concat('rm_policy',@index)"/>
                                    </xsl:attribute>
                                    <xsl:attribute name="type">text</xsl:attribute>
                                    <xsl:attribute name="size">40</xsl:attribute>
                                    <xsl:attribute name="class">esb-edit_disabled</xsl:attribute>
                                    <xsl:attribute name="value">
                                        <xsl:value-of select="syn:wsdl/syn:enableRM/@policy"/>
                                    </xsl:attribute>
                                    <xsl:attribute name="DISABLED"/>
                                </xsl:element>
                            </td>
                            <td>
                                <xsl:element name="img">
                                    <xsl:attribute name="src">
                                        extensions/core/images/registry_picker.gif
                                    </xsl:attribute>
                                    <xsl:attribute name="title">Registry Browser</xsl:attribute>
                                    <xsl:attribute name="onClick">
                                        javascript:policyfromregistry('<xsl:value-of select="@index"/>','RM','WSDL','<xsl:value-of select="@anonymous"/>');return false;
                                    </xsl:attribute>
                                </xsl:element>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </xsl:element>
    </xsl:template>
</xsl:stylesheet>
