<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="html"/>

    <xsl:template match="ns1:entryDataResponse" xmlns:ns1="http://org.apache.synapse/xsd">
         <div class="breadcrumb"> <a title="WSO2 ESB Home" onclick="javascript:showHome(); return false;" href="#">Home</a>&#160;&gt;&#160; Manage Local Registry Entries</div>
         <div class="page-main-title title-local-registry" style="z-index:0;">
			Manage Local Registry Entries
              <img src="extensions/core/images/help.gif" alt=""
                   onmouseover="showHelp(event,'entryHelpDiv')"
                   onmouseout="hideHelp(event,'entryHelpDiv')"/>
          </div>
          <div id="entryHelpDiv" style="z-index:600"></div>
             
        <fieldset style="border:none;z-index:0;">
            <div id='formset'>
                <xsl:choose>
                        <xsl:when test="return">
                            <table class="styled">
                                <thead>
                                <tr>
                                    <th>Entry Name</th>
                                    <th>Type</th>
                                    <th>Value</th>
                                    <th>Actions</th>
                                </tr>
                                </thead>
                                <tbody>
                                <xsl:for-each select="return">
                                    <tr>
                                        <td>
                                            <xsl:element name="a">
                                                <xsl:attribute name="href">#</xsl:attribute>
                                                <xsl:attribute name="onClick">javascript:editEntry('<xsl:value-of select="name"/>'); return false;</xsl:attribute>
                                                <xsl:value-of select="name"/>
                                            </xsl:element>
                                        </td>

                                        <td><xsl:value-of select="type"/></td>
                                        <td><xsl:value-of select="value"/></td>
                                        <td>
                                            <nobr>
                                                <a href="#" id="edit_link">
                                                    <xsl:attribute name="onClick">javascript:editEntry('<xsl:value-of select="name"/>'); return false;</xsl:attribute>
                                                    <xsl:attribute name="title">Edit local entry  <xsl:value-of select="name"/> </xsl:attribute>
                                                    <xsl:attribute name="alt">Edit  <xsl:value-of select="name"/> </xsl:attribute>
                                                    &#160;&#160;&#160;&#160;
                                                </a>

                                                <a href="#" id="delete_link">
                                                    <xsl:attribute name="onClick">javascript:delEntrySave('<xsl:value-of select="name"/>'); return false;</xsl:attribute>
                                                    <xsl:attribute name="title">Delete Entry  <xsl:value-of select="name"/> </xsl:attribute>
                                                    <xsl:attribute name="alt">Delete Entry  <xsl:value-of select="name"/></xsl:attribute>
                                                    &#160;&#160;&#160;&#160;
                                                </a>

                                            </nobr>
                                        </td>
                                    </tr>
                                </xsl:for-each>
                            </tbody>
                            </table>
                    </xsl:when>
                    <xsl:otherwise>
                        <br/><i><font style='color: brown'>No entries are currently defined. Press 'Add' to define a new entry on the local Registry</font></i><br/><br/>
                    </xsl:otherwise>
                </xsl:choose>
            </div>
            <input name="addEntry" type="button" class='panelbutton_default' value="Add" onclick="javascript:addEntry(event);return false;"/>
        </fieldset>
        
    </xsl:template>
 </xsl:stylesheet>
