<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:include href="../commons.xsl"/>

    <xsl:template match="syn:entrylist" xmlns:syn="http://ws.apache.org/ns/synapse">
        <div id="endpoint_edit_div" style="width:500px;">
            <xsl:variable name="entrystr" select="@entry_list"/>
            <div id="endpoint_edit" class="end-point-div">
                <br/>
                <table border="0" class="tabelcontainer">
                    <tbody>
                        <tr>
                            <xsl:if test="@key">
                                <td>
                                    <xsl:text>Key</xsl:text>
                                </td>
                                <td>
                                   <xsl:element name="select">
                                       <xsl:attribute name="id">localentry_key</xsl:attribute>
                                        <xsl:attribute name="class">esb-edit</xsl:attribute>
                                        <xsl:call-template name="options_from_string">
                                            <xsl:with-param name="option_string"
                                                            select="$entrystr"/>
                                            <xsl:with-param name="selected_value"
                                                            select="@key"/>
                                        </xsl:call-template>
                                    </xsl:element>
                                </td>
                            </xsl:if>
                            <xsl:if test="not(key)">
                                <td>
                                    <xsl:text>key</xsl:text>
                                </td>
                                <td>
                                    <xsl:element name="select">
                                        <xsl:attribute name="id">localentry_key</xsl:attribute>                                                                             
                                        <xsl:attribute name="class">esb-edit</xsl:attribute>
                                        <option value="Select A Value">Select</option>
                                        <xsl:call-template name="options_from_string">
                                            <xsl:with-param name="option_string"
                                                            select="$entrystr"/>
                                            <xsl:with-param name="selected_value"
                                                            select="syn:entrylist"/>
                                        </xsl:call-template>
                                    </xsl:element>
                                </td>
                            </xsl:if>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
    </xsl:template>
</xsl:stylesheet>