<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
 

    <xsl:template match="ns1:getLogConfigResponse" xmlns:ns1="http://org.apache.synapse/xsd">
    <xsl:variable name="loggerLevelRoot" 
        select="return/loggerLevelRoot" />
    <xsl:variable name="loggerLevelService" 
        select="return/loggerLevelService"/>
    <xsl:variable name="loggerLevelTrace" 
        select="return/loggerLevelTrace"/>
        <div class="breadcrumb"> <a title="WSO2 ESB Home" onclick="javascript:showHome(); return false;" href="#">Home</a>&#160;&gt;&#160; Log Settings</div>
        <div class="title-log-settings page-main-title"> Log Settings
            <img src="extensions/core/images/help.gif" alt=""
                     onmouseover="showHelp(event,'logConfigHelpDiv')"
                     onmouseout="hideHelp(event,'logConfigHelpDiv')"/>
            </div><div id="logConfigHelpDiv" style="visibility:hidden; z-index:600"></div>
        <form>

        <span style="margin-top:10px;margin-bottom:10px; display:block;_margin-top:0px;">
            The following 3 select boxes will display and let you change the log levels in the runtime system only.<br /> 
            They will not affect the saved log configuration. When you edit and save the log configuration below,<br />
            select boxes will be refreshed with the saved configuration values.</span>   
        <table cellpadding="0" cellspacing="0" border="0" style="width:770px;">
        	<tr>
        		<td style="width:80px;">Root Level</td>
        		<td style="width:600px;" align="left">
        			<select id="loggerRoot" class="esb-edit" style="width: 80px; align:left"
        				onchange="javascript:changeLogConfigLevelRoot(); return false;">
                        <option value="--">--</option>
                        <option value="TRACE"> 
                            <xsl:if test='$loggerLevelRoot = "TRACE"'>
                                <xsl:attribute name="selected">selected</xsl:attribute>
                            </xsl:if>
                            TRACE
                        </option>
                        <option value="DEBUG"> 
                            <xsl:if test='$loggerLevelRoot = "DEBUG"'>
                                <xsl:attribute name="selected">selected</xsl:attribute>
                            </xsl:if>
                            DEBUG
                        </option>                        
                        <option value="INFO"> 
                            <xsl:if test='$loggerLevelRoot = "INFO"'>
                                <xsl:attribute name="selected">selected</xsl:attribute>
                            </xsl:if>
                            INFO
                        </option>
                        <option value="WARN"> 
                            <xsl:if test='$loggerLevelRoot = "WARN"'>
                                <xsl:attribute name="selected">selected</xsl:attribute>
                            </xsl:if>
                            WARN
                        </option>
                        <option value="ERROR"> 
                            <xsl:if test='$loggerLevelRoot = "ERROR"'>
                                <xsl:attribute name="selected">selected</xsl:attribute>
                            </xsl:if>
                            ERROR
                        </option>
                        <option value="FATAL"> 
                            <xsl:if test='$loggerLevelRoot = "FATAL"'>
                                <xsl:attribute name="selected">selected</xsl:attribute>
                            </xsl:if>
                            FATAL
                        </option>
        			</select>
        		</td>
        	</tr>
            <tr>
                <td>Service Level</td>
                <td align="left">
                    <select id="loggerService" class="esb-edit" style="width: 80px; align:left"
                        onchange="javascript:changeLogConfigLevelService(); return false;">
                        <option value="--">--</option>
                        <option value="TRACE"> 
                            <xsl:if test='$loggerLevelService = "TRACE"'>
                                <xsl:attribute name="selected">selected</xsl:attribute>
                            </xsl:if>
                            TRACE
                        </option>                        
                        <option value="DEBUG"> 
                            <xsl:if test='$loggerLevelService = "DEBUG"'>
                                <xsl:attribute name="selected">selected</xsl:attribute>
                            </xsl:if>
                            DEBUG
                        </option>                          
                        <option value="INFO"> 
                            <xsl:if test='$loggerLevelService = "INFO"'>
                                <xsl:attribute name="selected">selected</xsl:attribute>
                            </xsl:if>
                            INFO
                        </option>
                        <option value="WARN"> 
                            <xsl:if test='$loggerLevelService = "WARN"'>
                                <xsl:attribute name="selected">selected</xsl:attribute>
                            </xsl:if>
                            WARN
                        </option>
                        <option value="ERROR"> 
                            <xsl:if test='$loggerLevelService = "ERROR"'>
                                <xsl:attribute name="selected">selected</xsl:attribute>
                            </xsl:if>
                            ERROR
                        </option>
                        <option value="FATAL"> 
                            <xsl:if test='$loggerLevelService = "FATAL"'>
                                <xsl:attribute name="selected">selected</xsl:attribute>
                            </xsl:if>
                            FATAL
                        </option>
                    </select>
                </td>
            </tr>
            <tr>
                <td>Trace Level</td>
                <td align="left">
                    <select id="loggerTrace" class="esb-edit" style="width: 80px; align:left"
                        onchange="javascript:changeLogConfigLevelTrace(); return false;">
                        <option value="--">--</option>
                        <option value="TRACE"> 
                            <xsl:if test='$loggerLevelTrace = "TRACE"'>
                                <xsl:attribute name="selected">selected</xsl:attribute>
                            </xsl:if>
                            TRACE
                        </option>
                        <option value="DEBUG"> 
                            <xsl:if test='$loggerLevelTrace = "DEBUG"'>
                                <xsl:attribute name="selected">selected</xsl:attribute>
                            </xsl:if>
                            DEBUG
                        </option>
                        <option value="INFO"> 
                            <xsl:if test='$loggerLevelTrace = "INFO"'>
                                <xsl:attribute name="selected">selected</xsl:attribute>
                            </xsl:if>
                            INFO
                        </option>
                        <option value="WARN"> 
                            <xsl:if test='$loggerLevelTrace = "WARN"'>
                                <xsl:attribute name="selected">selected</xsl:attribute>
                            </xsl:if>
                            WARN
                        </option>
                        <option value="ERROR"> 
                            <xsl:if test='$loggerLevelTrace = "ERROR"'>
                                <xsl:attribute name="selected">selected</xsl:attribute>
                            </xsl:if>
                            ERROR
                        </option>
                        <option value="FATAL"> 
                            <xsl:if test='$loggerLevelTrace = "FATAL"'>
                                <xsl:attribute name="selected">selected</xsl:attribute>
                            </xsl:if>
                            FATAL
                        </option>
                    </select>
                </td>
            </tr>
            
            <tr>
                <td><br /></td>
            </tr>
            
            <tr>
            	<td colspan="2">
            	<div id="logConfigText">

                <label style='text-align: left'>
                    <div class="text-area-header">ESB_HOME/webapp/WEB-INF/classes/conf/log4j.properties</div>
                </label>
                <textarea id="logConfigTextArea" class="esb-edit" style="width: 100%;height: 270px; margin-top:5px; font-family:monospace;">
                    <xsl:value-of select="return/logText"/>
                </textarea>
            </div>
                                     
            <div id="logConfigSave">
                <span style="margin-top:10px;margin-bottom:10px; display:block;_margin-top:0px;">
                Click 'Save' to commit and reload the log configuration. The 3 select box values will be overridden by this configuration.
                </span>
                <input name="logConfigSaveBtn" type="button" class="panelbutton_default"
                       value="Save"
                       onclick="javascript:saveLogConfig();return false;" style="margin-right:10px;" />
            </div>
            	
            	</td>
            </tr>
        </table>

            
        </form>
    </xsl:template>
</xsl:stylesheet>
