<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <!--<xsl:include href="commons.xsl"/>-->
    <xsl:include href="mediator_view.xsl"/>
    <!--<xsl:include href="target_edit.xsl"/>-->
    <!--<xsl:include href="target_view.xsl"/> -->

    <xsl:template match="syn:aggregate" xmlns:syn="http://ws.apache.org/ns/synapse">

        <div id="aggregate_edit_div">
            <label class="content-header">
                <img src="extensions/core/images/aggregate-big.jpg"/>
                <xsl:text>Aggregate Mediator</xsl:text>
            </label>

            <div class="inside-content">
            <table border="0" cellpadding="0" cellspacing="0" class="data-table" style="width: 550px;">
            <tbody>
				<tr>
                    <td style="width: 200px;">Aggregation Expression </td>
                    <td>
                        <input type="text" id="aggregate_expr" class="esb-edit">
                            <xsl:attribute name="value"><xsl:value-of select="syn:onComplete/@expression"/></xsl:attribute>
                        </input>
                    </td>
                    <td>
                        <a class="ns_editor" title="Namespace Editor">
                            <xsl:attribute name="onclick">javascript: showNameSpaceEditor('<xsl:value-of select="@esb_med_pos"/>','','')</xsl:attribute>
                        </a>
                    </td>
                </tr>
                
                <tr>
                    <td style="width: 200px;">Completion Timeout </td>
                    <td colspan="2">
                        <input type="text" id="complete_time" class="esb-edit">
                            <xsl:attribute name="value"><xsl:value-of select="syn:completeCondition/@timeout"/></xsl:attribute>
                        </input>
                    </td>
                </tr>
                
                <tr>
                    <td style="width: 200px;">Completion Max-messages </td>
                    <td colspan="2">
                        <input type="text" id="complete_max" class="esb-edit">
                            <xsl:attribute name="value"><xsl:value-of select="syn:completeCondition/syn:messageCount/@max"/></xsl:attribute>
                        </input>
                    </td>
                </tr>
                
                <tr>
                    <td style="width: 200px;">Completion Min-messages </td>
                    <td colspan="2">
                        <input type="text" id="complete_min" class="esb-edit">
                            <xsl:attribute name="value"><xsl:value-of select="syn:completeCondition/syn:messageCount/@min"/></xsl:attribute>
                        </input>
                    </td>
                </tr>
                
                <tr>
                    <td style="width: 200px;">Corelation Expression </td>
                    <td>
                        <input type="text" id="correlate_expr" class="esb-edit">
                            <xsl:attribute name="value"><xsl:value-of select="syn:correlateOn/@expression"/></xsl:attribute>
                        </input>
                    </td>
                    <td>
                        <a class="ns_editor" title="Namespace Editor">
                            <xsl:attribute name="onclick">javascript: showNameSpaceEditor('<xsl:value-of select="@esb_med_pos"/>','','')</xsl:attribute>
                        </a>
                    </td>
                </tr>

                </tbody>
            </table>

            <div class="sub-small-title">On Complete</div>

                <xsl:choose>
                <xsl:when test="syn:onComplete/@sequence">
                    <input type="button" value="Specify In-line" onclick="javascript: oncompletetoinline(); return false;" class="panelbutton_default"/>
                    <table border="0" cellpadding="0" cellspacing="0" class="data-table">
                        <tbody>
                            <tr>
                                <td style="width: 200px;">Sequence Ref </td>
                                <td>
                                    <input type="text" class="esb-edit" id="on_complete" disabled="true">
                                        <xsl:attribute name="value">
                                            <xsl:value-of select="syn:onComplete/@sequence"/>
                                        </xsl:attribute>
                                    </input>
                                    <img src="extensions/core/images/registry_picker.gif" align="middle" hspace="20" title="Registry Browser" onclick="javascript:oncompletefromregistry(); return false;"/>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                </xsl:when>
                <xsl:otherwise>
                    <input type="button" value="Specify Reference" onclick="javascript: oncompletetoref(); return false;" style="margin-top:5px;margin-bottom:5px;" class="panelbutton_default" />
                    <xsl:if test="count(syn:onComplete/child::*)=0">
                        <xsl:call-template name="add_mediator_control">
                            <xsl:with-param name="head_pos"
                                            select="concat(concat(syn:onComplete/@esb_med_pos, '.'), count(syn:onComplete/child::*))"/>
                        </xsl:call-template>
                    </xsl:if>
                    <xsl:for-each select="syn:onComplete">
                        <div class='indent'>
                            <xsl:apply-templates/>
                        </div>
                    </xsl:for-each>
                </xsl:otherwise>
            </xsl:choose>

            </div>

        <!--</xsl:for-each>-->
        </div>

    </xsl:template>

</xsl:stylesheet>