<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <!--<xsl:include href="commons.xsl"/>-->
    <!--<xsl:include href="target_edit.xsl"/>-->
    <!--<xsl:include href="target_view.xsl"/> -->

    <xsl:template match="syn:aggregate" mode="custom" priority="2" xmlns:syn="http://ws.apache.org/ns/synapse">

            <label class="content-header">
                <img src="extensions/core/images/aggregate-big.jpg"/>
                <xsl:text>Aggregate Mediator</xsl:text>
            </label>

            <div class="inside-content">
                <div id="common_table_content">
            <table border="0" cellpadding="0" cellspacing="0" class="data-table">
            <tbody>
				<tr>
                    <td style="width: 200px;">Aggregation Expression </td>
                    <td><xsl:value-of select="syn:onComplete/@expression"/></td>
                </tr>
                <tr>
                    <td style="width: 200px;">Completion Timeout </td>
                    <td><xsl:value-of select="syn:completeCondition/@timeout"/></td>
                </tr>
                <tr>
                    <td style="width: 200px;">Completion Max-messages </td>
                    <td><xsl:value-of select="syn:completeCondition/syn:messageCount/@max"/></td>
                </tr>
                <tr>
                    <td style="width: 200px;">Completion Min-messages </td>
                    <td><xsl:value-of select="syn:completeCondition/syn:messageCount/@min"/></td>
                </tr>
                <tr>
                    <td style="width: 200px;">Correlation Expression </td>
                    <td><xsl:value-of select="syn:correlateOn/@expression"/></td>
                </tr>

                </tbody>
            </table>
			</div>
			
            <div class="sub-small-title">On Complete </div>

                <xsl:choose>
                <xsl:when test="syn:onComplete/@sequence">
                    <table border="0" cellpadding="0" cellspacing="0" class="data-table">
                        <tbody>
                            <tr>
                                <td style="width: 200px;">Sequence Ref </td>
                                <td><xsl:value-of select="syn:onComplete/@sequence"/></td>
                            </tr>
                        </tbody>
                    </table>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:for-each select="syn:onComplete">
                        <div class='indent'>
                            <xsl:apply-templates/>
                        </div>
                    </xsl:for-each>
                </xsl:otherwise>
            </xsl:choose>

        <!--</xsl:for-each>-->
        </div>

    </xsl:template>

</xsl:stylesheet>