<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:template match="syn:cache" mode="custom" priority="2"
                  xmlns:syn="http://ws.apache.org/ns/synapse">
    	
        <label class="content-header">
            <img src="extensions/core/images/cache-big.jpg"/>
            <xsl:text>Cache Mediator</xsl:text>
        </label>
        <br/>
		<div class="inside-content">
        <div id="common_table_content">
            <table border="0" cellpadding="0" cellspacing="0" class="data-table">
            <tbody>

                <tr>
                    <td style="width: 200px;">Cache Id </td>
                    <td><xsl:value-of select="@id"/></td>
                </tr>


                <tr>
                    <td>Cache Scope </td>
                    <td><xsl:value-of select="@scope"/></td>
                </tr>
                <xsl:if test="@collector='true'">
                    <tr>
                        <td>Cache Type </td>
                        <td>Collector</td>
                    </tr>
                </xsl:if>

                <xsl:if test="not(@collector) or @collector!='true'">
                    <tr>
                        <td>Cache Type </td>
                        <td>Finder</td>
                    </tr>
                    <tr>
                        <td>Hash Generator </td>
                        <td><xsl:value-of select="@hashGenerator"/></td>
                    </tr>
                    <tr>
                        <td>Cache Timeout (seconds) </td>
                        <td><xsl:value-of select="@timeout"/></td>
                    </tr>
                    <tr>
                        <td>Maximum Message Size</td>
                        <td><xsl:value-of select="@maxMessageSize"/></td>
                    </tr>
                </xsl:if>

            </tbody>
        </table>

            <xsl:if test="not(@collector) or @collector!='true'">
            <div class="sub-small-title">Cache Implementation Details</div>
            <table border="0" cellpadding="0" cellspacing="0" class="data-table">
                <tbody>

                    <tr>
                        <td style="width: 200px;">Implementation Type</td>
                        <td><xsl:value-of select="syn:implementation/@type"/></td>
                    </tr>

                    <tr>
                        <td>Maximum Size </td>
                        <td><xsl:value-of select="syn:implementation/@maxSize"/></td>
                    </tr>

                </tbody>
            </table>

            <div class="sub-small-title">On Cache Hit</div>
            <!--<xsl:for-each select="onCacheHit">-->
            <xsl:choose>
                <xsl:when test="syn:onCacheHit/@sequence">
                    <table border="0" cellpadding="0" cellspacing="0" class="data-table">
                        <tbody>
                            <tr>
                                <td style="width: 200px;">Sequence Ref </td>
                                <td><xsl:value-of select="syn:onCacheHit/@sequence"/></td>
                            </tr>
                        </tbody>
                    </table>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:for-each select="syn:onCacheHit">
                        <div class='indent'>
                            <xsl:apply-templates/>
                        </div>
                    </xsl:for-each>
                </xsl:otherwise>
            </xsl:choose>
            </xsl:if>
        </div>

        <br/>
		</div>
    </xsl:template>

</xsl:stylesheet>