<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:include href="commons.xsl"/>
    <xsl:template match="syn:callout" xmlns:syn="http://ws.apache.org/ns/synapse">
        <div id="callout_edit_div">
            <label class="content-header headding-gap">
                <img align="top" src="extensions/core/images/callout-big.jpg"/>
                <xsl:text>Callout Mediator</xsl:text>
            </label>
            
            <div id="callout_edit" class="mediator-inside">
                <br/>
                <table border="0" style="width: 600px;">
                    <tbody>
                        <tr>
                            <td style="width:100px;">
                                ServiceURL
                                <font style='color: red;font-size: 8pt;'>&#160;*</font>
                            </td>
                            <td>
                                <input type="text" size="40" id="callout_serviceURL"
                                       class="esb-edit">
                                    <xsl:attribute name="value">
                                        <xsl:value-of select="@serviceURL"/>
                                    </xsl:attribute>
                                </input>
                            </td>
                        </tr>
                        <tr>
                            <td style="width:100px;">
                                Action
                            </td>
                            <td>
                                <input type="text" size="40" id="callout_action"
                                       class="esb-edit">
                                    <xsl:attribute name="value">
                                        <xsl:value-of select="@action"/>
                                    </xsl:attribute>
                                </input>
                            </td>
                        </tr>
                    </tbody>
                </table>
                <fieldset class="switch-field">
                <legend>Source <font style='color: red;font-size: 8pt;'>&#160;*</font></legend>
                
                <div class="specialField-header">Specify as :
                <xsl:element name="input">
                    <xsl:attribute name="onClick">
                        javascript:sourcexpath('<xsl:value-of select="@esb_med_pos"/>');
                    </xsl:attribute>
                    <xsl:attribute name="type">radio</xsl:attribute>
                    <xsl:attribute name="name">
                        sourcegroup
                    </xsl:attribute>
                    <xsl:attribute name="value">XPath</xsl:attribute>
                    <xsl:attribute name="style">margin-left: 50px;</xsl:attribute>
                    <xsl:if test="syn:source/@xpath or (@source_xpath and @source_xpath=0)">
                        <xsl:attribute name="checked">checked</xsl:attribute>
                    </xsl:if>
                </xsl:element>
                <label>XPath</label>
                <xsl:element name="input">
                    <xsl:attribute name="onClick">
                        javascript:sourcekey('<xsl:value-of select="@esb_med_pos"/>');
                    </xsl:attribute>
                    <xsl:attribute name="type">radio</xsl:attribute>
                    <xsl:attribute name="name">
                        sourcegroup
                    </xsl:attribute>
                    <xsl:attribute name="value">Key</xsl:attribute>
                    <xsl:attribute name="style">margin-left:20px;</xsl:attribute>
                    <xsl:if test="syn:source/@key or (@source_key and @source_key=0)">
                        <xsl:attribute name="checked">checked</xsl:attribute>
                    </xsl:if>
                </xsl:element>
                <label>Key</label>
                </div>
                <div class="specialField-content">
                <xsl:if test="syn:source/@xpath or (@source_xpath and @source_xpath=0)">
                    <table border="0">
                        <tbody>
                            <tr>
                                <td>
                                    <xsl:text>XPath</xsl:text>
                                </td>
                                <td>
                                    <input type="text" class="esb-edit" size="40"
                                           id="source_xpath">
                                        <xsl:attribute name="value">
                                            <xsl:value-of select="syn:source/@xpath"/>
                                        </xsl:attribute>
                                    </input>
                                </td>
                                <td>
                                    <a title="Namespace Editor" class="ns_editor">
                                        <xsl:attribute name="onclick">
                                            javascript:showNameSpaceEditorForSource('<xsl:value-of select="@esb_med_pos"/>','','');
                                        </xsl:attribute>
                                        <xsl:text>&#160;&#160;&#160;&#160;</xsl:text>
                                    </a>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                </xsl:if>
                <xsl:if test="syn:source/@key  or (@source_key and @source_key=0)">
                    <table border="0">
                        <tbody>
                            <tr>
                                <td>
                                    <xsl:text>Key</xsl:text>
                                </td>
                                <td>
                                    <input type="text" class="esb-edit" size="40"
                                           id="source_key">
                                        <xsl:attribute name="value">
                                            <xsl:value-of select="syn:source/@key"/>
                                        </xsl:attribute>
                                    </input>
                                </td>
                                <td>
                                    <xsl:element name="img">
                                        <xsl:attribute name="src">
                                            extensions/core/images/registry_picker.gif
                                        </xsl:attribute>
                                        <xsl:attribute name="title">Registry Browser</xsl:attribute>
                                        <xsl:attribute name="onClick">
                                            javascript:calloutsourcekeyfromregistry('<xsl:value-of select="@esb_med_pos"/>');return false;
                                        </xsl:attribute>
                                    </xsl:element>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                </xsl:if>
                </div>
                </fieldset>
                <fieldset class="switch-field">
                <legend>Target <font style='color: red;font-size: 8pt;'>&#160;*</font></legend>
                <div class="specialField-header">
                <label style="margin-left: 1em;">Specify as :</label>
                <xsl:element name="input">
                    <xsl:attribute name="onClick">
                        javascript:targetxpath('<xsl:value-of select="@esb_med_pos"/>');
                    </xsl:attribute>
                    <xsl:attribute name="type">radio</xsl:attribute>
                    <xsl:attribute name="name">
                        targetgroup
                    </xsl:attribute>
                    <xsl:attribute name="value">XPath</xsl:attribute>
                    <xsl:attribute name="style">margin-left:50px;</xsl:attribute>
                    <xsl:if test="syn:target/@xpath or (@target_xpath and @target_xpath=0)">
                        <xsl:attribute name="checked">checked</xsl:attribute>
                    </xsl:if>
                </xsl:element>
                <label>XPath</label>
                <xsl:element name="input">
                    <xsl:attribute name="onClick">
                        javascript:targetkey('<xsl:value-of select="@esb_med_pos"/>');
                    </xsl:attribute>
                    <xsl:attribute name="type">radio</xsl:attribute>
                    <xsl:attribute name="name">
                        targetgroup
                    </xsl:attribute>
                    <xsl:attribute name="value">Key</xsl:attribute>
                    <xsl:attribute name="style">margin-left:20px;</xsl:attribute>
                    <xsl:if test="syn:target/@key or (@target_key and @target_key=0)">
                        <xsl:attribute name="checked">checked</xsl:attribute>
                    </xsl:if>
                </xsl:element>
                <label>Key</label>
                </div>
                <div class="specialField-content">
                <xsl:if test="syn:target/@xpath or (@target_xpath and @target_xpath=0)">
                    <table border="0" style="width: 150px;">
                        <tbody>
                            <tr>
                                <td>
                                    <xsl:text>XPath</xsl:text>
                                </td>
                                <td>
                                    <input type="text" class="esb-edit" size="40"
                                           id="target_xpath">
                                        <xsl:attribute name="value">
                                            <xsl:value-of select="syn:target/@xpath"/>
                                        </xsl:attribute>
                                    </input>
                                </td>
                                <td>
                                    <a title="Namespace Editor" class="ns_editor">
                                        <xsl:attribute name="onclick">
                                            javascript:showNameSpaceEditorForTarget('<xsl:value-of select="@esb_med_pos"/>','','');
                                        </xsl:attribute>
                                        <xsl:text>&#160;&#160;&#160;&#160;</xsl:text>
                                    </a>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                </xsl:if>
                <xsl:if test="syn:target/@key or (@target_key and @target_key=0)">
                    <table border="0" style="width: 150px;">
                        <tbody>
                            <tr>
                                <td>
                                    <xsl:text>Key</xsl:text>
                                </td>
                                <td>
                                    <input type="text" class="esb-edit" size="40"
                                           id="target_key">
                                        <xsl:attribute name="value">
                                            <xsl:value-of select="syn:target/@key"/>
                                        </xsl:attribute>
                                    </input>
                                </td>
                                <td/>
                            </tr>
                        </tbody>
                    </table>
                </xsl:if>
                </div>
                </fieldset>
            </div>
        </div>
    </xsl:template>
</xsl:stylesheet>