<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:template match="syn:callout" mode="custom" priority="2"
                  xmlns:syn="http://ws.apache.org/ns/synapse">
        <label class="content-header headding-gap">
            <img src="extensions/core/images/callout-big.jpg" align="top" />
            <xsl:call-template name="capitalize-first"/>
            <xsl:text> Mediator</xsl:text>
        </label>
        
        <div id="common_table_content" class="mediator-inside">
            <table border="0" cellpadding="0" cellspacing="0">
                <tbody>
                    <tr>
                        <th>Property</th>
                        <th>Value</th>
                    </tr>
                    <tr>
                        <td>
                            <label class="log-attribute-name">
                                ServiceURL
                            </label>
                        </td>
                        <td>
                            <label class="log-attribute-value">
                                <xsl:value-of select="@serviceURL"/>
                            </label>
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <label class="log-attribute-name">
                                Action
                            </label>
                        </td>
                        <td>
                            <label class="log-attribute-value">
                                <xsl:value-of select="@action"/>
                            </label>
                        </td>
                    </tr>
                    <xsl:if test="syn:source/@xpath or syn:source/@key ">
                        <tr>
                            <td>
                                <label class="log-attribute-name">
                                    Source -
                                    <xsl:if test="syn:source/@xpath">
                                        XPath
                                    </xsl:if>
                                    <xsl:if test="syn:source/@key">
                                        Key
                                    </xsl:if>
                                </label>
                            </td>
                            <td>
                                <label class="log-attribute-value">
                                    <xsl:if test="syn:source/@xpath">
                                        <xsl:value-of select="syn:source/@xpath"/>
                                    </xsl:if>
                                    <xsl:if test="syn:source/@key">
                                        <xsl:value-of select="syn:source/@key"/>
                                    </xsl:if>
                                </label>
                            </td>
                        </tr>
                    </xsl:if>
                    <xsl:if test="syn:target/@xpath or syn:target/@key ">
                        <tr>
                            <td>
                                <label class="log-attribute-name">
                                    Target -
                                    <xsl:if test="syn:target/@xpath">
                                        XPath
                                    </xsl:if>
                                    <xsl:if test="syn:target/@key">
                                        Key
                                    </xsl:if>
                                </label>
                            </td>
                            <td>
                                <label class="log-attribute-value">
                                    <xsl:if test="syn:target/@xpath">
                                        <xsl:value-of select="syn:target/@xpath"/>
                                    </xsl:if>
                                    <xsl:if test="syn:target/@key">
                                        <xsl:value-of select="syn:target/@key"/>
                                    </xsl:if>
                                </label>
                            </td>
                        </tr>
                    </xsl:if>

                </tbody>
            </table>
        </div>
    </xsl:template>
</xsl:stylesheet>