<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:template match="syn:class" mode="custom" priority="2"
                  xmlns:syn="http://ws.apache.org/ns/synapse">
        <label class="content-header">
            <img src="extensions/core/images/class-mediator.gif" align="top"/>
            <xsl:text>Class Mediator</xsl:text>
        </label>
        <br/>

        <div id="common_table_content">
            <table border="0" cellpadding="0" cellspacing="0">
                <tbody>
                    <tr>
                        <th>Property</th>
                        <th>Value</th>
                    </tr>
                    <tr>
                        <td>
                            <label class="log-attribute-name">Name</label>
                        </td>
                        <td>
                            <label class="log-attribute-value">
                                <xsl:value-of select="@name"/>
                            </label>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>

        <br/>

        <xsl:if test="syn:property">
            <p>Properties defined for Class mediator</p>
            <br/>
            <div id="common_table_content">
                <table border="0" cellpadding="0" cellspacing="0" width="600">
                    <tr>
                        <th>Property Name</th>
                        <th>Property Value</th>
                    </tr>
                    <xsl:for-each select="syn:property">
                        <tr>
                            <td>
                                <xsl:value-of select="@name"/>
                            </td>
                            <td>
                                <xsl:value-of select="@value"/>
                            </td>
                        </tr>
                    </xsl:for-each>
                </table>
            </div>
        </xsl:if>
        <br/>

    </xsl:template>

</xsl:stylesheet>