<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:template match="syn:dblookup" mode="custom" priority="2" xmlns:syn="http://ws.apache.org/ns/synapse">

        <label class="content-header headding-gap">
            <img align="top" src="extensions/core/images/db-lookup-big.jpg"/>
            <xsl:text>Data Base lookup Mediator</xsl:text>
        </label>

        

        <xsl:if test="syn:connection">
            <table cellpadding="0" cellspacing="0" border="0" class="form-table">
                <tr>
                    <td class="sub-title">Connection Information:</td>
                    <td>
                        <xsl:if test="syn:connection/syn:pool/syn:driver">
                            Pool
                        </xsl:if>
                        <xsl:if test="syn:connection/syn:pool/syn:dsName">
                            Data Source
                        </xsl:if>
                    </td>
                </tr>
            </table>
            <xsl:if test="syn:connection/syn:pool">
                <div class="sub-sub-title">
                    <xsl:if test="syn:connection/syn:pool/syn:driver">
                        Pool
                    </xsl:if>
                    <xsl:if test="syn:connection/syn:pool/syn:dsName">
                        Data Source
                    </xsl:if>
                    Connection Properties for DBLookup Mediator
                </div>
                <div id="common_table_content">
            <table cellpadding="0" cellspacing="0" border="0" style="margin-left:0px;">
                <tbody>
                    <tr>
                        <th>Property</th>
                        <th>Value</th>
                    </tr>
                     <xsl:if test="syn:connection/syn:pool/syn:driver">
                    <tr>
                        <td>
                            
                                Driver
                            
                        </td>
                        <td>
                            
                                <xsl:value-of select="syn:connection/syn:pool/syn:driver"/>
                            
                        </td>
                    </tr>
                    </xsl:if>
                    <xsl:if test="syn:connection/syn:pool/syn:icClass">
                    <tr>
                        <td>
                            
                                Initial Context Class
                            
                        </td>
                        <td>
                            
                                <xsl:value-of select="syn:connection/syn:pool/syn:icClass"/>
                            
                        </td>
                    </tr>
                    </xsl:if>
                    <xsl:if test="syn:connection/syn:pool/syn:dsName">
                    <tr>
                        <td>
                            
                                Data Source Name
                            
                        </td>
                        <td>
                            
                                <xsl:value-of select="syn:connection/syn:pool/syn:dsName"/>
                            
                        </td>
                    </tr>
                    </xsl:if>
                    <xsl:if test="syn:connection/syn:pool/syn:url">
                        <tr>
                            <td>
                                
                                   Url
                                
                            </td>
                            <td>
                                
                                    <xsl:value-of select="syn:connection/syn:pool/syn:url"/>
                                
                            </td>
                        </tr>
                    </xsl:if>
                    <xsl:if test="syn:connection/syn:pool/syn:user">
                        <tr>
                            <td>
                                
                                    User
                                
                            </td>
                            <td>
                                
                                    <xsl:value-of select="syn:connection/syn:pool/syn:user"/>
                               
                            </td>
                        </tr>
                    </xsl:if>
                    <xsl:if test="syn:connection/syn:pool/syn:password">
                        <tr>
                            <td>
                                
                                    Password
                                
                            </td>
                            <td>
                                
                                    <xsl:value-of select="syn:connection/syn:pool/syn:password"/>
                                
                            </td>
                        </tr>
                    </xsl:if>
                </tbody>
            </table>
            </div>
            <xsl:if test="syn:connection/syn:pool/syn:property">
            <div class="sub-sub-title">Properties defined for the DBLookup Mediator</div>
            
            <div id="common_table_content">
            <table>
                <tr>
                    <th>Name</th>
                    <th>Value</th>
                </tr>
                <xsl:for-each select="syn:connection/syn:pool/syn:property">
                    <xsl:call-template name="syn-simple-property-view"/>
                </xsl:for-each>
            </table>
            </div>
        </xsl:if>
           </xsl:if>  


         </xsl:if>
        <xsl:if test="syn:statement">
            <div class="sub-title">Statements </div>
            
        <xsl:for-each select="syn:statement">
            <div class="area-div">
            <xsl:if test="syn:sql">
            <table cellpadding="0" cellspacing="0" border="0" class="form-table">
            	<tr>
                <td>
                	SQL Statement 
                </td>
                <td>
                <xsl:element name="input">
                     <xsl:attribute name="style">margin-left: 55px;</xsl:attribute>
                     <xsl:attribute name="type">text</xsl:attribute>
                     <xsl:attribute name="size">20</xsl:attribute>
                     <xsl:attribute name="class">esb-edit_disabled</xsl:attribute>
                     <xsl:attribute name="value">
                           <xsl:value-of select="syn:sql"/>
                     </xsl:attribute>
                     <xsl:attribute name="DISABLED"/>
                 </xsl:element>
            	</td>
            	</tr>
            </table>
            </xsl:if>
            
            <xsl:if test="syn:parameter">
                <div class="sub-sub-title">Parameters </div>
                <div id="common_table_content">
		            <table>
		                <tr>
		                    <th>Parameter Type</th>
		                    <th>Property Type</th>
		                    <th>Value / Expression</th>
		                </tr>
		                  <xsl:for-each select="syn:parameter">
		                    <xsl:call-template name="syn-parameter-view"/>
		                </xsl:for-each>
		            </table>
            	</div>

            </xsl:if>
            <xsl:if test="syn:result">
           <div class="sub-sub-title">Results </div>
           
           <div id="common_table_content">
            <table>
                <tr>
                    <th>Result Name</th>
                    <th>Column</th>
                </tr>
                  <xsl:for-each select="syn:result">
                    <xsl:call-template name="syn-result-view"/>
                </xsl:for-each>
            </table>
            </div>

            </xsl:if>
            </div>
            </xsl:for-each>
        </xsl:if>



    </xsl:template>
    
    <xsl:template name="syn-parameter-view">
	
        <tr>
            <td>
                <xsl:value-of select="@type"/>
            </td>
            <xsl:if test="@value">
                <td>Value</td>
                <td>
                    <xsl:value-of select="@value"/>
                </td>
            </xsl:if>
            <xsl:if test="@expression">
                <td>Expression</td>
                <td>
                    <xsl:value-of select="@expression"/>
                </td>
            </xsl:if>
        </tr>
	
    </xsl:template>
    <xsl:template name="syn-result-view">
	
        <tr>
            <td>
                <xsl:value-of select="@name"/>
            </td>
            <td>
                <xsl:value-of select="@column"/>
            </td>

        </tr>
	
    </xsl:template>
    <xsl:template name="syn-simple-property-view">
	
        <tr>
            <td>
                <xsl:value-of select="@name"/>
            </td>
            <td>
                <xsl:value-of select="@value"/>
            </td>

        </tr>
	
    </xsl:template>
</xsl:stylesheet>
