<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:template match="syn:header" mode="custom" priority="2"
                  xmlns:syn="http://ws.apache.org/ns/synapse">
        <label class="content-header">
            <img align="top" src="extensions/core/images/header-mediator.gif"/>
            <xsl:call-template name="capitalize-first"/>
            <xsl:text> Mediator</xsl:text>
        </label>
        <br/>
        <br/>
        <div id="common_table_content">
            <table border="0" cellpadding="0" cellspacing="0">
            <tbody>
                <tr>
                    <th>Property</th>
                    <th>Value</th>
                </tr>
                <tr>
                    <td>
                        <label class="log-attribute-name">
                            Name
                        </label>
                    </td>
                    <td>
                        <label class="log-attribute-value">
                            <xsl:value-of select="@name"/>
                        </label>
                    </td>
                </tr>
                <xsl:if test="@action = 'set' or not(@action = 'remove')">
                    <xsl:if test="@value">
                  <tr>
                    <td>
                        <label class="log-attribute-name">
                            Value
                        </label>
                    </td>
                    <td>
                        <label class="log-attribute-value">
                            <xsl:value-of select="@value"/>
                        </label>
                    </td>
                    </tr>
                 </xsl:if>
                    <xsl:if test="@expression">
                <tr>
                    <td>
                        <label class="log-attribute-name">
                            Expression
                        </label>
                    </td>
                    <td>
                        <label class="log-attribute-value">
                            <xsl:value-of select="@expression"/>
                        </label>
                    </td>
                </tr>
                </xsl:if>
                </xsl:if>
                <tr>
                    <td>
                        <label class="log-attribute-name">
                            Action
                        </label>
                    </td>
                    <td>
                        <label class="log-attribute-value">
                            <xsl:if test="@action = 'set'">
                                <xsl:text>Set</xsl:text>
                            </xsl:if>
                            <xsl:if test="@action = 'remove'">
                                <xsl:text>Remove</xsl:text>
                            </xsl:if>
                            <xsl:if test="not(@action)">Set</xsl:if>
                        </label>
                    </td>
                </tr>
            </tbody>
        </table>
 		</div>   
    </xsl:template>
</xsl:stylesheet>