<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:template match="syn:makefault" xmlns:syn="http://ws.apache.org/ns/synapse" xmlns:sf11="http://www.w3.org/2003/05/soap-envelope">
        <div id="makefault_edit_div">
            <label class="content-header">
                <img align="top" src="extensions/core/images/make-fault-mediator.gif"/>
                <xsl:text>Makefault Mediator</xsl:text>
            </label>

            <br></br>
            <br></br>

            <xsl:variable name="select">
                <select id="codeValueType">
                    <option>
                        <xsl:if test="@value">
                            <xsl:attribute name="selected">true</xsl:attribute>
                        </xsl:if>
                        Value
                    </option>
                    <option>
                        <xsl:if test="@expression">
                            <xsl:attribute name="selected">true</xsl:attribute>
                        </xsl:if>
                        Expression
                    </option>
                </select>
            </xsl:variable>
            <table border="0" cellpadding="0" cellspacing="0" id="common_table_nocolor">
                <tr>
                    <td>Version</td>
                    <td style="width:200px;">
                        <input id="soap11" type="radio">
                            <xsl:attribute name="onClick">
                                javascript:changeVersion('soap11','<xsl:value-of select="@esb_med_pos"/>');
                            </xsl:attribute>
                            <xsl:if test="not(@version) or @version='soap11'">
                                <xsl:attribute name="checked">
                                    true
                                </xsl:attribute>
                            </xsl:if>
                        </input>
                        <span style="padding-right:10px;padding-left:10px;">SOAP 1.1</span>


                        <input id="soap12" type="radio">
                            <xsl:attribute name="onClick">
                                javascript:changeVersion('soap12','<xsl:value-of select="@esb_med_pos"/>');
                            </xsl:attribute>
                            <xsl:if test="@version='soap12'">
                                <xsl:attribute name="checked">
                                    true
                                </xsl:attribute>
                            </xsl:if>
                        </input>
                        SOAP 1.2
                    </td>
                    <td></td>
                </tr>
            
                <tr>
                    <xsl:if test="@version='soap11' or not(@version)">

                        <td>FaultCode
                            <font style='color: red;font-size: 8pt;'>&#160;*</font>
                        </td>


                    </xsl:if>
                    <xsl:if test="@version='soap12'">

                        <td>Code
                            <font style='color: red;font-size: 8pt;'>&#160;*</font>
                        </td>

                    </xsl:if>
                    <td>
                        <select id="codeValue" class="esb-edit">
                            <option value="VersionMismatch">
                                <xsl:if test="syn:code/@value = 'sf11:VersionMismatch'">
                                    <xsl:attribute name="selected">true</xsl:attribute>
                                </xsl:if>
                                VersionMismatch
                            </option>
                            <option value="MustUnderstand">
                                <xsl:if test="syn:code/@value = 'sf11:MustUnderstand'">
                                    <xsl:attribute name="selected">
                                        true
                                    </xsl:attribute>
                                </xsl:if>
                                MustUnderstand
                            </option>
                            <xsl:if test="@version='soap11' or (not(@version='soap11') and not(@version='soap12'))">
                                <option value="Client">
                                    <xsl:if test="syn:code/@value = 'sf11:Client'">
                                        <xsl:attribute name="selected">
                                            true
                                        </xsl:attribute>
                                    </xsl:if>
                                    Client
                                </option>
                                <option value="Server">
                                    <xsl:if test="syn:code/@value = 'sf11:Server'">
                                        <xsl:attribute name="selected">
                                            true
                                        </xsl:attribute>
                                    </xsl:if>
                                    Server
                                </option>
                            </xsl:if>
                            <xsl:if test="@version='soap12'">
                                <option value="DataEncodingUnknown">
                                    <xsl:if test="syn:code/@value = 'sf12:DataEncodingUnknown'">
                                        <xsl:attribute name="selected">
                                            true
                                        </xsl:attribute>
                                    </xsl:if>
                                    DataEncodingUnknown
                                </option>
                                <option value="Sender">
                                    <xsl:if test="syn:code/@value = 'sf12:Sender'">
                                        <xsl:attribute name="selected">
                                            true
                                        </xsl:attribute>
                                    </xsl:if>
                                    Sender
                                </option>
                                <option value="Receiver">
                                    <xsl:if test="syn:code/@value = 'sf12:Receiver'">
                                        <xsl:attribute name="selected">
                                            true
                                        </xsl:attribute>
                                    </xsl:if>
                                    Receiver
                                </option>
                            </xsl:if>
                        </select>
                    </td>
                    <td></td>
                </tr>
                <tr>
                    <xsl:if test="@version='soap12'">

                        <td>Reason
                            <font style='color: red;font-size: 8pt;'>&#160;*</font>
                        </td>


                    </xsl:if>
                    <xsl:if test="@version='soap11' or not(@version)">

                        <td>FaultString
                            <font style='color: red;font-size: 8pt;'>&#160;*</font>
                        </td>

                    </xsl:if>
                    <td>
                        <input id="reasonTypeValue" name="reasonType" type="radio">
                            <xsl:attribute name="onClick">
                                javascript:showNamespaceButton('<xsl:value-of select="syn:reason/@esb_med_pos"/>','value','codeContent','namespaceButtonForReason','false');
                            </xsl:attribute>
                            <xsl:if test="syn:reason/@value ">
                                <xsl:attribute name="checked">
                                    true
                                </xsl:attribute>
                            </xsl:if>
                        </input>
                        <span style="padding-right:10px;padding-left:10px;">value</span>

                        <input id="reasonTypeExpression" name="reasonType" type="radio" value="expression">
                            <xsl:attribute name="onClick">
                                javascript:showNamespaceButton('<xsl:value-of select="syn:reason/@esb_med_pos"/>','','','namespaceButtonForReason','true');
                            </xsl:attribute>
                            <xsl:if test="syn:reason/@expression or not(syn:reason/@value)">
                                <xsl:attribute name="checked">
                                    true
                                </xsl:attribute>
                            </xsl:if>
                        </input>
                        expression
                    </td>
                    <td></td>
                </tr>
                <tr>
                    <td></td>
                    <td>
                        <input id="reasonContent" type="text" class="esb-edit">
                            <xsl:if test="syn:reason/@expression">
                                <xsl:attribute name="value">
                                    <xsl:value-of select="syn:reason/@expression"/>
                                </xsl:attribute>
                            </xsl:if>
                            <xsl:if test="syn:reason/@value">
                                <xsl:attribute name="value">
                                    <xsl:value-of select="syn:reason/@value"/>
                                </xsl:attribute>
                            </xsl:if>
                        </input>
                    </td>
                    <td id="namespaceButtonForReason">
                        <xsl:if test="syn:reason/@expression or not(syn:reason/@value)">
                            <a title="Namespace Editor" class="ns_editor">
                                <xsl:attribute name="onclick">
                                    javascript:showNameSpaceEditor('<xsl:value-of select="syn:reason/@esb_med_pos"/>','','');
                                </xsl:attribute>
                                <xsl:text>&#160;&#160;&#160;&#160;</xsl:text>
                            </a>
                        </xsl:if>
                    </td>
                </tr>
                <xsl:if test="@version='soap12'">
                    <tr>
                        <td>Node</td>
                    
                        <td colspan="2">
                            <input id="node" type="text" class="esb-edit">
                                <xsl:attribute name="value">
                                   <xsl:value-of select="syn:node/child::text()"/>
                                </xsl:attribute>
                            </input>
                        </td>

                    </tr>
                </xsl:if>
                    <tr>
                        <xsl:if test="@version='soap12'">
                            <td>Role</td>
                        </xsl:if>
                        <xsl:if test="@version='soap11' or not(@version)">
                            <td>FaultActor</td>
                        </xsl:if>
                        <td colspan="2">
                            <input id="role" type="text" class="esb-edit">
                                <xsl:attribute name="value">
                                    <xsl:value-of select="syn:role/child::text()"/>
                                </xsl:attribute>
                            </input>
                        </td>
                     </tr>
                    <tr>
                        <td>Detail</td>
                        <td colspan="2">                           
                            <textarea id="detail" class="esb-edit" cols="40" rows="3">
                                    <xsl:value-of select="syn:detail/child::text()"/>
                            </textarea>
                        </td>
                        <td></td>

                </tr>
            </table>
        </div>

    </xsl:template>
</xsl:stylesheet>
