<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:syn="http://ws.apache.org/ns/synapse"
                xmlns:spring="http://ws.apache.org/ns/synapse/spring"
                xmlns:json="http://ws.apache.org/ns/synapse/json">

    <xsl:variable name="supports-namespace-axis" select="count(/*/namespace::*) &gt; 0"/>

    <xsl:include href="commons.xsl"/>
    <xsl:include href="custom_mediator_includes.xsl"/>

    <xsl:variable name="parent_mediators">in out</xsl:variable>

    <xsl:template match="syn:endpoint | syn:proxy">
        <xsl:call-template name="print-xml"/>
    </xsl:template>

    <xsl:template match="syn:rules" priority="1">
        <xsl:apply-templates/>
    </xsl:template>

    <xsl:template match="syn:sequence[@name]" priority="1">
        <xsl:apply-templates/>
    </xsl:template>

    <xsl:template match="syn:* | spring:* | json:* " priority="0">
        <xsl:param name="level"/>
        <xsl:param name="hack"/>
        <xsl:call-template name="generic-mediator">
            <xsl:with-param name="level" select="$level"/>
            <xsl:with-param name="hack" select="$hack"/>
        </xsl:call-template>
    </xsl:template>

    <!--<xsl:template match="syn:* | spring:* | json:* " priority="1" mode="custom">-->
        <!--<xsl:param name="level"/>-->
        <!--<xsl:param name="hack"/>-->
        <!--<xsl:call-template name="generic-mediator">-->
            <!--<xsl:with-param name="level" select="$level"/>-->
            <!--<xsl:with-param name="hack" select="$hack"/>-->
        <!--</xsl:call-template>-->
    <!--</xsl:template>-->

    <xsl:template name="generic-mediator">
        <xsl:param name="level"/>
        <xsl:param name="hack"/>

        <xsl:choose>
            <xsl:when test="$hack='elem'">
                <xsl:choose>
                    <xsl:when test="$level">
                        <xsl:call-template name="syn-element">
                            <xsl:with-param name="head_pos" select="@esb_med_pos"/>
                            <xsl:with-param name="level" select="$level"/>
                        </xsl:call-template>
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:call-template name="syn-element">
                            <xsl:with-param name="head_pos" select="@esb_med_pos"/>
                        </xsl:call-template>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:when>
            <xsl:otherwise>

                <!--<xsl:if test="local-name(..) != '' and contains($parent_mediators, local-name(..)) and count(child::*)=0">-->
                    <!--<xsl:text>It is here</xsl:text>-->
                    <!--<xsl:call-template name="add_mediator_control">-->
                        <!--<xsl:with-param name="head_pos" select="@esb_med_pos"/>-->
                    <!--</xsl:call-template>-->
                <!--</xsl:if>-->

                <!--<xsl:value-of select="@esb_med_pos"/> -->
                <!--<xsl:if test="contains(@esb_med_pos, '.')">-->

                <!--</xsl:if>-->
                <div>
                <xsl:choose>
                    <xsl:when test="contains(@esb_med_pos, '.')">
                        <div>

                        <xsl:call-template name="panel_control">
                        <xsl:with-param name="head_pos" select="@esb_med_pos"/>
                    </xsl:call-template>

                        <div class="mediator-content">
                            <xsl:attribute name="id">
                                <xsl:value-of select="concat('mediatordiv', @esb_med_pos)"/>
                            </xsl:attribute>

                            <xsl:choose>
                                <xsl:when test="$level">
                                    <xsl:apply-templates select="." mode="custom">
                                        <xsl:with-param name="head_pos" select="@esb_med_pos"/>
                                        <xsl:with-param name="level" select="$level"/>
                                        <xsl:with-param name="hack" select="'elem'"/>
                                    </xsl:apply-templates>
                                </xsl:when>
                                <xsl:otherwise>
                                    <xsl:apply-templates select="." mode="custom">
                                        <xsl:with-param name="head_pos" select="@esb_med_pos"/>
                                        <xsl:with-param name="hack" select="'elem'"/>
                                    </xsl:apply-templates>
                                </xsl:otherwise>
                            </xsl:choose>
                        </div></div>
                    </xsl:when>
                    <xsl:otherwise>

                        <div class="contentPaneClass">

                            <xsl:call-template name="panel_control">
                        <xsl:with-param name="head_pos" select="@esb_med_pos"/>
                    </xsl:call-template>

                        <div class="mediator-content">
                            <xsl:attribute name="id">
                                <xsl:value-of select="concat('mediatordiv', @esb_med_pos)"/>
                            </xsl:attribute>


                        <xsl:choose>
                            <xsl:when test="$level">
                                <xsl:apply-templates select="." mode="custom">
                                    <xsl:with-param name="head_pos" select="@esb_med_pos"/>
                                    <xsl:with-param name="level" select="$level"/>
                                    <xsl:with-param name="hack" select="'elem'"/>
                                </xsl:apply-templates>
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:apply-templates select="." mode="custom">
                                    <xsl:with-param name="head_pos" select="@esb_med_pos"/>
                                    <xsl:with-param name="hack" select="'elem'"/>
                                </xsl:apply-templates>
                            </xsl:otherwise>
                        </xsl:choose>

                        </div>
                        </div>

                    </xsl:otherwise>
                </xsl:choose>
                </div><br/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>

    <xsl:template name="syn-element">
        <xsl:param name="head_pos"/>
        <xsl:param name="level"/>
        <xsl:call-template name="element-header"/>
        <!--<p class="mediator-description"><img src="extensions/core/images/computer.gif"/> <xsl:text> </xsl:text><xsl:call-template name="capitalize-first"/> Mediator will mediate the messages going through ESB acording to the following configuration</p><br/>-->
        <!--<p>Configurations for <xsl:call-template name="capitalize-first"/>  Mediator</p>-->
        <xsl:choose>
            <xsl:when test="$level">
                <xsl:call-template name="print-xml">
                    <xsl:with-param name="head_pos" select="$head_pos"/>
                </xsl:call-template>
            </xsl:when>
            <xsl:otherwise>
                <xsl:call-template name="print-xml">
                    <xsl:with-param name="head_pos" select="$head_pos"/>
                    <xsl:with-param name="level">0</xsl:with-param>
                </xsl:call-template>
            </xsl:otherwise>
        </xsl:choose>
        <br/>
    </xsl:template>

    <xsl:template match="*" priority="1" mode="custom">
        <xsl:param name="level"/>
        <xsl:choose>
            <xsl:when test="contains($parent_mediators, local-name(.)) or contains('drop', local-name(.))">
                                    <xsl:call-template name="syn-element">
                                        <xsl:with-param name="head_pos" select="@esb_med_pos"/>                                        
                                        <xsl:with-param name="level" select="$level"/>
                                    </xsl:call-template>
                                </xsl:when>
            <xsl:otherwise>
        <label class="content-header">
        <img src="extensions/core/images/mediator.gif"/>  <xsl:call-template name="capitalize-first"/>
        <xsl:text> Mediator</xsl:text>
    </label><br/>
        <div style="border: solid 1px #c8c8c8; background-color:#f5f5f5;"><br/>
        <xsl:apply-templates mode="generic" select="."/>
        <br/>
    </div>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>

    <xsl:template match="*" mode="generic">
        <!--<xsl:param name="head_pos"/>-->
        <!--<xsl:param name="level"/>-->
        <div class="indent">
            <div class="indent">
                <xsl:call-template name="element-start">
                    <!--<xsl:with-param name="level" select="$level"/>-->
                </xsl:call-template>
            </div>
            <xsl:apply-templates mode="generic">
                <!--<xsl:with-param name="level" select="$level+1"/>-->
            </xsl:apply-templates>
            <xsl:if test="node()">
                <div class="indent">
                    <xsl:call-template name="element-end"/>
                </div>
            </xsl:if>
        </div>
    </xsl:template>

    <xsl:template name="print-xml">
        <xsl:param name="head_pos"/>
        <xsl:param name="level"/>
        <div class="indent">
            <!--<div class="indent">-->
                <!--<xsl:call-template name="element-start">-->
                    <!--<xsl:with-param name="level" select="$level"/>-->
                <!--</xsl:call-template>-->
            <!--</div>-->
            <xsl:apply-templates>
                <xsl:with-param name="level" select="$level+1"/>
            </xsl:apply-templates>
            <xsl:if test="contains($parent_mediators, local-name(.)) and count(child::*)=0">
                <xsl:call-template name="add_mediator_control">
                    <xsl:with-param name="head_pos" select="concat(concat($head_pos, '.'), count(child::*))"/>
                </xsl:call-template>
            </xsl:if>
            <!--<xsl:if test="node()">-->
                <!--<div class="indent">-->
                    <!--<xsl:call-template name="element-end"/>-->
                <!--</div>-->
            <!--</xsl:if>-->
        </div>
    </xsl:template>

    <xsl:template name="element-start">
        <xsl:param name="level"/>
        <xsl:param name="class" select="'markup-element'"/>
        <span class="markup">&lt;</span>
        <span class="{$class}">
            <xsl:value-of select="name(.)"/>
        </span>
        <xsl:apply-templates select="@*"/>
        <xsl:call-template name="namespaces">
            <xsl:with-param name="level" select="$level"/>
        </xsl:call-template>
        <!--<xsl:if test="$level=0">-->
        <!--<span class="markup-namespace">-->
        <!--<xsl:text> xmlns:syn="http://ws.apache.org/ns/synapse"</xsl:text>-->
        <!--<xsl:text></xsl:text>-->
        <!--</span>-->
        <!--</xsl:if>-->
        <span class="markup">
            <xsl:if test="not(node())">
                <xsl:text>/</xsl:text>
            </xsl:if>
            <xsl:text>&gt;</xsl:text>
        </span>
    </xsl:template>

    <xsl:template name="element-end">
        <xsl:param name="class" select="'markup-element'"/>
        <xsl:if test="node()">
            <span class="markup">
                <xsl:text>&lt;/</xsl:text>
            </span>
            <span class="{$class}">
                <xsl:value-of select="name(.)"/>
            </span>
            <span class="markup">
                <xsl:text>&gt;</xsl:text>
            </span>
        </xsl:if>
    </xsl:template>

    <xsl:template match="@*">
        <xsl:if test="local-name(.)!='esb_med_pos'">
            <xsl:call-template name="attribute"/>
        </xsl:if>
    </xsl:template>

    <xsl:template name="attribute">
        <xsl:param name="value-class" select="'markup-attribute-value'"/>
        <xsl:param name="reference"/>
        <xsl:param name="native-attribute" select="parent::syn:* and namespace-uri(.)=''"/>
        <xsl:text> </xsl:text>
        <span>
            <xsl:choose>
                <xsl:when test="$native-attribute">
                    <xsl:attribute name="class">markup-attribute</xsl:attribute>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:attribute name="class">markup-extension-attribute</xsl:attribute>
                </xsl:otherwise>
            </xsl:choose>
            <xsl:value-of select="name(.)"/>
        </span>
        <span class="markup">
            <xsl:text>="</xsl:text>
        </span>
        <span class="{$value-class}">
            <xsl:choose>
                <xsl:when test="$reference">
                    <a href="{$reference}">
                        <xsl:value-of select="."/>
                    </a>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="."/>
                </xsl:otherwise>
            </xsl:choose>
        </span>
        <span class="markup">
            <xsl:text>"</xsl:text>
        </span>
    </xsl:template>

    <xsl:template name="namespaces">
        <xsl:param name="level"/>
        <xsl:variable name="current" select="current()"/>

        <!-- Unfortunately Mozilla doesn't support the namespace axis, need to check for that and simulate declarations -->
        <xsl:choose>
            <xsl:when test="$supports-namespace-axis">
                <!--
                        When the namespace axis is present (e.g. Internet Explorer), we can simulate
                        the namespace declarations by comparing the namespaces in scope on this element
                        with those in scope on the parent element.  Any difference must have been the
                        result of a namespace declaration.  Note that this doesn't reflect the actual
                        source - it will strip out redundant namespace declarations. -->

                <xsl:for-each select="namespace::*[. != 'http://www.w3.org/XML/1998/namespace']">
                    <xsl:if test="not($current/parent::*[namespace::*[. = current()]]) or $level=0">
                        <span class="markup-namespace">
                            <xsl:text> xmlns</xsl:text>
                            <xsl:if test="name() != ''">:</xsl:if>
                            <xsl:value-of select="name()"/>
                            <xsl:text>="</xsl:text>
                        </span>
                        <span class="markup-namespace-uri">
                            <xsl:value-of select="."/>
                        </span>
                        <span class="markup-namespace">
                            <xsl:text>"</xsl:text>
                        </span>
                    </xsl:if>
                </xsl:for-each>
            </xsl:when>
            <xsl:otherwise>
                <!--
                        When the namespace axis isn't supported (e.g. Mozilla), we can simulate
                        appropriate declarations from namespace elements.
                        This currently doesn't check for namespaces on attributes.
                        In the general case we can't reliably detect the use of QNames in content, but
                        in the case of schema, we know which content could contain a QName and look
                        there too.  This mechanism is rather unpleasant though, since it records
                        namespaces where they are used rather than showing where they are declared
                        (on some parent element) in the source.  Yukk!  -->

                <xsl:if test="namespace-uri(.) != namespace-uri(parent::*) or $level=0">
                    <span class="markup-namespace">
                        <xsl:text> xmlns</xsl:text>
                        <xsl:if test="substring-before(name(),':') != ''">:</xsl:if>
                        <xsl:value-of select="substring-before(name(),':')"/>
                        <xsl:text>="</xsl:text>
                    </span>
                    <span class="markup-namespace-uri">
                        <xsl:value-of select="namespace-uri(.)"/>
                    </span>
                    <span class="markup-namespace">
                        <xsl:text>"</xsl:text>
                    </span>
                </xsl:if>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>

</xsl:stylesheet>
