<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:include href="commons.xsl"/>

    <xsl:template match="syn:pojoCommand" xmlns:syn="http://ws.apache.org/ns/synapse">
        <div id="command_edit_div">
        <label class="content-header">
            <img align="top" src="extensions/core/images/command-big.jpg"/>
            <xsl:text>POJOCommand Mediator</xsl:text>
        </label>
        <br/>
        <br/>
         <div id="xslt_edit" class="end-point-div">
        <table border="0" style="margin-left: 3em; width: 150px;">
            <tbody>
                <tr>
                    <td>
                        Name<font style='color: red;font-size: 8pt;'>&#160;*</font>
                    </td>
                    <td>
                        <input type="text" class="esb-edit" size="40"
                               id="command_pojo_name">
                            <xsl:attribute name="value">
                                <xsl:if test="not(@name)"></xsl:if>
                                <xsl:if test="@name">
                                    <xsl:value-of select="@name"/>
                                </xsl:if>
                            </xsl:attribute>
                        </input>
                    </td>
                    <td>
                        <xsl:if test="not(syn:property)">
                            <input type="button" href="#" onclick="javascript: loadcommandpojo(); return false;" style="margin-left: 3em;width:100px;" value="Load Class" class="panelbutton_default"/>
                        </xsl:if>
                        <xsl:if test="syn:property">
                            <input type="button" href="#" onclick="javascript: loadcommandpojo(); return false;" style="margin-left: 3em;width:100px;" value="Reload Class" class="panelbutton_default"/>
                        </xsl:if>
                    </td>
                </tr>
            </tbody>
        </table>
        <xsl:if test="syn:property">
            <p>Properties defined for POJOCommand mediator</p>
            <br/>
            <div id="common_table_content">
            <table border="0" cellpadding="0" cellspacing="0" width="1000">
                <tr>
                    <th>Property Name</th>
                    <th>Read Info</th>
                    <th>Update Info</th>
                    <th>Actions</th>
                </tr>
                <xsl:for-each select="syn:property">
                    <tr>
                        <xsl:attribute name="name">syn-property</xsl:attribute>
                        <td rowspan="2">
                            <input type="text" name="property_name" class="esb-edit small_textbox" disabled="true">
                                <xsl:attribute name="value">
                                    <xsl:value-of select="concat(translate(substring(@name,1,1),
                                    'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ'),
                                    substring(@name,2,string-length(@name)))"/>
                                </xsl:attribute>
                            </input>
                        </td>
                        
                        <td>From:
                            <select class="esb-edit small_textbox">
                                <xsl:attribute name="id"><xsl:value-of select="concat('propertyReadType',@esb_med_pos)"/></xsl:attribute>
                                <xsl:attribute name="name"><xsl:value-of select="concat('prop_type_read_', @name)"/></xsl:attribute>
                                <xsl:attribute name="onchange">
                                    javascript:reloadChanges();return false;
                                </xsl:attribute>
                                <option value="none">- NONE -</option>
                                <option value="value">
                                    <xsl:if test="@value">
                                        <xsl:attribute name="selected">true</xsl:attribute>
                                    </xsl:if>
                                    Value 
                                </option>
                                <option value="message">
                                    <xsl:if test="not(@value) and @action!='UpdateMessage' and @expression">
                                        <xsl:attribute name="selected">true</xsl:attribute>
                                    </xsl:if>
                                    Message
                                </option>
                                <option value="context">
                                    <xsl:if test="not(@value) and @action!='UpdateContext' and @context-name">
                                        <xsl:attribute name="selected">true</xsl:attribute>
                                    </xsl:if>
                                    Context
                                </option>
                            </select>
                        </td>
                        <td>To:
                            <select class="esb-edit small_textbox">
                                <xsl:attribute name="id"><xsl:value-of select="concat('propertyUpdateType',@esb_med_pos)"/></xsl:attribute>
                                <xsl:attribute name="name"><xsl:value-of select="concat('prop_type_update_', @name)"/></xsl:attribute>
                                <xsl:attribute name="onchange">
                                    javascript:reloadChanges();return false;
                                </xsl:attribute>
                                <option value="none">- NONE -</option>
                                <option value="message">
                                    <xsl:if test="(@action!='ReadMessage' and @expression) or (@value and @expression)">
                                        <xsl:attribute name="selected">true</xsl:attribute>
                                    </xsl:if>
                                    Message
                                </option>
                                <option value="context">
                                    <xsl:if test="(@action!='ReadContext' and @context-name) or (@value and @context-name)">
                                        <xsl:attribute name="selected">true</xsl:attribute>
                                    </xsl:if>
                                    Context
                                </option>
                            </select>
                        </td>
                        <td rowspan="2"><a href="#" id="delete_link">
                                                    <xsl:attribute name="onclick">javascript: removecommandmedprop('<xsl:value-of select="@name"/>'); return false;</xsl:attribute>&#160;&#160;&#160;&#160;</a></td>                        
                        </tr><tr>
                        <td>
                            <xsl:if test="@value">Value:
                                <input class="esb-edit small_textbox" type="text">
                                    <xsl:attribute name="id">
                                        <xsl:value-of select="concat('command_med_prop_read', @name)"/>
                                    </xsl:attribute>
                                    <xsl:attribute name="value">
                                        <xsl:value-of select="@value"/>
                                    </xsl:attribute>
                                </input>
                            </xsl:if>
                            <xsl:if test="not(@value) and @expression and (@action='ReadMessage' or @action='UpdateContext' or @action='ReadAndUpdateMessage')">Expression:
                                <input class="esb-edit small_textbox" type="text">
                                    <xsl:attribute name="id">
                                        <xsl:value-of select="concat('command_med_prop_read', @name)"/>
                                    </xsl:attribute>
                                    <xsl:attribute name="value">
                                        <xsl:value-of select="@expression"/>
                                    </xsl:attribute>
                                </input>
                            </xsl:if>
                            <xsl:if test="not(@value) and @context-name and (@action='ReadContext' or @action='UpdateMessage' or @action='ReadAndUpdateContext')">Context name:
                                <input class="esb-edit small_textbox" type="text">
                                    <xsl:attribute name="id">
                                        <xsl:value-of select="concat('command_med_prop_read', @name)"/>
                                    </xsl:attribute>
                                    <xsl:attribute name="value">
                                        <xsl:value-of select="@context-name"/>
                                    </xsl:attribute>
                                </input>
                            </xsl:if>
                        </td>
                        <td>
                            <xsl:if test="(@expression and (@action='UpdateMessage' or @action='ReadContext' or @action='ReadAndUpdateMessage')) or (@value and @expression)">Expression:
                                <input class="esb-edit small_textbox" type="text">
                                    <xsl:attribute name="id">
                                        <xsl:value-of select="concat('command_med_prop_update', @name)"/>
                                    </xsl:attribute>
                                    <xsl:attribute name="value">
                                        <xsl:value-of select="@expression"/>
                                    </xsl:attribute>
                                </input>
                            </xsl:if>
                            <xsl:if test="(@context-name and (@action='UpdateContext' or @action='ReadMessage' or @action='ReadAndUpdateContext')) or (@value and @context-name)">Context name:
                                <input class="esb-edit small_textbox" type="text">
                                    <xsl:attribute name="id">
                                        <xsl:value-of select="concat('command_med_prop_update', @name)"/>
                                    </xsl:attribute>
                                    <xsl:attribute name="value">
                                        <xsl:value-of select="@context-name"/>
                                    </xsl:attribute>
                                </input>
                            </xsl:if>
                        </td>


                        </tr>
                </xsl:for-each>
            </table>
            </div>
        </xsl:if>
         </div>
        </div>
    </xsl:template>

</xsl:stylesheet>