<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:template match="syn:pojoCommand" mode="custom" priority="2"
                  xmlns:syn="http://ws.apache.org/ns/synapse">
        <label class="content-header">
            <img align="top" src="extensions/core/images/command-big.jpg"/>
            <xsl:text>POJOCommand Mediator</xsl:text>
        </label>
        <br/>

        <div id="common_table_content">
            <table border="0" cellpadding="0" cellspacing="0">
                <tbody>
                    <tr>
                        <th>Property</th>
                        <th>Value</th>
                    </tr>
                    <tr>
                        <td>
                            <label class="log-attribute-name">Name</label>
                        </td>
                        <td>
                            <label class="log-attribute-value">
                                <xsl:value-of select="@name"/>
                            </label>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>

        <br/>

        <xsl:if test="syn:property">
            <p>Properties defined for POJOCommand mediator</p>
            <br/>
            <div id="common_table_content">
                <table border="0" cellpadding="0" cellspacing="0" width="600">
                    <tr>
                        <th>Property Name</th>
                        <th>Read Info</th>
                        <th>Update Info</th>
                    </tr>
                    <xsl:for-each select="syn:property">
                        <tr>
                            <td>
                                <xsl:value-of select="concat(translate(substring(@name,1,1),
                                    'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ'),
                                    substring(@name,2,string-length(@name)))"/>
                            </td>
                            <td>
                                <xsl:if test="@value">Value:
                                    <xsl:value-of select="@value"/>
                            </xsl:if>
                            <xsl:if test="not(@value) and @expression and (@action='ReadMessage' or @action='UpdateContext' or @action='ReadAndUpdateMessage')">Expression:
                                <xsl:value-of select="@expression"/>
                            </xsl:if>
                            <xsl:if test="not(@value) and @context-name and (@action='ReadContext' or @action='UpdateMessage' or @action='ReadAndUpdateContext')">Context name:
                                <xsl:value-of select="@context-name"/>
                            </xsl:if>
                        </td>
                        <td>
                            <xsl:if test="(@expression and (@action='UpdateMessage' or @action='ReadContext' or @action='ReadAndUpdateMessage')) or (@value and @expression)">Expression:
                                <xsl:value-of select="@expression"/>
                            </xsl:if>
                            <xsl:if test="(@context-name and (@action='UpdateContext' or @action='ReadMessage' or @action='ReadAndUpdateContext')) or (@value and @context-name)">Context name:
                                <xsl:value-of select="@context-name"/>
                            </xsl:if>
                        </td>


                        </tr>
                </xsl:for-each>
                </table>
            </div>
        </xsl:if>
        <br/>

    </xsl:template>

</xsl:stylesheet>