<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:include href="commons.xsl"/>

    <xsl:template match="syn:property" xmlns:syn="http://ws.apache.org/ns/synapse">

        <label class="content-header">
            <img align="top" src="extensions/core/images/property-mediator.gif"/>
            <xsl:call-template name="capitalize-first"/>
            <xsl:text> Mediator</xsl:text>
        </label>
        <br/>
        <br/>

        <table border="0" style="width: 650px;">
            <tbody>
                <tr>
                    <td>Name
                        <font style='color: red;font-size: 8pt;'>&#160;*</font>
                    </td>
                    <td>
                        <input type="text" class="esb-edit" width="80px" id="name">
                            <xsl:attribute name="value">
                                <xsl:value-of select="@name"/>
                            </xsl:attribute>
                        </input>
                    </td>
                </tr>
                <tr>
                    <td>
                        <xsl:text>Action</xsl:text>
                    </td>
                    <td>
                    	<input id="set" name="action" type="radio">
                            <xsl:attribute name="onClick">
                                javascript: setPropertyAction('set'); return false;
                            </xsl:attribute>
                            <xsl:if test="not(@action) or @action != 'remove'">
                                <xsl:attribute name="checked">
                                    true
                                </xsl:attribute>
                            </xsl:if>
                        </input>
                        Set
                    
                        <input id="remove" name="action" type="radio">
                            <xsl:attribute name="onClick">
                                javascript: setPropertyAction('remove'); return false;
                            </xsl:attribute>
                            <xsl:if test="@action = 'remove'">
                                <xsl:attribute name="checked">
                                    true
                                </xsl:attribute>
                            </xsl:if>
                        </input>
                        Remove
                    </td>
                </tr>
                <xsl:if test="not(@action) or @action != 'remove'">
                    <tr>
                        <td colspan="2">
                        	<div class="specialField-header">
	                        	<table cellpadding="0" cellspacing="0" border="0" style="width:90%">
	                        	<tr>
	                        	<td style="padding-right:10px;">
	                        	Set Action as
	                        	</td>
	                        	<td style="padding-right:5px;">
	                            <input id="value" name="type" type="radio">
	                                <xsl:attribute name="onClick">
	                                    javascript:setPropertyValue('<xsl:value-of select="@esb_med_pos"/>');
	                                </xsl:attribute>
	                                <xsl:if test="@value or not(@expression)">
	                                    <xsl:attribute name="checked">
	                                        true
	                                    </xsl:attribute>
	                                </xsl:if>
	                            </input>
	                            Value
	                            <xsl:if test="@value or not(@expression)">
	                            	<font style='color: red;font-size: 8pt;'>&#160;*</font>
	                            </xsl:if>
	                        	
	                            <input id="expression" name="type" type="radio">
	                                <xsl:attribute name="onClick">
	                                    javascript:setPropertyExpr('<xsl:value-of select="@esb_med_pos"/>');
	                                </xsl:attribute>
	                                <xsl:if test="@expression">
	                                    <xsl:attribute name="checked">
	                                        true
	                                    </xsl:attribute>
	                                </xsl:if>
	                            </input>
	                            Expression
	                            <xsl:if test="@expression">
	                            	<font style='color: red;font-size: 8pt;'>&#160;*</font>
	                            </xsl:if>
		                        </td>
								</tr>
								</table>
							</div>
							<div class="specialField-content">
								<table  cellpadding="0" cellspacing="0" border="0" style="width:90%">
								<tr>
		                        <td  style="width:200px;">
		
		                            <input type="text" class="esb-edit" width="80px" id="val_ex">
		                                <xsl:attribute name="value">
		                                    <xsl:if test="@value">
		                                        <xsl:value-of select="@value"/>
		                                    </xsl:if>
		                                    <xsl:if test="@expression">
		                                        <xsl:value-of select="@expression"/>
		                                    </xsl:if>
		                                </xsl:attribute>
		                            </input>
		                        </td>
		                        <td id="namespaceButtonCell" align="left">
		                            <xsl:if test="@expression">
		                                <a title="Namespace Editor" class="ns_editor">
		                                    <xsl:attribute name="onclick">
		                                        javascript:showNameSpaceEditor('<xsl:value-of select="@esb_med_pos"/>', '', '', 'true');
		                                    </xsl:attribute>
		                                    <xsl:text>&#160;&#160;&#160;&#160;</xsl:text>
		                                </a>
		                            </xsl:if>
		                        </td>
		                        </tr>
		                        </table>
                        	</div>
                        </td>

                    </tr>
                </xsl:if>
                <tr>
                    <td>
                        <xsl:text>Scope</xsl:text>
                    </td>
                    <td>
                        <select class="esb-edit" width="100px" id="scope">
                            <option value="synapse">Synapse</option>
                            <option value="transport">
                                <xsl:if test="@scope='transport'">
                                    <xsl:attribute name="selected">true</xsl:attribute>
                                </xsl:if>
                                Transport
                            </option>
                            <option value="axis2">
                                <xsl:if test="@scope='axis2'">
                                    <xsl:attribute name="selected">true</xsl:attribute>
                                </xsl:if>
                                Axis2
                            </option>
                        </select>
                    </td>
                </tr>
            </tbody>
        </table>

    </xsl:template>
</xsl:stylesheet>
