<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:include href="target_edit.xsl"/>

    <xsl:template match="syn:router" xmlns:syn="http://ws.apache.org/ns/synapse">
        <div id="clone_edit_div">
            <label class="content-header">
                <img align="top" src="extensions/core/images/router-big.gif"/>
                <xsl:text>Router Mediator</xsl:text>
            </label>
           <!--<div id="clone_edit_body">-->
            <table border="0" cellpadding="0" cellspacing="0" class="data-table">
            <tbody>
                <tr>
                    <td style="width: 200px;">
                        Continue after
                    </td>
                    <td>
                        <select id="continueAfter" class="esb-edit" style="width: 80px;">
                            <xsl:if test="@continueAfter='true'">
                                <option value="true" selected="true">True</option>
                                <option value="false">False</option>
                            </xsl:if>
                            <xsl:if test="not(@continueAfter) or @continueAfter='false'">
                                <option value="true">True</option>
                                <option value="false" selected="true">False</option>
                            </xsl:if>
                        </select>
                    </td>
                </tr>
            </tbody>
        </table>
        <div class="subtitle">Routes</div>
            <xsl:for-each select="syn:route">

                        <label class="sub-small-title">Route information of the route<xsl:value-of
                            select="@rt_pos"/></label>

                    <a id="panel_delete" title="Delete">
                        <xsl:attribute name="href">#mediatordiv<xsl:value-of select="@esb_med_pos"/></xsl:attribute>
                        <xsl:attribute name="onclick">javascript:deletemediator('<xsl:value-of select="@esb_med_pos"/>'); return false;</xsl:attribute>
                        <img src="extensions/core/images/delete.gif"/>
                    </a>
                <br/>
                <div class="popup-box">
                <table border="0" cellpadding="0" cellspacing="0" class="data-table">
                    <tbody>
                        <tr>
                            <td style="width: 200px;">
                                XPath Expression
                            </td>
                            <td>
                                <input type="text" class="esb-edit" style="width: 200px;">
                                    <xsl:attribute name="id"><xsl:value-of select="concat('route_expr', @rt_pos)"/></xsl:attribute>
                                    <xsl:if test="@expression">
                                        <xsl:attribute name="value"><xsl:value-of select="@expression"/></xsl:attribute>
                                    </xsl:if>
                                </input>
                            </td>
                        </tr>
                        <tr>
                            <td style="width: 200px;">
                                Regular Expression
                            </td>
                            <td>
                                <input type="text" class="esb-edit" style="width: 200px;">
                                    <xsl:attribute name="id"><xsl:value-of select="concat('route_match', @rt_pos)"/></xsl:attribute>
                                    <xsl:if test="@match">
                                        <xsl:attribute name="value"><xsl:value-of select="@match"/></xsl:attribute>
                                    </xsl:if>
                                </input>
                            </td>
                        </tr>
                        <tr>
                            <td style="width: 200px;">
                                Break Route
                            </td>
                            <td>
                                <select class="esb-edit" style="width: 80px;">
                                    <xsl:attribute name="id"><xsl:value-of select="concat('route_break', @rt_pos)"/></xsl:attribute>
                                    <xsl:if test="@breakRouter='true'">
                                        <option value="true" selected="true">True</option>
                                        <option value="false">False</option>
                                    </xsl:if>
                                    <xsl:if test="not(@breakRouter) or @breakRouter='false'">
                                        <option value="true">True</option>
                                        <option value="false" selected="true">False</option>
                                    </xsl:if>
                                </select>
                            </td>
                        </tr>
                    </tbody>
                </table>

                    <xsl:for-each select="syn:target">
                        <xsl:attribute name="id">
                            <xsl:value-of select="@esb_med_pos"/>
                        </xsl:attribute>
                        <xsl:call-template name="syn-target-edit">
                            <xsl:with-param name="external" select="1"/>
                        </xsl:call-template>
                    </xsl:for-each>
                </div>
            </xsl:for-each><br/>


            <input type="button" value="Add Route" onclick="javascript: addroute(); return false;" style="width:100px;" class="panelbutton_default"/>
            <br/>
            <!--</div>-->
        </div>
    </xsl:template>

</xsl:stylesheet>