<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:template match="syn:router" mode="custom" priority="2"
                  xmlns:syn="http://ws.apache.org/ns/synapse">
        <label class="content-header">
            <img align="top" src="extensions/core/images/router-big.gif"/>
            <xsl:text> Router Mediator</xsl:text>
        </label>

        <div id="common_table_content">
            <table border="0" cellpadding="0" cellspacing="0" class="data-table">
                <tbody>
                    <tr>
                        <th>Property</th>
                        <th>Value</th>
                    </tr>
                    <tr>
                        <td>
                            <label class="log-attribute-name">Continue after</label>
                        </td>
                        <td>
                            <label class="log-attribute-value">
                                <xsl:choose>
                                    <xsl:when test="@continueAfter">
                                        <xsl:value-of select="@continueAfter"/>
                                    </xsl:when>
                                    <xsl:otherwise>false</xsl:otherwise>
                                </xsl:choose>
                            </label>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>

        <xsl:for-each select="syn:route">

            <br/>
            <label style="margin-left:10px; font-weight: 400;">Route information for the Route <xsl:value-of
                        select="@rt_pos"/></label>
            <br/>
            <div id="common_table_content">
            <table border="0" cellpadding="0" cellspacing="0" class="data-table">
                <tbody>
                    <tr>
                        <th>Property</th>
                        <th>Value</th>
                    </tr>
                    <tr>
                        <td>
                            <label class="log-attribute-name">XPath Expression</label>
                        </td>
                        <td>
                            <label class="log-attribute-value">
                                <xsl:value-of select="@expression"/>
                            </label>
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <label class="log-attribute-name">Regular Expression</label>
                        </td>
                        <td>
                            <label class="log-attribute-value">
                                <xsl:value-of select="@match"/>
                            </label>
                        </td>
                    </tr>
                    <tr>
                        <td>
                            <label class="log-attribute-name">Break Route</label>
                        </td>
                        <td>
                            <label class="log-attribute-value">
                                <xsl:choose>
                                    <xsl:when test="@breakRouter">
                                        <xsl:value-of select="@breakRouter"/>
                                    </xsl:when>
                                    <xsl:otherwise>false</xsl:otherwise>
                                </xsl:choose>
                            </label>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
            
        <xsl:for-each select="syn:target">
            <br/>
            <label style="margin-left:10px; font-weight: 400;">Target information for the route</label>
            <br/>
            <xsl:call-template name="syn-target-view"/>
        </xsl:for-each>
        </xsl:for-each>

    </xsl:template>

</xsl:stylesheet>