<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  

    <xsl:template match="syn:script" mode="custom" priority="2"
                  xmlns:syn="http://ws.apache.org/ns/synapse">
        <label class="content-header">
            <img align="top" src="extensions/core/images/script-mediator.gif"/>
            <xsl:call-template name="capitalize-first"/>
            <xsl:text>Mediator</xsl:text>
        </label>
        <br/>
        <br/>
        <xsl:variable name="header">
            <tr>
                        <th>Property</th>
                        <th>Value</th>
            </tr>
        </xsl:variable>

        <xsl:variable name="language">
                    <tr>
                        <td> Language</td>
                        <td>
                            <xsl:if test="@language='js'">
                                Javascript
                            </xsl:if>
                            <xsl:if test="@language='rb'">
                                Ruby
                            </xsl:if>
                            <xsl:if test="@language='groovy'">
                                Groovy
                            </xsl:if>
                        </td>
                    </tr>
        </xsl:variable>

        <xsl:variable name="key">
                    <tr>
                        <td>Key</td>
                        <td><xsl:value-of select="@key"/></td>
                    </tr>
        </xsl:variable>

        <xsl:variable name="function">
                    <tr>
                        <td>Function</td>
                        <td><xsl:value-of select="@function"/></td>
                    </tr>
        </xsl:variable>
        <xsl:variable name="source">
                    <tr>
                        <td>Source Script</td>
                        <td>
                           Inline Script
                        </td>
                    </tr>
        </xsl:variable>
        
        <xsl:variable name="include_header">
            <tr>
                        <th>Include</th>
            </tr>
        </xsl:variable>
        
        <xsl:if test="@language">
        <xsl:if test="@key">
            <div id="common_table_content">
            <table border="0" cellpadding="0" cellspacing="0">
                <tbody>
                    <xsl:copy-of select="$header"/>
                    <xsl:copy-of select="$language"/>
                    <xsl:if test="@key">
                        <xsl:copy-of select="$key"/>
                    </xsl:if>
                    <xsl:if test="@function">
                        <xsl:copy-of select="$function"/>
                    </xsl:if>
                </tbody>
            </table>
            <xsl:if test="syn:include">
                <table border="0" cellpadding="0" cellspacing="0">
                    <tbody>
                        <xsl:copy-of select="$include_header"/>
                            <xsl:for-each select="syn:include">
                                <tr>
                                    <td><xsl:value-of select="@key"/></td>
                                </tr>
                            </xsl:for-each>
                    </tbody>
                </table>
            </xsl:if>
            </div>
        </xsl:if>

        <xsl:if test="not(@key)">
        <div id="common_table_content">
            <table border="0" cellpadding="0" cellspacing="0">
                <tbody>
                    <xsl:copy-of select="$header"/>
                    <xsl:copy-of select="$language"/>
                    <xsl:copy-of select="$source"/>
                </tbody>
            </table>
         </div>
         </xsl:if>
         </xsl:if> 
    </xsl:template>
</xsl:stylesheet>
