<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:include href="commons.xsl"/>
    <xsl:template match="syn:send" xmlns:syn="http://ws.apache.org/ns/synapse">
        <xsl:variable name="position" select="@esb_med_pos"/>
        <div id="ep">
            <div class="content-header" style="margin-bottom:15px;">
                <img align="top" src="extensions/core/images/send-mediator.gif"/>
                <xsl:text>Send Mediator</xsl:text>
            </div>
            
            <xsl:if test="syn:endpoint">
                <xsl:for-each select="syn:endpoint">
                    <div id="send_edit_div" class="end-point-div mediator-inside" style="margin-top:-10px;margin-left:40px;">
                        <br/>
                        <xsl:if test="@key">
                            <div>
                            	<table cellpadding="0" cellspacing="0" border="0">
	                            	<tr>
	                            	<td class="endpointLeft" style="padding-left:0px;padding-right:0px;">
		                            <img src="extensions/core/images/look_up_endpoint.gif" width="30" align="middle" />
	                                <label class="content-header">
	                                    <xsl:text>Lookup Endpoint</xsl:text>
	                                </label>
	                                </td>
	                                <td style="padding-left:0px;padding-right:0px;">
	                                <xsl:element name="img">
	                                    <xsl:attribute name="src">
	                                        extensions/core/images/_edit.gif</xsl:attribute>
	                                    <xsl:attribute name="title">Edit Endpoint</xsl:attribute>
	                                    <xsl:attribute name="onClick">
	                                        javascript:convertToEndpoint('<xsl:value-of select="$position"/>');return false;
	                                    </xsl:attribute>
	                                </xsl:element>
	                                </td>
	                                <td>
	                                 <xsl:element name="img">
	                                    <xsl:attribute name="src">
	                                        extensions/core/images/delete.gif</xsl:attribute>
	                                    <xsl:attribute name="title">Delete Endpoint</xsl:attribute>
	                                    <xsl:attribute name="onClick">
	                                        javascript:removeEndpoint('<xsl:value-of select="$position"/>');return false;
	                                    </xsl:attribute>
	                                </xsl:element>
	                                </td>
	                                </tr>
                                </table>
                            </div>
                        </xsl:if>
                        <xsl:if test="syn:address">
                            <div>
                            	<table cellpadding="0" cellspacing="0" border="0">
	                            	<tr>
	                            	<td class="endpointLeft" style="padding-left:0px;padding-right:0px;">
		                                <label class="content-header">
		                                <img src="extensions/core/images/address_endpoint.gif" width="30" align="middle"/>
		                                <xsl:text>Address Endpoint</xsl:text>
		                                </label>
		                            </td>
	                                <td style="padding-left:0px;padding-right:0px;">
		                                <xsl:element name="img">
		                                    <xsl:attribute name="src">
		                                        extensions/core/images/edit.gif</xsl:attribute>
		                                    <xsl:attribute name="title">Edit Endpoint</xsl:attribute>
		                                    <xsl:attribute name="onClick">
		                                        javascript:convertToEndpoint('<xsl:value-of select="$position"/>');return false;
		                                    </xsl:attribute>
		                                </xsl:element>
		                            </td>
		                            <td>
		                                <xsl:element name="img">
		                                    <xsl:attribute name="src">
		                                        extensions/core/images/delete.gif</xsl:attribute>
		                                    <xsl:attribute name="title">Delete Endpoint</xsl:attribute>
		                                    <xsl:attribute name="onClick">
		                                        javascript:removeEndpoint('<xsl:value-of select="$position"/>');return false;
		                                    </xsl:attribute>
		                                </xsl:element>
		                            </td>
		                            </tr>
		                        </table>
                            </div>
                        </xsl:if>
                        <xsl:if test="syn:wsdl">
                             <div>
                             	<table cellpadding="0" cellspacing="0" border="0">
	                            	<tr>
	                            	<td class="endpointLeft" style="padding-left:0px;padding-right:0px;">
		                                <label class="content-header">
		                                <img src="extensions/core/images/wsdl_endpoint.gif" width="30" align="middle"/>
		                                <xsl:text>WSDL Endpoint</xsl:text>
		                                </label>
		                            </td>
		                            <td style="padding-left:0px;padding-right:0px;">
		                                <xsl:element name="img">
		                                    <xsl:attribute name="src">
		                                        extensions/core/images/_edit.gif</xsl:attribute>
		                                    <xsl:attribute name="title">Edit Endpoint</xsl:attribute>
		                                    <xsl:attribute name="onClick">
		                                        javascript:convertToEndpoint('<xsl:value-of select="$position"/>');return false;
		                                    </xsl:attribute>
		                                </xsl:element>
		                            </td>
		                            <td>
		                                  <xsl:element name="img">
		                                    <xsl:attribute name="src">
		                                        extensions/core/images/delete.gif</xsl:attribute>
		                                    <xsl:attribute name="title">Delete Endpoint</xsl:attribute>
		                                    <xsl:attribute name="onClick">
		                                        javascript:removeEndpoint('<xsl:value-of select="$position"/>');return false;
		                                    </xsl:attribute>
		                                </xsl:element>
		                            </td>
		                        	</tr>
		                        </table>
                            </div>
                        </xsl:if>
                        <xsl:if test="syn:loadbalance">
                             <div>
                             	<table cellpadding="0" cellspacing="0" border="0">
	                            	<tr>
	                            	<td class="endpointLeft" style="padding-left:0px;padding-right:0px;">
		                                <label class="content-header">
		                                <img src="extensions/core/images/load_balance_endpoint.gif" width="30" align="middle"/>
		                                <xsl:text>Load-balance Endpoint</xsl:text>
		                                </label>
		                            </td>
		                            <td style="padding-left:0px;padding-right:0px;">
		                                <xsl:element name="img">
		                                    <xsl:attribute name="src">
		                                        extensions/core/images/_edit.gif</xsl:attribute>
		                                    <xsl:attribute name="title">Edit Endpoint</xsl:attribute>
		                                    <xsl:attribute name="onClick">
		                                        javascript:convertToEndpoint('<xsl:value-of select="$position"/>');return false;
		                                    </xsl:attribute>
		                                </xsl:element>
		                            </td>
		                            <td>
		                                  <xsl:element name="img">
		                                    <xsl:attribute name="src">
		                                        extensions/core/images/delete.gif</xsl:attribute>
		                                    <xsl:attribute name="title">Delete Endpoint</xsl:attribute>
		                                    <xsl:attribute name="onClick">
		                                        javascript:removeEndpoint('<xsl:value-of select="$position"/>');return false;
		                                    </xsl:attribute>
		                                </xsl:element>
		                            </td>
		                            </tr>
		                        </table>
                            </div>
                        </xsl:if>
                        <xsl:if test="syn:failover">
                           <div>
                           <table cellpadding="0" cellspacing="0" border="0">
	                            	<tr>
	                            	<td class="endpointLeft" style="padding-left:0px;padding-right:0px;">
		                                <label class="content-header">
		                                <img src="extensions/core/images/failover_endpoint.gif" width="30" align="middle"/>
		                                <xsl:text>Failover Endpoint</xsl:text>
		                                </label>
		                            </td>
		                            <td style="padding-left:0px;padding-right:0px;">
		                                <xsl:element name="img">
		                                    <xsl:attribute name="src">
		                                        extensions/core/images/_edit.gif</xsl:attribute>
		                                    <xsl:attribute name="title">Edit Endpoint</xsl:attribute>
		                                    <xsl:attribute name="onClick">
		                                        javascript:convertToEndpoint('<xsl:value-of select="$position"/>');return false;
		                                	</xsl:attribute>
		                                </xsl:element>
		                                </td>
		                            	<td>
		                                <xsl:element name="img">
		                                    <xsl:attribute name="src">
		                                        extensions/core/images/delete.gif</xsl:attribute>
		                                    <xsl:attribute name="title">Delete Endpoint</xsl:attribute>
		                                    <xsl:attribute name="onClick">
		                                        javascript:removeEndpoint('<xsl:value-of select="$position"/>');return false;
		                                    </xsl:attribute>
		                                </xsl:element>
		                                </td>
		                            	</tr>
		                   		</table>
                            </div>
                        </xsl:if>
                    </div>
                </xsl:for-each>
            </xsl:if>
            <xsl:if test="not(syn:endpoint)">
                <div>
                    <xsl:element name="img">
                        <xsl:attribute name="src">extensions/core/images/add.gif</xsl:attribute>
                        <xsl:attribute name="style">margin-left: 20px;</xsl:attribute>
                        <xsl:attribute name="onClick">
                            javascript:addSendMediatorEndpointmenu(event,'<xsl:value-of select="$position"/>');return false;
                        </xsl:attribute>
                    </xsl:element>
                    <label class="styled-link" style="padding-left:20px;vertical-align:bottom;">Add Endpoint</label>
                </div>
            </xsl:if>
        </div>
    </xsl:template>
</xsl:stylesheet>