<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:template match="*" xmlns:syn="http://ws.apache.org/ns/synapse">
        <xsl:element name="div">
            <xsl:attribute name="id">
                                <xsl:value-of select="concat('statement',@statement_index)"/>
                            </xsl:attribute>
              <div class="area-div" style="margin-bottom:20px;">

                            <table border="0" class="data-table">
	                            <tr>
	                            <td>SQL<font style='color: red;font-size: 8pt;'>&#160;*</font></td>
	                            <td>
                            <xsl:element name="input">
                                <xsl:attribute name="id">
                                    <xsl:value-of
                                            select="concat('sql_id',@statement_index)"/>
                                </xsl:attribute>
                                <xsl:attribute name="type">text</xsl:attribute>
                                <xsl:attribute name="class">esb-edit</xsl:attribute>
                                <xsl:attribute name="value">
                                    <xsl:value-of
                                            select="syn:sql"/>
                                </xsl:attribute>
                            </xsl:element>
                            </td>
                            <td>
                            <label>statement</label>
                            <a href="#" id="delete_link">
                                                <xsl:attribute name="onclick">javascript:deletestatement('<xsl:value-of select="@statement_index"/>','<xsl:value-of select="@esb_med_pos"/>'); return false;
                                                </xsl:attribute>
                                                &#160;&#160;&#160;&#160;
                            </a>
                            </td>
                            </tr>
                            </table>
                            <div class="sub-sub-title">Parameters</div>
                          <div id="common_table_content">
                            <xsl:element name="table">
                                <xsl:attribute name="border">0</xsl:attribute>
                                <xsl:attribute name="cellpadding">0</xsl:attribute>
                                <xsl:attribute name="width">600</xsl:attribute>
                                <xsl:attribute name="cellspacing">0</xsl:attribute>
                                <tbody>
                                    <xsl:attribute name="id">
                                    <xsl:value-of
                                            select="concat('parameters',@statement_index)"/>
                                </xsl:attribute>
                                </tbody>
                            </xsl:element>
                         </div>
                            <xsl:element name="input">
                                <xsl:attribute name="href">#</xsl:attribute>
                                <xsl:attribute name="type">button</xsl:attribute>
                                <xsl:attribute name="class">panelbutton_default</xsl:attribute>
                                <xsl:attribute name="value">Add Parameter</xsl:attribute>
                                <xsl:attribute name="onclick">javascript:addparameter('<xsl:value-of select="@esb_med_pos"/>','<xsl:value-of select="@pindex"/>','<xsl:value-of select="@statement_index"/>','0');
                                </xsl:attribute>
                                <xsl:attribute name="style">width:110px;margin-left:10px;
                                </xsl:attribute>
                            </xsl:element>
                            
                            <div class="sub-sub-title" style="margin-top:20px;">Results</div>
                            <div id="common_table_content">
                            <xsl:element name="table">
                                <xsl:attribute name="border">0</xsl:attribute>
                                <xsl:attribute name="cellpadding">0</xsl:attribute>
                                <xsl:attribute name="width">600</xsl:attribute>
                                <xsl:attribute name="cellspacing">0</xsl:attribute>
                                <tbody>
                                    <xsl:attribute name="id">
                                    <xsl:value-of
                                            select="concat('results',@statement_index)"/>
                                </xsl:attribute>
                                </tbody>
                            </xsl:element>
                            </div>

                            <xsl:element name="input">
                                <xsl:attribute name="href">#</xsl:attribute>
                                <xsl:attribute name="type">button</xsl:attribute>
                                <xsl:attribute name="class">panelbutton_default</xsl:attribute>
                                <xsl:attribute name="value">Add result</xsl:attribute>
                                <xsl:attribute name="onclick">javascript:addresult(<xsl:value-of select="@esb_med_pos"/>,'<xsl:value-of select="@statement_index"/>','<xsl:value-of select="count(syn:result)"/>');
                                </xsl:attribute>
                                <xsl:attribute name="style">width:110px;margin-left:10px;
                                </xsl:attribute>
                            </xsl:element>
                            
						</div>
                        </xsl:element>
            </xsl:template>
  </xsl:stylesheet>