<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:include href="mediator_view.xsl"/>

    <xsl:template match="syn:switch" xmlns:syn="http://ws.apache.org/ns/synapse">

        <label class="content-header-mediators">
            <img align="top" src="extensions/core/images/switch-mediator.gif"/>  <xsl:call-template name="capitalize-first"/>
            <xsl:text> Mediator</xsl:text>
        </label>

  
        <table>
            <tr>
                <td>
                    <label style="margin-left:20px;">Source XPath<font style='color: red;font-size: 8pt;'>&#160;*</font></label>
                </td>
                <td>
                    <input type="text" id="source_val" class="esb-edit">
                        <xsl:attribute name="value"><xsl:value-of select="@source"/></xsl:attribute>
                    </input>
                </td>
                <td>
                    <a title="Namespace Editor" class="ns_editor">
                        <xsl:attribute name="onclick">
                            javascript:showNameSpaceEditor('<xsl:value-of select="@esb_med_pos"/>','','');
                        </xsl:attribute>
                        <xsl:text>&#160;&#160;&#160;&#160;</xsl:text>
                    </a>
                </td>
            </tr>
        </table>
		<fieldset class="switch-field">
		<legend>Switch Cases</legend>
        <div class="indent"><xsl:apply-templates/></div>

        <div class='field-mediator-add'><xsl:attribute name="id">mediator-add<xsl:value-of select="@esb_med_pos"/></xsl:attribute>
            <img src='extensions/core/images/add-case.gif'>
                <xsl:attribute name="onclick">javascript:addcase("<xsl:value-of select="@esb_med_pos"/>");return false;</xsl:attribute>
            </img>
            <label class='styled-link-button'> Add Case </label>
        </div>
		</fieldset>
		<fieldset class="switch-field">
		<legend>Default Case</legend>
        <xsl:if test="not(syn:default)">
            <div class='field-mediator-add'><xsl:attribute name="id">mediator-add<xsl:value-of select="@esb_med_pos"/></xsl:attribute>
                <img src='extensions/core/images/add-case.gif'>
                    <xsl:attribute name="onclick">javascript:adddefault("<xsl:value-of select="@esb_med_pos"/>");return false;</xsl:attribute>
                </img>
                <label class='styled-link-button'> Add Default </label>
            </div>
        </xsl:if>
		</fieldset>
		
        <xsl:for-each select="syn:default">

            <div class="indent">
                <label class="content-sub-header"><img src="extensions/core/images/add-case.gif"/> Default Case </label>
                <xsl:if test="count(child::*)=0">
                    <xsl:call-template name="add_mediator_control">
                        <xsl:with-param name="head_pos" select="concat(@esb_med_pos, '.0')"/>
                    </xsl:call-template>
                </xsl:if>
                <div class="indent"><xsl:apply-templates/></div>
            </div>
        </xsl:for-each>

    </xsl:template>

</xsl:stylesheet>