<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:template match="syn:switch" mode="custom" priority="2" xmlns:syn="http://ws.apache.org/ns/synapse">

        <label class="content-header-mediators">
            <img align="top" src="extensions/core/images/switch-mediator.gif"/>  <xsl:call-template name="capitalize-first"/>
            <xsl:text> Mediator</xsl:text>
        </label>

		<table cellpadding="0" cellspacing="0" border="0">
		<tr>
        <td style="margin-left:20px;">Source XPath </td>
        <td>
            <xsl:if test="@source!=''"><xsl:value-of select="@source"/></xsl:if>
            <xsl:if test="@source=''">Not specified</xsl:if>
        </td>
       </tr>
       </table>
        <fieldset class="switch-field">
		<legend>Switch Cases</legend>
        <div class="indent">
            <xsl:apply-templates/>
        </div>
        
        <div class='field-mediator-add'><xsl:attribute name="id">mediator-add<xsl:value-of select="@esb_med_pos"/></xsl:attribute>
            <img src='extensions/core/images/add-case.gif'>
                <xsl:attribute name="onclick">javascript:addcase("<xsl:value-of select="@esb_med_pos"/>");return false;</xsl:attribute>
            </img>
            <label class='styled-link-button'> Add Case </label>
        </div>
		</fieldset>
		
		<fieldset class="switch-field">
		<legend>Default Case</legend>
        <xsl:if test="not(syn:default)">
            <div class='field-mediator-add'><xsl:attribute name="id">mediator-add<xsl:value-of select="@esb_med_pos"/></xsl:attribute>
                <img src='extensions/core/images/add-case.gif'>
                    <xsl:attribute name="onclick">javascript:adddefault("<xsl:value-of select="@esb_med_pos"/>");return false;</xsl:attribute>
                </img>
                <label class='styled-link-button'> Add Default </label>
            </div>
        </xsl:if>
        
        <xsl:for-each select="syn:default">

            <div class="indent" style="padding-top:5px;padding-bottom:5px;">
                <label class="content-sub-header"><img src="extensions/core/images/2rightarrow.jpg" align="top" /> Default Case</label>
                <xsl:if test="count(child::*)=0">
                    <xsl:call-template name="add_mediator_control">
                        <xsl:with-param name="head_pos" select="concat(@esb_med_pos, '.0')"/>
                    </xsl:call-template>
                </xsl:if>
                <div class="indent"><xsl:apply-templates/></div>
            </div>
        </xsl:for-each>
        </fieldset>

    </xsl:template>

    <xsl:template match="syn:default" mode="custom" priority="2" xmlns:syn="http://ws.apache.org/ns/synapse">
        
    </xsl:template>

    <xsl:template match="syn:case" mode="custom" priority="2" xmlns:syn="http://ws.apache.org/ns/synapse">
        <label class="content-sub-header"><img src="extensions/core/images/2rightarrow.jpg" align="top" /> Switch Case<img src="extensions/core/images/line-brake.gif" align="bottom" style="margin-left:10px;" /></label>
        <br/><br/>
        <label style="margin-left:10px;"> Case Regular Expression </label>
        <label style="margin-left: 50px;">
            <xsl:if test="@regex!=''"><xsl:value-of select="@regex"/></xsl:if>
            <xsl:if test="@regex=''">Not specified</xsl:if>
        </label>
        <br/>
        <div class="indent"><xsl:apply-templates/></div>

        <xsl:if test="count(child::*)=0">
        <div style="padding-top:10px;">
            <xsl:call-template name="add_mediator_control">
                <xsl:with-param name="head_pos" select="concat(@esb_med_pos, '.0')"/>
            </xsl:call-template>
        </div>
        </xsl:if>
    </xsl:template>

</xsl:stylesheet>