<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:syn="http://ws.apache.org/ns/synapse">

    <xsl:include href="mediator_view.xsl"/>

    <xsl:template match="syn:target">
        <xsl:call-template name="syn-target-edit"/>
    </xsl:template>


    <xsl:template name="syn-target-edit">

        <xsl:param name="external"/>
        <xsl:variable name="position" select="@esb_med_pos"/>

        <div>
            <xsl:attribute name="id"><xsl:value-of select="concat('ep', $position)"/></xsl:attribute>
            <xsl:if test="not($external=1)">
                <xsl:attribute name="class">popup-box</xsl:attribute>
            </xsl:if>

            <table style="width: 600px;">
        	<tr>
            <td style="width:300px;">To URI</td>
            <td><input class="esb-edit" type="text">
                <xsl:attribute name="id"><xsl:value-of select="concat('toURI', @tg_pos)"/></xsl:attribute>
                <xsl:if test="@to"><xsl:attribute name="value"><xsl:value-of select="@to"/></xsl:attribute></xsl:if>
            </input></td>
            </tr>
            </table>

            <table style="width: 600px;">
        	<tr>
            <td style="width:300px;">Soap Action</td>
            <td><input class="esb-edit" type="text">
                <xsl:attribute name="id"><xsl:value-of select="concat('soapAction', @tg_pos)"/></xsl:attribute>
                <xsl:if test="@soapAction"><xsl:attribute name="value"><xsl:value-of select="@soapAction"/></xsl:attribute></xsl:if>
            </input></td>
            </tr>
            </table>

            <table style="width: 600px;"><tr>
            <td style="width:280px;"><label style="margin-left: 5px;">Mediation Sequence</label></td>
            <xsl:if test="@sequence">
                <td><label style="margin-left:3em;"><xsl:value-of select="@sequence"/></label></td>
                <td style="width: 100px;"><input type="button" value="Edit Reference" class="panelbutton_default" style="width: 100px; margin-left: 1em;">
                    <xsl:attribute name="onclick">javascript: settargetref('<xsl:value-of select="@esb_med_pos"/>', 'sequence'); return false;</xsl:attribute>
                </input></td>
            </xsl:if>
            <xsl:if test="not(@sequence)">
                <td colspan="2" style="width: 100px;"><input type="button" value="Set Reference" class="panelbutton_default" style="width: 100px; margin-left: 1em;">
                    <xsl:attribute name="onclick">javascript: settargetref('<xsl:value-of select="@esb_med_pos"/>', 'sequence'); return false;</xsl:attribute>
                </input></td>
            </xsl:if>
            <td style="width: 100px;"><xsl:if test="not(syn:sequence)">
                <input type="button" value="Define Inline" class="panelbutton_default" style="width: 100px; margin-left: 1em;">
                    <xsl:attribute name="onclick">javascript: settargetseqinline('<xsl:value-of select="@esb_med_pos"/>'); return false;</xsl:attribute>
                </input>
            </xsl:if></td>
            </tr></table>
            <!--<xsl:if test="syn:sequence">-->
            <xsl:for-each select="syn:sequence">
                <xsl:if test="count(child::*)!=0">
                    <div class='indent'>
                        <xsl:apply-templates/>
                    </div>
                </xsl:if>
                <xsl:if test="count(child::*)=0">
                    <xsl:call-template name="add_mediator_control">
                        <xsl:with-param name="head_pos"
                                        select="concat(concat(@esb_med_pos, '.'), count(child::*))"/>
                    </xsl:call-template>
                    <br/><br/>
                </xsl:if>
            </xsl:for-each>
            <!--</xsl:if>-->

            <table style="width: 600px;"><tr>
            <td style="width:280px;"><label style="margin-left:5px;">Delivery Endpoint</label></td>
            <xsl:if test="@endpoint">
                <td><label style="margin-left:3em;"><xsl:value-of select="@endpoint"/></label></td>
                <td style="width: 100px;"><input type="button" value="Edit Reference" class="panelbutton_default" style="width: 100px; margin-left: 1em;">
                    <xsl:attribute name="onclick">javascript: settargetref('<xsl:value-of select="@esb_med_pos"/>', 'endpoint'); return false;</xsl:attribute>
                </input></td>
            </xsl:if>
            <xsl:if test="not(@endpoint)">
                <td colspan="2" style="width: 100px;"><input type="button" value="Set Reference" class="panelbutton_default" style="width: 100px; margin-left: 1em;">
                    <xsl:attribute name="onclick">javascript: settargetref('<xsl:value-of select="@esb_med_pos"/>', 'endpoint'); return false;</xsl:attribute>
                </input></td>
            </xsl:if>
            <td style="width: 100px;"><xsl:if test="not(syn:endpoint) and not(@ep_anon)">
                <input type="button" value="Define Inline" class="panelbutton_default" style="width: 100px; margin-left: 1em;">
                    <xsl:attribute name="onclick">javascript: settargetepinline('<xsl:value-of select="@esb_med_pos"/>'); return false;</xsl:attribute>
                </input>
            </xsl:if></td>
            </tr></table>


            <!--<div id="ep">-->
            <xsl:if test="syn:endpoint">
                <xsl:for-each select="syn:endpoint">
                    <div id="send_edit_div" class="end-point-div">
                        <br/>
                        <xsl:if test="@key">
                            <div>
                                <label class="content-header">
                                    <img src="extensions/core/images/look_up_endpoint.gif"/>
                                    <xsl:text>Lookup Endpoint&#32;&#32;&#32;&#32;&#32;&#32;</xsl:text>
                                </label>
                                <xsl:element name="img">
                                    <xsl:attribute name="style">margin-left: 20px;</xsl:attribute>
                                    <xsl:attribute name="src">
                                        extensions/core/images/_edit.gif</xsl:attribute>
                                    <xsl:attribute name="title">Edit Endpoint</xsl:attribute>
                                    <xsl:attribute name="onClick">
                                        javascript:convertToEndpoint('<xsl:value-of select="$position"/>');return false;
                                    </xsl:attribute>
                                </xsl:element>
                                 <xsl:element name="img">
                                    <xsl:attribute name="style">margin-left: 20px;</xsl:attribute>
                                    <xsl:attribute name="src">
                                        extensions/core/images/delete.gif</xsl:attribute>
                                    <xsl:attribute name="title">Delete Endpoint</xsl:attribute>
                                    <xsl:attribute name="onClick">
                                        javascript:deleteTargetEndponit('<xsl:value-of select="$position"/>');return false;
                                    </xsl:attribute>
                                </xsl:element>
                            </div>
                        </xsl:if>
                        <xsl:if test="syn:address">
                            <div>
                                <label class="content-header">
                                <img src="extensions/core/images/address_endpoint.gif"/>
                                <xsl:text>Address Endpoint&#32;&#32;&#32;&#32;&#32;&#32;</xsl:text>
                                </label>
                                <xsl:element name="img">
                                    <xsl:attribute name="style">margin-left: 20px;</xsl:attribute>
                                    <xsl:attribute name="src">
                                        extensions/core/images/edit.gif</xsl:attribute>
                                    <xsl:attribute name="title">Edit Endpoint</xsl:attribute>
                                    <xsl:attribute name="onClick">
                                        javascript:convertToEndpoint('<xsl:value-of select="$position"/>');return false;
                                    </xsl:attribute>
                                </xsl:element>
                                <xsl:element name="img">
                                    <xsl:attribute name="style">margin-left: 20px;</xsl:attribute>
                                    <xsl:attribute name="src">
                                        extensions/core/images/delete.gif</xsl:attribute>
                                    <xsl:attribute name="title">Delete Endpoint</xsl:attribute>
                                    <xsl:attribute name="onClick">
                                        javascript:deleteTargetEndponit('<xsl:value-of select="$position"/>');return false;
                                    </xsl:attribute>
                                </xsl:element>
                            </div>
                        </xsl:if>
                        <xsl:if test="syn:wsdl">
                             <div>
                                <label class="content-header">
                                <img src="extensions/core/images/wsdl_endpoint.gif"/>
                                <xsl:text>WSDL Endpoint&#32;&#32;&#32;&#32;&#32;&#32;</xsl:text>
                                </label>
                                <xsl:element name="img">
                                    <xsl:attribute name="style">margin-left: 20px;</xsl:attribute>
                                    <xsl:attribute name="src">
                                        extensions/core/images/_edit.gif</xsl:attribute>
                                    <xsl:attribute name="title">Edit Endpoint</xsl:attribute>
                                    <xsl:attribute name="onClick">
                                        javascript:convertToEndpoint('<xsl:value-of select="$position"/>');return false;
                                    </xsl:attribute>
                                </xsl:element>
                                  <xsl:element name="img">
                                    <xsl:attribute name="style">margin-left: 20px;</xsl:attribute>
                                    <xsl:attribute name="src">
                                        extensions/core/images/delete.gif</xsl:attribute>
                                    <xsl:attribute name="title">Delete Endpoint</xsl:attribute>
                                    <xsl:attribute name="onClick">
                                        javascript:deleteTargetEndponit('<xsl:value-of select="$position"/>');return false;
                                    </xsl:attribute>
                                </xsl:element>
                            </div>
                        </xsl:if>
                        <xsl:if test="syn:loadbalance">
                             <div>
                                <label class="content-header">
                                <img src="extensions/core/images/load_balance_endpoint.gif"/>
                                <xsl:text>Load-balance Endpoint&#32;&#32;&#32;&#32;&#32;&#32;</xsl:text>
                                </label>
                                <xsl:element name="img">
                                    <xsl:attribute name="style">margin-left: 20px;</xsl:attribute>
                                    <xsl:attribute name="src">
                                        extensions/core/images/_edit.gif</xsl:attribute>
                                    <xsl:attribute name="title">Edit Endpoint</xsl:attribute>
                                    <xsl:attribute name="onClick">
                                        javascript:convertToEndpoint('<xsl:value-of select="$position"/>');return false;
                                    </xsl:attribute>
                                </xsl:element>
                                  <xsl:element name="img">
                                    <xsl:attribute name="style">margin-left: 20px;</xsl:attribute>
                                    <xsl:attribute name="src">
                                        extensions/core/images/delete.gif</xsl:attribute>
                                    <xsl:attribute name="title">Delete Endpoint</xsl:attribute>
                                    <xsl:attribute name="onClick">
                                        javascript:deleteTargetEndponit('<xsl:value-of select="$position"/>');return false;
                                    </xsl:attribute>
                                </xsl:element>
                            </div>
                        </xsl:if>
                        <xsl:if test="syn:failover">
                           <div>
                                <label class="content-header">
                                <img src="extensions/core/images/failover_endpoint.gif"/>
                                <xsl:text>Failover Endpoint&#32;&#32;&#32;&#32;&#32;&#32;</xsl:text>
                                </label>
                                <xsl:element name="img">
                                    <xsl:attribute name="style">margin-left: 20px;</xsl:attribute>
                                    <xsl:attribute name="src">
                                        extensions/core/images/_edit.gif</xsl:attribute>
                                    <xsl:attribute name="title">Edit Endpoint</xsl:attribute>
                                    <xsl:attribute name="onClick">
                                        javascript:convertToEndpoint('<xsl:value-of select="$position"/>');return false;
                                    </xsl:attribute>
                                </xsl:element>
                                <xsl:element name="img">
                                    <xsl:attribute name="style">margin-left: 20px;</xsl:attribute>
                                    <xsl:attribute name="src">
                                        extensions/core/images/delete.gif</xsl:attribute>
                                    <xsl:attribute name="title">Delete Endpoint</xsl:attribute>
                                    <xsl:attribute name="onClick">
                                        javascript:deleteTargetEndponit('<xsl:value-of select="$position"/>');return false;
                                    </xsl:attribute>
                                </xsl:element>
                            </div>
                        </xsl:if>
                    </div>
                </xsl:for-each>
            </xsl:if>
            <xsl:if test="@ep_anon and not(syn:endpoint)">
                <div>
                    <xsl:element name="img">
                        <xsl:attribute name="src">extensions/core/images/add.gif</xsl:attribute>
                        <xsl:attribute name="style">margin-left: 20px;</xsl:attribute>
                        <xsl:attribute name="onClick">
                            javascript:addSendMediatorEndpointmenu(event,'<xsl:value-of select="@esb_med_pos"/>');return false;
                        </xsl:attribute>
                    </xsl:element>
                    <label class='styled-link'>Add Endpoint</label>
                </div><br/><br/>
            </xsl:if>
            <!--</div>-->


        </div>
    </xsl:template>
    </xsl:stylesheet>