<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:include href="mediator_view.xsl"/>
    <xsl:template match="syn:throttle" xmlns:wsp="http://schemas.xmlsoap.org/ws/2004/09/policy"  xmlns:syn="http://ws.apache.org/ns/synapse">
        <div id="throttle_edit">
        <label class="content-header">
            <img align="top" src="extensions/core/images/throttle_mediator.gif"/>
            <xsl:text>Throttle Mediator</xsl:text>
        </label>
        <br/>
            <div id="policy_div" class="indent">
                <br/>
                <label>Thottle Group ID <font style='color: red;font-size: 8pt;'>&#160;*</font></label>
                <xsl:element name="input">
                    <xsl:attribute name="id">
                        <xsl:value-of select="concat('throttle_id',@esb_med_pos)"/>
                    </xsl:attribute>
                    <xsl:attribute name="style">margin-left: 55px;</xsl:attribute>
                    <xsl:attribute name="type">text</xsl:attribute>
                    <xsl:attribute name="size">20</xsl:attribute>
                    <xsl:attribute name="class">esb-edit</xsl:attribute>
                    <xsl:attribute name="value">
                        <xsl:value-of select="@id"/>
                    </xsl:attribute>
                </xsl:element>
                <br/>
                <br/>
                    <label >Specify as :</label>
                    <xsl:element name="input">
                        <xsl:attribute name="onClick">
                            javascript:showinlinepolicylayout('<xsl:value-of select="@esb_med_pos"/>');
                        </xsl:attribute>
                        <xsl:attribute name="type">radio</xsl:attribute>
                        <xsl:attribute name="name">
                            policygroup
                        </xsl:attribute>
                        <xsl:attribute name="value">InLinePolicy</xsl:attribute>
                        <xsl:attribute name="style">margin-left: 3em;</xsl:attribute>
                        <xsl:if test="syn:policy/* or (@inline and @inline=0)">
                            <xsl:attribute name="checked">checked</xsl:attribute>
                        </xsl:if>
                    </xsl:element>
                    <label >In-lined Policy</label>
                    <xsl:element name="input">
                        <xsl:attribute name="onClick">
                            javascript:showrefpolicylayout('<xsl:value-of select="@esb_med_pos"/>');
                        </xsl:attribute>
                        <xsl:attribute name="type">radio</xsl:attribute>
                        <xsl:attribute name="name">
                            policygroup
                        </xsl:attribute>
                        <xsl:attribute name="value">PolicyKey</xsl:attribute>
                        <xsl:attribute name="style">margin-left:120px;</xsl:attribute>
                         <xsl:if test="syn:policy/@key">
                            <xsl:attribute name="checked">checked</xsl:attribute>
                        </xsl:if>
                    </xsl:element>
                    <label >Referring Policy</label>
                <xsl:if test="(syn:policy/@key) and not(syn:policy/*)">
                    <div id="policylayoutdiv">
                    <br/>
                    <label style="margin-left:5em;">Referring Policy</label>
                    <xsl:element name="input">
                        <xsl:attribute name="id"><xsl:value-of select="concat('policy_ref',@esb_med_pos)"/></xsl:attribute>
                        <xsl:attribute name="style">margin-left: 55px;</xsl:attribute>
                        <xsl:attribute name="type">text</xsl:attribute>
                        <xsl:attribute name="size">20</xsl:attribute>
                        <xsl:attribute name="class">esb-edit_disabled</xsl:attribute>
                        <xsl:attribute name="value">
                            <xsl:value-of select="syn:policy/@key"/>
                        </xsl:attribute>
                        <xsl:attribute name="DISABLED"/>
                    </xsl:element>
                    <xsl:element name="img">
                        <xsl:attribute name="style">margin-left: 40px;</xsl:attribute>
                        <xsl:attribute name="src">
                            extensions/core/images/registry_picker.gif</xsl:attribute>
                        <xsl:attribute name="title">Registry Browser</xsl:attribute>
                        <xsl:attribute name="onClick">
                            javascript:throttlepolicykeyfromregistry('<xsl:value-of select="@esb_med_pos"/>');return false;
                        </xsl:attribute>
                    </xsl:element>
                    </div>
                </xsl:if>
                    <xsl:if test="(syn:policy/*) or (@inline and @inline=0)">
                        <div id="policylayoutdiv">
                        <br/>
                        <label style="margin-left:5em;">In-lined
                            Policy</label>
                        <xsl:element name="img">
                            <xsl:attribute name="style">margin-left: 65px;</xsl:attribute>
                            <xsl:attribute name="src">
                                extensions/core/images/_edit.gif</xsl:attribute>
                            <xsl:attribute name="title">Edit Policy</xsl:attribute>
                            <xsl:attribute name="onClick">
                                javascript:editinlinethrottlepolicy('<xsl:value-of select="@esb_med_pos"/>');return false;
                            </xsl:attribute>
                        </xsl:element>
                        <br/>
                         </div>
                    </xsl:if>
                <br/>
            </div>
            <div id="onaccept_div" class="indent">
                <xsl:if test="@onAccept">
                    <br/>
                    <label class="sub-small-title">On Acceptance</label>
                    <br/>
                    <br/>
                    <label>Specify as :</label>
                    <xsl:element name="input">
                        <xsl:attribute name="onClick">
                            javascript:showinlineonacceplayout('<xsl:value-of select="@esb_med_pos"/>');
                        </xsl:attribute>
                        <xsl:attribute name="type">radio</xsl:attribute>
                        <xsl:attribute name="name">
                            onacceptgroup
                        </xsl:attribute>
                        <xsl:attribute name="value">onAcceptSequence</xsl:attribute>
                        <xsl:attribute name="style">margin-left: 3em;</xsl:attribute>
                    </xsl:element>
                    <label>In-lined Sequence</label>
                    <xsl:element name="input">
                        <xsl:attribute name="onClick">
                            javascript:showrefonacceptlayout('<xsl:value-of select="@esb_med_pos"/>');
                        </xsl:attribute>
                        <xsl:attribute name="type">radio</xsl:attribute>
                        <xsl:attribute name="name">
                            onacceptgroup
                        </xsl:attribute>
                        <xsl:attribute name="value">onAcceptSequenceKey</xsl:attribute>
                        <xsl:attribute name="style">margin-left:100px;</xsl:attribute>
                        <xsl:attribute name="checked">checked</xsl:attribute>
                    </xsl:element>
                    <label>Referring Sequence</label>
                    <br/>
                    <br/>
                    <label style="margin-left:5em;">Referring Sequence</label>
                    <xsl:element name="input">
                        <xsl:attribute name="id">
                            <xsl:value-of select="concat('onaccept_ref',@esb_med_pos)"/>
                        </xsl:attribute>
                        <xsl:attribute name="style">margin-left: 55px;</xsl:attribute>
                        <xsl:attribute name="type">text</xsl:attribute>
                        <xsl:attribute name="size">20</xsl:attribute>
                        <xsl:attribute name="class">esb-edit_disabled</xsl:attribute>
                        <xsl:attribute name="value">
                            <xsl:value-of select="@onAccept"/>
                        </xsl:attribute>
                        <xsl:attribute name="DISABLED"/>
                    </xsl:element>
                    <xsl:element name="img">
                            <xsl:attribute name="src">
                                extensions/core/images/registry_picker.gif</xsl:attribute>
                            <xsl:attribute name="title">Registry Browser</xsl:attribute>
                            <xsl:attribute name="onClick">
                                javascript:onacceptkeyfromregistry('<xsl:value-of select="@esb_med_pos"/>');return false;
                            </xsl:attribute>
                            <xsl:attribute name="style">margin-left: 25px;</xsl:attribute>
                        </xsl:element>
                    <br/>
                </xsl:if>

                <xsl:if test="not(@onAccept)">
                    <br/>
                     <label class="sub-small-title">On Acceptance</label>
                    <br/>
                    <br/>
                    <label>Specify as :</label>
                    <xsl:element name="input">
                        <xsl:attribute name="onClick">
                            javascript:showinlineonacceplayout('<xsl:value-of select="@esb_med_pos"/>');
                        </xsl:attribute>
                        <xsl:attribute name="type">radio</xsl:attribute>
                        <xsl:attribute name="name">
                            onacceptgroup
                        </xsl:attribute>
                        <xsl:attribute name="value">onAcceptSequence</xsl:attribute>
                        <xsl:attribute name="style">margin-left: 3em;</xsl:attribute>
                        <xsl:attribute name="checked">checked</xsl:attribute>
                    </xsl:element>
                    <label>In-lined Sequence</label>
                    <xsl:element name="input">
                        <xsl:attribute name="onClick">
                            javascript:showrefonacceptlayout('<xsl:value-of select="@esb_med_pos"/>');
                        </xsl:attribute>
                        <xsl:attribute name="type">radio</xsl:attribute>
                        <xsl:attribute name="name">
                            onacceptgroup
                        </xsl:attribute>
                        <xsl:attribute name="value">onAcceptSequenceKey</xsl:attribute>
                        <xsl:attribute name="style">margin-left:100px;</xsl:attribute>
                    </xsl:element>
                    <label>Referring Sequence</label>
                    <br/>
                    <xsl:for-each select="syn:onAccept">
                        <div id="onacceptlayoutdiv">
                            <xsl:choose>
                                <xsl:when test="count(child::*)!=0">
                                    <div class="indent" style="margin-left:1em;">
                                        <xsl:apply-templates/>
                                    </div>
                                </xsl:when>
                                <xsl:otherwise>
                                    <div class="indent">
                                        <xsl:call-template name="add_mediator_control">
                                            <xsl:with-param name="head_pos">
                                                <xsl:value-of select="concat(@esb_med_pos, '.0')"/>
                                            </xsl:with-param>
                                        </xsl:call-template>
                                    </div>
                                    <br/>
                                </xsl:otherwise>
                            </xsl:choose>
                        </div>
                    </xsl:for-each>
                </xsl:if>
            </div>
            <div id="onreject_div" class="indent">
                <xsl:if test="@onReject">
                    <br/>
                    <label class="sub-small-title">On Rejection</label>
                    <br/>
                    <br/>
                    <label>Specify as :</label>
                    <xsl:element name="input">
                        <xsl:attribute name="onClick">
                            javascript:showinlineonrejectlayout('<xsl:value-of select="@esb_med_pos"/>');
                        </xsl:attribute>
                        <xsl:attribute name="type">radio</xsl:attribute>
                        <xsl:attribute name="name">
                            onrejectgroup
                        </xsl:attribute>
                        <xsl:attribute name="value">onRejectSequence</xsl:attribute>
                        <xsl:attribute name="style">margin-left: 3em;</xsl:attribute>
                    </xsl:element>
                    <label>In-lined Sequence</label>
                    <xsl:element name="input">
                        <xsl:attribute name="onClick">
                            javascript:showrefonrejectlayout('<xsl:value-of select="@esb_med_pos"/>');
                        </xsl:attribute>
                        <xsl:attribute name="type">radio</xsl:attribute>
                        <xsl:attribute name="name">
                            onrejectgroup
                        </xsl:attribute>
                        <xsl:attribute name="value">onRejectSequenceKey</xsl:attribute>
                        <xsl:attribute name="style">margin-left:100px;</xsl:attribute>
                        <xsl:attribute name="checked">checked</xsl:attribute>
                    </xsl:element>
                    <label>Referring Sequence</label>
                    <br/>
                    <br/>
                    <label style="margin-left:5em;">Referring Sequence</label>
                    <xsl:element name="input">
                        <xsl:attribute name="id">
                            <xsl:value-of select="concat('onreject_ref',@esb_med_pos)"/>
                        </xsl:attribute>
                        <xsl:attribute name="style">margin-left: 55px;</xsl:attribute>
                        <xsl:attribute name="type">text</xsl:attribute>
                        <xsl:attribute name="size">20</xsl:attribute>
                        <xsl:attribute name="class">esb-edit_disabled</xsl:attribute>
                        <xsl:attribute name="value">
                            <xsl:value-of select="@onReject"/>
                        </xsl:attribute>
                        <xsl:attribute name="DISABLED"/>
                    </xsl:element>
                    <xsl:element name="img">
                            <xsl:attribute name="src">
                                extensions/core/images/registry_picker.gif</xsl:attribute>
                            <xsl:attribute name="title">Registry Browser</xsl:attribute>
                            <xsl:attribute name="onClick">
                                javascript:onrejectkeyfromregistry('<xsl:value-of select="@esb_med_pos"/>');return false;
                            </xsl:attribute>
                            <xsl:attribute name="style">margin-left: 25px;</xsl:attribute>
                        </xsl:element>
                    <br/>
                    <br/>
                </xsl:if>

                <xsl:if test="not(@onReject)">
                    <br/>
                     <label class="sub-small-title">
                                On Rejection
                            </label>
                    <br/>
                    <br/>
                    <label>Specify as :</label>
                    <xsl:element name="input">
                        <xsl:attribute name="onClick">
                            javascript:showinlineonrejectlayout('<xsl:value-of select="@esb_med_pos"/>');
                        </xsl:attribute>
                        <xsl:attribute name="type">radio</xsl:attribute>
                        <xsl:attribute name="name">
                            onrejectgroup
                        </xsl:attribute>
                        <xsl:attribute name="value">onRejectSequence</xsl:attribute>
                        <xsl:attribute name="style">margin-left: 3em;</xsl:attribute>
                        <xsl:attribute name="checked">checked</xsl:attribute>
                    </xsl:element>
                    <label>In-lined Sequence</label>
                    <xsl:element name="input">
                        <xsl:attribute name="onClick">
                            javascript:showrefonrejectlayout('<xsl:value-of select="@esb_med_pos"/>');
                        </xsl:attribute>
                        <xsl:attribute name="type">radio</xsl:attribute>
                        <xsl:attribute name="name">
                            onrejectgroup
                        </xsl:attribute>
                        <xsl:attribute name="value">onRejectSequenceKey</xsl:attribute>
                        <xsl:attribute name="style">margin-left:100px;</xsl:attribute>
                    </xsl:element>
                    <label>Referring Sequence</label>
                    <br/>
                    <xsl:for-each select="syn:onReject">
                        <div id="onrejectlayoutdiv">
                            <xsl:choose>
                                <xsl:when test="count(child::*)!=0">
                                    <div class="indent" style="margin-left:1em;">
                                        <xsl:apply-templates/>
                                    </div>
                                </xsl:when>
                                <xsl:otherwise>
                                    <div class="indent">
                                        <xsl:call-template name="add_mediator_control">
                                            <xsl:with-param name="head_pos">
                                                <xsl:value-of select="concat(@esb_med_pos,'.0')"/>
                                            </xsl:with-param>
                                        </xsl:call-template>
                                    </div>
                                    <br/>
                                </xsl:otherwise>
                            </xsl:choose>
                        </div>
                    </xsl:for-each>
                </xsl:if>
            </div>
        </div>
    </xsl:template>
</xsl:stylesheet>
