<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:include href="commons.xsl"/>

    <xsl:template match="syn:xslt" xmlns:syn="http://ws.apache.org/ns/synapse">
         <div id="ep">
        <label class="content-header">
            <img align="top" src="extensions/core/images/xslt-mediator.gif"/>
            <xsl:text>XSLT Mediator</xsl:text>
        </label>
        <br/>
        <br/>
        <div id="xslt_edit" class="end-point-div">
        <br/>
        <table border="0" style="margin-left: 3em; width: 150px;">
            <tbody>
                <tr>
                    <td>
                        Key<font style='color: red;font-size: 8pt;'>&#160;*</font>
                    </td>
                    <td>
                        <input type="text" class="esb-edit_disabled"
                               size="40"
                               id="xslt_key">
                            <xsl:attribute name="value">
                                <xsl:if test="not(@key)"></xsl:if>
                                <xsl:if test="@key">
                                    <xsl:value-of select="@key"/>
                                </xsl:if>
                            </xsl:attribute>
                            <xsl:attribute name="DISABLED"/>
                        </input>
                    </td>
                    <td>
                        <xsl:element name="img">
                            <xsl:attribute name="src">
                                extensions/core/images/registry_picker.gif</xsl:attribute>
                            <xsl:attribute name="title">Registry Browser</xsl:attribute>
                            <xsl:attribute name="onClick">
                                javascript:xsltkeyfromregistry('<xsl:value-of select="@esb_med_pos"/>');return false;
                            </xsl:attribute>
                        </xsl:element>
                    </td>
                </tr>
                <tr>
                    <td>
                        <xsl:text>Source</xsl:text>
                    </td>
                    <td>
                        <input type="text" class="esb-edit" size="40"
                               id="xslt_source">
                            <xsl:attribute name="value">
                                <xsl:value-of select="@source"/>
                            </xsl:attribute>
                        </input>
                    </td>
                    <td>
                        <a title="Namespace Editor" class="ns_editor">
                            <xsl:attribute name="onclick">
                                javascript:showNameSpaceEditor('<xsl:value-of select="syn:reason/@esb_med_pos"/>','','');
                            </xsl:attribute>
                            <xsl:text>&#160;&#160;&#160;&#160;</xsl:text>
                        </a>
                    </td>
                </tr>
            </tbody>
        </table>
        <xsl:if test="syn:property">
            <p>Properties defined for the XSLT Mediator</p>
            <br/>
            <div id="common_table_content">
            <table border="0" cellpadding="0" cellspacing="0" width="600">
                <tr>
                    <th>Property Name</th>
                    <th>Property Type</th>
                    <th>Value / Expression</th>
                    <th></th>
                </tr>
                <xsl:for-each select="syn:property">
                    <xsl:call-template name="syn-property-edit"/>
                </xsl:for-each>
            </table>
            </div>
        </xsl:if>
       <input type="button" href="#" onclick="javascript: addmediatorproperty(); return false;" style="margin-left: 3em; width:100px;" value="Add Property" class="panelbutton_default"/>
        <br/>
        <br/>
        <xsl:if test="syn:feature">
            <p>Features defined for the XSLT Mediator</p>
            <br/>
            <div id="common_table_content">
            <table border="0" cellpadding="0" cellspacing="0" width="600">
                <tr>
                    <th>Feature Name</th>
                    <th>Feature Value</th>
                    <th></th>
                </tr>
                <xsl:for-each select="syn:feature">
                    <xsl:call-template name="syn-feature-edit"/>
                </xsl:for-each>
            </table>
            </div>
        </xsl:if>
       <input type="button" href="#" onclick="javascript: addmediatorfeature(); return false;" style="margin-left: 3em; width:100px;" value="Add Feature" class="panelbutton_default"/>
        <br/>
        <br/>
        </div>
      </div>
    </xsl:template>

</xsl:stylesheet>