<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:template match="syn:xslt" mode="custom" priority="2"
                  xmlns:syn="http://ws.apache.org/ns/synapse">
        <label class="content-header">
            <img align="top" src="extensions/core/images/xslt-mediator.gif"/>
            <xsl:text>XSLT Mediator</xsl:text>
        </label>
        <br/>
        <xsl:if test="@key">
            <div id="common_table_content">
            <table border="0" cellpadding="0" cellspacing="0">
                <tbody>
                    <tr>
                        <th>Property</th>
                        <th>Value</th>
                    </tr>
                    <tr>
                        <td>
                            <label class="log-attribute-name">
                                Key
                            </label>
                        </td>
                        <td>
                            <label class="log-attribute-value">
                                <xsl:value-of select="@key"/>
                            </label>
                        </td>
                    </tr>
                    <xsl:if test="@source">
                        <tr>
                            <td>
                                <label class="log-attribute-name">
                                    Source
                                </label>
                            </td>
                            <td>
                                <label class="log-attribute-value">
                                    <xsl:value-of select="@source"/>
                                </label>
                            </td>
                        </tr>
                    </xsl:if>
                </tbody>
            </table>
            </div>
             <br/>
        <br/>

        <xsl:if test="syn:property">
            <p>Properties defined for the XSLT Mediator</p>
            <br/>
            <div id="common_table_content">
            <table>
                <tr>
                    <th>Property Name</th>
                    <th>Property Type</th>
                    <th>Value / Expression</th>
                </tr>
                <xsl:for-each select="syn:property">
                    <xsl:call-template name="syn-property-view"/>
                </xsl:for-each>
            </table>
            </div>
        </xsl:if>
        <br/>
        <xsl:if test="syn:feature">
            <p>Features defined for the XSLT Mediator</p>
            <br/>
            <div id="common_table_content">
            <table>
                <tr>
                    <th>Feature Name</th>
                    <th>Feature Value</th>
                </tr>
                <xsl:for-each select="syn:feature">
                    <xsl:call-template name="syn-feature-view"/>
                </xsl:for-each>
            </table>
            </div>
        </xsl:if>
        <br/>
        </xsl:if>
    </xsl:template>
</xsl:stylesheet>