<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:syn="http://ws.apache.org/ns/synapse">

    <xsl:template match="syn:proxy">
        
        <div class="content-header proxy-miscellaneous">Miscellaneous configuration</div>
        <!--<label class="content-description">-->
            <!--<img src="extensions/core/images/miscellaneous-configuration.gif"/>-->
            <!--Configure miscellaneous options for the proxy service.-->
        <!--</label>-->
        
		<table cellpadding="0" cellspacing="0" border="0" class="data-table">
		
        <xsl:choose>
            <xsl:when test="syn:publishWSDL">
                <xsl:choose>
                    <xsl:when test="syn:publishWSDL/@key">
                    	<tr>
        					<td style="width:170px;">Publishing WSDL</td>
                    	<td align="left">
                        <img  src="extensions/core/images/dropdown.gif">
                            <xsl:attribute name="onclick">javascript: displaywsdlmenu(event,'key'); return false;</xsl:attribute>
                        </img>
                        </td>
                        </tr>
                        <tr>
                        <td style="width:160px;" class="indent-small">Reference key</td>
                        <td align="left">
                        <input id="wsdl_ref"  type="text" size="20" class="esb-edit_disabled">
                            <xsl:attribute name="DISABLED"/>
                            <xsl:attribute name="value"><xsl:value-of select="syn:publishWSDL/@key"/></xsl:attribute>
                        </input>
                        <img src="extensions/core/images/registry_picker.gif"
                            title="Registry Browser" onclick="javascript:proxywsdlfromregistry();return false;" style="margin-left: 10px;" align="top"/>
                        </td>
                        </tr>
                    </xsl:when>
                    <xsl:when test="syn:publishWSDL/@uri">
                    	                    	<tr>
        					<td style="width:170px;">Publishing WSDL</td>
                    	<td align="left">
	                        <img src="extensions/core/images/dropdown.gif">
	                            <xsl:attribute name="onclick">javascript: displaywsdlmenu(event,'uri'); return false;</xsl:attribute>
	                        </img>
	                    </td>
	                    </tr>
	                    <tr>
                        <td class="indent-small" style="width:160px;">
                            Source URL
                        </td>
                        <td>
                            <input type="text" id="wsdl_uri" class="esb-edit">
                                <xsl:attribute name="value"><xsl:value-of select="syn:publishWSDL/@uri"/></xsl:attribute>
                            </input>
                        </td>
                        </tr>
                        
                    </xsl:when>
                    <xsl:otherwise>
                                        	<tr>
        					<td style="width:170px;">Publishing WSDL</td>
                    	<td align="left">
                        <img src="extensions/core/images/dropdown.gif">
                            <xsl:attribute name="onclick">javascript: displaywsdlmenu(event,'inline'); return false;</xsl:attribute>
                        </img>
                        </td>
                        </tr>
                        <tr>
                        <td style="width:160px" class="indent-small form-sub-field">
                        	Specified as inline 
                        </td>
                        <td>
                        <img src="extensions/core/images/edit.gif" onclick="javascript: showproxywsdl(); return false;" align="top"/>
                        </td>
                    </tr>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:when>
            <xsl:otherwise>
                                	<tr>
        					<td style="width:170px;">Publishing WSDL</td>
	            	<td>
	                	<img src="extensions/core/images/dropdown.gif">
	                    	<xsl:attribute name="onclick">javascript: displaywsdlmenu(event,''); return false;</xsl:attribute>
	                	</img>
	                </td>
                </tr>
                <tr>
                	<td colspan="2">
               			<div id="wsdl_div" ></div>
               		</td>
               	</tr>
            </xsl:otherwise>
        </xsl:choose>
		</table>
        <xsl:if test="count(self::node()//syn:resource)!=0">
            <div style="margin-left:20px;">Resources</div>
            <div id="common_table_content">
                <table border="0" cellpadding="0" cellspacing="0" style="margin-left:10px;">
                    <thead>
                        <tr>
                            <th>Location</th>
                            <th>Key</th>
                            <th/>
                            <th/>
                        </tr>
                    </thead>
                    <tbody id="wsdl_resources_id">
                        <xsl:call-template name="resource_keys_template">
                            <xsl:with-param name="value">
                                <xsl:value-of
                                        select="count(self::node()//syn:resource)"/>
                            </xsl:with-param>
                            <xsl:with-param name="limit">
                                <xsl:value-of
                                        select="count(self::node()//syn:resource)"/>
                            </xsl:with-param>
                        </xsl:call-template>
                    </tbody>
                </table>
            </div>
        </xsl:if>
        <xsl:if test="(syn:publishWSDL/@uri) or (syn:publishWSDL/@key) or ((syn:publishWSDL) and not(syn:publishWSDL/@uri) and not(syn:publishWSDL/@key))">
            <!--<label class="sub-small-title">Add Reference</label>                    -->
            <xsl:element name="input">
                <xsl:attribute name="type">button</xsl:attribute>
                <xsl:attribute name="class">panelbutton_default</xsl:attribute>
                <xsl:attribute name="href">#</xsl:attribute>
                <xsl:attribute name="style">margin-left: 20px;</xsl:attribute>
                <xsl:attribute name="value">Add Reference</xsl:attribute>
                <xsl:attribute name="onClick">javascript:addresource();return false;
                </xsl:attribute>
            </xsl:element>
        </xsl:if>
        <table cellpadding="0" cellspacing="0" border="0" class="data-table">
	        <tr>
	        <td style="width:170px;height:40px;">Load service on startup</td>
	        <td>
	            <xsl:choose>
	                <xsl:when test="@startOnLoad != 'true'">
	                    <input type="checkbox" id="startOnLoad"/>
	                </xsl:when>
	                <xsl:otherwise>
	                    <input type="checkbox" id="startOnLoad" checked="true"/>
	                </xsl:otherwise>
	            </xsl:choose>
	        </td>
	        </tr>
	    </table>

        <table cellpadding="0" cellspacing="0" border="0" class="data-table">
            <tr>
                <td style="width:170px;margin-left:40px;">Pinned servers (separated by comma or space)</td>
                <td>
                    <input type="text" id="pinnedServers" class="esb-edit">
                        <xsl:attribute name="value">
                            <xsl:value-of select="@pinnedServers"/>
                        </xsl:attribute>
                    </input>
                </td>
            </tr>
	      </table>
    </xsl:template>
    <xsl:template name="resource_keys_template">
        <xsl:param name="value"/>
        <xsl:param name="limit"/>
        <xsl:if test="$value != 0">
            <xsl:call-template name="resource_key_template">
                <xsl:with-param name="index" select="($limit +1) - $value"/>
            </xsl:call-template>
            <xsl:call-template name="resource_keys_template">
                <xsl:with-param name="value" select="$value - 1"/>
                <xsl:with-param name="limit" select="$limit"/>
            </xsl:call-template>
        </xsl:if>
    </xsl:template>
    <xsl:template name="resource_key_template" xmlns:syn="http://ws.apache.org/ns/synapse">
        <xsl:param name="index"/>
        <tr>
            <td>
                <input type="text" class="esb-edit" size="40"
                       id="location">
                    <xsl:attribute name="value">
                        <xsl:value-of select="self::node()//syn:resource[$index]/@location"/>
                    </xsl:attribute>
                </input>
            </td>
            <td>
                <input type="text" size="40" name="resource_key"
                       class="esb-edit_disabled">
                    <xsl:attribute name="id">
                        <xsl:value-of select="concat('resource_key',$index)"/>
                    </xsl:attribute>
                    <xsl:attribute name="value">
                        <xsl:value-of select="self::node()//syn:resource[$index]/@key"/>
                    </xsl:attribute>
                    <xsl:attribute name="DISABLED"/>
                </input>
            </td>
            <td>
                <xsl:element name="img">
                    <xsl:attribute name="style">margin-left: 3em;</xsl:attribute>
                    <xsl:attribute name="src">
                        extensions/core/images/registry_picker.gif
                    </xsl:attribute>
                    <xsl:attribute name="title">Registry
                        Browser
                    </xsl:attribute>
                    <xsl:attribute name="onClick">
                        javascript:resourcekeyfromregistry('<xsl:value-of select="$index"/>');return false;
                    </xsl:attribute>
                </xsl:element>
            </td>
            <td>
                <a href='#' id='delete_link'>
                    <xsl:attribute name="onclick">
                        javascript:deleteresource('<xsl:value-of select="$index"/>');return false;
                    </xsl:attribute>
                    &#160;&#160;&#160;&#160;
                </a>
            </td>
        </tr>
    </xsl:template>

</xsl:stylesheet>