<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:syn="http://ws.apache.org/ns/synapse">

    <xsl:template match="syn:proxy">
        <div class="content-header proxy-miscellaneous">
            Miscellaneous configuration
        </div>
        <!--<label class="content-description">-->
            <!--Configure miscellaneous options for the proxy service.-->
        <!--</label>-->

        <xsl:if test="syn:publishWSDL">
        	<table cellpadding="0" cellspacing="0" border="0" class="data-table">
        	<tr>
            <td class="sub-small-title" colspan="2">Publishing WSDL</td>
            </tr>
            <xsl:choose>
                    <xsl:when test="syn:publishWSDL/@key">
                    <tr>
                        <td class="indent-small" style="width:150px;">
                        	Reference key
                        </td>
                        <td id="wsdl_div" >
                            <xsl:value-of select="syn:publishWSDL/@key"/>
                        </td>
                    </tr>
                    </xsl:when>
                    <xsl:when test="syn:publishWSDL/@uri">
                    <tr>
                        <td class="indent-small">
                            Source URL
                        </td>
                        <td id="wsdl_div">
                                <xsl:value-of select="syn:publishWSDL/@uri"/>
                        </td>
                    </tr>
                    </xsl:when>
                    <xsl:otherwise>
                        <tr>
            				<td class="sub-small-title" colspan="2">Specified as inline</td>
            			</tr>
                    </xsl:otherwise>
            </xsl:choose>
            </table>
            <br/>
            <xsl:if test="count(self::node()//syn:resource)!=0">
                <div style="margin-left:20px;">Resources</div>
                <div id="common_table_content">
                    <table  style="margin-left:10px;">
                        <tr>
                            <th>Location</th>
                            <th>Key</th>
                        </tr>
                        <xsl:call-template name="resources_view_template">
                            <xsl:with-param name="value">
                                <xsl:value-of
                                        select="count(self::node()//syn:resource)"/>
                            </xsl:with-param>
                            <xsl:with-param name="limit">
                                <xsl:value-of
                                        select="count(self::node()//syn:resource)"/>
                            </xsl:with-param>
                        </xsl:call-template>
                    </table>
                </div>
            </xsl:if>
        </xsl:if>
        <table cellpadding="0" cellspacing="0" border="0" class="data-table">
        <tr>
        <td style="width:170px;margin-left:20px;">Load service on startup</td>
        <td>
            <xsl:choose>
                <xsl:when test="@startOnLoad != 'true'">
                    <img src="extensions/core/images/disabled_icon.png" style="margin-right:10px;" align="absmiddle"/><xsl:text>Disabled</xsl:text>
                </xsl:when>
                <xsl:otherwise>
                    <img src="extensions/core/images/enabled_icon.png" style="margin-right:10px;" align="absmiddle"/><xsl:text>Enabled</xsl:text>
                </xsl:otherwise>
            </xsl:choose>
        </td>
        </tr>
        </table>


        <table cellpadding="0" cellspacing="0" border="0" class="data-table">
            <tr>
                <td style="width:170px;margin-left:20px;">Pinned servers (separated by comma or space)</td>
                <td>
                    <input type="text" id="pinnedServers">
                            	<xsl:attribute name="type">text</xsl:attribute>
                            	<xsl:attribute name="disabled">true</xsl:attribute>
                        <xsl:attribute name="value">
                            <xsl:value-of select="@pinnedServers"/>
                        </xsl:attribute>
                    </input>
                </td>
            </tr>
	      </table>
    </xsl:template>
    <xsl:template name="resources_view_template">
        <xsl:param name="value"/>
        <xsl:param name="limit"/>
        <xsl:if test="$value != 0">
            <xsl:call-template name="resource_view_template">
                <xsl:with-param name="index" select="($limit +1) - $value"/>
            </xsl:call-template>
            <xsl:call-template name="resources_view_template">
                <xsl:with-param name="value" select="$value - 1"/>
                <xsl:with-param name="limit" select="$limit"/>
            </xsl:call-template>
        </xsl:if>
    </xsl:template>
    <xsl:template name="resource_view_template" xmlns:syn="http://ws.apache.org/ns/synapse">
        <xsl:param name="index"/>
        <xsl:if test="(self::node()//syn:resource[$index]/@location) and (self::node()//syn:resource[$index]/@key)">
        <tr>
            <td>
                <xsl:value-of select="self::node()//syn:resource[$index]/@location"/>
            </td>
            <td>
                <xsl:value-of select="self::node()//syn:resource[$index]/@key"/>
            </td>
        </tr>
        </xsl:if>
    </xsl:template>

</xsl:stylesheet>