<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:syn="http://ws.apache.org/ns/synapse">

    <xsl:template match="syn:proxy">
        
        <div class="content-header proxy-qos">QOS configuration</div>
        <!--<label class="content-description">-->
            <!--Select the QOS aspects for this proxy service. You may enable or disable WS-Security and WS-Reliable Messaging-->
            <!--and specify appropriate service level WS-Policies to define the behaviour.-->
        <!--</label>-->
        
        <table cellpadding="0" cellspacing="0" border="0" class="data-table">
            <tbody>
                <tr>
                    <td align="left" style="width:170px;">WS-Security</td>
                    <td align="left">
                        <xsl:call-template name="qos_checkbox">
                            <xsl:with-param name="type">enableSec</xsl:with-param>
                            <xsl:with-param name="status" select="child::syn:enableSec"/>
                        </xsl:call-template>
                    </td>
                </tr>
                <tr>
                    <td align="left">WS-Reliable Messaging</td>
                    <td align="left">
                        <xsl:call-template name="qos_checkbox">
                            <xsl:with-param name="type">enableRM</xsl:with-param>
                            <xsl:with-param name="status" select="child::syn:enableRM"/>
                        </xsl:call-template>
                    </td>
                </tr>
            </tbody>
        </table>

        
        <xsl:if test="child::syn:policy">
		<div class="sub-small-title">Service Policies</div>
            <div id="common_table_content">
            <table border="0" cellpadding="0" cellspacing="0">
                <thead><tr><th>Policy reference</th><th>Actions</th></tr></thead>
                <tbody>
                    <xsl:for-each select="syn:policy">
                        <tr>
                            <td><xsl:value-of select="@key"/></td>
                            <td><a href='#' id='delete_link'>
                                <xsl:attribute name="onclick">
                                    javascript:removepolicy('<xsl:value-of select="@key"/>');return false;
                                </xsl:attribute>&#160;&#160;&#160;&#160;</a>
                            </td>
                        </tr>
                    </xsl:for-each>
                </tbody>
            </table>
            </div>
        </xsl:if>
        <fieldset class="field-group" style="padding-left:5px;width:600px;z-index: 1;">
        	<legend><div class="sub-small-title">Add New Service Policy</div></legend>
		<table cellpadding="0" cellspacing="0" border="0" class="data-table">
			<tr>
				<td style="width:170px;">Policy reference</td>
				<td>
        		<input id="policy_ref" type="text" size="20" class="esb-edit_disabled" style="margin-top:3px;" >
            		<xsl:attribute name="DISABLED"/>
        		</input>
        		<img src="extensions/core/images/registry_picker.gif" style="margin-left:10px;"
             			title="Registry Browser" onclick="javascript:proxypolicyfromregistry();return false;" align="top"/>
             			
             	<input type="button" class="panelbutton_default" onclick="javascript: setpolicy(); return false" value="Add" style="margin-left:10px;"/>
             	</td>
            
        	</tr>
        </table>
        
        
        </fieldset>
		
        <!--<div id="proxypolicydiv">-->
            <!--<input type="button" class='panelbutton_default' onclick="javascript: addpolicyview(); return false;" value="Add"/><br/>-->
        <!--</div>-->
    </xsl:template>

    <xsl:template name="qos_checkbox">
        <xsl:param name="type"/>
        <xsl:param name="status"/>
        
        <xsl:choose>
            <xsl:when test="$status">
                <input type="checkbox" checked="true">
                    <xsl:attribute name="id">
                        <xsl:value-of select="$type"/>
                    </xsl:attribute>
                </input>
            </xsl:when>
            <xsl:otherwise>
                <input type="checkbox">
                    <xsl:attribute name="id">
                        <xsl:value-of select="$type"/>
                    </xsl:attribute>
                </input>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>

</xsl:stylesheet>