<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:syn="http://ws.apache.org/ns/synapse">

    <xsl:template match="syn:proxy">
        <div class="content-header proxy-qos">
            QOS configuration
        </div>
        <!--<label class="content-description">-->
            <!--Select the QOS aspects for this proxy service. You may enable or disable WS-Security and WS-Reliable Messaging-->
            <!--and specify appropriate service level WS-Policies to define the behaviour.-->
        <!--</label>-->
        
        <table cellpadding="0" cellspacing="0" border="0" class="data-table">
            <tbody>
                <tr>
                    <td style="width:170px;" align="left">WS-Security</td>
                    <td align="left">
                        <xsl:if test="child::syn:enableSec"><img src="extensions/core/images/enabled_icon.png" style="margin-right:10px;" align="absmiddle"/>Enabled</xsl:if>
                        <xsl:if test="not(child::syn:enableSec)"><img src="extensions/core/images/disabled_icon.png" style="margin-right:10px;" align="absmiddle"/>Disabled</xsl:if>
                    </td>
                </tr>
                <tr>
                    <td align="left">WS-Reliable Messaging</td>
                    <td align="left">
                        <xsl:if test="child::syn:enableRM"><img src="extensions/core/images/enabled_icon.png" style="margin-right:10px;" align="absmiddle"/>Enabled</xsl:if>
                        <xsl:if test="not(child::syn:enableRM)"><img src="extensions/core/images/disabled_icon.png" style="margin-right:10px;" align="absmiddle"/>Disabled</xsl:if>
                    </td>
                </tr>
            </tbody>
        </table>
        <xsl:if test="child::syn:policy">
            <div class="sub-small-title">Service Policies</div>
            <xsl:for-each select="syn:policy">
                <label style="margin-left: 10px;"><xsl:value-of select="@key"/></label><br/>
            </xsl:for-each>
        </xsl:if>
    </xsl:template>

</xsl:stylesheet>