<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="html"/>

    <xsl:template match="*">
    	<div class="breadcrumb"> <a title="WSO2 ESB Home" onclick="javascript:showHome(); return false;" href="#">Home</a>&#160;&gt;&#160; Statistics</div>
        <div class="page-main-title title-statistics">ESB System Statistics
            <img src="extensions/core/images/help.gif" alt=""
                  onmouseover="showHelp(event,'statisticsHelpDiv')"
                  onmouseout="hideHelp(event,'statisticsHelpDiv')"/>
         </div><div id="statisticsHelpDiv" style="z-index:600"></div>
        <br/>        
        <div id="container1">
            <div id="boxone1">
                <h4>
                    <xsl:element name="a">
                        <xsl:attribute name="href">#</xsl:attribute>
                        <xsl:attribute name="onClick">javascript:listServers(); return false;
                        </xsl:attribute>
                        <xsl:text>Server Statistics Summary</xsl:text>
                    </xsl:element>
                </h4>
                <iframe>
                        <xsl:attribute name="id">divServerGraph</xsl:attribute>
                        <xsl:attribute name="frameborder">0</xsl:attribute>
                        <xsl:attribute name="scrolling">no</xsl:attribute>
                </iframe>
            </div>
            <div id="boxtwo1">
                <h4>
                    <xsl:element name="a">
                        <xsl:attribute name="href">#</xsl:attribute>
                        <xsl:attribute name="onClick">javascript:listProxyServices();return false;
                        </xsl:attribute>
                        <xsl:text>Proxy Services Statistics Summary</xsl:text>
                    </xsl:element>
                </h4>
                 <iframe>
                        <xsl:attribute name="id">divProxyServiceGraph</xsl:attribute>
                        <xsl:attribute name="frameborder">0</xsl:attribute>
                        <xsl:attribute name="scrolling">no</xsl:attribute>
                </iframe>
            </div>
            <div id="boxthree1">
                <h4>
                    <xsl:element name="a">
                        <xsl:attribute name="href">#</xsl:attribute>
                        <xsl:attribute name="onClick">javascript:listEndPoint(); return false;
                        </xsl:attribute>
                        <xsl:text>Endpoints Statistics Summary</xsl:text>
                    </xsl:element>
                    <iframe>
                        <xsl:attribute name="id">divEndPointsGraph</xsl:attribute>
                        <xsl:attribute name="frameborder">0</xsl:attribute>
                        <xsl:attribute name="scrolling">no</xsl:attribute>
                   </iframe>
                </h4>
            </div>
            <div id="boxfour1">
                <h4>
                    <xsl:element name="a">
                        <xsl:attribute name="href">#</xsl:attribute>
                        <xsl:attribute name="onClick">javascript:listSequence(); return false;
                        </xsl:attribute>
                        <xsl:text>Sequences Statistics Summary</xsl:text>
                    </xsl:element>
                    <iframe>
                        <xsl:attribute name="id">divSequencesGraph</xsl:attribute>
                        <xsl:attribute name="frameborder">0</xsl:attribute>
                        <xsl:attribute name="scrolling">no</xsl:attribute>
                    </iframe>
                </h4>
            </div>
        </div>
        <div class="clearLog" style="margin-top: 430px; position: absolute;_position: absolute;_margin-left: 0px;_margin-top: 455px;">
            <input name="clearLogs" type="button"
                   class="panelbutton_default"
                   value="Clear All"
                   onclick="javascript:clearAllStatistics();return false;"/>
        </div>
    </xsl:template>
</xsl:stylesheet>
