<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="html"/>
    <xsl:template match="*">
		<div class="breadcrumb"></div>
        <div class="page-main-title title-home">WSO2 Enterprise Service Bus (ESB) - Home</div>
        <div id="formset">
            <h3 class="static_table_headding"> Server Information
                <img src="extensions/core/images/help.gif" alt=""
                     onmouseover="showHelp(event,'serverInfoHelpDiv')"
                     onmouseout="hideHelp(event,'serverInfoHelpDiv')"/>
            </h3><div id="serverInfoHelpDiv" style="z-index:600"></div>
            <table cellpadding="0" cellspacing="0" border="0" class="table-data-01">
                <xsl:for-each select="return">
                    <tr>
                        <th>
                            Server Name
                        </th>
                        <td>
                            <xsl:value-of select="serverName"/>
                        </td>
                    </tr>
                    <tr>
                        <th>
                            Server Start Time
                        </th>
                        <td>
                            <xsl:value-of select="serverStartTime"/>
                        </td>
                    </tr>
                    <tr>
                        <th>
                            System Up Time
                        </th>
                        <td>
                            <xsl:value-of select="systemUpTime"/>
                        </td>
                    </tr>
                    <tr>
                        <th>
                            Free Memory (JVM)
                        </th>
                        <td>
                            <xsl:value-of select="freeMemory"/>
                        </td>
                    </tr>
                    <tr>
                        <th>
                            Total Memory (JVM)
                        </th>
                        <td>
                            <xsl:value-of select="totalMemory"/>
                        </td>
                    </tr>
                </xsl:for-each>
            </table>
        </div>
        <div id="homeText" style="text-align:justify;padding-right:10px;">
        <p>The WSO2 ESB is an ultra fast, light-weight and versatile Enterprise Service Bus
        based on the <a target="_blank" href="http://synapse.apache.org/">Apache Synapse ESB</a>.
        It allows you to Connect, Manage and Transform
        service interactions between Web services, REST/POX services and Legacy systems.
        Refer the <a target="_blank" href="/docs/ESB_QuickStart.html">Quick Start Guide</a> for more information on getting started.
				
				</p>
				<div class="home-submain">The management console allows you to define:</div>
				<a class="tittle-proxy-services" href="#" onclick="javascript:showproxyservices(); return false;">Proxy Services</a>
				<p>
				Proxy services define endpoints/services exposed on the ESB that are able to accept requests, mediate them and deliver them to the remote services or endpoints. 
				</p>
				<a class="tittle-tasks" href="#" onclick="javascript:showtasks(); return false;">Scheduled Tasks</a>
				<p>
				The built-in Quartz scheduler lets administrators schedule tasks to run at specified intervals. Tasks may be used to initiate long-running tasks, automate recurring processes and facilitate reporting etc.
				</p>
				<a class="tittle-endpoint" href="#" onclick="javascript:showEndpoints(); return false;">Endpoints</a>
				<p>These specify a destination for messages. This can be a URL-based address, an existing WSDL document, or a collection of load-balanced and/or failover endpoints.
                </p>
				<a class="tittle-sequences" href="#" onclick="javascript:showsequences(); return false;">Sequences</a>
				<p>Sequences are named, re-usable lists of actions, which can be executed in-order on a message. A sequence may branch into another sequence, and/or specify another sequence as its error handler.</p>
				<a class="tittle-registries" href="#" onclick="javascript:showEntries(); return false;">Registries</a>
				<p>Registries are used to store and define resources and configuration elements including XMLs, WSDLs, Scripts, Policies etc. 
				The  <a href="#" onclick="javascript:showEntries(); return false;">Local Registry</a> is a simple list of items embedded within the configuration, while the <a href="#" onclick="javascript:showESBRegistry(); return false;">Integrated Registry</a> is a more powerful
				 implementation that allows resources to be stored and retrieved dynamically from an integrated repository.</p>
				<br/><br/>
				<p>
				The WSO2 ESB console also offers a simple way to view <a href="#" onclick="javascript:manageSystem(); return false;" title="View system information">system information</a> and <a href="#" onclick="javascript:showStatistics(); return false;" title="View system statistics">statistics</a>, as well as viewing <a href="#" onclick="javascript:viewLogs(); return false;" title="View system logs">system logs</a> and <a href="#" onclick="javascript:viewTraceLogs(); return false;" title="View trace logs">traces</a>.
				</p>
        </div>
        
    </xsl:template>
</xsl:stylesheet>
