<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:variable name="supports-namespace-axis" select="count(/*/namespace::*) &gt; 0"/>

    <xsl:template match="syn:task" xmlns:syn="http://ws.apache.org/ns/synapse">

        <div id="task_edit_div">

            <div class='page-main-title title-task'>
                <xsl:choose><xsl:when test="not(@name='')"> Task <xsl:value-of
                select="@name"/></xsl:when><xsl:otherwise> New Task </xsl:otherwise></xsl:choose>
            </div>
            
            <table border="0" cellpadding="0" cellspacing="0" class="data-table">
            <tbody>

                <tr>
                    <td style="width: 150px;">Task name </td>
                    <td align="left">
                        <input type="text" id="task_name" class="esb-edit">
                            <xsl:if test="not(@name='')">
                                <xsl:attribute name="value"><xsl:value-of select="@name"/></xsl:attribute>
                                <xsl:attribute name="disabled">true</xsl:attribute>
                            </xsl:if>
                        </input>
                    </td>
                </tr>

                <tr>
                    <td>Task implementation </td>
                    <td align="left">
                        <input type="text" id="task_class" class="esb-edit">
                            <xsl:attribute name="value"><xsl:value-of select="@class"/></xsl:attribute>
                        </input>
                    
                        <xsl:if test="not(syn:property)">
                            <input type="button" href="#" onclick="javascript: loadtaskclass(); return false;" style="width:100px;margin-left:10px;" value="Load Class" class="panelbutton_default"/>
                        </xsl:if>
                        <xsl:if test="syn:property">
                            <input type="button" href="#" onclick="javascript: loadtaskclass(); return false;" style="width:100px; margin-left:10px;" value="Reload Class" class="panelbutton_default"/>
                        </xsl:if>
                    </td>
                </tr>

            </tbody>
        </table>
        <div>
            <xsl:if test="syn:property">
                <div class="sub-small-title">Properties defined for the Task </div>
                
                <div id="common_table_content">
                    <table border="0" cellpadding="0" cellspacing="0" width="600">
                        <tr>
                            <th>Property Name</th>
                            <th>Property Type</th>
                            <th>Property Value</th>
                            <th></th>
                        </tr>
                        <xsl:for-each select="syn:property">
                            <tr>
                                <xsl:attribute name="name">syn-task-property</xsl:attribute>
                                <td align="left">
                                    <input type="text" name="property_name" class="esb-edit small_textbox" disabled="true">
                                        <xsl:attribute name="value">
                                            <xsl:value-of select="concat(translate(substring(@name,1,1),
                                    'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ'),
                                    substring(@name,2,string-length(@name)))"/>
                                        </xsl:attribute>
                                    </input>
                                </td>

                                <!--<xsl:if test="@value">-->
                                    <td align="left">
                                        <select class="esb-edit small_textbox">
                                            <xsl:attribute name="id"><xsl:value-of select="concat('propertyType',@esb_med_pos)"/></xsl:attribute>
                                            <xsl:attribute name="name"><xsl:value-of select="concat('prop_type_', @name)"/></xsl:attribute>
                                            <xsl:attribute name="onchange">
                                                javascript:updatetaskprop('<xsl:value-of select="concat('task_prop', @name)"/>');
                                            </xsl:attribute>                                            
                                            <!--<xsl:attribute name="onchange">-->
                                                <!--javascript:showNamespaceButtonForTaskProperties('<xsl:value-of select="@esb_med_pos"/>','propertyType','namespaceCell');;-->
                                            <!--</xsl:attribute>-->
                                            <option value="value">
                                                <xsl:if test="@value">
                                                    <xsl:attribute name="selected">true</xsl:attribute>
                                                </xsl:if>
                                            Literal</option>
                                            <option value="xml">
                                                <xsl:if test="not(@value)">
                                                    <xsl:attribute name="selected">true</xsl:attribute>
                                                </xsl:if>
                                            XML</option>
                                        </select>
                                    </td>
                                    <td>
                                    
                                    <xsl:if test="@value">
                                        <input type="textarea" class="esb-edit">
                                            <xsl:attribute name="id">
                                                <xsl:value-of select="concat('task_prop', @name)"/>
                                            </xsl:attribute>
                                            <xsl:attribute name="value"><xsl:value-of select="@value"/></xsl:attribute>
                                        </input>
                                    </xsl:if>

                                    <xsl:if test="not(@value)">
                                        <input type="text" class="esb-edit small_textarea">
                                            <xsl:attribute name="id">
                                                <xsl:value-of select="concat('task_prop', @name)"/>
                                            </xsl:attribute>
                                            <xsl:attribute name="value"><xsl:value-of select="."/></xsl:attribute>
                                        </input>
                                    </xsl:if>
                                    
                                    </td>
                                    <td>
                                        <xsl:attribute name="id"><xsl:value-of select="concat('namespaceCell',@esb_med_pos)"/></xsl:attribute>
                                    </td>
                                <!--</xsl:if>-->

                                <!--<xsl:if test="@expression">-->
                                    <!--<td id="property_value">-->
                                        <!--<select class="esb-edit small_textbox" disabled="true">-->
                                            <!--<xsl:attribute name="id"><xsl:value-of select="concat('propertyType',@esb_med_pos)"/></xsl:attribute>-->
                                            <!--<xsl:attribute name="name"><xsl:value-of select="concat('prop_type_', @name)"/></xsl:attribute>-->
                                            <!--<xsl:attribute name="onchange">-->
                                                <!--javascript:showNamespaceButtonForTaskProperties('<xsl:value-of select="@esb_med_pos"/>','propertyType','namespaceCell');;-->
                                            <!--</xsl:attribute>-->
                                            <!--<option value="value">Value</option>-->
                                            <!--<option value="expression" selected="true">Expression</option>-->
                                        <!--</select>-->
                                    <!--</td>-->
                                    <!--<td>-->
                                        <!--<input type="text" class="esb-edit small_textbox">-->
                                            <!--<xsl:attribute name="id">-->
                                                <!--<xsl:value-of select="concat('task_prop', @name)"/>-->
                                            <!--</xsl:attribute>-->
                                            <!--<xsl:attribute name="value"><xsl:value-of select="@expression"/></xsl:attribute>-->
                                        <!--</input>-->
                                    <!--</td>-->
                                    <!--<td>-->
                                        <!--<xsl:attribute name="id"><xsl:value-of select="concat('namespaceCell',@esb_med_pos)"/></xsl:attribute>-->
                                        <!--<a title="Namespace Editor" class="ns_editor">-->
                                            <!--<xsl:attribute name="onclick">-->
                                                <!--javascript:showTaskNameSpaceEditor('<xsl:value-of select="@esb_med_pos"/>','','');-->
                                            <!--</xsl:attribute>-->
                                            <!--<xsl:text>&#160;&#160;&#160;&#160;</xsl:text>-->
                                        <!--</a>-->
                                    <!--</td>-->
                                <!--</xsl:if>-->

                                <td><a href="#" id="delete_link">
                                    <xsl:attribute name="onclick">javascript: removetaskprop('<xsl:value-of select="concat('task_prop', @name)"/>'); return false;</xsl:attribute>&#160;&#160;&#160;&#160;</a></td>
                            </tr>
                        </xsl:for-each>
                    </table>
                </div>
            </xsl:if>
            <xsl:if test="not(syn:property)">
                <p style="color: brown">There are no properties defined for the task</p>
            </xsl:if>
        </div>
        <div>
            <div class="sub-small-title" style="line-height:40px;">Trigger information of the Task </div>
           
            <div>
                <table border="0" cellpadding="0" cellspacing="0" class="data-table" style="width:500px;">
                    <tr>
                        <td style="width:150px;">Trigger Type</td>
                        <td align="left" style="width:100px;"><input type="radio" name="task_trigger" value="simple" onclick="javascript: settrigger('simple'); return false;">
                            <xsl:if test="not(syn:trigger/@cron)">
                                <xsl:attribute name="checked">true</xsl:attribute>
                            </xsl:if>
                        </input> Simple</td>
                        <td align="left"><input type="radio" name="task_trigger" value="cron" onclick="javascript: settrigger('cron'); return false;">
                            <xsl:if test="syn:trigger/@cron">
                                <xsl:attribute name="checked">true</xsl:attribute>
                            </xsl:if>    
                        </input> Cron</td>
                    </tr>
                </table>
                <table border="0" cellpadding="0" cellspacing="0" class="data-table">
                    <xsl:if test="not(syn:trigger/@cron)">
                        <tr>
                            <td style="width:150px;">Count</td>
                            <td align="left">
                                <input type="text" class="esb-edit" id="trigger_count">
                                    <xsl:attribute name="value">
                                        <xsl:value-of select="syn:trigger/@count"/>
                                    </xsl:attribute>
                                </input>
                            </td>
                        </tr>
                        <tr>
                            <td>Interval</td>
                            <td align="left">
                                <input type="text" class="esb-edit" id="trigger_interval">
                                    <xsl:attribute name="value">
                                        <xsl:value-of select="syn:trigger/@interval"/>
                                    </xsl:attribute>
                                </input>
                            </td>
                        </tr>
                    </xsl:if>
                    <xsl:if test="syn:trigger/@cron">
                        <tr>
                            <td>Expression</td>
                            <td align="left">
                                <input type="text" class="esb-edit" id="trigger_cron">
                                    <xsl:attribute name="value">
                                        <xsl:value-of select="syn:trigger/@cron"/>
                                    </xsl:attribute>
                                </input>
                            </td>
                        </tr>
                    </xsl:if>
                </table>
            </div>
        </div>

        <div>
            <div class="sub-small-title" style="line-height:40px;">Miscellaneous Information</div>

            <div>
                <table border="0" cellpadding="0" cellspacing="0" class="data-table">
                    <tr>
                        <td style="width:150px;">Pinned servers (separated by comma or space)</td>
                        <td align="left">
                            <input type="text" class="esb-edit" id="pinnedServers">
                                <xsl:attribute name="value">
                                    <xsl:value-of select="@pinnedServers"/>
                                </xsl:attribute>
                            </input>
                        </td>
                    </tr>
                </table>
            </div>
        </div>

        </div>
        
    </xsl:template>

    <xsl:template name="print-xml2">
        <xsl:call-template name="element-start2"/>
        <xsl:apply-templates mode="text"/>
        <xsl:call-template name="element-end2"/>
    </xsl:template>

    <xsl:template match="*" mode="text">
        <xsl:call-template name="print-xml2"/>
    </xsl:template>

    <xsl:template name="element-start2">
        <xsl:text>&lt;</xsl:text>
        <xsl:value-of select="name(.)"/>
        <xsl:apply-templates select="@*"/>
        <!--<xsl:call-template name="namespaces2"/>-->
        <xsl:if test="not(node())">
            <xsl:text>/</xsl:text>
        </xsl:if>
        <xsl:text>&gt;</xsl:text>
    </xsl:template>

    <xsl:template name="element-end2">
        <xsl:if test="node()">
            <xsl:text>&lt;/</xsl:text>
            <xsl:value-of select="name(.)"/>
            <xsl:text>&gt;</xsl:text>
        </xsl:if>
    </xsl:template>

    <xsl:template match="@*">
        <xsl:if test="local-name(.)!='esb_med_pos'">
            <xsl:call-template name="attribute2"/>
        </xsl:if>
    </xsl:template>

    <xsl:template name="attribute2">
        <xsl:text> </xsl:text>
            <xsl:value-of select="name(.)"/>
            <xsl:text>="</xsl:text>
                    <xsl:value-of select="."/>
            <xsl:text>"</xsl:text>
    </xsl:template>

    <xsl:template name="namespaces2">
        <xsl:variable name="current" select="current()"/>

        <!-- Unfortunately Mozilla doesn't support the namespace axis, need to check for that and simulate declarations -->
        <xsl:choose>
            <xsl:when test="$supports-namespace-axis">
                <!---->
                        <!--When the namespace axis is present (e.g. Internet Explorer), we can simulate-->
                        <!--the namespace declarations by comparing the namespaces in scope on this element-->
                        <!--with those in scope on the parent element.  Any difference must have been the-->
                        <!--result of a namespace declaration.  Note that this doesn't reflect the actual-->
                        <!--source - it will strip out redundant namespace declarations. -->

                <xsl:for-each select="namespace::*[. != 'http://www.w3.org/XML/1998/namespace']">
                    <xsl:if test="not($current/parent::*[namespace::*[. = current()]])">
                            <xsl:text> xmlns</xsl:text>
                            <xsl:if test="name() != ''">:</xsl:if>
                            <xsl:value-of select="name()"/>
                            <xsl:text>="</xsl:text>
                            <xsl:value-of select="."/>
                            <xsl:text>"</xsl:text>
                    </xsl:if>
                </xsl:for-each>
            </xsl:when>
            <xsl:otherwise>
                <!---->
                        <!--When the namespace axis isn't supported (e.g. Mozilla), we can simulate-->
                        <!--appropriate declarations from namespace elements.-->
                        <!--This currently doesn't check for namespaces on attributes.-->
                        <!--In the general case we can't reliably detect the use of QNames in content, but-->
                        <!--in the case of schema, we know which content could contain a QName and look-->
                        <!--there too.  This mechanism is rather unpleasant though, since it records-->
                        <!--namespaces where they are used rather than showing where they are declared-->
                        <!--(on some parent element) in the source.  Yukk!  -->

                <xsl:if test="namespace-uri(.) != namespace-uri(parent::*)">
                        <xsl:text> xmlns</xsl:text>
                        <xsl:if test="substring-before(name(),':') != ''">:</xsl:if>
                        <xsl:value-of select="substring-before(name(),':')"/>
                        <xsl:text>="</xsl:text>
                        <xsl:value-of select="namespace-uri(.)"/>
                        <xsl:text>"</xsl:text>
                </xsl:if>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>

</xsl:stylesheet>