<!--
  ~  Copyright (c) 2005-2008, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
  ~
  ~  WSO2 Inc. licenses this file to you under the Apache License,
  ~  Version 2.0 (the "License"); you may not use this file except
  ~  in compliance with the License.
  ~  You may obtain a copy of the License at
  ~
  ~    http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~  Unless required by applicable law or agreed to in writing,
  ~  software distributed under the License is distributed on an
  ~  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
  ~  KIND, either express or implied.  See the License for the
  ~  specific language governing permissions and limitations
  ~  under the License.
  ~
  -->

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="html"/>
    <xsl:template match="*">
        <div id='formset'>
        	<div class="breadcrumb"> <a title="WSO2 ESB Home" onclick="javascript:showHome(); return false;" href="#">Home</a>&#160;&gt;&#160; Trace Logs</div>
            <div class="title-tracemessages page-main-title"> Trace Logs
            <img src="extensions/core/images/help.gif" alt=""
                 onmouseover="showHelp(event,'traceHelpDiv')"
                 onmouseout="hideHelp(event,'traceHelpDiv')"/>
            </div><div id="traceHelpDiv" style="z-index:600"></div>
            <form>
                <fieldset style="border:none; margin-left:-25px;">
                    <xsl:choose>
                       <xsl:when test="count(//return)!=0">
                       <div id="logtoolbar" style="overflow:hidden;">
                                        <table border="0" style="width:98%;">
                                            <tbody>
                                                <tr>
                                                    <td align="right" style="text-align: right;width:410px;">
                                                        <xsl:text>Ignore Case</xsl:text>
                                                   
                                                        <xsl:element name="input">
                                                            <xsl:attribute name="type">checkbox</xsl:attribute>
                                                            <xsl:attribute name="id">ignore_case</xsl:attribute>
                                                            <xsl:attribute name="style">margin-left:5px;</xsl:attribute>
                                                            <xsl:if test="@ignoreCase='true'">
                                                                <xsl:attribute name="checked">checked</xsl:attribute>
                                                            </xsl:if>
                                                        </xsl:element>
                                                    </td>
                                                    <td align="right" style="text-align:right;">
                                                        <xsl:element name="input">
                                                            <xsl:attribute name="id">tracekeyword</xsl:attribute>
                                                            <xsl:attribute name="type">text</xsl:attribute>
                                                            <xsl:attribute name="class">log-select</xsl:attribute>
                                                            <xsl:attribute name="style">margin-right:5px;width:200px;</xsl:attribute>
                                                            <xsl:attribute name="value">
                                                                <xsl:value-of select="@keyword"/>
                                                            </xsl:attribute>
                                                            <xsl:attribute name="onKeyPress">submitentertrace(event)</xsl:attribute>
                                                        </xsl:element>
                                                    
                                                        <a href="#" id="search_link">
                                                            <xsl:attribute name="onClick">javascript:searchTrace(); return false;</xsl:attribute>
                                                            <xsl:attribute name="title">Search Log</xsl:attribute>
                                                            <xsl:attribute name="alt">Search Log </xsl:attribute>
                                                            &#160;&#160;&#160;&#160;
                                                        </a>
                                                    </td>
                                                </tr>
                                            </tbody>
                                        </table>
                                    </div>
                            <div id="tracelogdiv" class="trace">
                                <table class="log">
                                    <tbody>
                                        <xsl:call-template name="print-row">
                                            <xsl:with-param name="value">
                                                <xsl:value-of select="count(//return)"/>
                                            </xsl:with-param>
                                            <xsl:with-param name="limit">
                                                <xsl:value-of select="count(//return)"/>
                                            </xsl:with-param>
                                        </xsl:call-template>
                                    </tbody>
                                </table>
                            </div>
                            <div class="clearLog">
                                <input name="clearTraceLogs" type="button"
                                       class="panelbutton_default"
                                       value="Clear All"
                                       onclick="javascript:clearTraceLogsa();return false;"/>
                            </div>
                        </xsl:when>
                        <xsl:otherwise>
                            <br/>
                            <i>
                                <font style='color: brown'>Currently there are no trace log messages
                                    present</font>
                            </i>
                            <br/>
                            <br/>
                        </xsl:otherwise>
                    </xsl:choose>
                </fieldset>
            </form>
        </div>
    </xsl:template>
    <xsl:template name="print-row">
        <xsl:param name="value"/>
        <xsl:param name="limit"/>
        <xsl:if test="$value != 0">
            <xsl:if test="$value mod 2 = 0">
                <tr>
                    <xsl:call-template name="print-logs">
                        <xsl:with-param name="index" select="($limit +1) - $value"/>
                    </xsl:call-template>
                </tr>
                <xsl:call-template name="print-row">
                    <xsl:with-param name="value" select="$value - 1"/>
                    <xsl:with-param name="limit" select="$limit"/>
                </xsl:call-template>
            </xsl:if>
            <xsl:if test="$value mod 2 = 1">
                <tr bgcolor="#E3E4FA">
                    <xsl:call-template name="print-logs">
                        <xsl:with-param name="index" select="($limit +1) - $value"/>
                    </xsl:call-template>
                </tr>
                <xsl:call-template name="print-row">
                    <xsl:with-param name="value" select="$value - 1"/>
                    <xsl:with-param name="limit" select="$limit"/>
                </xsl:call-template>
            </xsl:if>
        </xsl:if>
    </xsl:template>
    <xsl:template name="print-logs">
        <xsl:param name="index"/>
        <td>
            <xsl:value-of select="//return[$index]/child::text()"/>
        </td>
    </xsl:template>

</xsl:stylesheet>
